function FileAPI(data){

	var self = this;

	data	= data || {};

	this.fileList = null;
	this.fileField = null;
	this.dropZone = null;
	this.url = "";
	this.fileQueue = new Array();
	this.preview = null;
	this.fileName = null;
	this.progressBar = null;
	this.percentage = null;
	this.uploadOneOrMore = false;
	this.onBeforeUpload = null;
	this.onAfterUpload = null;
	this.onCompleteAll = null;
	this.onAddFile = null;
	this.onRemoveFile = null;
	this.isNotSupport = false;
	this.buttonValue = "Browse";
	this.buttonClass = "btn";
	this.buttonIndex = "32";
	this.fileMaxSize	= 50*1024*1024;	// 50 MB
	this.params = new Array();

	this.init = function(){
		this.fileList = null;
		this.fileQueue	= [];

		var $container = $("<div></div>");
		var $cntfilelist = $("<div></div>");
		var $cntleft = $("<div></div>");
		var $cntright = $("<div></div>");
		var $cntstatus = $("<div></div>");
		var $percentage = $("<div></div>");
		var $progressBar = $("<div></div>");

		this.progressBar = $progressBar;
		this.percentage = $percentage;

		$(self.fileField).after($container);
		$(self.fileField).addClass("fle");
		$container.append($cntleft);

		if (this.fileList == null)
		{
			this.fileList = $cntfilelist;
			$container.append($cntfilelist).append($cntright).append($cntstatus);
		}
		else
		{
			this.fileList = $(this.fileList);
		}
		var tabIndex	= $(self.fileField).attr("tabindex") || 0;
		$browsebtn	= $("<button tabindex='" + tabIndex + "' class='" + this.buttonClass + " '>" + this.buttonValue + "</button>");
		$browsebtn.click(function(e){
			$(self.fileField).click();
			typeof this.buttonClick == "function" && this.buttonClick(e);
		});

		$cntleft.append(self.fileField).append($browsebtn);
		$cntright.append($progressBar);
		$progressBar.append($percentage);
		$cntleft.addClass("pull-left file-browse pr");
		$cntright.addClass("pull-left");
		$cntfilelist.addClass("pull-left file-list");
		$cntstatus.addClass("pull-left file-name");

		$container.addClass("file-uploader").append("<div class='clearfix'></div>");
		$progressBar.addClass("progress progress-striped active");
		$percentage.addClass("bar");

//		self.dropZone = (data.dropZone ? data.dropZone.get(0) : null) || $container.get(0);
		if (data.dropZone && $(data.dropZone).get(0))
		{
			self.dropZone	= $(data.dropZone).get(0);
		}
		else
		{
			self.dropZone	= $container.get(0);
		}
		self.isNotSupport = ($.browser.msie && $.browser.version <= 9);
		if (self.isNotSupport == undefined)
		{
			self.isNotSupport = false;
		}
		try
		{
			var fr = new FileReader();
		}
		catch (e)
		{
			self.isNotSupport = true;
		}
		self.fileField.onclick = function(){
			this.value = null;
		};
		self.fileField.onchange = this.addFiles;
		if (self.isNotSupport == false)
		{
			self.dropZone.addEventListener("dragenter", this.stopProp, false);
			self.dropZone.addEventListener("dragleave", this.dragExit, false);
			self.dropZone.addEventListener("dragover", this.dragOver, false);
			self.dropZone.addEventListener("drop", this.showDroppedFiles, false);
		}
	}

	this.allowedMimeTypes	= data.mimeTypes || ["text/x-comma-separated-values","text/comma-separated-values","application/octet-stream","application/vnd.ms-excel","application/x-csv","text/x-csv","text/csv","application/csv","application/excel","application/vnd.msexcel","application/x-photoshop","application/pdf","application/x-download","application/postscript","application/msexcel","application/powerpoint","application/vnd.ms-powerpoint","application/x-gzip","application/x-javascript","application/x-tar","application/x-gzip-compressed","application/xhtml+xml","application/x-zip","application/zip","application/x-zip-compressed","image/bmp","image/x-windows-bmp","image/gif","image/jpeg","image/pjpeg","image/png","image/x-png","image/tiff","text/css","text/html","text/plain","text/x-log","text/richtext","text/rtf","text/xml","application/msword","application/vnd.openxmlformats-officedocument.wordprocessingml.document","application/vnd.openxmlformats-officedocument.spreadsheetml.sheet","message/rfc822","application/json","text/json"];

	if (data.imageOnly)
	{
		this.allowedMimeTypes	= ["image/bmp","image/x-windows-bmp","image/gif","image/jpeg","image/pjpeg","image/png","image/x-png","image/tiff"];
	}

	this.addFiles = function(e){
		if (!self.isNotSupport)
		{
			/* Max FileSize check begins. */
			var files	= e.target.files,
				fileSize	= 0;
			var unsetFiles	= [];
			for (var i=0, iLen=files.length; i<iLen; i++)
			{
				if (files[i].type && self.allowedMimeTypes.indexOf(files[i].type) < 0)
				{
					alert("The filetype you are attempting to upload is not allowed.");
					return false;
				}

				if (files[i].size > self.fileMaxSize)
				{
					alert("The file you are attempting to upload is larger than the permitted size (Max file size : " + self.fileMaxSize + ").");
					return false;
				}
			}
			/* Max FileSize check end. */
		}

		self.fileList.empty();
		self.fileQueue = new Array();

		if (self.isNotSupport)
		{
			addIEFileListItems();
		}
		else
		{
			addFileListItems(this.files);
		}
	}

	var addIEFileListItems = function(){
		var name = $(self.fileField).val();
		var size = 0;
		name = name.substring(name.lastIndexOf('\\') + 1);
		self.addFileList(name, 0, null);
	}

	this.ieAjaxFileUpload = function(item){
		var li = item.li;
		var $progressBar = $(".progress", li);
		var $percentage = $(".bar", li);
		$progressBar.addClass("uploading").html("Uploading...");
		$.ajaxFileUpload({
		    url : self.url,
		    secureuri : false,
		    fileField : self.fileField,
		    dataType : 'json',
		    data : self.params,
		    success : function(data, status){
			    if (self.onAfterUpload)
			    {
				    self.onAfterUpload(data, item);
			    }
			    li.remove();
			    if (self.onRemoveFile)
			    {
				    self.onRemoveFile();
			    }
		    },
		    error : function(data, status, e){
			    alert("ajaxFileUpload:" + e);
			    // li.remove();
		    }
		})

		return false;
	};

	self.fileLen	= 0;
	self.numFiles	= 0;
	var addFileListItems = function(files){
		try
		{
			self.fileLen	= files.length;
			self.numFiles	= 0;
			for (var i = 0; i < self.fileLen; i++)
			{
				var fr = new FileReader();
				fr.file = files[i];
				fr.onloadend = showFileInList;
				fr.readAsDataURL(files[i]);
			}
		}
		catch (e)
		{
			alert("addFileListItems: " + e);
		}
	}

	this.showDroppedFiles = function(ev){
		ev.stopPropagation();
		ev.preventDefault();
		var files = ev.dataTransfer.files;
		addFileListItems(files);
		$(this).removeClass("dragover");
	}

	this.clearList = function(ev){
		self.fileList.empty();
		self.fileQueue = new Array();
	}

	this.dragOver = function(ev){
		ev.stopPropagation();
		ev.preventDefault();
		$(this).addClass("dragover");
	}

	this.dragExit = function(ev){
		ev.stopPropagation();
		ev.preventDefault();
		$(this).removeClass("dragover");
	}

	this.stopProp = function(ev){
		ev.stopPropagation();
		ev.preventDefault();
	}

	this.uploadQueue = function(ev){
		// ev.preventDefault();
		if (self.uploadOneOrMore)
		{
			while (self.fileQueue.length > 0)
			{
				var item = self.fileQueue.pop();
				if (item)
				{
					var p = document.createElement("p");
					p.className = "loader";
					var pText = document.createTextNode("Uploading...");
					p.appendChild(pText);
					item.li.appendChild(p);
					if (item.file.size < 1048576)
					{
						uploadFile(item);
					}
					else
					{
						p.textContent = "File to large";
						p.style["color"] = "red";
					}
				}
			}
		}
		else
		{
			if (self.fileQueue.length > 0)
			{
				var item	= self.fileQueue.pop();
				if (item)
				{
					uploadFile(item);
				}
			}
			else
			{
				if (self.onCompleteAll)
				{
					self.onCompleteAll();
				}
			}
		}
	}

	this.addFileList = function(filename, filesize, file){
		self.numFiles++;
		var li = $("<div class='list'></div>");
		var $cntright = $("<div></div>");
		var $percentage = $("<div></div>");
		var $progressBar = $("<div></div>");
		$progressBar.addClass("progress progress-striped active");
		$percentage.addClass("bar");
		$cntright.addClass("pull-left");
		var $filename = $("<div class='pull-left'></div>");
		var disphtml = filename;
		if (filesize > 0)
		{
			disphtml += " (" + Math.round(filesize / 1024) + "KB" + ")"
		}
		$filename.html(disphtml);
		var $close = $("<button class='close'>&times;</button>");
		$filename.append($close);
		$cntright.append($progressBar);
		$progressBar.append($percentage);
		li.append($filename).append($cntright).append("<div class='clearfix'></div>");
		var fle = {
		    file : file,
		    li : li
		};
		self.fileQueue.push(fle);
		if (self.onAddFile)
		{
			self.onAddFile(self.fileQueue.length);
		}
		$close.click(function(){
			var index = self.fileQueue.indexOf(fle);
			self.fileQueue.splice(index, 1);
			$(this).parents(".list:first").remove();
			if (self.onRemoveFile)
			{
				self.onRemoveFile();
			}
		});
		self.fileList.prepend(li);

		// After all files added.
		if (self.fileLen == self.numFiles && typeof self.onAddAllFiles === 'function')
		{
			self.onAddAllFiles();
		}
	};

	var showFileInList = function(ev){
		try
		{
			var file = ev.target.file;
			if (file)
			{
				var li = document.createElement("li");
				if (file.type.search(/image\/.*/) != -1)
				{
					var thumb = new Image();
					thumb.src = ev.target.result;
					thumb.addEventListener("mouseover", showImagePreview, false);
					thumb.addEventListener("mouseout", removePreview, false);
					li.appendChild(thumb);
					$(thumb).css({
					    "width" : "50px",
					    "height" : "50px"
					});
				}
				var h3 = document.createElement("h3");
				var h3Text = document.createTextNode(file.name);
				h3.appendChild(h3Text);
				li.appendChild(h3)
				var p = document.createElement("p");
				var pText = document.createTextNode("File type: (" + file.type + ") - " + Math.round(file.size / 1024) + "KB");
				p.appendChild(pText);
				li.appendChild(p);
				var divLoader = document.createElement("div");
				divLoader.className = "loadingIndicator";
				li.appendChild(divLoader);
				// self.fileList.appendChild(li);

				self.addFileList(file.name, file.size, file);
				return;
			}
		}
		catch (e)
		{
			alert("showFileInList:" + e);
		}
	}

	var showImagePreview = function(ev){
		var div = document.createElement("div");
		div.style["top"] = (ev.pageY + 10) + "px";
		div.style["left"] = (ev.pageX + 10) + "px";
		div.style["opacity"] = 0;
		div.className = "imagePreview";
		var img = new Image();
		img.src = ev.target.src;
		div.appendChild(img);
		$("img", div).css({
		    "width" : "50px",
		    "height" : "50px"
		});
		document.body.appendChild(div);
		document.body.addEventListener("mousemove", movePreview, false);
		self.preview = div;
		fadePreviewIn();
	}

	var movePreview = function(ev){
		if (self.preview)
		{
			self.preview.style["top"] = (ev.pageY + 10) + "px";
			self.preview.style["left"] = (ev.pageX + 10) + "px";
		}
	}

	var removePreview = function(ev){
		document.body.removeEventListener("mousemove", movePreview, false);
		document.body.removeChild(self.preview);
	}

	var fadePreviewIn = function(){
		if (self.preview)
		{
			var opacity = self.preview.style["opacity"];
			for (var i = 10; i < 250; i = i + 10)
			{
				(function(){
					var level = i;
					setTimeout(function(){
						self.preview.style["opacity"] = opacity + level / 250;
					}, level);
				})();
			}
		}
	}

	var uploadFile = function(item){
		if (self.isNotSupport)
		{
			self.ieAjaxFileUpload(item);
			return;
		}
		var li = item.li;
		var file = item.file;
		if (li && file)
		{
			var xhr = new XMLHttpRequest(), upload = xhr.upload;
			upload.addEventListener("progress", function(ev){
				if (ev.lengthComputable)
				{
					var loader = li.getElementsByTagName("div")[0];
					loader.style["width"] = (ev.loaded / ev.total) * 100 + "%";
				}
			}, false);
			upload.addEventListener("load", function(ev){
				var ps = li.getElementsByTagName("p");
				var div = li.getElementsByTagName("div")[0];
				div.style["width"] = "100%";
				div.style["backgroundColor"] = "#0f0";
				for (var i = 0; i < ps.length; i++)
				{
					if (ps[i].className == "loader")
					{
						ps[i].textContent = "Upload complete";
						ps[i].style["color"] = "#3DD13F";
						break;
					}
				}
			}, false);
			upload.addEventListener("error", function(ev){
				console.log(ev);
			}, false);
			xhr.open("POST", self.url);
			xhr.setRequestHeader("Cache-Control", "no-cache");
			xhr.setRequestHeader("X-Requested-With", "XMLHttpRequest");
			xhr.setRequestHeader("X-File-Name", file.name);
			// xhr.send(file);

			var $progressBar = $(".progress", li);
			var $percentage = $(".bar", li);
			$progressBar.width(100);
			$percentage.width(0);
			var formData = new FormData();
			formData.append("ot_csrf", window.getOTT());
			formData.append($(self.fileField).attr("name"), file);
			if (self.onBeforeUpload)
			{
				self.onBeforeUpload(item);
			}
			// Upload using jQuery AJAX
			jqxhr = $.ajax({
			    url : self.url,
			    data : formData,
			    cache : false,
			    contentType : false,
			    processData : false,
			    type : 'POST',
			    xhr : function(){
				    var req = $.ajaxSettings.xhr();
				    if (req)
				    {
					    req.upload.addEventListener('progress', function(ev){
						    // Display progress Percentage
						    progress = Math.round(ev.loaded * 100 / ev.total);
						    $percentage.css("width", progress.toString() + '%');
					    }, false);
				    }
				    return req;
			    },
			    success:function(data){
					// afterEachUpload($form.attr('id'), data);
					if (self.onAfterUpload)
					{
						self.onAfterUpload(data, item);
						// self.onAfterUpload(jQuery.parseJSON(data));
					}
					if (self.onRemoveFile)
					{
						self.onRemoveFile();
					}
				},
				error: function(jqXHR, textStatus, errorThrown){
					// afterEachUpload($form.attr('id'), null, textStatus,
					// errorThrown);
				},
				complete:function(jqXHR, textStatus){
					// $progressBar.html(100);
					$percentage.css("width", "100%");
					$(li).remove();
					if (self.uploadOneOrMore == false)
					{
						self.uploadQueue();
					}
					// uploadQueue();
				}
			});
		}
	}
}

jQuery.extend({
	handleError : function(s, xhr, status, e){
		// If a local callback was specified, fire it
		if (s.error)
			s.error(xhr, status, e);
		// If we have some XML response text (e.g. from an AJAX call) then log
		// it in the console
		else if (xhr.responseText)
			console.log(xhr.responseText);
	}
});

jQuery.extend({
    createUploadIframe : function(id, uri){
	    // create frame
	    var frameId = 'jUploadFrame' + id;

	    if (window.ActiveXObject)
	    {
		    var io = $('<iframe id="' + frameId + '" name="' + frameId + '" />').get(0);
		    if (typeof uri == 'boolean')
		    {
			    io.src = 'javascript:false';
		    }
		    else if (typeof uri == 'string')
		    {
			    io.src = uri;
		    }
	    }
	    else
	    {
		    var io = document.createElement('iframe');
		    io.id = frameId;
		    io.name = frameId;
	    }
	    io.style.position = 'absolute';
	    io.style.top = '-1000px';
	    io.style.left = '-1000px';

	    document.body.appendChild(io);

	    return io
    }

    ,
    createUploadForm : function(id, fileField, additionalParam){
	    // create form
	    var formId = 'jUploadForm' + id;
	    var fileId = 'jUploadFile' + id;
	    var form = $('<form  action="" method="POST" name="' + formId + '" id="' + formId + '" enctype="multipart/form-data"></form>');
	    // set attributes
	    $(form).css('position', 'absolute');
	    $(form).css('top', '-1200px');
	    $(form).css('left', '-1200px');
	    $(form).appendTo('body');
	    cloneFile = $(fileField).clone();
	    $(fileField).before(cloneFile);
	    $(form).append(fileField);
	    i = 0;
	    if (additionalParam)
	    {
		    for (i = 0; i < additionalParam.length; i++)
		    {
			    var input = document.createElement("input");
			    $(input).attr({
			        type : 'hidden',
			        name : additionalParam[i].name,
			        value : additionalParam[i].value
			    });
			    $(form).append(input);
		    }
	    }
	    $(form).append(input);
	    return form;
    },
    cloneFile : null,
    ajaxFileUpload : function(s){
	    // TODO introduce global settings, allowing the client to modify them
		// for all requests, not only timeout
	    s = jQuery.extend({}, jQuery.ajaxSettings, s);
	    var id = new Date().getTime();
	    var prsid = 0; // Math.floor(Math.random()*10000000);
	    var form = jQuery.createUploadForm(id, s.fileField, s.param);
	    var io = jQuery.createUploadIframe(id, s.secureuri);
	    var frameId = 'jUploadFrame' + id;
	    var formId = 'jUploadForm' + id;
	    s.isComplete = false;
	    // Watch for a new set of requests
	    if (s.global && !jQuery.active++)
	    {
		    jQuery.event.trigger("ajaxStart");
	    }
	    var requestDone = false;
	    // Create the request object
	    var xml = {}
	    if (s.global)
		    jQuery.event.trigger("ajaxSend", [ xml, s ]);
	    // Wait for a response to come back
	    var uploadCallback = function(isTimeout){
		    var io = document.getElementById(frameId);

		    try
		    {
			    if (io.contentWindow)
			    {
				    xml.responseText = io.contentWindow.document.body ? io.contentWindow.document.body.innerHTML : null;
				    xml.responseXML = io.contentWindow.document.XMLDocument ? io.contentWindow.document.XMLDocument : io.contentWindow.document;

			    }
			    else if (io.contentDocument)
			    {
				    xml.responseText = io.contentDocument.document.body ? io.contentDocument.document.body.innerHTML : null;
				    xml.responseXML = io.contentDocument.document.XMLDocument ? io.contentDocument.document.XMLDocument : io.contentDocument.document;
			    }
		    }
		    catch (e)
		    {
			    jQuery.handleError(s, xml, null, e);
		    }
		    if (xml || isTimeout == "timeout")
		    {
			    requestDone = true;
			    var status;
			    // try {
			    status = isTimeout != "timeout" ? "success" : "error";
			    // Make sure that the request was successful or notmodified
			    if (status != "error")
			    {
				    // process the data (runs the xml through httpData
					// regardless of callback)
				    var data = jQuery.uploadHttpData(xml, s.dataType);
				    // If a local callback was specified, fire it and pass it
					// the data
				    if (s.success)
				    {
					    s.success(data, status);
				    }

				    // Fire the global callback
				    if (s.global)
					    jQuery.event.trigger("ajaxSuccess", [ xml, s ]);
			    }
			    else
			    {
				    jQuery.handleError(s, xml, status);
			    }
			    // } catch (e) {
			    // status = "error";
			    // jQuery.handleError(s, xml, status, e);
			    // }

			    cloneFile.before(s.fileField);
			    cloneFile.remove();
			    /*
				 * var originalForm = $("#" + s.formId);
				 * $(":input[type='file']", form).each(function () { var id =
				 * $(this).attr("id"); var fle = $("#" + id, originalForm);
				 * $(fle).before(this); $(fle).remove(); });
				 */

			    // The request was completed
			    if (s.global)
				    jQuery.event.trigger("ajaxComplete", [ xml, s ]);

			    // Handle the global AJAX counter
			    if (s.global && !--jQuery.active)
				    jQuery.event.trigger("ajaxStop");

			    // Process result
			    s.isComplete = true;
			    if (s.complete)
			    {
				    s.complete(xml, status);
			    }
			    jQuery(io).unbind();

			    setTimeout(function(){
				    try
				    {
					    $(io).remove();
					    $(form).remove();
				    }
				    catch (e)
				    {
					    jQuery.handleError(s, xml, null, e);
				    }
			    }, 100)
			    xml = null
		    }
	    }

	    var checkProgress = function(){
		    $.get(addProgressId("/Progress/", id), null, function(data, success){
			    setTimeout(function(){
				    checkProgress();
			    }, 1000);
		    });
	    };

	    var addProgressId = function(url){
		    // / <summary>Check for and add if need the ?</summary>
		    return url.concat(url.indexOf("?") > -1 ? "" : "?", "progressId=", id)
	    };

	    // Timeout checker
	    if (s.timeout > 0)
	    {
		    setTimeout(function(){
			    // Check to see if the request is still happening
			    if (!requestDone)
				    uploadCallback("timeout");
		    }, s.timeout);
	    }
	    try
	    {
		    // var io = $('#' + frameId);
		    var form = $('#' + formId);
		    $(form).attr('action', s.url);
		    $(form).attr('method', 'POST');
		    $(form).attr('target', frameId);
		    if (form.encoding)
		    {
			    form.encoding = 'multipart/form-data';
		    }
		    else
		    {
			    form.enctype = 'multipart/form-data';
		    }
		    $(form).submit();
	    }
	    catch (e)
	    {
		    jQuery.handleError(s, xml, null, e);
	    }
	    if (window.attachEvent)
	    {
		    document.getElementById(frameId).attachEvent('onload', uploadCallback);
	    }
	    else
	    {
		    document.getElementById(frameId).addEventListener('load', uploadCallback, false);
	    }
	    return {
		    abort : function(){
		    }
	    };

    },
    uploadHttpData : function(r, type){
	    var data = !type;
	    data = type == "xml" || data ? r.responseXML : r.responseText;
	    // If the type is "script", eval it in global context
	    if (type == "script")
		    jQuery.globalEval(data);
	    // Get the JavaScript object, if JSON is used.
	    if (type == "json")
	    {
		    if (data.indexOf("<pre>") > -1)
		    {
			    var $pre = $(data);
			    data = $pre.text();
		    }
		    data = jQuery.parseJSON(data);
	    }
	    // evaluate scripts within html
	    if (type == "html")
		    jQuery("<div>").html(data).evalScripts();
	    //jAlert($('param', data).each(function(){jAlert($(this).attr('value'));}));
	    return data;
    }
})
