(function(Otime){

	Otime.Details	= new function Details(){
		var _this	= this;

		_this.all_users = {};

		_this.all_projects = {};

		_this.all_task_types = {};

		_this.all_task_status = {};

		_this.all_sprint = Otime.o({});

		_this.completed_sprint = Otime.o({});

		_this.all_expense_types = {};
		_this.project_expense_types = {};

		_this.teams = [];
		_this.teamsById = {};
		
		_this.departments = [];
		_this.departmentsById = {};

		_this.tags = [];
		_this.tagsById = {};

		_this.default_status	= null;

		_this.open_status	= null;

		_this.close_status	= null;
		
		/*_this.users_count	= null;
		_this.clients_count	= null;
		_this.projects_count= null;*/

		_this.getUsers	= function(ids){
			
		};

		// cache vars
		var projects	= null,
			activeProjects	= [],
			all_users	= null,
			projectUsers	= {},
			projectTaskTypes	= {};

		_this.ResetCacheVars	= function(){
			// Reset cache vars
			projects	= null;
			activeProjects	= [];
			all_users	= null;
			projectUsers	= {};
			projectTaskTypes	= {};
		};

		_this.getProjects	= function(){
			if (projects)
				return projects;

			if (!_this.all_projects)
			{
				_this.isInitialized	= false;
				_this.init();
				return null;
			}

			projects	= Object.values(_this.all_projects).quickSort(function(a, b){
				return a.pname.toLowerCase() > b.pname.toLowerCase() ? 1 : 0;
			});
			return projects;
		};
		_this.getActiveProjects	= function(){
			if (activeProjects.length > 0)
				return activeProjects;

			if (!_this.all_projects)
			{
				_this.isInitialized	= false;
				_this.init();
				return null;
			}
			$.each(_this.all_projects, function(key, val){
				val && (val.is_active-0) && activeProjects.push(val);
			});
			activeProjects	= activeProjects.quickSort(function(a, b){
				return a.pname.toLowerCase() > b.pname.toLowerCase() ? 1 : 0;
			});
			return activeProjects;
		};
/*
		_this.getProject	= function(id, clbk){
			if (!id || !clbk || typeof clbk != 'function')
				return false;

			if (!_this.all_projects)
			{
				_this.isInitialized	= false;
				_this.init();
				return null;
			}

			var ret	= _this.all_projects[id];
			if (!ret)
			{
				// Ajax with post data
				// project_id
			}

			clbk(ret);
		};
*/
		_this.getTaskTypes	= function(ids){
			if (!ids)
			{
				return _this.all_task_types;
			}
			else if (typeof ids === "number" || typeof ids === "string")
			{
				return _this.all_task_types[ids] ? _this.all_task_types[ids] : null;
			}
			else if(typeof ids === "object")	// is Array
			{
				var ret	= {};
				for (var i=0, iLen = ids.length; i<iLen; i++)
				{
					ret[ids[i]]	= _this.all_task_types[ids[i]];
				}
				return ret;
			}
		};

		_this.getTaskStatus	= function(){
			
		};

		_this.getAllUsers	= function(){
			if (all_users)
				return all_users;

			all_users	= Object.values(_this.all_users).quickSort(function(a, b){
				return a.first_name.toLowerCase() > b.first_name.toLowerCase() ? 1 : 0;
			});
			return all_users;
		};

		_this.getProjectUsers	= function(project_id, clbk){
			if (!project_id)
			{
				return ;
			}
			if (projectUsers[project_id])
			{
				typeof clbk === "function" && $.each(projectUsers[project_id], clbk);
				return projectUsers[project_id];
			}

			var ret	= {};
			$.each(_this.project_users[project_id], function(key, val){
				if (val)
				{
					ret[val] = _this.all_users[val];
					typeof clbk === "function" && clbk(val, _this.all_users[val]);
				}
			});
			projectUsers[project_id]	= ret;

			return ret;
		};

		_this.getUserProjects = function(userId, clbk){
			if (!userId)
			{
				return ;
			}

			var ret	= [];
			$.each(_this.users_projects[userId], function(key, pId){
				if (_this.all_projects[pId])
				{
					ret.push(_this.all_projects[pId]);
					typeof clbk === "function" && clbk(pId, _this.all_projects[pId]);
				}
			});

			return ret;
		};

		_this.getProjectTaskTypes	= function(project_id, clbk){
			if (!project_id)
			{
				return ;
			}
			if (projectTaskTypes[project_id])
			{
				typeof clbk === "function" && $.each(projectTaskTypes[project_id], clbk);
				return projectTaskTypes[project_id];
			}

			var ret	= {};
			$.each(_this.project_task_types[project_id], function(key, val){
				if (val && _this.all_task_types[val])
				{
					ret[val] = _this.all_task_types[val];
					typeof clbk === "function" && clbk(val, _this.all_task_types[val]);
				}
			});
			projectTaskTypes[project_id]	= ret;

			return ret;
		};

		_this.Tasks	= new function TaskSearch(){
			var _self = this;

			_self.list = {};

			_self.isNullResult	= false;

			_self.get	= function(request, callback, self){
				request.term	= $.trim(request.term);

				var pid	= self.project_id() || 0,
					tid	= self.task_type_id() || 0;
/*
				var _key	= "P"+pid+"TT"+tid+(request.term || "__null__");
//	console.log(_key, _self.list, _self.isNullResult && !_self.list[_key]);
				if ((_self.isNullResult && !_self.list[_key]) || pid <= 0 || tid <= 0)
				{
//					console.log("Called1", _self.isNullResult, _self.list[_key], pid, tid);
					callback([]);
					return [];
				}
*/
/*
				if (request.term == "")
				{
					self.project_task_id(0);
					return false;
				}
*/
/*
				if (_self.list[_key])
				{
					callback(_self.list[_key]);
					return [];
				}
*/
				$.ajax({
					type: "POST",
					url: Otime.siteUrl + "/timesheet/tasks",
					data: {
						ot_csrf: $.cookie('ot_csrf_token'),
						term: request.term,
						task_type_id: tid,
						project_id: pid
					},
					success: function(response){
						if (is_expired(response))
						{
							return;
						}
						if(response[0] == true && response[2].length > 0)
						{
							var ret	= [];
							$.each(response[2], function(key, item){
								var lbl	= item.parent_name ? '<b class="text-success">' + item.parent_name + '</b>&nbsp;&nbsp;>&nbsp;&nbsp;' : '';
								ret.push({
									label : "#" + item.task_number + " " + lbl + item.name.escapeHtml(),
									value : item.parent_name ? item.parent_name + " > " + item.name : item.name,
									id : item.task_id,
									task_number: item.task_number,
									billable : item.is_billable,
									task_type_id:item.task_type_id
								});
							});
//							_self.isNullResult	= false;
//							_self.list[_key]	= ret;
							callback(ret);
			            }
						else
						{
//							_self.isNullResult	= true;
						}
					},
					dataType: "JSON",
					global: false
				});
			};

			_self.set	= function(event, ui, self){
				if (Number(ui.item.id) != 0)
				{
					self.project_task_id(ui.item.id);
					self.activity_name.original_value	= ui.item.value;
					self.activity_name(ui.item.value);
					self._info && self._info.task_number && self._info.task_number(ui.item.task_number);
					// self.is_billable(ui.item.billable == 1);
					self.task_type_id(ui.item.task_type_id-0 || self.task_type_id());
				}
			};

			return _self;
		};

		var onReadyCallbacks	= [];
		_this.onReady	= function(clbks){
			onReadyCallbacks.push(clbks);
		};

		_this.isInitialized	= false;
		_this.forceInit	= function(){
			_this.isInitialized	= false;
			_this.init();
		};

		_this.init	= function(){
			if (_this.isInitialized)
				return true;

			_this.ResetCacheVars();

//			var url	= Otime.siteUrl + "/tasks/common_data";
			var url	= window.siteUrl + "/tasks/common_data";
			$.get(url, function(data){
				if (!data[0] || !data[2])
				{
					return;
				}

				var data = data[2];
				if (data.projects && data.projects.otvalues)
				{
					_this.all_projects	= data.projects.otvalues.setKeys(data.projects.otkeys, function(itm){
						itm.pname	= itm.project_code + itm.project_name;
					}, "project_id");
				}

				if (data.team && data.team.otvalues)
				{
					_this.teamsById = {};
					_this.teams = data.team.otvalues.setKeys(data.team.otkeys, function(itm){
						_this.teamsById[itm.team_id] = itm;
					});
				}

				if (data.tags && data.tags.otvalues)
				{
					_this.tags = [];
					_this.tagsById = {};
					data.tags.otvalues.setKeys(data.tags.otkeys, function(itm){
						_this.tags.push(itm);
						_this.tagsById[itm.id] = itm;
					});
				}

				/*else
				{
					_this.isInitialized	= true;
					return false;
				}*/

				if (data.all_users && data.all_users.otvalues)
				{
					_this.all_users = data.all_users.otvalues.setKeys(data.all_users.otkeys, function(itm){
						itm.first_name = itm.first_name.charAt(0).toUpperCase() + itm.first_name.slice(1);
						itm.user_name	= itm.first_name + " " + itm.last_name;
					}, "user_id");
				}

				_this.user_roles = data.user_roles;

				_this.departmentsById = {};
				if (data.departments && data.departments.otvalues)
				{
					_this.departments = data.departments.otvalues.setKeys(data.departments.otkeys, function(itm){
						_this.departmentsById[itm.user_dept_id] = itm;
					});
				}

				window.tmp_count.clients = data.clients_count-0 || 0;

				if (data.task_status && data.task_status.otvalues) {
					_this.all_task_status	= data.task_status.otvalues.setKeys(data.task_status.otkeys, function(itm){
						// Default Status
						if (itm.is_default-0)
						{
							_this.default_status	= itm.task_status_id-0;
						}
						// Open Status
						if ((itm.system_defined=='O') && !(itm.is_closed-0))
						{
							_this.open_status	= itm.task_status_id-0;
						}

						// Closed Status
						if (!!(itm.is_closed-0))
						{
							_this.close_status = itm.task_status_id-0;
						}
					}, "task_status_id");
				}

				_this.all_task_status["0"] = {
					bg_color: "#FFF",
					is_closed: 0,
					is_default: 0,
					name: "",
					sort_order: 0,
					system_defined: '',
					task_status_id: "0",
					text_color: "#FFF"
				};

				if (data.task_types && data.task_types.otvalues) {
					_this.all_task_types	= data.task_types.otvalues.setKeys(data.task_types.otkeys, null, "task_type_id");
				}

				if (data.sprint && data.sprint.otvalues) {
					_this.all_sprint	= data.sprint.otvalues.setKeys(data.sprint.otkeys, null, "sprint_id");
				}

				if (data.completed_sprint && data.completed_sprint.otvalues) {
					_this.completed_sprint	= data.completed_sprint.otvalues.setKeys(data.completed_sprint.otkeys, null, "sprint_id");
				}
				
				_this.project_task_types = {};
				$.each(data.project_task_types, function(key, val){
					if (val)
					{
						_this.project_task_types[key] = val.split(",");
					}
				});

				_this.project_users = {};
				$.each(data.project_users, function(key, val){
					if (val)
					{
						_this.project_users[key] = val.split(",");
					}
				});

				_this.users_projects = {};
				$.each(_this.project_users, function(_pId, _usrs){
					$.each(_usrs, function(idx, userId){
						if (!_this.users_projects[userId]) {
							_this.users_projects[userId] = [];
						}
						_this.users_projects[userId].push(_pId);
					});
				});

				if (data.expense_types && data.expense_types.otvalues) {
					_this.all_expense_types = data.expense_types.otvalues.setKeys(data.expense_types.otkeys, null, "expense_type_id");
				}

				_this.project_expense_types = {};
				$.each(data.project_expense_types, function(key, val){
					if (val)
					{
						_this.project_expense_types[key] = val.split(",");
					}
				});

				_this.isInitialized	= true;
				onReadyCallbacks.length > 0 && $.each(onReadyCallbacks, function(key, val){
					val();
				});
				onReadyCallbacks	= [];

				// open intro model when projects or users length ==1
				window.tmp_count.users 	= Object.keys(_this.all_users).length-1;	// ignore admin user
				window.tmp_count.projects 	= Object.keys(_this.all_projects).length;

				if (window.cloud_app) {
					window.tmp_count.users		= (Object.keys(_this.all_users).length==2 && (Object.values(_this.all_users)[1].first_name=='TestUser1'))?0:Object.keys(_this.all_users).length;
					window.tmp_count.projects	= (window.tmp_count.projects==1 && (Object.values(_this.all_projects)[0].project_name=='Test Project1'))?0:window.tmp_count.projects;
				}

				if (!window.tmp_count.users || !window.tmp_count.clients || !window.tmp_count.projects) {
					//alert(_this.demo_popup_tmp);
					var list_active = -1;
					list_active = (list_active<0 && !window.tmp_count.users)?1:list_active;
					list_active = (list_active<0 && !window.tmp_count.clients)?2:list_active;
					list_active = (list_active<0 && !window.tmp_count.projects)?3:list_active;

					if ($('#demo_popup') && $('#intro_text').length) {
						$('#demo_popup').on('show.bs.modal', function (event) {
							if (window.demo_popup_tmp) {
								$('#demo_popup').find('#close_button').css('display','block');
						  	  	$('#demo_popup').find('#skip_button').css('display','none');
							  	$('#demo_popup').find('.modal-body').html($('#intro_text').html());
							 }
							ko.applyBindings({
							  	users_count:window.tmp_count.users,
							  	clients_count:window.tmp_count.clients,
							  	projects_count:window.tmp_count.projects,
							  	list_active:list_active
							  },$('#demo_popup').get(0));
						});
						
						$('#demo_popup').modal('show');							
					}
				}
			}).fail(function(){
				console.log("Common Data Failed.");
				$("body").removeClass("loading");
			});
		};

		_this.getExpenseTypes = function(){
			var expense_types = Object.values(_this.all_expense_types);

			if (!expense_types || !expense_types.length)
			{
				return [];
			}

			expense_types = expense_types.quickSort(function(a, b){
				return a.name.toLowerCase() > b.name.toLowerCase() ? 1 : 0;
			});

			return expense_types;
		};

	}

}(window.Otime));
Otime.Details.init();

