﻿(function(Otime){

	Otime.Entity	= new function Entity(){
//		"use strict";

		var _this	= this;

		_this.name	= "settings";

		_this.currencies	= {};

		_this.number_formats	= {};

		_this.currency_html	= null;
		
		_this.date_prev	= "";

		_this.appModel	= null;

		_this.cfByFCode = {};

		_this.custom_mod = [];

		var sortCustomFields = function () {
			_this.custom_mod.mergeSort(function (a, b) {
				if (!a.ordNo) {
					return 1;
				}
				if (!b.ordNo) {
					return -1;
				}
				return (a.ordNo > b.ordNo) ? 1 : -1;
			});
		};

		var taskColumns = {
			"TT": { id: 0, fCode: "TT", fEnable: 1, isSys: 1, fName: "Task Type", colName: "ttype" },
			"DU": { id: 0, fCode: "DU", fEnable: 1, isSys: 1, fName: "Duration", colName: "duration" },
			"SD": { id: 0, fCode: "SD", fEnable: 1, isSys: 1, fName: "Start Date", colName: "sdate" },
			"FD": { id: 0, fCode: "FD", fEnable: 1, isSys: 1, fName: "Finish Date", colName: "fdate" },
			"EH": { id: 0, fCode: "EH", fEnable: 1, isSys: 1, fName: "Estimated Hours", colName: "esthrs" },
			"AH": { id: 0, fCode: "AH", fEnable: 1, isSys: 1, fName: "Actual Hours", colName: "acthrs" },
			"ST": { id: 0, fCode: "ST", fEnable: 1, isSys: 1, fName: "Status", colName: "status" },
			"AS": { id: 0, fCode: "AS", fEnable: 1, isSys: 1, fName: "Assignee", colName: "assignee" },
			"FL": { id: 0, fCode: "FL", fEnable: 1, isSys: 1, fName: "Followers", colName: "followers" },
			"PR": { id: 0, fCode: "PR", fEnable: 1, isSys: 1, fName: "Predecessors", colName: "predec" }
		};
		if(Otime.isSPRINT){
			taskColumns["SP"] = { id: 0, fCode: "SP", fEnable: 1, isSys: 1, fName: "SPrint", colName: "sprint" }
		}

		_this.EntityListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.company	= Otime.o(null);
			self.datetime	= Otime.o(null);
			self.timesheet	= Otime.o(null);
			self.invoice	= Otime.o(null);
			self.calendar	= Otime.o(null);
			self.projectStatus	= Otime.o(null);
			self.taskTypes	= Otime.o(null);
			self.expenses	= Otime.o(null);
			self.taskStatus	= Otime.o(null);
			self.department	= Otime.o(null);
			self.addon	= Otime.o(null);
			self.smtp	= Otime.o(null);
			self.customFields = Otime.o(null);

			self.showLicPopup	= function(){
				$("#update_license").modal("show");
			};
		};

		_this.CompanyModel	= function(data){
			var self	= this;

			data	= data || {};

			self.company_name	= Otime.o(data.company_name || "");
			self.entity_logo	= Otime.o(data.entity_logo || "");
			
			self.adminMembers		= Otime.a([]);
			self.account_owner_id 	= Otime.o(data.account_owner_id || 0);
			self.admin_user_image 	= Otime.o();
			self.admin_user_name	= Otime.o("");
			
			if (data.users && data.users.otvalues && Object.keys(data.users.otvalues).length>0)
			{
				data.users	= data.users.otvalues.setKeys(data.users.otkeys, null, "user_id");
				self.adminMembers(data.users);
			}
			var setAccountOwner = function(newVal){
				var mem	= self.adminMembers()[newVal];
				if (newVal && mem)
				{
					self.admin_user_image(mem.user_image);
					self.admin_user_name(mem.first_name);
				}
			};
			setAccountOwner(data.account_owner_id);
			self.account_owner_id.subscribe(setAccountOwner);
			
			if(data.user_image) 
			{
				data.user_image = Otime.UMIP + data.user_image;
			}

			self._info	= {};
			self._info.user_name	= Otime.o(data.user_name || "");
			self._info.user_image	= Otime.o(data.user_image || Otime.baseUrl + "/files/photo/no-User.png");
			if (data.entity_logo_disp)
			{
				data.entity_logo_disp = Otime.fileUrl + data.entity_logo_disp+ "?time=" + new Date().getTime();
			}
//Otime.preLoadImage(data.entity_logo_disp);
//console.log("Called : ", new Date().getTime());
			self._info.image_path	= Otime.o(data.entity_logo_disp || "../files/photo/nocompany.jpg");
			self._info.oldImage		= Otime.o(data.entity_logo_disp || "../files/photo/nocompany.jpg");

			self._info.is_edit_mode	= Otime.o(false);

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});
			
			var fileApi	= new FileAPI({
				mimeTypes: Otime.allowedmimes,
				imageOnly: true
			});
			fileApi.buttonClass	= "dn";

			self.uploadDialog	= function(){
				$("#company-logo").trigger("click");
			};

			self._info.isTempLoad	= false;
			self.setEdit	= function(item){
				var onBeginEdit	= function(){
					ko.editable(self);
					self.beginEdit();
					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("company", function(response){
						var cEdit = $("#company-edit");
						cEdit.html($.trim(response));
						cEdit = $("#company-edit > div");
						ko.applyBindings(self, cEdit.get(0));

						fileApi.fileField	= $("#company-logo").get(0);
						fileApi.url		= Otime.siteUrl + "/attachment/company_image_upload";
						fileApi.onAddFile	= function(param){
							var reader = new FileReader();
							reader.onload = function(e){
								self._info.image_path(e.target.result);
							};
							reader.readAsDataURL(fileApi.fileQueue[0].file);
						};
						fileApi.onRemoveFile	= function(){
							self._info.image_path(self._info.oldImage());
							$('#company-logo').val('');
						};
						fileApi.init();

						self._info.isTempLoad	= true;

						onBeginEdit();
					});
				}
				else
				{
					fileApi.onRemoveFile	= function(){
						self._info.image_path(self._info.oldImage() + "?time=" + new Date().getTime());
					};
					onBeginEdit();
				}
			};

			self.save	= function(item){
				if(self.hasChanges && self.hasChanges())
				{
					var saveFn	= function(){
						var data	= JSON.parse(ko.toJSON(self));
						delete data._info;
						delete data.hasChanges;

						Otime.app.postData(new Otime.ContextModel("save/company", data, function(resp){
							self.commit();
							self._info.is_edit_mode(false);
						}));
					};

					if($("#company-logo").val() != '')
					{
						fileApi.onAfterUpload = function(data){
							if (data && !data[0])
							{
								Otime.error_message(data[1], $("#alert_message"));
								// console.log("Error :- ", data[1]);
								return;
							}

							self._info.oldImage(Otime.fileUrl + data[2].url + "?time=" + new Date().getTime());
							self._info.image_path(Otime.fileUrl + data[2].url + "?time=" + new Date().getTime());
							self.entity_logo(data[2].file_name);
							saveFn();
						};
						fileApi.uploadQueue();
					}
					else
					{
						saveFn();
					}
				}	
			};

			self.cancel	= function(item){
				self.rollback();
				self._info.is_edit_mode(false);
			};
		};


		_this.ProjectStatusListModel	= function(data){
			var self	= this;
		
			data	= data || {};
		
			self.listing	= Otime.a([]);
		
			self._info	= {};
			self._info.is_edit_mode	= Otime.o(false);
			self._info.isTempLoad	= false;
			self.default_status	= Otime.o(0);

			self.default_status.subscribe(function(newVal){
				$.each(self.listing(), function(key, val){
					val.is_default(val._info.unique_id() == newVal);
				});
			});
		
			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});
		
			var addNewItem	= function(){
				var newItem	= new _this.ProjectStatusModel();
				ko.editable(newItem);
				newItem.beginEdit();
				self.listing.push(newItem);
			};
			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
				{
					addNewItem();
				}
				else
				{
					self.listing.pop();
				}
			});
			if (data && data.otvalues)
			{
				var tmpArr	= [];
				data	= data.otvalues.setKeys(data.otkeys, function(item){					
					var tmpItem	= new _this.ProjectStatusModel(item);
					tmpArr.push(tmpItem);
					if (Number(tmpItem.is_default()))
					{
						self.default_status(tmpItem._info.unique_id());
					}
				});
				self.listing(tmpArr);
			}
			
			self.setEdit	= function(item){
				var onBeginEdit	= function(){
					$.each(self.listing(), function(key, val){
						ko.editable(val);
						val.beginEdit();
					});
		
					self._info.is_edit_mode(true);
				};
		
				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("project_status", function(response){
						var tEdit = $("#projectstatus-edit");
						tEdit.html($.trim(response));
						tEdit = $("#projectstatus-edit > div");
						ko.applyBindings(self, tEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};
		
			var newDataArr	= [];
			var deletedIds	= [];
			self.prepareData	= function(){
				var arr = self.listing();
				var deleted_project_status	= [];
				var retData	= [];
				newDataArr	= [];
				var tmp=null;
				for (var i=0; i<arr.length; i++)
				{
					tmp	= arr[i];
					if (tmp._destroy)
					{
						deleted_project_status.push(tmp.id());
						deletedIds.push(tmp);
						continue;
					}

					if ((!tmp.id() && tmp.name()!="") || tmp.isDirty())
					{
						var data	= JSON.parse(ko.toJSON(tmp));
						delete data.isDirty;
						delete data._info;
						delete data.hasChanges;

						data.is_default	= Number(data.is_default);
						retData.push(data);
						if (!tmp.id() || tmp.id()<=0)
						{
							newDataArr.push(tmp);
						}
					}
				}

				return {
					items: retData,
					deleted_project_status: deleted_project_status
				};
			};

			self.save	= function(item){
				var data	= self.prepareData();
				var finishIt	= function(){
					$.each(self.listing(), function(key, lstItem){
						lstItem.commit();
						lstItem.resetIsDirty();
					});
					self._info.is_edit_mode(false);
				};

				if (!data || (data.items.length <= 0 && data.deleted_project_status.length <=0))
				{
					finishIt();
					return false;
				}

				Otime.app.postData(new Otime.ContextModel("save/project_status", data, function(resp){
					resp	= resp.response;
					var tmp = null;
					for (var i=0; i<newDataArr.length; i++)
					{
						tmp	= newDataArr[i];
						if (!tmp.id())
						{
							tmp.id(resp.data.save_ids[i]);
							tmp._info.isNew(false);
						}
					}
					newDataArr	= [];
					if (data.deleted_project_status && deletedIds.length > 0)
					{
						for(var i=0; i<deletedIds.length; i++)
						{
							self.listing.remove(deletedIds[i]);
						}
						deletedIds	= [];
					}
					finishIt();
				}));
			};
		
			self.cancel	= function(item){
				$.each(self.listing(), function(key, val){
					if(val._destroy)
					{
						delete val._destroy;
					}
					val.rollback();
				});
				self._info.is_edit_mode(false);
			};
		
			self.addNew	= function(item){
				if (self.listing().indexOf(item) == self.listing().length-1 && item.name() != "")
				{
					addNewItem();
				}
			};
		
			self.remove	= function(item){
				if (item.id() > 0)
					self.listing.destroy(item);
				else
					self.listing.remove(item);
			};
		};
		
		_this.ProjectStatusModel	= function(data){
			var self	= this;
		
			data	= data || {};
		
			self.id	= Otime.o(data.id || 0);
			self.name = Otime.o(data.name || "").extend({required:_this.language["ERR_PROJECT_STATUS_NAME_REQUIRED"], trackChange: true});
			self.is_default	= Otime.o((data.is_default==1)).extend({trackChange: true});
			self._info	= {};
			self._info.isNew		= Otime.o(self.id()>0?false:true);
			self._info.unique_id		= Otime.o(new Date().getTime()+Math.round(Math.random()*100000));
		
		
			self.resetIsDirty	= function(){
				for (var key in self)
				{
					Otime.i(self[key]) && self[key].isDirty && self[key].isDirty(false);
				}
			};
		
			self.isDirty	= Otime.c(function(){
				for (var key in self)
				{
					if (Otime.i(self[key]) && self[key].isDirty && self[key].isDirty())
					{
						return true;
					}
				}
				return false;
			});
		};

		_this.DateTimeModel	= function(data){
			var self	= this;

			data	= data || {};

			self.time_zone_code	= Otime.o(data.time_zone_code || "");
			self.date_format	= Otime.o("");
			self.time_format	= Otime.o("");
			self.period_format	= Otime.o("");

			self._info		= {};
			self._info.time_zone_disp	= Otime.o("");
			self._info.time_zone_city	= Otime.o("");
			self._info.date_format_disp	= Otime.o("");
			self._info.time_format_disp	= Otime.o("");
			self._info.period_format_disp	= Otime.o("");
			self._info.is_edit_mode		= Otime.o(false);
			self._info.editTemplate		= Otime.o("");

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			var setTimeZone = function(newVal){
				newVal	= newVal || self.time_zone_code() || "";
				var tz	= Otime.timezones[newVal] || newVal;
				if (tz.match(/\((.*)\) (.*)/)) {
					tz	= tz.match(/\((.*)\) (.*)/);
					self._info.time_zone_disp($.trim(tz[1]));
					self._info.time_zone_city($.trim(tz[2]));
				} else {
					self._info.time_zone_disp($.trim(tz));
				}
			};
			setTimeZone();
			self.time_zone_code.subscribe(setTimeZone);

			self.date_format.subscribe(function(newVal){
				newVal	= newVal || self.date_format() || "MMM dd, yyyy";
				// self._info.date_format_disp(_this.date_formats[newVal]);
				self._info.date_format_disp(new Date().format(newVal));
			});
			self.date_format(data.date_format || "");

			self.time_format.subscribe(function(newVal){
				newVal	= Number(newVal || self.time_format());
				self._info.time_format_disp(!!newVal?"23:59":"11:59 PM");
			});
			self.time_format(Number(data.time_format));

			self.period_format.subscribe(function(newVal){
				newVal	= Number(newVal || self.period_format());
				self._info.period_format_disp(!newVal?"Hours and Minutes (10:45)":"Decimal (10.75)");
			});
			self.period_format(Number(data.period_format));
			self.save	= function(item){
				var data	= JSON.parse(ko.toJSON(self));
				if (self.hasChanges && self.hasChanges())
				{
					var data	= JSON.parse(ko.toJSON(self));
					delete data._info;
					delete data.hasChanges;
					Otime.app.postData(new Otime.ContextModel("save/datetime", data, function(response){
						self._info.is_edit_mode(false);
						self.commit();
						Otime.dateFormat	= self.date_format();
						Otime.hourFormat	= !!self.time_format();
						Otime.periodFormat	= self.period_format();
					}));
				}
			};

			self.cancel	= function(item){
				self.rollback();
				self._info.is_edit_mode(false);
			};

			self._info.isTempLoad	= false;
			self.setEdit	= function(item){
				var onBeginEdit	= function() {
					ko.editable(self);
					self.beginEdit();
					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("datetime", function(response){
						var dtEdit	= $("#date-time-edit");
						dtEdit.html($.trim(response));
						dtEdit = $("#date-time-edit > div");
						ko.applyBindings(self, dtEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};
		};

		_this.TimesheetModel	= function(data){
			var self	= this;

			data	= data || {};
			self.task_required		= Otime.o(!!Number(data.task_required));
			self.time_stamp_req		= Otime.o(!!Number(data.time_stamp_req));
			self.time_sheet_approval= Otime.o(!!Number(data.time_sheet_approval));
			self.modify_billable	= Otime.o(!!Number(data.modify_billable));
			self.allow_future_time	= Otime.o(!!Number(data.allow_future_time));
			self.sprint_required= Otime.o(!!Number(data.sprint_required));
			self.daily_progress_report_required= Otime.o(!!Number(data.daily_progress_report_required));
			self.daily_progress_user_depts = Otime.a(data.daily_progress_user_depts?data.daily_progress_user_depts.split(","):[]).extend({trackChange: true});//Otime.o(data.user_depts || "-1");
			self.hours_per_day		= Otime.o(data.hours_per_day-0 || 8);
			self.preschedule_min_hours_per_day		= Otime.o(data.preschedule_min_hours_per_day-0 || 7);
			self.user_depts = Otime.a(data.user_depts?data.user_depts.split(","):[]).extend({trackChange: true});//Otime.o(data.user_depts || "-1");

			self.hours_per_day.subscribe(function(newVal){
				if (isNaN(newVal))
				{
					self.hours_per_day(8);
				}
				if (newVal > 24)
				{
					self.hours_per_day(24);
				}
				if (newVal < 0)
				{
					self.hours_per_day(0);
				}
			});

			self.preschedule_min_hours_per_day.subscribe(function(newVal){
				if (isNaN(newVal))
				{
					self.preschedule_min_hours_per_day(7);
				}
				if (newVal > 24)
				{
					self.preschedule_min_hours_per_day(24);
				}
				if (newVal < 0)
				{
					self.preschedule_min_hours_per_day(0);
				}
			});

			self.departments		= Otime.a([]);
			if (data.userdepts && data.userdepts.otvalues && Object.keys(data.userdepts.otvalues).length>0)
			{
				var tmpArr	= [];
				data	= data.userdepts.otvalues.setKeys(data.userdepts.otkeys, function(item){
					tmpArr.push(new _this.UserDepartmentModel(item));
				});
				self.departments(tmpArr);
			}
			self._info	= {};
			self._info.is_edit_mode	= Otime.o(false);

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			self.save	= function(item){
				if(self.hasChanges && self.hasChanges())
				{
					// var data	= JSON.parse(ko.toJSON(self));
					console.log("**********user dept",self.user_depts());
					var data	= {
						time_stamp_req: self.time_stamp_req()-0 || 0,
						time_sheet_approval: self.time_sheet_approval()-0 || 0,
						modify_billable: self.modify_billable()-0 || 0,
						hours_per_day: self.hours_per_day()-0 || 8,
						allow_future_time: self.allow_future_time()-0 || 0,
						task_required: self.task_required()-0 || 0,
						sprint_required: self.sprint_required()-0 || 0,
						daily_progress_report_required: self.daily_progress_report_required()-0 || 0,
						daily_progress_user_depts: self.daily_progress_user_depts().toString() || "-1",
						preschedule_min_hours_per_day: self.preschedule_min_hours_per_day()-0 || 7,
						user_depts: self.user_depts().toString() || "-1",
					};
					Otime.app.postData(new Otime.ContextModel("save/timesheet", data, function(response){
//						Otime.tsReq	= self.time_stamp_req();
//						Otime.isAR	= self.time_sheet_approval();
//						console.log("Timesheet -> ", response);
						self.commit();
						self._info.is_edit_mode(false);

						// show hide approve menu based on time sheet approve
						if (!Otime.isAR)
							$('ul.dropdown-menu li.approve').hide();
						else
							$('ul.dropdown-menu li.approve').show();
					}));
				}
			};

			self.cancel	= function(item){
				self.rollback();
				self._info.is_edit_mode(false);
			};

			self._info.isTempLoad	= false;
			self.setEdit	= function(item){
				var onBeginEdit	= function() {
					ko.editable(self);
					self.beginEdit();
					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("timesheet", function(response){
						var tsEdit	= $("#time-sheet-edit");
						tsEdit.html($.trim(response));
						tsEdit	= $("#time-sheet-edit > div");
						ko.applyBindings(self, tsEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});					
				}
				else
				{
					onBeginEdit();
				}
			};
		};

		_this.InvoiceModel	= function(data){
			var self	= this;

			data	= data || {};

			self.fiscal_year_month	= Otime.o(data.fiscal_year_month || 1);
			self.currency_code		= Otime.o(data.currency_code || "INR");
			self.number_format		= Otime.o(data.number_format || "D");
			self.time_round_to		= Otime.o("");
			self.inv_template		= Otime.o(data.inv_template || "default");
			
			self._info	= {};
			self._info.fiscal_month		= Otime.o(Date.monthNames[self.fiscal_year_month()-1]);
			self._info.currency_html	= Otime.o("");
			self._info.is_edit_mode		= Otime.o(false);
			self._info.round_to_disp	= Otime.o("");


			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			self.time_round_to.subscribe(function(newVal){
				self._info.round_to_disp(_this.time_round_to[newVal] || 'No roundup');
			});
			self.time_round_to(data.time_round_to || "N");

			var prepareCurrencyHtml	= function(){
				var html	= "";
				html	+= _this.currencies[self.currency_code() || "INR"].currency_symbol + " ";
				html	+= _this.number_formats[self.number_format()];
				html	+= " ( " + self.currency_code() + " )";
				self._info.currency_html(html);
				return true;
			};

			prepareCurrencyHtml();
			self.currency_code.subscribe(prepareCurrencyHtml);
			self.number_format.subscribe(prepareCurrencyHtml);

			self.fiscal_year_month.subscribe(function(newVal){
				self._info.fiscal_month(Date.monthNames[newVal-1]);
			});

			self.save	= function(){
				if(self.hasChanges())
				{
					var data	= JSON.parse(ko.toJSON(self));
					delete data._info;
					delete data.hasChanges;
					Otime.app.postData(new Otime.ContextModel("save/invoice", data, function(resp){
						_this.currency_html(_this.currencies[self.currency_code() || "INR"].currency_symbol);
						self.commit();
						Otime.NumFormat	= self.number_format() || Otime.NumFormat || "D";
						Otime.fiscal_year_month	= self.fiscal_year_month();
						self._info.is_edit_mode(false);
					}));
				}
			};

			self.cancel	= function(){
				self.rollback();
				self._info.is_edit_mode(false);
			};

			self._info.isTempLoad		= false;
			self.setEdit	= function(){
				var onBeginEdit	= function(){
					ko.editable(self);
					self.beginEdit();
					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("invoice", function(response){
						var iEdit = $("#invoice-edit");
						iEdit.html($.trim(response));
						iEdit = $("#invoice-edit > div");
						ko.applyBindings(self, iEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};
		};

		_this.DaysOfModel	= function(data, parent){
			var self	= this;

			data	= data || {};

			self.entity_dayoff_id	= Otime.o(data.entity_dayoff_id || 0);

			self._info	= {};
			self._info.dateDisp	= Otime.o("MMM DD, YYYY");

			data.dayoff_date	= data.dayoff_date ? Otime.stoj(data.dayoff_date) : new Date();
			self.dayoff_date	= Otime.o(data.dayoff_date.format(Otime.jdf)).extend({trackChange:true});
			self.dayoff_date.subscribe(function(newVal){
				parent.addNew(self);
			});
			self._info.isNew	= Otime.o(self.entity_dayoff_id() ? false : true);
			self.description	= Otime.o(data.description || "").extend({trackChange:true});
			self.description.subscribe(function(newVal){
				parent.addNew(self);
			});
			self.repeat			= Otime.o(false).extend({trackChange:true});
			self.repeat.subscribe(function(newVal){
				self._info.dateDisp(newVal ? "MMM DD" : "MMM DD, YYYY");
			});
			self.repeat(Boolean(Number(data.repeat)));

			self.isDirty	= Otime.c(function(){
				for (var key in self)
				{
					if (self.hasOwnProperty(key) && Otime.i(self[key]) && typeof self[key].isDirty === 'function' && self[key].isDirty())
					{
						return true;
					}
				}
			});

			return self;
		};

		_this.CalendarModel	= function(data){
			var self	= this;

			data	= data || {};

			self._info	= {};
			self._info.today	= new Date();
			self._info.date		= Otime.o(self._info.today);
			self._info.is_edit_mode	= Otime.o(false);
			self._info.isTempLoad	= false;
			self._info.swoDisp		= Otime.o("");
			self._info.nwdDisp		= Otime.o("");

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			var days	= {
				"SU": "Sunday", "MO": "Monday", "TU": "Tuesday", "WE": "Wednesday",
				"TH": "Thursday", "FR": "Friday", "SA": "Saturday"
			};

			self.start_week_on		= Otime.o(data.start_week_on || "SU");
			self.non_working_days	= Otime.a(data.non_working_days.split(","));
			self.skip_daysoff		= Otime.o(Boolean(Number(data.skip_daysoff)) || false);
			self.daysoff			= Otime.a([]);

			self._info.swoDisp(days[self.start_week_on()]);
			self.start_week_on.subscribe(function(newVal){
				self._info.swoDisp(days[newVal]);
			});

			var applyDisp	= function(newVal){
				var _d1	= [];
				newVal	= newVal || self.non_working_days();
				for (var i=0; i<newVal.length; i++)
				{
					_d1.push(days[newVal[i]]);
				}
				self._info.nwdDisp(_d1.join(", "));
			};
			applyDisp();
			self.non_working_days.subscribe(applyDisp);

			var date_last = '';
			var tmpArr = [];
			if (Object.keys(data.daysoff).length > 0)
			{
				data.daysoff	= data.daysoff.otvalues.setKeys(data.daysoff.otkeys, function(item){
					date_last = item.dayoff_date;
					tmpArr.push(new _this.DaysOfModel(item, self));
				});
			}//alert(date_last.addDays(1));
			tmpArr.push(new _this.DaysOfModel(null, self));
			self.daysoff(tmpArr);

			self.setEdit	= function(item){
				var onBeginEdit	= function(){
					ko.editable(self);
					self.beginEdit();
					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("calendar", function(response){
						var cEdit = $("#calendar-edit");
						cEdit.html($.trim(response));
						cEdit = $("#calendar-edit > div");
						ko.applyBindings(self, cEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};

			var newDataArr	= [];

			self.prepareData	= function(){
				var data	= JSON.parse(ko.toJSON(self));

				delete data._info;
				delete data.hasChanges;
				data.non_working_days	= data.non_working_days.join(",");
				data.skip_daysoff	= Number(data.skip_daysoff);
				data.deleted_daysoff	= [];

				var tmpArr	= [], tmp;
				for(var i=0; i<self.daysoff().length; i++)
				{
					tmp	= self.daysoff()[i];

					if (tmp._destroy)
						data.deleted_daysoff.push(tmp.entity_dayoff_id());
					if (!tmp.isDirty() || tmp._destroy)
						continue;

					newDataArr.push(tmp);
					tmp	= JSON.parse(ko.toJSON(tmp));
					delete tmp._info;
					tmp.dayoff_date	= new Date(tmp.dayoff_date).format("YYYY-MM-DD");
					tmp.repeat	= Number(tmp.repeat);
					tmpArr.push(tmp);
				}
				data.daysoff	= tmpArr;

				return data;
			};

			self.save	= function(item){
				var data	= self.prepareData();
				
				Otime.app.postData(new Otime.ContextModel("save/calendar", data, function(resp){
					resp	= resp.response;
					var tmp	= null;
					for (var i=0; i<newDataArr.length; i++)
					{
						tmp	= newDataArr[i];
						tmp.entity_dayoff_id(resp.data.save_ids[i]);
						tmp._info.isNew(false);
					}
					newDataArr	= [];
					self.commit();
					self._info.is_edit_mode(false);
				}));
			};

			self.cancel	= function(item){
				$.each(self.daysoff(), function(key, val){
					if(val._destroy)
					{
						delete val._destroy;
					}
				});
				self.rollback();
				self._info.is_edit_mode(false);
			};

			self.addNew	= function(item){
			/*
				var item_date = item.dayoff_date();
				$.each(self.daysoff(), function(key, val){
					if(val.dayoff_date()>new Date(item_date)) {
						item_date = val.dayoff_date().format(Otime.jdf);
					}													
				});
				_this.date_prev = item_date;
			*/
				if (self.daysoff().indexOf(item) == self.daysoff().length-1 && item.dayoff_date() != "")
				{
					self.daysoff.push(new _this.DaysOfModel({
						dayoff_date: new Date(item.dayoff_date()).addDays(1).format(Otime.sdf)
					}, self));
				}

				if (self.daysoff().indexOf(item) == self.daysoff().length-1 && item.description() != "")
				{
					self.daysoff.push(new _this.DaysOfModel({
						dayoff_date: new Date(item.dayoff_date()).addDays(1).format(Otime.sdf)
					}, self));
				}
			};

			self.remove	= function(item){
				if (item.entity_dayoff_id())
					self.daysoff.destroy(item);
				else
					self.daysoff.remove(item);
			};
		};

		_this.TaskTypeListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.listing	= Otime.a([]);
			self._info	= {};
			self._info.is_edit_mode	= Otime.o(false);
			self._info.isTempLoad	= false;

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			var addNewItem	= function(){
				var newItem	= new _this.TaskTypeModel({is_billable:1});
				ko.editable(newItem);
				newItem.beginEdit();
				self.listing.push(newItem);
			};
			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
				{
					addNewItem();
				}
				else
				{
					self.listing.pop();
				}
			});
			if (data && data.otvalues)
			{
				var tmpArr	= [];
				data	= data.otvalues.setKeys(data.otkeys, function(item){
					tmpArr.push(new _this.TaskTypeModel(item));
				});
				self.listing(tmpArr);
			}

			self.setEdit	= function(item){
				var onBeginEdit	= function(){
					$.each(self.listing(), function(key, lstItem){
						ko.editable(lstItem);
						lstItem.beginEdit();
					});
					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("task_types", function(response){
						var tEdit	= $("#tasktype-edit");
						tEdit.html($.trim(response));
						tEdit = $("#tasktype-edit > div");
						ko.applyBindings(self, tEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};

			var newDataArr	= [];
			var deletedIds	= [];
			self.prepareData	= function(){
				var arr = self.listing();
				var deleted_task_types	= [];
				var retData	= [];
				newDataArr = [];
				var tmp = null;

				for (var i=0; i<arr.length; i++)
				{
					tmp	= arr[i];
					if (tmp._destroy)
					{
						deleted_task_types.push(tmp.task_type_id());
						deletedIds.push(tmp);
						continue;
					}

					if ((tmp.task_type_id()<=0 && tmp.name()!="") || tmp.isDirty())
					{
						var data	= JSON.parse(ko.toJSON(tmp));

						delete data.isDirty;
						delete data.isNew;
						delete data.hasChanges;

						data.is_billable	= data.is_billable ? 1 : 0;
						data.is_common		= data.is_common ? 1 : 0;

						retData.push(data);
						if (!tmp.task_type_id() || tmp.task_type_id()<=0)
						{
							newDataArr.push(tmp);
						}
					}
				}

				return {
					items: retData,
					deleted_task_types: deleted_task_types
				};
			};

			self.save	= function(item){
				var data	= self.prepareData();

				var finishIt	= function(){
					$.each(self.listing(), function(key, lstItem){
						lstItem.commit();
						lstItem.resetIsDirty();
					});
					self._info.is_edit_mode(false);
				};

				if (!data || (data.items.length <= 0 && data.deleted_task_types.length <=0))
				{
					finishIt();
					return false;
				}

				Otime.app.postData(new Otime.ContextModel("save/task_types", data, function(resp){
					resp	= resp.response;
					var tmp = null;
					for (var i=0; i<newDataArr.length; i++)
					{
						tmp	= newDataArr[i];
						if (!tmp.task_type_id())
						{
							tmp.task_type_id(resp.data.save_ids[i]);
							tmp.isNew(false);
						}
					}
					newDataArr	= [];

					if (data.deleted_task_types && deletedIds.length > 0)
					{
						for(var i=0; i<deletedIds.length; i++)
						{
							self.listing.remove(deletedIds[i]);
						}
						deletedIds	= [];
					}
					finishIt();
				},null,function(newval) {
					self.cancel();
					self._info.is_edit_mode(true);
				}));
			};

			self.cancel	= function(item){
				$.each(self.listing(), function(key, val){
					if(val._destroy)
					{
						delete val._destroy;
					}
					val.rollback();
				});
				self._info.is_edit_mode(false);
			};

			self.addNew	= function(item){
				if (self.listing().indexOf(item) == self.listing().length-1 && item.name() != "")
				{
					addNewItem();
				}
			};

			self.remove	= function(item){
				if (item.task_type_id())
					self.listing.destroy(item);
				else
					self.listing.remove(item);
			};

			self.sortData	= function(item){
				var parent	= item.sourceParent();
				var postData	= [];
				for (var i=0; i<parent.length; i++)
				{
					if (parent[i].task_type_id()>0)
					{
						postData.push({
							task_type_id: parent[i].task_type_id()
						});
					}
				}
				Otime.app.postData(new Otime.ContextModel("sort/task_types", {
					items: postData
				}));
			};
		};

		_this.TaskTypeModel	= function(data){
			var self	= this;

			data	= data || {};

			self.task_type_id	= Otime.o(data.task_type_id || 0);
			self.name			= Otime.o(data.name || "").extend({required:_this.language["ERR_TASK_TYPE_NAME_REQUIRED"], trackChange: true});
			self.hourly_rate	= Otime.o(data.hourly_rate || 0).extend({required:_this.language["ERR_TASK_TYPE_AMOUNT_REQUIRED"], trackChange: true});
			self.is_common		= Otime.o((data.is_common==1)).extend({trackChange: true});
			self.is_billable	= Otime.o((data.is_billable==1)).extend({trackChange: true});
			self.isNew			= Otime.o(self.task_type_id()>0 ? false : true);

			self.hourly_rate.subscribe(function(newVal){
				newVal	= newVal-0;
				if (newVal > 99999999)
				{
					newVal	= (newVal+"").substr(0,8)-0;
				}
				newVal	= newVal.toFixed(2)-0;
				self.hourly_rate(newVal);
			});

			self.resetIsDirty	= function(){
				for (var key in self)
				{
					Otime.i(self[key]) && self[key].isDirty && self[key].isDirty(false);
				}
			};

			self.isDirty	= Otime.c(function(){
				for (var key in self)
				{
					if (Otime.i(self[key]) && self[key].isDirty && self[key].isDirty())
					{
						return true;
					}
				}
				return false;
			});
		};

		_this.ExpensesTypeListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.listing	= Otime.a([]);

			self._info	= {};
			self._info.is_edit_mode	= Otime.o(false);
			self._info.isTempLoad	= false;

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			var addNewItem	= function(){
				var newItem	= new _this.ExpensesTypeModel();
				ko.editable(newItem);
				newItem.beginEdit();
				self.listing.push(newItem);
			};
			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
				{
					addNewItem();
				}
				else
				{
					self.listing.pop();
				}
			});
			if (data && data.otvalues)
			{
				var tmpArr	= [];
				data	= data.otvalues.setKeys(data.otkeys, function(item){
					tmpArr.push(new _this.ExpensesTypeModel(item));
				});
				self.listing(tmpArr);
			}

			self.setEdit	= function(item){
				var onBeginEdit	= function(){
					$.each(self.listing(), function(key, val){
						ko.editable(val);
						val.beginEdit();
					});

					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("expense_types", function(response){
						var tEdit = $("#expensestype-edit");
						tEdit.html($.trim(response));
						tEdit = $("#expensestype-edit > div");
						ko.applyBindings(self, tEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};

			var newDataArr	= [];
			var deletedIds	= [];
			self.prepareData	= function(){
				var arr = self.listing();
				var deleted_expenses_types	= [];
				var retData	= [];
				newDataArr = [];
				var tmp=null;
				for (var i=0; i<arr.length; i++)
				{
					tmp	= arr[i];
					if (tmp._destroy)
					{
						deleted_expenses_types.push(tmp.expense_type_id());
						deletedIds.push(tmp);
						continue;
					}

					if ((tmp.expense_type_id()<=0 && tmp.name()!="") || tmp.isDirty())
					{
						var data	= JSON.parse(ko.toJSON(tmp));
						delete data.isDirty;
						delete data._info;
						delete data.hasChanges;
						data.units	= $.trim(data.units.replace(/\//g, ""));
						retData.push(data);
						if (!tmp.expense_type_id() || tmp.expense_type_id()<=0)
						{
							newDataArr.push(tmp);
						}
					}
				}

				return {
					items: retData,
					deleted_expenses_types: deleted_expenses_types
				};
			};

			self.save	= function(item){
				var data	= self.prepareData();

				var finishIt	= function(){
					$.each(self.listing(), function(key, lstItem){
						lstItem.commit();
						lstItem.resetIsDirty();
					});
					self._info.is_edit_mode(false);
				};

				if (!data || (data.items.length <= 0 && data.deleted_expenses_types.length <=0))
				{
					finishIt();
					return false;
				}

				Otime.app.postData(new Otime.ContextModel("save/expense_types", data, function(resp){
					resp	= resp.response;
					var tmp = null;
					for (var i=0; i<newDataArr.length; i++)
					{
						tmp	= newDataArr[i];
						if (!tmp.expense_type_id())
						{
							tmp.expense_type_id(resp.data.save_ids[i]);
							tmp._info.isNew(false);
						}
					}

					newDataArr	= [];

					if (data.deleted_expenses_types && deletedIds.length > 0)
					{
						for(var i=0; i<deletedIds.length; i++)
						{
							self.listing.remove(deletedIds[i]);
						}
						deletedIds	= [];
					}

					finishIt();
				}));
			};

			self.cancel	= function(item){
				$.each(self.listing(), function(key, val){
					if(val._destroy)
					{
						delete val._destroy;
					}
					val.rollback();
				});
				self._info.is_edit_mode(false);
			};

			self.addNew	= function(item){
				if (self.listing().indexOf(item) == self.listing().length-1 && item.name() != "")
				{
					addNewItem();
				}
			};

			self.remove	= function(item){
				if (item.expense_type_id() > 0)
					self.listing.destroy(item);
				else
					self.listing.remove(item);
			};
		};

		_this.ExpensesTypeModel	= function(data){
			var self	= this;

			data	= data || {};

			self.expense_type_id	= Otime.o(data.expense_type_id || 0);
			self.name			= Otime.o(data.name || "").extend({required:_this.language["ERR_EXPENSE_NAME_REQUIRED"], trackChange: true});
			self.unit_price		= Otime.o(data.unit_price-0 || "").extend({required:_this.language["ERR_EXPENSE_AMOUNT_REQUIRED"], trackChange: true});
			self.units			= Otime.o(data.units || "").extend({trackChange: true});

			self._info	= {};
			self._info.amount_disp	= Otime.o("");
			self._info.isNew		= Otime.o(self.expense_type_id()>0?false:true);

			var updateSess = function(){
				var units	= self.units(),
					unit_price	= self.unit_price();

				units	= $.trim(units.replace(/\//g, ""));
				units	= units ? " / " + units:"";
				unit_price	= (_this.currency_html() || Otime.Currency || "") + unit_price;
				self._info.amount_disp(unit_price + units);
			};
			updateSess();
			self.unit_price.subscribe(updateSess);
			self.units.subscribe(updateSess);

			self.resetIsDirty	= function(){
				for (var key in self)
				{
					Otime.i(self[key]) && self[key].isDirty && self[key].isDirty(false);
				}
			};

			self.isDirty	= Otime.c(function(){
				for (var key in self)
				{
					if (Otime.i(self[key]) && self[key].isDirty && self[key].isDirty())
					{
						return true;
					}
				}
				return false;
			});
		};

		_this.TaskStatusListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.listing	= Otime.a([]);
			self.default_status	= Otime.o(0);

			self.default_status.subscribe(function(newVal){
				$.each(self.listing(), function(key, val){
					val.is_default(val._info.unique_id() == newVal);
				});
			});

			self._info	= {};
			self._info.is_edit_mode	= Otime.o(false);
			self._info.isTempLoad	= false;

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			var addNewItem	= function(){
				var newItem	= new _this.TaskStatusModel();
				ko.editable(newItem);
				newItem.beginEdit();
				self.listing.push(newItem);
			};
			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
				{
					addNewItem();
				}
				else
				{
					self.listing.pop();
				}
			});
			if (data)
			{
				var tmpArr	= [],
					tmpItem	= null;
				data	= data.otvalues.setKeys(data.otkeys, function(item){
					tmpItem	= new _this.TaskStatusModel(item);
					tmpArr.push(tmpItem);
					if (Number(tmpItem.is_default()))
					{
						self.default_status(tmpItem._info.unique_id());
					}
				});
				self.listing(tmpArr);
			}

			self.setEdit	= function(item){
				var onBeginEdit	= function(){
					$.each(self.listing(), function(key, val){
						ko.editable(val);
						val.beginEdit();
					});
					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("task_status", function(response){
						var tEdit = $("#task-status-edit");
						tEdit.html($.trim(response));
						tEdit = $("#task-status-edit > div");
						ko.applyBindings(self, tEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};

			var newDataArr	= [];
			var deletedIds	= [];
			self.prepareData	= function(){
				var arr = self.listing();
				var deleted_task_status	= [];
				var retData	= [];
				newDataArr	= [];
				var tmp=null;
				for (var i=0; i<arr.length; i++)
				{
					tmp	= arr[i];
					if (tmp._destroy)
					{
						deleted_task_status.push(tmp.task_status_id());
						deletedIds.push(tmp);
						continue;
					}

					if ((!tmp.task_status_id() && tmp.name()!="") || tmp.isDirty())
					{
						var data	= JSON.parse(ko.toJSON(tmp));
						delete data.isDirty;
						delete data._info;
						delete data.hasChanges;

						data.is_default	= Number(data.is_default);
						retData.push(data);
						if (!tmp.task_status_id() || tmp.task_status_id()<=0)
						{
							newDataArr.push(tmp);
						}
					}
				}

				return {
					items: retData,
					deleted_task_status: deleted_task_status
				};
			};

			self.save	= function(item){
				var data	= self.prepareData();
				var finishIt	= function(){
					$.each(self.listing(), function(key, lstItem){
						lstItem.commit();
						lstItem.resetIsDirty();
					});
					self._info.is_edit_mode(false);
				};

				if (!data || (data.items.length <= 0 && data.deleted_task_status.length <=0))
				{
					finishIt();
					return false;
				}

				Otime.app.postData(new Otime.ContextModel("save/task_status", data, function(resp){
					resp	= resp.response;
					var tmp = null;
					for (var i=0; i<newDataArr.length; i++)
					{
						tmp	= newDataArr[i];
						if (!tmp.task_status_id())
						{
							tmp.task_status_id(resp.data.save_ids[i]);
							tmp._info.isNew(false);
						}
					}
					newDataArr	= [];
					if (data.deleted_task_status && deletedIds.length > 0)
					{
						for(var i=0; i<deletedIds.length; i++)
						{
							self.listing.remove(deletedIds[i]);
						}
						deletedIds	= [];
					}
					finishIt();
				}));
			};

			self.cancel	= function(item){
				$.each(self.listing(), function(key, val){
					if(val._destroy)
					{
						delete val._destroy;
					}
					val.rollback();
				});

				self._info.is_edit_mode(false);
			};

			self.addNew	= function(item){
				if (self.listing().indexOf(item) == self.listing().length-1 && item.name() != "")
				{
					addNewItem();
				}
			};

			self.remove	= function(item){
				if (item.task_status_id() > 0)
					self.listing.destroy(item);
				else
					self.listing.remove(item);
			};

			self.sortData	= function(item){
				var parent	= item.sourceParent();
				var postData	= [];
				for (var i=0; i<parent.length; i++)
				{
					if (parent[i].task_status_id()>0)
					{
						postData.push({
							task_status_id: parent[i].task_status_id()
						});
					}
				}
				Otime.app.postData(new Otime.ContextModel("sort/task_status",{
					items: postData
				}));
			};
		};

		_this.TaskStatusModel	= function(data){
			var self	= this;

			data	= data || {};

			self.task_status_id	= Otime.o(data.task_status_id || 0);
			self.name			= Otime.o(data.name || "").extend({required:_this.language["ERR_TASK_STATUS_NAME_REQUIRED"], trackChange: true});
			//self.text_color		= Otime.o(data.text_color || "#000000").extend({trackChange: true});
			self.bg_color = Otime.o(data.bg_color || Otime.bgpicker_colors[Math.floor(Math.random() * Otime.bgpicker_colors.length)]);
			self.status_icon	= Otime.o(data.status_icon || "").extend({trackChange: true});
			self.is_default		= Otime.o(data.is_default || false).extend({trackChange: true});
			self.system_defined		= Otime.o(data.system_defined || '');


			self._info	= {};
			self._info.isNew	= Otime.o(!self.task_status_id());
			self._info.unique_id		= Otime.o(new Date().getTime()+Math.round(Math.random()*100000));

			self.resetIsDirty	= function(){
				for (var key in self)
				{
					if (Otime.i(self[key]) && self[key].isDirty)
					{
						self[key].originalValue	= self[key]();
						self[key].isDirty(false);
					}
				}
			};

			self.isDirty	= Otime.c(function(){
				for (var key in self)
				{
					if (Otime.i(self[key]) && self[key].isDirty && self[key].isDirty())
						return true;
				}
			});
		};

		_this.UserDepartmentListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.listing = Otime.a([]);
			self.task_types = Otime.a();

			if (_this.appModel.taskTypes() && _this.appModel.taskTypes().listing)
			{
				self.task_types(_this.appModel.taskTypes().listing());
			}

			self._info	= {};
			self._info.is_edit_mode	= Otime.o(false);
			self._info.isTempLoad	= false;

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			var addNewItem	= function(){
				var newItem	= new _this.UserDepartmentModel();
				ko.editable(newItem);
				newItem.beginEdit();
				self.listing.push(newItem);
			};

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
				{
					addNewItem();
				}
				else
				{
					self.listing.pop();
				}
			});

			if (data && data.otvalues)
			{
				var tmpArr	= [];
				data	= data.otvalues.setKeys(data.otkeys, function(item){
					tmpArr.push(new _this.UserDepartmentModel(item));
				});
				self.listing(tmpArr);
			}

			self.setEdit	= function(item){
				var onBeginEdit	= function(){
					$.each(self.listing(), function(key, val){
						ko.editable(val);
						val.beginEdit();
					});
					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("departments", function(response){
						var tEdit = $("#department-edit");
						tEdit.html($.trim(response));
						tEdit = $("#department-edit > div");
						ko.applyBindings(self, tEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};

			var newDataArr	= [];
			var deletedIds	= [];
			self.prepareData	= function(){
				var arr = self.listing();
				var deleted_departments	= [];
				var retData	= [];
				newDataArr = [];
				var tmp=null;
				var tt_cnt = self.task_types().length;

				for (var i=0; i<arr.length; i++)
				{
					tmp	= arr[i];
					if (tmp._destroy)
					{
						deleted_departments.push(tmp.user_dept_id());
						deletedIds.push(tmp);
						continue;
					}

					if ((!tmp.user_dept_id() && tmp.department()!="") || tmp.isDirty())
					{
						var data	= JSON.parse(ko.toJSON(tmp));
						if (tt_cnt==data.task_types.length) {
							data.task_types	= "";	
						} else 
							data.task_types	= data.task_types.join(",");
						delete data.isDirty;
						delete data._info;
						delete data.hasChanges;
						retData.push(data);
						if (!tmp.user_dept_id() || tmp.user_dept_id()<=0)
						{
							newDataArr.push(tmp);
						}
					}
				}

				return {
					items: retData,
					deleted_departments: deleted_departments
				};
			};

			self.save	= function(item){
				var data	= self.prepareData();
				var finishIt	= function(){
					$.each(self.listing(), function(key, lstItem){
						lstItem.commit();
						lstItem.resetIsDirty();
					});
					self._info.is_edit_mode(false);
				};
				if (!data || (data.items.length <= 0 && data.deleted_departments.length <=0))
				{
					finishIt();
					return false;
				}
				Otime.app.postData(new Otime.ContextModel("save/departments", data, function(resp){
					resp	= resp.response;
					var tmp = null;
					for (var i=0; i<newDataArr.length; i++)
					{
						tmp	= newDataArr[i];
						if (!tmp.user_dept_id())
						{
							tmp.user_dept_id(resp.data.save_ids[i]);
							tmp._info.isNew(false);
						}
					}
					newDataArr	= [];
					if (data.deleted_departments && deletedIds.length > 0)
					{
						for(var i=0; i<deletedIds.length; i++)
						{
							self.listing.remove(deletedIds[i]);
						}
						deletedIds	= [];
					}
					finishIt();
				}));
			};

			self.cancel	= function(item){
				$.each(self.listing(), function(key, val){
					if(val._destroy)
					{
						delete val._destroy;
					}
					val.rollback();
				});

				self._info.is_edit_mode(false);
			};

			self.addNew	= function(item){
				if (self.listing().indexOf(item) == self.listing().length-1 && item.department() != "")
				{
					addNewItem();
				}
			};

			self.remove	= function(item){
				if (item.user_dept_id() > 0)
					self.listing.destroy(item);
				else
					self.listing.remove(item);
			};
		};

		_this.UserDepartmentModel	= function(data){
			var self	= this;

			data	= data || {};

			self.user_dept_id	= Otime.o(data.user_dept_id || 0);
			self.department		= Otime.o(data.department || "").extend({required:_this.language["ERR_USER_DEPT_NAME_REQUIRED"], trackChange: true});
			self.task_types 	= Otime.a(data.task_types?data.task_types.split(","):[]).extend({trackChange: true});;
			
			self._info	= {};
			self._info.isNew	= Otime.o(!self.user_dept_id());

			self.resetIsDirty	= function(){
				for (var key in self)
				{
					Otime.i(self[key]) && self[key].isDirty && self[key].isDirty(false);
				}
			};

			self.isDirty	= Otime.c(function(){
				for (var key in self)
				{
					if (Otime.i(self[key]) && self[key].isDirty && self[key].isDirty())
						return true;
				}
				return false;
			});
		};

		
		// web hooks model
		_this.AddonsListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.listing	= Otime.a([]);

			self._info	= {};
			self._info.is_edit_mode	= Otime.o(false);
			self._info.edit_addon	= Otime.o(false);
			self._info.isTempLoad	= false;

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			var addNewItem	= function(){
				var newItem	= new _this.AddonsModel();
				ko.editable(newItem);
				newItem.beginEdit();
				self.listing.push(newItem);
			};

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
				{
					addNewItem();
				}
				else
				{
					self.listing.pop();
				}
			});

			if (data.otvalues)
			{
				var tmpArr	= [];
				data	= data.otvalues.setKeys(data.otkeys, function(item){
					tmpArr.push(new _this.AddonsModel(item));
					self._info.edit_addon(self._info.edit_addon() || (item.is_active && !(item.is_enabled-0)));

				});
				self.listing(tmpArr);
			}

			self.setEdit	= function(item){
				var onBeginEdit	= function(){
					$.each(self.listing(), function(key, val){
						ko.editable(val);
						val.beginEdit();
					});
					// self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.Menu.loadURL("addons");
					Otime.app.load_template("addon", function(response){
						var tEdit	= $("#addons-edit");
						tEdit.html($.trim(response));
						tEdit = $("#addons-edit > div");
						ko.applyBindings(self, tEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};

			var newDataArr	= [];
			var deletedIds	= [];
			self.prepareData	= function(){
				var arr = self.listing();
				var deleted_departments	= [];
				var retData	= [];
				newDataArr = [];
				var tmp=null;
				for (var i=0; i<arr.length; i++)
				{
					tmp	= arr[i];
					if (tmp._destroy)
					{
						deleted_departments.push(tmp.user_dept_id());
						deletedIds.push(tmp);
						continue;
					}

					if ((!tmp.user_dept_id() && tmp.department()!="") || tmp.isDirty())
					{
						var data	= JSON.parse(ko.toJSON(tmp));
						delete data.isDirty;
						delete data._info;
						delete data.hasChanges;
						retData.push(data);
						if (!tmp.user_dept_id() || tmp.user_dept_id()<=0)
						{
							newDataArr.push(tmp);
						}
					}
				}

				return {
					items: retData,
					deleted_departments: deleted_departments
				};
			};

			self.save	= function(item){
				var data	= self.prepareData();
				var finishIt	= function(){
					$.each(self.listing(), function(key, lstItem){
						lstItem.commit();
						lstItem.resetIsDirty();
					});
					self._info.is_edit_mode(false);
				};
				if (!data || (data.items.length <= 0 && data.deleted_departments.length <=0))
				{
					finishIt();
					return false;
				}
				Otime.app.postData(new Otime.ContextModel("save/departments", data, function(resp){
					resp	= resp.response;
					var tmp = null;
					for (var i=0; i<newDataArr.length; i++)
					{
						tmp	= newDataArr[i];
						if (!tmp.user_dept_id())
						{
							tmp.user_dept_id(resp.data.save_ids[i]);
							tmp._info.isNew(false);
						}
					}
					newDataArr	= [];
					if (data.deleted_departments && deletedIds.length > 0)
					{
						for(var i=0; i<deletedIds.length; i++)
						{
							self.listing.remove(deletedIds[i]);
						}
						deletedIds	= [];
					}
					finishIt();
				}));
			};

			self.cancel	= function(item){
				$.each(self.listing(), function(key, val){
					if(val._destroy)
					{
						delete val._destroy;
					}
					val.rollback();
				});

				self._info.is_edit_mode(false);
			};

			self.addNew	= function(index){
				return function(item){
					if (index == self.listing().length-1 && item.department() != "")
					{
						addNewItem();
					}
				};
			};

			self.remove	= function(item){
				if (item.user_dept_id() > 0)
					self.listing.destroy(item);
				else
					self.listing.remove(item);
			};
		};

		_this.AddonsModel	= function(data){
			var self	= this;

			data	= data || {};

			self.user_dept_id	= Otime.o(data.user_dept_id || 0);
			self.addon		= Otime.o(data.app_name || "").extend({required:_this.language["ERR_USER_DEPT_NAME_REQUIRED"], trackChange: true});
			self.app_image	= Otime.o(($.trim(data.app_image) != "") ? (_this.IMG + data.app_image):"");
			self.is_enabled		= Otime.o(data.is_enabled || 0);

			self._info	= {};
			self._info.isNew		= Otime.o(!self.user_dept_id());

			self.resetIsDirty	= function(){
				for (var key in self)
				{
					Otime.i(self[key]) && self[key].isDirty && self[key].isDirty(false);
				}
			};

			self.isDirty	= Otime.c(function(){
				for (var key in self)
				{
					if (Otime.i(self[key]) && self[key].isDirty && self[key].isDirty())
						return true;
				}
				return false;
			});
		};

		_this.SmtpModel	= function(data){
			var self	= this;

			data	= data || {};

			self.smtp_host	= Otime.o(data.smtp_host || "");
			self.smtp_port	= Otime.o(data.smtp_port || "");
			self.smtp_user	= Otime.o(data.smtp_user || "");
			self.smtp_pass	= Otime.o(data.smtp_pass || "");
			self.smtp_from_name	= Otime.o(data.smtp_from_name || "");
			self.smtp_connection = Otime.o(data.smtp_connection || "");

			self._info	= {};
			self._info.is_edit_mode	= Otime.o(false);
			self._info.isTempLoad	= false;
			self._info.error	= data.error || "";

			self.save	= function(){
				if(self.hasChanges && self.hasChanges())
				{
					var data	= JSON.parse(ko.toJSON(self));
					delete data._info;
					delete data.hasChanges;

					Otime.app.postData(new Otime.ContextModel("save/smtp", data, function(resp){
						self.commit();
						self._info.is_edit_mode(false);
					}));
				}
			};

			self.testsmtp = function(){							
				var data	= JSON.parse(ko.toJSON(self));				
				Otime.app.postData(new Otime.ContextModel("test_smtp", data, function(resp){
					if(response){
						Otime.success_message("Mail Sent Successfully!",$('#alert_message'));
					}else{
						Otime.error_message(resp,$("#alert_message"));
					}
				}));
			};

			self.cancel	= function(){
				self.rollback();
				self._info.is_edit_mode(false);
			};

			var onBeginEdit	= function(){
				ko.editable(self);
				self.beginEdit();
				self._info.is_edit_mode(true);
			};

			self.setEdit	= function(){
				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("smtp", function(response){
						var cEdit = $("#smtp-edit");
						cEdit.html($.trim(response));
						cEdit = $("#smtp-edit > div");
						ko.applyBindings(self, cEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};
		};

// SURESH
		_this.CustomFieldsModel = function(data){

			var self = this;

			data = data || {};

			self.listing = Otime.a([]);

			self._info	= {};
			self._info.is_edit_mode	= Otime.o(false);
			self._info.isTempLoad	= false;
			self.columns = Otime.a();

			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			var addNewItem	= function(){
				var newItem	= new _this.CustomFieldModel();
				ko.editable(newItem);
				newItem.beginEdit();
				self.listing.push(newItem);
			};
			self._info.is_edit_mode.subscribe(function(newVal){
				if (newVal)
				{
					addNewItem();
				}
				else
				{
					self.listing.pop();
				}
			});			

			if (data && data.custom_fields && data.custom_fields.otvalues)
			{
				var enabledCols = [];
				self.columns();
				var tmpArr = [], tmpItem = null;
				_this.custom_mod.forEach(function (itm) {
					itm.fEnable = 0;
				});

				data.custom_fields = data.custom_fields.otvalues.setKeys(data.custom_fields.otkeys, function (item) {
					if(item.isSys==1){
						item.id = item.id - 0;
						item.fEnable = (!item.fId) ? 0 : 1;
						item.fType = item.fType || ("cf_" + item.id);

						if (taskColumns[item.fType]) {
							item.fName = taskColumns[item.fType].fName;
						}

						if (_this.cfByFCode[item.fType]) {
							Object.assign(_this.cfByFCode[item.fType], item);
						}
						else {
							_this.cfByFCode[item.fType] = item;
							_this.custom_mod.push(item);
						}
					}else{
						tmpItem	= new _this.CustomFieldModel(item);
						tmpArr.push(tmpItem);
					}
				});

				self.listing(tmpArr);

				//sortCustomFields();

				var enabledCols = [];
				self.columns();

				$.each(_this.custom_mod, function (key, val) {
					if(val.fCode=='SP'){
						if(Otime.isSPRINT){
							if (typeof val.fEnable === "undefined") {
								val.fEnable = 1;
							}
							enabledCols.push(_this.cfByFCode[val.fType]);
							self.columns.push(_this.cfByFCode[val.fType]);
						}
					}else{
						if (typeof val.fEnable === "undefined") {
							val.fEnable = 1;
						}
						enabledCols.push(_this.cfByFCode[val.fType]);
						self.columns.push(_this.cfByFCode[val.fType]);
					}
				});
			}

			self.setEdit	= function(item){
				var onBeginEdit	= function(){
					$.each(self.listing(), function(key, val){
						ko.editable(val);
						val.beginEdit();
					});
					self._info.is_edit_mode(true);
				};

				if(self._info.isTempLoad == false)
				{
					Otime.app.load_template("customfield", function(response){
						var tEdit = $("#custom-field-edit");
						tEdit.html($.trim(response));
						tEdit = $("#custom-field-edit > div");
						ko.applyBindings(self, tEdit.get(0));
						self._info.isTempLoad	= true;
						onBeginEdit();
					});
				}
				else
				{
					onBeginEdit();
				}
			};

			var newDataArr	= [];
			var deletedIds	= [];
			self.prepareData	= function(){
				var arrFields = self.columns();
				var saveData = {
					mId: 0,
					mType: "T",
					fields: []
				};

				var ordNo = 0;
				$.each(self.columns(), function (key, val) {
					if (val.fEnable) {
						val.id = val.id - 0;
						saveData.fields.push({
							fId: val.id || 0,
							fCode: val.fType,
							fName: val.fName,
							// ordNo: val.ordNo - 0
							ordNo: ++ordNo
						});
					}
				});

				var arr = self.listing();
				var deleted_fields	= [];
				var retData = [];
				newDataArr = [];
				var tmp = null;
				for (var i=0; i<arr.length; i++)
				{
					tmp	= arr[i];
					if (tmp._destroy)
					{
						deleted_fields.push(tmp.id());
						deletedIds.push(tmp);
						continue;
					}

					if (tmp.fName() != "" && (!tmp.id() || tmp.isDirty()))
					{
						var data	= JSON.parse(ko.toJSON(tmp));
						if (data.fOptions)
						{
							if (data.fOptions.items)
							{
								var fOptions = {
									def: data.fOptions.def,
									items: []
								};

								$.each(data.fOptions.items, function(key, opt){
									if (opt.val)
									{
										fOptions.items.push(opt);
									}
								});
								data.fOptions = fOptions;
							}
							/*
							if (data.fOptions.items)
							{
								data.fOptions.items = data.fOptions.items.split(",");
							}
							*/
							data.fOptions = JSON.stringify(data.fOptions);
						}

						delete data.isDirty;
						delete data._info;
						delete data.hasChanges;

						retData.push(data);
						if (!tmp.id() || tmp.id()<=0)
						{
							newDataArr.push(tmp);
						}
					}
				}

				return {
					items: retData,
					deleted_fields: deleted_fields,
					save_fields: saveData
				};
			};

			self.save = function(item){
				var data = self.prepareData();

				var finishIt	= function(){
					$.each(self.listing(), function(key, lstItem){
						lstItem.commit();
						lstItem.resetIsDirty();
					});
					self._info.is_edit_mode(false);
				};				

				/*if (!data || (data.items.length <= 0 && data.deleted_fields.length <=0))
				{
					finishIt();
					return false;
				}*/

				if(data && (data.save_fields.fields.length > 0 || (data.items.length > 0 && data.deleted_fields.length > 0))){
					Otime.app.postData(new Otime.ContextModel("fields/save", data, function(resp){
						resp	= resp.response;
						var tmp = null;
						for (var i=0; i<newDataArr.length; i++)
						{
							tmp	= newDataArr[i];
							if (!tmp.id())
							{
								tmp.id(resp.save_ids[i]);
								// tmp._info.isNew(false);
							}
						}
						newDataArr	= [];
						if (data.deleted_fields && deletedIds.length > 0)
						{
							for(var i=0; i<deletedIds.length; i++)
							{
								self.listing.remove(deletedIds[i]);
							}
							deletedIds	= [];
						}
						finishIt();
					}), true);
				}else{
					finishIt();
					return false;
				}
			};

			self.cancel	= function(item){
				$.each(self.listing(), function(key, val){
					if(val._destroy)
					{
						delete val._destroy;
					}
					val.rollback();
				});

				self._info.is_edit_mode(false);
			};

			self.addNew	= function(item){
				if (self.listing().indexOf(item) == self.listing().length-1 && item.fName() != "")
				{
					addNewItem();
				}
			};
			
			self.remove	= function(item){
				if (self.listing().indexOf(item) == self.listing().length-1) {
					return;
				}

				if (item.id() > 0)
					self.listing.destroy(item);
				else
					self.listing.remove(item);
			};

			self.sortData	= function(item){
				var parent	= item.sourceParent();
				var postData	= [];
				for (var i=0; i<parent.length; i++)
				{
					if (parent[i].id()>0)
					{
						postData.push({
							id: parent[i].id()
						});
					}
				}
				Otime.app.postData(new Otime.ContextModel("sort/customfield",{
					items: postData
				}));
			};
		};

		_this.CustomFieldModel	= function(data){
			var self	= this;

			data	= data || {};

			self.id	= Otime.o(data.id || 0);
			self.fName = Otime.o(data.fName || "").extend({required:_this.language["ERR_CUSTOM_FIELD_NAME_REQUIRED"], trackChange: true});
			self.fType = Otime.o(data.fType || "text").extend({trackChange: true});
			self.mType = Otime.o(data.mType || "T").extend({trackChange: true});

			if (data.fOptions && typeof data.fOptions === "string")
			{
				data.fOptions = JSON.parse(data.fOptions);
			}
			self.fOptions = data.fOptions || {
				def: "",
				items: []
			};

			if (self.fOptions.items)
			{
				if (!Array.isArray(self.fOptions.items))
				{
					try {
						self.fOptions.items = JSON.parse(self.fOptions.items);
					} catch (e) {
						self.fOptions.items = self.fOptions.items.split(",");
						var optItems = [];
						for (var i=0, iLen=self.fOptions.items.length; i<iLen; i++)
						{
							optItems.push({
								val: self.fOptions.items[i],
								bg: ""
							});
						}
						self.fOptions.items = optItems;
					}
				}
			}

			if (!self.fOptions.items || typeof self.fOptions.items !== "function")
			{
				var optItems = [];
				$.each(self.fOptions.items, function(k, v){
					optItems.push(new _this.CFOptions(v));
				});
				self.fOptions.items = Otime.a(optItems || []).extend({trackChange: true});
			}

			self.fOptions.items.push(new _this.CFOptions());
			self.fOptions.def = Otime.o(data.fOptions && data.fOptions.def ? data.fOptions.def : "");

			self.removeOpt = function(opt){
				if (self.fOptions.items().indexOf(opt) == self.fOptions.items().length-1) {
					return;
				}
				self.fOptions.items.splice(self.fOptions.items().indexOf(opt), 1);
			};

			self.addNewOpt = function(opt){
				if (self.fOptions.items.indexOf(opt) == self.fOptions.items().length-1 && opt.val())
				{
					self.fOptions.items.push(new _this.CFOptions());
				}
			};

			for (var i=0, iLen=self.fOptions.items.length; i<iLen; i++)
			{
				self.fOptions.items[i].val = Otime.o(self.fOptions.items[i].val);
				self.fOptions.items[i].bg = Otime.o(self.fOptions.items[i].bg);
			}

			var popElem = null;
			self.showPopOver = function(itm, e){
				popElem = $(e.target).next();
				$(".right-popover").not(popElem).hide();
				popElem.toggle();
				// Update default selected field.
				self.fOptions.def.valueHasMutated();
/*
				var handler = function(e) {
					setTimeout(function() {
						if (!popElem.is($(e.target)) && popElem.has($(e.target)).length === 0) {
							$(".right-popover").hide();
							$(document).unbind("mousedown", handler);
						}
					}, 50);
				};

				$(document).bind("mousedown", handler);
*/
			};

			self.closePopOver = function(){
				$(".right-popover").hide();
			};

			self.resetIsDirty = function(){
				for (var key in self)
				{
					Otime.i(self[key]) && self[key].isDirty && self[key].isDirty(false);
				}
			};

			self.isDirty	= Otime.c(function(){
				for (var key in self)
				{
					if (Otime.i(self[key]) && self[key].isDirty && self[key].isDirty())
					{
						return true;
					}
					else if (self.fOptions.items.isDirty())
					{
						return true;
					}
				}
				return false;
			});
		};

		_this.CFOptions = function(data){
			var self = this;

			data = data || {};

			self.val = Otime.o(data.val || "");
			self.bg = Otime.o(data.bg || "");
		};

		_this.loadTemplates	= function(clbk, data){
			var url	= Otime.siteUrl + '/settings/tmpl';
			Otime.loadTemplates(url, {
				v: Otime.version
//				upl: (data.show_update_link ? 1 : 0),
//				abt: (data.show_about ? 1 : 0)
			}, function(content){
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
			}, "entitysetting_" + Otime.version);
		};

		_this.init	= function(){
			Otime.unbind();

			_this.container	= $("#entity-setting");

			_this.appModel	= new _this.EntityListModel();
			ko.applyBindings(_this.appModel, _this.container.get(0));

			_this.currency_html	= Otime.o(Otime.Currency || "&#8377;");

			Otime.app.loadData(new Otime.ContextModel('info', null, function(resp){
				resp	= resp.response;
				_this.appModel.company(new _this.CompanyModel(resp));
				_this.appModel.datetime(new _this.DateTimeModel(resp));
				_this.appModel.timesheet(new _this.TimesheetModel(resp));
				_this.appModel.invoice(new _this.InvoiceModel(resp));
				_this.appModel.smtp(new _this.SmtpModel(resp ? (resp.smtp || {}) : {}));
			}));

			Otime.app.loadData(new Otime.ContextModel("info/calendar", null, function(resp){
				resp	= resp.response;
				_this.appModel.calendar(new _this.CalendarModel(resp));
			}));

			Otime.app.loadData(new Otime.ContextModel('info/task_types', null, function(resp){
				resp	= resp.response;
				_this.appModel.taskTypes(new _this.TaskTypeListModel(resp));
			}));

			Otime.app.loadData(new Otime.ContextModel("info/project_status", null, function(resp){
				resp	= resp.response;
				_this.appModel.projectStatus(new _this.ProjectStatusListModel(resp));
			}));

			Otime.app.loadData(new Otime.ContextModel("info/expense_types", null, function(resp){
				resp	= resp.response;
				_this.appModel.expenses(new _this.ExpensesTypeListModel(resp));
			}));

			Otime.app.loadData(new Otime.ContextModel("info/task_status", null, function(resp){
				resp	= resp.response;
				_this.appModel.taskStatus(new _this.TaskStatusListModel(resp));
			}));

			Otime.app.loadData(new Otime.ContextModel("info/departments", null, function(resp){
				resp	= resp.response;
				_this.appModel.department(new _this.UserDepartmentListModel(resp));
			}));
			
			Otime.app.loadData(new Otime.ContextModel("info/addons", null, function(resp){
				resp	= resp.response;
				_this.appModel.addon(new _this.AddonsListModel(resp));
			}));

			Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + "/fields/items", null, function(resp){
				resp	= resp.response;
				_this.appModel.customFields(new _this.CustomFieldsModel(resp));
			}), true);

			return true;
		};
	};
}(window.Otime));
