﻿(function(Otime){

	Otime.Expenses	= new function Expenses(){
//		"use strict";

		var _this	= this;

		_this.name	= "expenses";

		_this.model	= "ExpenseListModel";

		_this.language	= null;

		_this.user_details	= null;

		_this.projects	= null;

		_this.months	= null;

		_this.appModel	= null;

		_this.is_edit_mode	= null;

		_this.ExpenseListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.today			= new Date();
			self.date			= Otime.o(self.today);
			self.current_date	= Otime.o(self.date());
			self.listing		= Otime.a([]);
			self.appr_listing	= Otime.a([]);
			self.users			= Otime.a([]);
			self.sel_user		= Otime.o(["0"]);
			self.clients		= Otime.a([]);
			self.sel_client		= Otime.o(["0"]);
			self.projects		= Otime.o(["0"]);
			self.sel_project	= Otime.o(["0"]);
			self.f_projects		= Otime.o({});
			self.f_teams = Otime.a([]);
			$.each(Otime.Details.teams, function(key, val){
				self.f_teams.push(Object.assign({ id: "t" + val.team_id }, val));
			});

			self.categories		= Otime.o(["0"]);
			self.total_amount	= Otime.o(0);
			self.receipt_path	= Otime.o("");

			self.is_edit_mode	= Otime.o(false);
			self.selected_item	= Otime.o(null);

			var ret = false, oldVal	= [];
			self.sel_project.subscribe(function(oldValue){
				oldVal	= oldValue;
			}, null, "beforeChange");
			self.sel_project.subscribe(function(newVal){
				if (ret)
				{
					ret	= false;
					self.loadInfo();
					return true;
				}
				if (newVal.length <= 0)
				{
					ret	= true;
					self.sel_project(["0"]);
					return true;
				}
				if (Number(newVal[0]) <= 0)
				{
					ret	= true;
					if (oldVal.length==1 && newVal.length == 2)
					{
						newVal.splice(Number(oldVal[0] == newVal[1]), 1);
						self.sel_project(newVal);
						return true;
					}
					self.sel_project(["0"]);
					return true;
				}
				self.loadInfo();
			});

			var user_ret = false, user_oldVal	= [];
			self.sel_user.subscribe(function(oldValue){
				user_oldVal	= oldValue;
			}, null, "beforeChange");
			self.sel_user.subscribe(function(newVal){
				if (user_ret)
				{
					user_ret	= false;
					self.loadInfo();
					return true;
				}
				if (newVal.length <= 0)
				{
					user_ret	= true;
					self.sel_user(["0"]);
					return true;
				}
				if (Number(newVal[0]) <= 0)
				{
					user_ret	= true;
					if (user_oldVal.length==1 && newVal.length == 2)
					{
						newVal.splice(Number(user_oldVal[0] == newVal[1]), 1);
						self.sel_user(newVal);
						return true;
					}
					self.sel_user(["0"]);
					return true;
				}
				self.loadInfo();
			});

			var client_ret = false, client_oldVal	= [];
			self.sel_client.subscribe(function(oldValue){
				client_oldVal	= oldValue;
			}, null, "beforeChange");
			self.sel_client.subscribe(function(newVal){
				if (client_ret)
				{
					client_ret	= false;
					self.loadInfo();
					return true;
				}
				if (newVal.length <= 0)
				{
					client_ret	= true;
					self.sel_client(["0"]);
					return true;
				}
				if (Number(newVal[0]) <= 0)
				{
					client_ret	= true;
					if (client_oldVal.length==1 && newVal.length == 2)
					{
						newVal.splice(Number(client_oldVal[0] == newVal[1]), 1);
						self.sel_client(newVal);
						return true;
					}
					self.sel_client(["0"]);
					return true;
				}
				self.loadInfo();
			});

			self.approve_total_amount	= Otime.o(0);
			self.member					= Otime.o(false);
			self.current_month			= Otime.o(self.today.format("MM"));
			self.selected_month 		= Otime.o(self.today.format("MM"));
			self.sel_year 				= Otime.o(self.today.format("YYYY"));

			self._info	= {};

			self.addNew	= function(){
				var newItem	= new _this.ExpenseDetailModel();
				ko.editable(newItem);
				newItem.beginEdit();
				newItem._info.is_new(true);
				self.selected_item(newItem);
				self.is_edit_mode(true);
			};

			self.date.subscribe(function(newVal){
				self.loadInfo();
			});
		
			self.dtup	= function(item, element){
				self.date(new Date(self.date()).addMonth(1));
			};

			self.dtdown	= function(){
				self.date(new Date(self.date()).addMonth(-1));
			};

			self.approve_entry	= function(item){
				var data = {
					project_id: self.sel_project()
				};

				if(item.hasOwnProperty('expense_id'))
				{
					data	= {
						expense_id: item.expense_id()
					};
				}

				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/" + _this.name +'/approve', data, function(context){
					var response	= context.response;
					self.loadInfo();
				}), true);
			};

			self.load	= function(context){
				var data	= context.response || {};
				self.member(data.member);

				var tmpArr	= [];
				if (data.categories && data.categories.otvalues && Object.keys(data.categories.otvalues).length > 0)
				{
					data.categories	= data.categories.otvalues.setKeys(data.categories.otkeys, null, "expense_type_id");
					data.categories["0"] = {
						expense_type_id: 0,
						name: "", // "Select the Expenses Type",
						unit_price: 0,
						units: ""
					};
					self.categories(data.categories);
				}
				if (data.clients && data.clients.otvalues && Object.keys(data.clients.otvalues).length > 0)
				{
					tmpArr	= [{
						client_id: "0",
						client_name: _this.language['ALL_CLIENTS'] || "All Clients"
					}];
					data.clients	= data.clients.otvalues.setKeys(data.clients.otkeys, function(c){
						tmpArr.push({
							client_id: c.client_id,
							client_name: c.client_code + c.client_name
						});
					});
					self.clients(tmpArr);
				}

				if (data.attachments && Object.keys(data.attachments).length > 0 && data.attachments.otvalues && data.attachments.otvalues.length > 0)
				{
					data.attachments	= data.attachments.otvalues.setKeys(data.attachments.otkeys, null, "module_id");
				}

				self.listing([]);
				self.total_amount(0);
				if (data.items.otvalues && data.items.otvalues.length > 0)
				{
					var total	= 0;
					var lstData	= [];
					data.items.otvalues.setKeys(data.items.otkeys, function(item){
						item.attach_details = data.attachments[item.expense_id];
						lstData.push(new _this.ExpenseDetailModel(item));
						total	+= parseFloat(item.amount);
					});
					self.listing(lstData);
					self.total_amount(total.toFixed(2));
				}

				self.appr_listing([]);
				self.approve_total_amount(0);
				if (data.approve_items && data.approve_items.otvalues && data.approve_items.otvalues.length > 0)
				{
					var total	= 0;
					var lstData	= [];
					data.approve_items.otvalues.setKeys(data.approve_items.otkeys, function(item){
						item.attach_details = data.attachments[item.expense_id];
						lstData.push(new _this.ExpenseDetailModel(item));
						total	+= parseFloat(item.amount);
					});
					self.appr_listing(lstData);
					self.approve_total_amount(total.toFixed(2));
				}
			};
			
			self.resettotal = function()
			{
				// reset total
				var total	= 0;
				$.each(self.listing(), function(key, item){
					total	+= parseFloat(item.amount());
				});
				self.total_amount(total.toFixed(2));

				total=0;
				$.each(self.appr_listing(), function(key, item){
					total	+= parseFloat(item.amount());
				});
				self.approve_total_amount(total.toFixed(2));
			};

//			self.addentry	= function(){				
//				var lstData	= new _this.ExpenseDetailModel();
//				ko.editable(lstData);
//				lstData.beginEdit();
//				lstData._info.is_new(true);
//				self.listing.unshift(lstData);
//			};

			self.save	= function(item){
				var isNew		= item.expense_id()-0 <= 0;
				var img_name	= '';

				if(isNew && self.member() == false)
				{
					item.approved_by(_this.user_details.id);
				}

				var attachment	= [];

				var data	= self.prepareData(item);

				if(!(data.project_id-0) || !(data.expense_type_id-0) || (item.unit_price()-0 && !(data.quantity-0)) || !(data.amount-0))
				{
					alert("Required Field Missing");
					return false;
				}

				data.expense_date	= new Date(data.expense_date).format('YYYY-MM-DD');

				var saveData	= function(dataU){
					dataU	= dataU || {};

					Otime.app.postData(new Otime.ContextModel("save", data,  function(cont){
						var response	= cont.response;

						var det	= item.attach_details();
						if (det)
						{
							det.file_type(data.attach_details.file_type);
							det.file_name(data.attach_details.file_name.replace(/^.*\\/, ""));
							det.file_size(data.attach_details.file_size);
							det.encrypt_key(response.encrypt_key);
							item.attachment_id(response.attachment_id-0);
							det.attachment_id(response.attachment_id-0);
						}

						if (dataU.img_name)
						{
							self.moveAttachments(dataU.img_name, response.attachment_id);
						}
						item.expense_id(response.expense_id);
						item.commit();
						item._info.is_edit_mode(false);
						if (item._info.is_new())
						{
							item._info.is_new(false);
							self.listing.unshift(item);
						}
						// self.loadInfo();
						self.selected_item(null);
						self.is_edit_mode(false);
						self.resettotal();
					}));
					return true;
				};

				if(data.attach_receipt)
				{
					var filename	= data.attach_receipt; 
					var files		= filename.split('.');

					data.attach_details	= {
						file_type: files[1],
						file_name: files[0].replace(/^.*\\/, ""),
						file_size: item._info.fileapi.fileQueue[0].file.size,
						posted_by: _this.user_details.id
					};

					item._info.fileapi.onAfterUpload	= function(img_data){
						if (img_data && !img_data[0])
						{
							Otime.error_message(img_data[1], $("#alert_message"));
							// alert(img_data[1]);
							return;
						}

						var img_name = img_data[2].file_name;

						saveData({
							img_name: img_name
						});
					};
					item._info.fileapi.uploadQueue();		
				}
				else
				{
					saveData();
				}
				
				self.resettotal();
			};

			self.prepareData	= function(item){
				var tmp_file_api	= item._info.fileapi;
				delete item._info.fileapi;
				var data	= JSON.parse(ko.toJSON(item));
				item._info.fileapi	= tmp_file_api;

				if(item._info.fileapi.fileQueue[0])
				{
					data.attachment	= true;
				}
				else
				{
					data.attachment	= false;
					data.attach_receipt = "";
				}

				return data;
			};

			self.cancel	= function(item){
				item._info.fileapi.fileList && item._info.fileapi.clearList();
				item.rollback();
				if(item.expense_id() > 0)
				{
					item._info.is_edit_mode(false);
				}
				else
				{
					item.beginEdit();
				}
				self.selected_item(null);
				self.is_edit_mode(false);
			};

			self.reloadInfo	= function(){
				_this.is_edit_mode(false);
				var data	= {
					start_date: new Date(self.date()).getMonthStart().format("YYYY-MM-DD"),
					finish_date: new Date(self.date()).getMonthEnd().format("YYYY-MM-DD"),
					filter_project_id: self.sel_project(),
					filter_user_id: self.sel_user(),
					filter_client_id: self.sel_client()
				};

				Otime.app.loadData(new Otime.ContextModel('reload', data, function(cont){
					var total	= 0;
					var response	= cont.response;

					if (response.items.otvalues.length > 0)
					{
						var lstData	= [];
						response.items.otvalues.setKeys(response.items.otkeys, function(item){
							lstData.push(new _this.ExpenseDetailModel(item));
							total	+= parseFloat(item.amount);
						});
						self.listing(lstData);
						self.total_amount(total.toFixed(2));
					}
				}));
				return true;
			};
			
			self.loadFilters	= function(callback){
				var tmpArr	= [];

				if (Otime.Details.all_projects)
				{
					var tmp	= JSON.parse(JSON.stringify(Otime.Details.getActiveProjects()));

					tmp.splice(0, 0, {
						project_id: "0",
						project_name: "All my Projects"
					});

					self.f_projects(JSON.parse(JSON.stringify(tmp)));
					tmp[0]	= {
						project_id: "0",
						project_name: ""// "Select Projects..."
					};
					self.projects(tmp);
				}
				else
				{
					Otime.show_propop('Track Your Expenses', 'Create your project to track your expenses');
				}

				if (Otime.Details.all_users)
				{
					tmpArr	= JSON.parse(JSON.stringify(Otime.Details.getAllUsers()));
					tmpArr.splice(0, 0, {
						user_id: "0",
						user_name: "All Users"
					});
					self.users(tmpArr);
				}

/*
				Otime.app.loadData(new Otime.ContextModel('load_filters', null, function(context){
					var data	= context.response;
					var tmpArr	= [];

					if (data.categories.otvalues && Object.keys(data.categories.otvalues).length > 0)
					{
						data.categories	= data.categories.otvalues.setKeys(data.categories.otkeys, null, "expense_type_id");
						self.categories(data.categories);
					}

					if (data.clients && data.clients.otvalues && Object.keys(data.clients.otvalues).length > 0)
					{
						tmpArr	= [{
							client_id: "0",
							client_name: "All Clients"
						}];
						data.clients	= data.clients.otvalues.setKeys(data.clients.otkeys, function(c){
							tmpArr.push({
								client_id: c.client_id,
								client_name: c.client_code + c.client_name
							});
						});
						self.clients(tmpArr);
					}

					typeof callback == "function" && callback();
				}));
*/
				typeof callback == "function" && callback(true);
			};

			self.loadInfo	= function(isOnInit){
				_this.is_edit_mode(false);
				var data	= {
					start_date: new Date(self.date()).getMonthStart().format("YYYY-MM-DD"),
					finish_date: new Date(self.date()).getMonthEnd().format("YYYY-MM-DD")
				};

				data.filter_project_id = (self.sel_project().length > 0 ? self.sel_project() : []).join(",");
				data.filter_user_id	= (self.sel_user().length > 0 ? self.sel_user() : []).join(",");
				data.filter_client_id = (self.sel_client().length > 0 ? self.sel_client() : []).join(",");
				data.onInit = isOnInit ? 1 : 0;

				var pId = [], tId = [];
				$.each(self.sel_project(), function(key, val){
					if ((val+"")[0] == "t")
					{
						tId.push(val.replace("t", ""));
					}
					else
					{
						pId.push(val);
					}
				});
				data.filter_project_id = pId.join(",");
				data.filter_team_id = tId.join(",");

				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + "/" + _this.name +"/project_expenses", data, self.load), true);
			};

			self.edit	= function(item, elem){
				if (!self.is_edit_mode())
				{
					item._info.is_edit_mode(true);

					var tmp_file_api	= item._info.fileapi;
					delete item._info.fileapi;
					ko.editable(item);
					item._info.fileapi	= tmp_file_api;
					item.beginEdit();

					self.selected_item(item);
					self.is_edit_mode(true);
				}
			};

			self.remove	= function(item){
				if (item.expense_id() > 0 && confirm(_this.language["CONFIRM_DELETE"]) == true)
				{
					Otime.app.postData(new Otime.ContextModel({
						url: "delete/" + item.expense_id(),
						global: false,
						callback: function(cont){
							self.listing.remove(item);
							self.appr_listing.remove(item);
							self.resettotal();
						}
					}));
				}
			};	

			self.moveAttachments = function(file_name, attachment_id){
				var context	= new Otime.ContextModel("move_attachments", {
					file_name: file_name,
					attachment_id: attachment_id
				}, function(cont){
					var response	= cont.response;
					if(response[0])
						return true;
					else
						return false;
				});
				context.module_name	= "attachment";
				Otime.app.postData(context);
				return true;
			};
		};

		var getProjectExpenses = function(project_id, clbk){
			Otime.app.postData(new Otime.ContextModel("expensetypes/" + project_id, {
				
			}, function(context){
				var response = context.response;
				typeof clbk === "function" && clbk(response);
			}));
		};

		_this.ExpenseDetailModel = function(data){
			var self	= this;

			data	= data || {};

			if (data.expense_date)
			{
//				data.expense_date	= new Date(data.expense_date.replace(" ", "T"));
				data.expense_date	= Otime.stoj(data.expense_date);
			}
			else
			{
				data.expense_date	= new Date();
			}

			if(!data.user_image && _this.user_details.image && !data.invoice_id)
			{
				data.user_image = Otime.UMIP + _this.user_details.image;
			}
			else if(data.user_image)
			{
				data.user_image = Otime.UMIP + data.user_image;
			}

			self.expense_id			= Otime.o(data.expense_id || 0);
			self.expense_type_id	= Otime.o(data.expense_type_id || 0);
			self.project_id			= Otime.o(data.project_id || 0);
			self.approved_by		= Otime.o(data.approved_by || 0);

			self.quantity	= Otime.o(data.quantity-0 || "");
			self.unit_price	= Otime.o(data.unit_price-0 || "");
			self.amount		= Otime.o(data.amount-0 || "");

			var amtCalc	= function(){
				if (self.quantity()-0 && self.unit_price()-0)
					self.amount((self.unit_price() * self.quantity()).toFixed(2));
			}

			self.notes				= Otime.o(data.notes || "");
			self.expense_date		= Otime.o(data.expense_date);
			self.name				= Otime.o(data.name || _this.language["OTHER_EXPENSES"]);
			self.user_image			= Otime.o(data.user_image || Otime.baseUrl + 'assets/img/no_img_32.png');
			self.user_name			= Otime.o(data.first_name || _this.user_details.name);
			self.invoice_id			= data.invoice_id;
			self.attach_receipt		= Otime.o(data.attach_receipt || '');
			self.attach_details 	= Otime.o(null);
			self.attachment_id		= Otime.o(0);
			self.attachment_delete		= Otime.o(0);

			if (data.attach_details)
			{
				self.attach_details(new Otime.AttachmentDetailModel(data.attach_details));
				self.attachment_id(self.attach_details().attachment_id());
			}
			else
			{
				self.attach_details(new Otime.AttachmentDetailModel());
			}

			self._info	= {};
			self._info.hasEditPerm	= Otime.o(!!(data.proj_edit_permission-0) || false);
			self._info.is_new		= Otime.o(false);
			self._info.units		= Otime.o(data.units || "");
			self._info.is_edit_mode	= Otime.o(false);
			self._info.project_name	= Otime.o(data.project_name || "");
			self._info.project_code	= Otime.o(data.project_code || "");
			self._info.project_value	= Otime.o(self._info.project_code() + self._info.project_name());

			self.edit_permission	= Otime.o(!!(data.edit_permission-0) || false);

			self._info.fileapi	= new FileAPI({
				mimeTypes: Otime.allowedmimes,
			});
			self._info.fileapi.url	= Otime.siteUrl + '/attachment/expense_receipt_upload';
			self._info.fileapi.buttonClass	= "dn";

			self._info.fileapi.onRemoveFile	= function(){
				self.attach_receipt('');
				$('#expense-container div.file-uploader').attr('style','display:none');
			};

			self._info.fileapi.onAddFile	= function(param){
				$('#expense-container div.file-uploader').attr('style','display:block');
			};

			self._info.is_edit_mode.subscribe(function(newVal){
				_this.is_edit_mode(newVal);
			});

			self.quantity.subscribe(amtCalc);
			self.unit_price.subscribe(amtCalc);

			self.uploadDialog	= function(item, elem){
				$("#attach_receipt",$(elem.delegateTarget).parent()).trigger("click");
			};

			self.fileremove	= function(){
				self.attachment_id(0);
				self.attach_receipt('');
				self.attachment_delete(1);
			};

			self.project_id.subscribe(function(newVal){
				newVal	= Otime.Details.all_projects[newVal];

				if(newVal)
				{
					getProjectExpenses(newVal.project_id, function(resp){
						var parent = _this.appModel;
						var expenseTypes = [
							parent.categories()[0]
						];

						if (resp && resp.expense_type_ids && resp.expense_type_ids.length)
						{
							$.each(resp.expense_type_ids, function(k, v){
								expenseTypes.push(Otime.Details.all_expense_types[v]);
							});
						}
						else
						{
							$.each(Object.values(Otime.Details.all_expense_types), function(k, v){
								expenseTypes.push(v);
							});
						}
						parent.categories(expenseTypes);
					});

					self._info.project_name(newVal.project_name);
					self._info.project_code(newVal.project_code);
					self._info.project_value((newVal.project_code || "") + (newVal.project_name || ""));
				}
			});

			self.expense_type_id.subscribe(function(newVal){
				var value	= null;
				if (newVal && (value = _this.appModel.categories()[newVal]))
				{
					self.unit_price(value.unit_price-0 || 0);
					self._info.units(value.units);
					self.name(value.name);
				}
				else
				{
					self._info.units("");
					self.quantity(1);
					self.unit_price(0);
					self.name(_this.language["OTHER_EXPENSES"]);
				}
			});
		};

		_this.loadTemplates	= function(clbk, data){
			var url	= Otime.siteUrl + '/' + _this.name + '/tmpl';
			Otime.loadTemplates(url, {
				v: Otime.version,
				r: Otime.usr,
				m: data.m
			}, function(content){
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
			}, "exp_" + Otime.version + "_" + data.m);
		};

		_this.init	= function(){
			_this.list_container	= $("#expense-container");

			_this.user_details	= {
				id: Otime.userDetails.id,
				name: Otime.userDetails.name,
				image: Otime.userDetails.image
			};

			if(Object.keys(Otime.Details.all_projects).length <= 0)
			{
				$("body").addClass("loading");
				_this.list_container.removeClass("dib").hide();
				if (!Otime.Details.isInitialized)
				{
					Otime.Details.onReady(_this.init);
					return false;
				}
				Otime.show_propop('Track Your Time', 'Create your project to track your time');
				return false;
			}
			_this.list_container.hide().addClass("dib");
			$("body").removeClass("loading");

			Otime.unbind();

			//_this.user_details	= Otime.a([]);
			_this.months	= Otime.a([]);
			_this.is_edit_mode	= Otime.o();

			_this.appModel	= new _this.ExpenseListModel();

			ko.applyBindings(_this.appModel, _this.list_container.get(0));

			_this.appModel.loadFilters(_this.appModel.loadInfo);
		};
	};
}(window.Otime));
