﻿(function(Otime){

	Otime.Invoice	= new function Invoice(){
//		"use strict";

		var _this	= this;

		_this.name	= "invoice";

		_this.page	= "invoice";

		_this.isDeposit	= false;

		_this.model	= "InvoiceContentModel";

		_this.language	= null;

		_this.IID	= 0;

		_this.Status	= null;

		_this.is_slide_opened	= null;

		_this.filter_labels	= null;

		_this.Clients	= null;

		_this.Currency	= null;

		_this.CurrCode	= null;

		_this.deposit	= false;

		_this.approve_data	= null;

		_this.payment_selected	= null;

		_this.client_id	= null;
		
		_this.project_ids	= null;
		
		_this.project_names	= null;

		_this.statusList	= {};

		_this.invoice_status	= 'U';

		_this.listModel	= null;

		_this.date_filter	= null;

		_this.is_add_new	= 0;

		_this.addNew	= function(){
			_this.is_add_new	= 0;
			_this.listModel.addItem();
		};

		var newClient	= function(data){
			data	= data || {};
			_this.listModel.isNewAdd(1);

			var assignModel	= function(){
				var _newClient	= new Otime.Client.ClientContentModel();
				_newClient.save	= function(item){
					if (item.contacts()[0].name() == '')
					{
						alert("Atleast 1 contact needed");
						return false;
					}
					var postData	= Otime.Client.prepareData(item);
					Otime.app.postData(new Otime.ContextModel({
						url: Otime.siteUrl+"/clients/save",
						global: false,
						data: postData,
						callback: function(cont){
							var response = cont.response;
							if(response.client_id)
							{
								data.onSave	&& data.onSave({
									client_id: response.client_id,
									client_name: (item.client_code()?item.client_code()+" - ":"")+item.client_name()
								});
								_this.listModel.loadFilters();
							}
							_this.listModel.isNewAdd(0);
						}
					}), true);
				};

				_newClient.cancel	= function(item){
					data.onCancel && data.onCancel();
					_this.listModel.isNewAdd(0);
				};
				_this.listModel.newClient(_newClient);
			};

			if (!Otime.app.hasBinding(_this.client_container))
			{
				Otime.app.load_template(Otime.siteUrl + "/clients/template/edit", function(response){
					$($.trim(response)).attr("data-bind", "with:newClient").appendTo(_this.client_container);
					assignModel();
					ko.applyBindings({newClient:_this.listModel.newClient}, _this.client_container.get(0));
				}, true);
				return false;
			}
			else
			{
				assignModel();
			}
		};

		_this.InvoiceListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.items	= Otime.a([]);
			self.columns	= Otime.a(new Array());
			self.is_edit_mode	= Otime.o(false);
			self.is_view_mode	= Otime.o(false);
			self.is_slide_modes	= Otime.o(false);

			self.selectedItem	= Otime.o(null);

			self.emailPopUp	= Otime.o(null);
			self.paymentPopUp	= Otime.o(null);

			self.invoice_status	= Otime.o(_this.invoice_status || "U");

			self._info			= {};
			self._info.count_b	= Otime.o(''); // partial & submit
			self._info.count_d	= Otime.o(''); // draft
			self._info.count_p	= Otime.o(''); // full paid
			self._info.count_s	= Otime.o(''); // sent
			self._info.notify_text	= Otime.o('Loading..');
			self.clients		= Otime.a([]);
			self.sel_client		= Otime.o(["0"]);
			self.search_invoice = Otime.o('');
			self.is_comment_mode	= Otime.o(false);
			_this.CommentsHandler	= Otime.o(null);
			
			self.page	= 1;
			self.finish			= Otime.o(true);
//			self.show_no_data	= Otime.o(false); 
			self.show_more		= Otime.o(false);

			self.isNewAdd	= Otime.o(0);
			self.newClient	= Otime.o(null);

			var ret = false, oldVal	= [];
			self.sel_client.subscribe(function(oldValue){
				oldVal	= oldValue;
			}, null, "beforeChange");
			self.sel_client.subscribe(function(newVal){
				if (ret)
				{
					ret	= false;
					self.refresh();
					return true;
				}
				if (newVal.length <= 0)
				{
					ret	= true;
					self.sel_client(["0"]);
					return true;
				}
				if (Number(newVal[0]) <= 0)
				{
					ret	= true;
					if (oldVal.length==1 && newVal.length == 2)
					{
						newVal.splice(Number(oldVal[0] == newVal[1]), 1);
						self.sel_client(newVal);
						return true;
					}
					self.sel_client(["0"]);
					return true;
				}
				self.refresh();
			});
			
			self.search	= function(item, event){
				if (event.keyCode == 13)
				{
					if(!isNaN(item.search_invoice()))
					{
						self.refresh();
					}
					return false;
				}
				return true;
			};

			self.changeInvoice	= function(status){
				return function(item, elem){
					if (self.selectedItem())
						self.cancel_edit(self.selectedItem());

					self.search_invoice("");
					self.invoice_status(status);
					Otime.Menu.ReplaceURL((_this.deposit ? _this.name + "/deposit" : _this.name) + "/" + _this.statusList[self.invoice_status().toUpperCase()]);
					self.refresh();
				};
			};

			self.payment	= function(item){
				var newitem	= null;
				if (item.invoice_payment_id)
				{
					_this.payment_selected(item);
					var tmp	= JSON.parse(ko.toJSON(item));
					newitem	= new _this.PaymentModel(tmp);
				}
				else
				{
					newitem	= new _this.PaymentModel({});
					_this.payment_selected(newitem);
				}
				if (item instanceof _this.InvoiceContentModel == false && self.selectedItem())
				{
					item	= self.selectedItem();
				}
				item._info.payment_add(newitem);

				Otime.app.loadData(new Otime.ContextModel('outstanding_amount', {
					invoice_id: item.invoice_id(),
					client_id: item.client_id()
				}, function(cont){
					item._info.outstanding_amount(parseFloat(cont.response.outstanding_amount || 0).toFixed(2));
					newitem.invoice_id(item.invoice_id());
					newitem.invoice_number(item.invoice_number());
					$("#payment-modal").modal('show');
				}));
				self.paymentPopUp(item);
			};
			
			self.payment_remove	= function(item){
				var itm	= self.selectedItem();
				if (item.invoice_payment_id() > 0 && confirm(_this.language["DELETE_CONFIRM"]) == true)
				{
					Otime.app.postData(new Otime.ContextModel({
						url: "payment_delete/" + item.invoice_payment_id(),
						global: false,
						callback: function(){
//							if (self.selectedItem())
//								self.cancel_edit(self.selectedItem());
//							self.refresh();

							itm._info.payment_list.remove(item);
							var old_status = itm.status();
							itm.status((itm._info.payment_list().length > 0) ? 'b' : 's');
							if (old_status=='p') {
								self._info.count_p(self._info.count_p()-1);
								self._info.count_b(self._info.count_b()+1);
							}
							if (old_status!=itm.status()) {
								itm.change_status(itm.status());
							}
						}
					}));
					return true;
				}
			};

			self.payment_save = function(item) {
				var itm	= item._info.payment_add();
				var post_data = JSON.parse(ko.toJSON(itm));
				post_data.client_contact_id = item.client_contact_id();
				post_data.client_id = item.client_id();
				post_data.client_name = (item._info.client_code()?item._info.client_code()+" - ":"")+item._info.client_name();
				post_data.currency_code	= item.currency_code();

				/*if (isNaN(post_data.amount) || parseFloat(post_data.amount) <= 0)
				{
					alert(_this.language['AMOUNT_MUST_BE_GREATER_THAN_ZERO']);
					return false;
				}*/

				if (itm.invoice_payment_id()) {
						if (_this.pre_amount == itm.amount()) {
							var amount = (item._info.outstanding_amount()-0) + (_this.pre_amount-0);
							if (amount < itm.amount()) {
								alert(_this.language['PAYMENT_GREATER_THAN_BALANCE']);
								return false;
							}
						}
				} else {
					if(parseFloat(post_data.amount)  > item._info.outstanding_amount()) 
					{
						alert(_this.language['PAYMENT_GREATER_THAN_BALANCE']);
						return false;
					}
				}

				delete post_data._info;
				$("#payment-modal").modal('hide');
				Otime.app.loadData(new Otime.ContextModel('payment_save', post_data, function(cont){
					var data	= cont.response || {};

					if (!itm.invoice_payment_id())
					{
						itm.invoice_payment_id(data.invoice_payment_id);
						item._info.payment_list.push(itm);
					}
					else
					{
						var tmpPayment	= _this.payment_selected();
						if (tmpPayment)
						{
							$.each(tmpPayment, function(key, val){
								if (Otime.i(tmpPayment[key]))
								{
									tmpPayment[key](itm[key]());
								}
							});
						}
					}
					item.change_status(data.status);					
				}));
			};

			self.addItem	= function(item, elem){
				var newItem	= new _this.InvoiceContentModel(null, self);
				self.edit(newItem);
				self.viewItem(newItem);
				newItem.is_new(true);
//				self.items.push(newItem);
			};

			self.archiveItem = function(){
				return function(item, elem){
					var newval	= (item._info.is_archive()) ? 0 : 1;
					Otime.app.loadData(new Otime.ContextModel('archive_status/' + item.invoice_id(), {archive:newval}, function(cont){
						// any archive relate changes here
						self.refresh();
					}));
				};
			};

			self.edit	= function(item, elem){
				if (item.status() != 'd')
					return false;
				self.selectedItem(item);

//				Disabled due to slow performance.
//				ko.editable(item);
//				item.beginEdit();

				item.is_edit_mode(true);
				self.is_edit_mode(true);
				item.is_view_mode(false);
				self.is_view_mode(false);
				$("#dtype").selectpicker('refresh');
				if (item.details().length <= 0)
				{
					item.addNewDetail();
					item.addNewDetail();
					item.addNewDetail();
				}
				item.addNewDetail();
			};

			self.cancel_edit	= function(item, elem){
				item	= self.selectedItem();

				if (!item)
				{
					return false;
				}

				item.is_edit_mode(false);

				if(item.invoice_id()>0 && !item.is_view_mode()) 
				{
					item.is_view_mode(true);
					self.is_view_mode(true);
				}
				else
				{
					item.is_view_mode(false);
					self.is_view_mode(false);
					self.is_edit_mode(false);
					self.selectedItem(new _this.InvoiceContentModel(null, self));
				}

				$('#view-layout').removeClass('opened');
				$('#project-invoice-container').removeClass('opened');
				$('#project-invoice-container').html("");
				_this.comment_container.html("");
				_this.client_id(0);
				_this.project_ids([]);
				_this.project_names([]);
				_this.date_filter([]);

				self.is_slide_modes(false);
				self.is_comment_mode(false);
//				_this.is_slide_opened(false);
				Otime.Menu.ReplaceURL(_this.name + "/" + _this.statusList[self.invoice_status().toUpperCase()]);
			};

			self.remove	= function(item, elem){
				if ((item.invoice_id()) > 0)
				{
					Otime.app.postData(new Otime.ContextModel("delete/" + item.invoice_id(), null, function(){
						self.items.remove(self);
					}));
					self.refresh();
					return true;
				}
			};

			self.sort	= function(item, elem){
				var sortArr	= self.columns() || [];
				var sort_by = item;
				
				var columns = Object.keys(self.columns());
				for(var i=0, iLen=columns.length; i<iLen; i++) 
				{
					sortArr[columns[i]].is_sorted(false);
				}

				var arr	= self.items().sort(function(a, b){
					if(a._info[sort_by])
					{
						var x	= isNaN(a._info[sort_by]()) ? a._info[sort_by]() : Number(a._info[sort_by]()),
							y	= isNaN(b._info[sort_by]()) ? b._info[sort_by]() : Number(b._info[sort_by]());
					}
					else
					{
						var x	= isNaN(a[sort_by]()) ? a[sort_by]() : Number(a[sort_by]()),
							y	= isNaN(b[sort_by]()) ? b[sort_by]() : Number(b[sort_by]());
					}

					return x < y ? -1 : x > y ? 1 : 0;
				});
								
				sortArr[sort_by]	= sortArr[sort_by] || {
					is_asc: Otime.o(false),
					is_sorted: Otime.o(false)
				};
				sortArr[sort_by].is_asc(!sortArr[sort_by].is_asc());
				sortArr[sort_by].is_sorted(true);
				if (self.columns()[sort_by] && !self.columns()[sort_by].is_asc())
				{
					arr.reverse();
				}
				self.items(arr);
				self.columns(sortArr);
			};

			self.load_more	= function(){
				var url	= (_this.deposit) ? 'listing/deposit/' : 'listing/default/';
				self.page++;
				
				var context	= new Otime.ContextModel(url + self.page, {'status': self.invoice_status()}, function(cont){
					if (Object.keys(cont.response.items).length > 0)
					{
						$.each(cont.response.items, function(key, item){
							self.items.push(new _this.InvoiceContentModel(item, self));
						});
					}
					self.finish(cont.response.finish || false);
					self.show_more(cont.response.finish != true);
				});
				context.prepare	= "items";
				Otime.app.loadData(context);
			};

			var closeCommentsPane	= function(){
				self.is_comment_mode(false);
				$('#comment_layout').removeClass("opened").addClass("closed");
			};
			var showComments	= function(item, elem){
				var params	= {
					module: "invoice",
					module_type: "I",
					filter: "activity",
					close: function(){ closeCommentsPane(); }
				};
				if (item != null)
				{
					params["module_id"]	= item.invoice_id();
				}
				_this.CommentsHandler(Otime.Comments.init(params));
			};
			self.show_comments	= function(item, elem){
				item	= self.selectedItem();
				_this.UpdateContainers();
				if(self.is_comment_mode() == true)
				{
					closeCommentsPane();
					return;
				}
				else
				{
					if (!Otime.app.hasBinding(_this.comment_container))
					{
						Otime.app.load_template("activity", function(response){
							_this.comment_container.html($.trim(response));
							showComments(item, elem);
							ko.applyBindings(_this.CommentsHandler, $("#comments-container").get(0));
						});
					}
					else
					{
						showComments(item, elem);
					}
					self.is_comment_mode(true);
					_this.comment_container.addClass('opened').removeClass('closed');
				}
			};
		
			self.viewItem	= function(item){
				self.selectedItem(item);

				if (!Otime.app.hasBinding(_this.view_container))
				{
					var url	= _this.deposit ? "view/deposit" : "view";

					Otime.app.load_template(url, function(response){
						_this.view_container.html($.trim(response));
						ko.applyBindings(self.selectedItem, _this.view_container.get(0));
						self.viewItem(item);
					});
					return false;
				}

				if (item.invoice_id() > 0)
				{
					Otime.app.loadData(new Otime.ContextModel('info/' + item.invoice_id(), null, function(cont){
						self.is_edit_mode(false);
						item.is_view_mode(false);
						self.is_view_mode(false);
						item.load(cont);
						self.is_edit_mode(true);
						item.is_view_mode(true);
						self.is_view_mode(true);
					}));
					Otime.Menu.ReplaceURL(_this.name + "/" + _this.statusList[self.invoice_status().toUpperCase()] + "/" + item.invoice_id());
//					self.refresh();
				}
				else
				{
					Otime.app.loadData(new Otime.ContextModel('defaults', null, function(cont){
						item.last_used(cont.response.last || "");
						item.invoice_number(cont.response.next || "");
						item.due_date_mode(cont.response.due_date_mode || item.due_date_mode());
						if(_this.client_id()>0)
							item.client_id(_this.client_id());
					}));
				}
			};
			self.loadFilters	= function(callback){
				Otime.app.loadData(new Otime.ContextModel('load_filters', null, function(context){
					var data	= context.response;
				
					if ((data.clients && data.clients.otvalues) && Object.keys(data.clients.otvalues).length > 0)
					{
						var tmpArr	= [];
						tmpArr.push({
							client_id: "0",
							client_name: _this.language['ALL_CLIENTS'] || "All Clients"
						});
						data.clients	= data.clients.otvalues.setKeys(data.clients.otkeys, function(client){
							tmpArr.push({
								client_id: client.client_id,
								client_name: client.client_name
							});
						});
						self.clients(tmpArr);
					}

					if (typeof callback == "function")
					{
						callback();
					}
				}));
			};

			self.refresh	= function(){
				var url	= (_this.deposit) ? 'listing/deposit' : 'listing/default';
				self._info.notify_text("Loading..");
				var isBySearch	= (!!self.search_invoice() || !!(self.sel_client()[0]-0));

				var postData	= {
					invoice_number : self.search_invoice(),	
					status: self.invoice_status(),
					filter_client_id : (self.sel_client().length > 0 ? self.sel_client() : []).join(",")
				};

				postData.from_search	= isBySearch ? 1 : 0;

				self.page = 1;
				Otime.app.loadData(new Otime.ContextModel(url, postData, function(cont){
					var resp	= cont.response,
						flag0	= false;

					var tmpArr	= [];
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0)
					{
						var tmpModel	= null;
						resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(itm){
							tmpModel	= new _this.InvoiceContentModel(itm, self);
							if (_this.IID == tmpModel.invoice_id())
							{
								flag0	= true;
								self.selectedItem(tmpModel);
							}
							tmpArr.push(tmpModel);
						});
					}
					else
					{
						self._info.notify_text("No Data Found");
//						self.show_no_data(true);
					}

					if (resp.items_count)
					{
						var status	= ['d','b','p','s'],
							itm		= null;
						$.each(status, function(key, val){
							itm = resp.items_count[val] == undefined ? {count:0, status_res : val}:resp.items_count[val];
							self._info["count_"+itm.status_res](itm.count);
						});

						var keys	= Object.keys(resp.items_count);
						if(keys.length > 0 && postData.status != undefined)
						{
							if (postData.filter_client_id-0 || isNaN(postData.filter_client_id-0))
							{
								isBySearch	= false;
							}
							if (postData.invoice_number-0)
							{
								isBySearch	= true;
							}
							var key	= postData.status;
							if (isBySearch)
							{
								key	= keys[0].toUpperCase();
							}

							self.invoice_status({"B":"U", "U":"U", "D":"D", "P":"P", "A":"A", "R":"R"}[key]);
						}
						self._info.count_b(Number(self._info.count_b()) + Number(self._info.count_s()));
					}

					if(Otime.Menu.is_new)
					{
						self.addItem();
						Otime.Menu.is_new = false;
					}
					self.items(tmpArr);

					if (flag0 && self.selectedItem())
					{
						flag0	= false;
						_this.IID	= 0;
						self.viewItem(self.selectedItem());
					}

//					self.show_no_data(false);
//					self._info.notify_text("");

					self.show_more(resp.finish != true);
					self.finish(resp.finish || false);

					_this.is_add_new && _this.addNew();
				}));
			};
		};

		_this.InvoiceContentModel	= function(data, parent){
			var self	= this;

			data	= data || {};
			self._info	= {};
			self.newActivity	= Otime.o();
			self.timeline	= Otime.a();

			data.invoice_date		= (data.invoice_date ? Otime.stoj(data.invoice_date) : Otime.Date().getTime());
			data.due_date			= (data.due_date ? Otime.stoj(data.due_date) : Otime.Date().getTime());
			self.invoice_date		= Otime.o(new Date(data.invoice_date));
			self.invoice_id			= Otime.o(data.invoice_id || 0);
			self.invoice_number		= Otime.o(data.invoice_number || 0);
			self.due_date			= Otime.o(new Date(data.due_date));
			self.due_date_mode		= Otime.o(data.due_date_mode || 0);
			self.overdue			= Otime.o(true);

			if (data.status=='b' || data.status=='s') {
//				console.log(self.due_date());
				self.overdue(! self.due_date().isPast());
			}

			self.format_date			= Otime.o(Otime.dateFormat);
//			self.recurring_invoice   	= Otime.o(false);
			self.recurring_mode			= Otime.o(data.recurring_mode || 0);
			self.recurring_next_inv_date= Otime.o(data.recurring_next_inv_date ? Otime.stoj(data.recurring_next_inv_date) : new Date());
			self.recurring_auto			= Otime.o(!!(data.recurring_auto-0));
			self.last_updated_date		= Otime.o(Otime.stoj(data.last_updated_date));

			self.status_class			= Otime.o(_this.status_class[data.status] || _this.status_class['d']);

			var vars	= [
				"client_company", "phone_no", "subject", "notes",
				"is_discount", "discount_type", "discount_value", "discount_percentage", "discount_amount",
				"tax1_enable", "tax1_name", "tax1_percentage", "tax1_amount",
				"tax2_enable", "tax2_name", "tax2_percentage", "tax2_amount",
				"tax3_enable", "tax3_name", "tax3_percentage", "tax3_amount",
				"sub_total", "before_tax", "last_used", "is_tax_enable",
				// for email popup
				"popup_bind", "email_to", "email_cc", "email_subject", "email_url", "email_message", "email_file", "email_filepath",
				// for deposit invoice.
				"isDepTbl"
			];

			Otime.prepareObservable(vars, self);

			self.subject.isLocked	= false;
			self.onSubject	= function(){
				self.subject.isLocked	= true;
				return true;
			};
			self._info.import_config	= Otime.o(data.import_config || '');
			self._info.payment_amount	= Otime.o(parseFloat(data.payment_amount) || 0.00);
			self._info.remaining		= Otime.o(parseFloat(data.deposit_balance) || 0.00);
			var calc	= function(newVal){
				self._info.applied_invoice(self._info.payment_amount() - self._info.remaining());
			};
			self._info.remaining.subscribe(calc);
			self._info.payment_amount.subscribe(calc);
			self._info.applied_invoice	= Otime.o(self._info.payment_amount() - self._info.remaining());
			self._info.applied_list	= Otime.a([]);
			self._info.is_archive = Otime.o(Number(data.is_archive || 0));

			self.show_dep_tbl	= function(item){
				if (!item.isDepTbl())
				{
					Otime.app.loadData(new Otime.ContextModel('applied/' + item.invoice_id(), null, function(cont){
						var data	= cont.response || {};
						if(data.items.otvalues != undefined) {
							data.items	= data.items.otvalues.setKeys(data.items.otkeys);
							self._info.applied_list(data.items.slice());
							item.isDepTbl(true);
						}
					}));
				}
			};

			self.hide_dep_tbl	= function(item){
				item.isDepTbl(false);
				$(".deposit-table").remove();
			};

			self.client_id			= Otime.o(data.client_id || 0);
			self.client_contact_id	= Otime.o(data.client_contact_id || 0);
			self.address			= Otime.o(data.address || "");
			self._info.client_name	= Otime.o(data.client_name || "");
			self._info.client_code	= Otime.o(data.client_code || "");
			self._info.contacts		= Otime.a([]);
			self._info.contact_name	= Otime.o(data.contact_name || "");
			self._info.contact_email= Otime.o(data.contact_email || "");
			// Deposit Outstanding Amt.
			self._info.out_cr		= Otime.o(data.out_cr || 0);
			self._info.enable_check_all = Otime.o(false);
			self.project_listing	= Otime.a([]);

			self.is_deposit			=	Otime.o(data.is_deposit || 0);
			self.deposit_balance	=	Otime.o(data.deposit_balance || 0);

			self.amount				= Otime.o(parseFloat(data.amount || 0).toFixed(2));

			self.currency_code		= Otime.o(data.currency_code || _this.CurrCode);
			self._info.currency		= Otime.o(_this.Currency[self.currency_code()].currency_symbol || "");
			self.currency_code.subscribe(function(newVal){
				if (_this.Currency[newVal])
				{
					self._info.currency(_this.Currency[newVal].currency_symbol);
					$("#dtype").selectpicker('refresh');
				}
			});

			self._info.filters	= Otime.o(data.filters);

			self._info.date_filter_type	= Otime.o(data.date_filter_type || _this.dft || "ALL");
			self._info.date_filter_disp	= Otime.o(_this.language[_this.filter_labels[data.date_filter_type || _this.dft || "ALL"]]);

			self.today	= Otime.o(new Date().format("yyyy/mm/dd"));
			self.date	= Otime.o(new Date().format("yyyy/mm/dd"));
			self.date_disp	= Otime.o(new Date(self.date()).format(Otime.dateFormat));

			Otime.date_filter(self, _this);

			if (_this.date_filter().date_filter_type) {
				self._info.date_filter_type(_this.date_filter().date_filter_type || self._info.date_filter_type());
				self._info.date_filter_disp(_this.language[_this.filter_labels[_this.date_filter().date_filter_type || self._info.date_filter_type()]]);
				self.date_filter.from_date(_this.date_filter().from_date || self.date_filter.from_date());
				self.date_filter.to_date(_this.date_filter().to_date || self.date_filter.to_date());
			}


			// for invoice import
			self._info.invoice_hours		= Otime.o(true);
			self._info.detail_hours 		= Otime.o(data.detail_hours || '');
			self._info.invoice_expenses		= Otime.o(true);
			self._info.detail_expenses 		= Otime.o(data.detail_expenses || 'C');
			self._info.uninvoiced_hours			= Otime.o(0);
			self._info.uninvoiced_expenses		= Otime.o(0);
			self._info.gp_project		= Otime.o(true);
			self._info.gp_tasktype		= Otime.o(false);
			self._info.gp_member		= Otime.o(false);
			self._info.gp_date			= Otime.o(false);
			self._info.gp_activity		= Otime.o(false);
			self._info.project_ids		= Otime.a([]);

			self._info.payment_list	= Otime.a([]);
			self._info.payment_add	= Otime.o();
			self._info.total		= Otime.o(data.amount || 0);

			self._info.outstanding_amount		= Otime.o();
			self._info.status = Otime.a([]);
			self._info.actions = Otime.a(null);

			self.clients	= Otime.a([]);
			self.clients(new Array({client_id:0, client_name:_this.language['SELECT_CLIENT'] || 'Select any client...'}));
			if (Object.keys(_this.Clients).length > 0)
			{
					$.each(_this.Clients, function(key, val){
						self.clients.push({
							client_id: val.client_id,
							client_name: val.client_name
						});
					});
			}
			self.clients.push({client_id:'Separator', client_name:'---------------------------------'});
			self.clients.push({client_id:'-1', client_name:_this.language['ADD_CLIENT'] ||  'Add a Client'});

			self.project_details = function(inv){
				var post_data = {client_id : inv.client_id(), invoice_id : inv.invoice_id()};

			if (inv._info.date_filter_type()!='ALL') {
				$.extend(post_data, {
					start_date : new Date(inv.date_filter.from_date()).format(Otime.sdf),
					finish_date : new Date(inv.date_filter.to_date()).format(Otime.sdf)
				});
			}
			if(Otime.Invoice.project_ids().length>0) {
				$.extend(post_data, {'project_id': Otime.Invoice.project_ids(), 'filter_project_id':  Otime.Invoice.project_ids()});
			}

			Otime.app.loadData(new Otime.ContextModel('invoice_details', post_data, function(cont){
				var data	= cont.response || {};
				inv.check_all(false);
				inv.project_listing([]);
				inv._info.enable_check_all(false);
				if (Object.keys(data.items).length) {
					var p_invoices	= {};
					if (data.p_invoices && Object.keys(data.p_invoices).length) {
						p_invoices	= data.p_invoices.otvalues.setKeys(data.p_invoices.otkeys, null,'project_id');
					}
					data.items	= data.items.otvalues.setKeys(data.items.otkeys, function(val){
						val.last_invoiced = (p_invoices[val.project_id])?p_invoices[val.project_id].invoice_id:0;
						val.is_checked = false;
						if (inv.imported_data && (inv.imported_data().project_ids && $.inArray(val.project_id, inv.imported_data().project_ids)!=-1) || (inv._info.project_ids() && $.inArray(val.project_id, inv._info.project_ids())!=-1)) {
							if (Number(val.billable_hours) || Number(val.unap_billable_hours) || Number(val.expense_total) || Number(val.unap_expense_total)) {
								val.is_checked = true;
							}							
						}
						if ((Number(val.billable_hours) >0 ||  Number(val.unap_billable_hours) >0 || Number(val.expense_total) >0)) {
							inv._info.enable_check_all(inv._info.enable_check_all() + true);
						}
						inv.project_listing.push(new Otime.Invoice.ProjectInvoiceListModel(val));
					});
				}
				// _this.listModel.is_slide_modes(true);
				// $('#project-invoice-container').addClass('opened').removeClass('closed');
				
			}));
			}

			self.projects_invoices	= function(item, elem){
				console.log("**********comes");
				if (!_this.listModel.selectedItem())
				{
					_this.listModel.selectedItem(self);
				}

				if ($.trim($("#project-invoice-container").html()) == "")
				{
					Otime.app.load_template("project_invoice", function(response){
						$("#project-invoice-container").html($.trim(response));
						ko.applyBindings(_this.listModel.selectedItem, $("#project-invoice-container").get(0));
						self.projects_invoices(item, elem);
					});
					return true;
				}

				var post_data = {client_id : self.client_id(), invoice_id : self.invoice_id()};

				if (self._info.date_filter_type()!='ALL') {
					$.extend(post_data, {
						start_date : new Date(self.date_filter.from_date()).format(Otime.sdf),
						finish_date : new Date(self.date_filter.to_date()).format(Otime.sdf)
					});
				}
				if(_this.project_ids().length>0) {
					$.extend(post_data, {'project_id': _this.project_ids(), 'filter_project_id':  _this.project_ids()});
				}

				Otime.app.loadData(new Otime.ContextModel('invoice_details', post_data, function(cont){
					var data	= cont.response || {};
					self.check_all(false);
					self.project_listing([]);
					self._info.enable_check_all(false);
					if (Object.keys(data.items).length) {
						var p_invoices	= {};
						if (data.p_invoices && Object.keys(data.p_invoices).length) {
							p_invoices	= data.p_invoices.otvalues.setKeys(data.p_invoices.otkeys, null,'project_id');
						}
						data.items	= data.items.otvalues.setKeys(data.items.otkeys, function(val){
							val.last_invoiced = (p_invoices[val.project_id])?p_invoices[val.project_id].invoice_id:0;
							val.is_checked = false;
							if (self.imported_data && (self.imported_data().project_ids && $.inArray(val.project_id, self.imported_data().project_ids)!=-1) || (self._info.project_ids() && $.inArray(val.project_id, self._info.project_ids())!=-1)) {
								if (Number(val.billable_hours) || Number(val.unap_billable_hours) || Number(val.expense_total) || Number(val.unap_expense_total)) {
									val.is_checked = true;
								}							
							}
							if ((Number(val.billable_hours) >0 ||  Number(val.unap_billable_hours) >0 || Number(val.expense_total) >0)) {
								self._info.enable_check_all(self._info.enable_check_all() + true);
							}
							self.project_listing.push(new _this.ProjectInvoiceListModel(val));
						});
					}
					_this.listModel.is_slide_modes(true);
					$('#project-invoice-container').addClass('opened').removeClass('closed');
					
				}));
			};

			self.status	= Otime.o(data.status || "d");

			var status_text = (self.status() != 's') ? _this.Status[self.status()] : 'Sent';
			self.status_display	= Otime.o(status_text);
			self.status.subscribe(function(newVal){
				self.status_class(_this.status_class[newVal] || _this.status_class['d']);
				self.status_display((newVal != 's') ? _this.Status[newVal] : 'Sent');
			});
			$.each(_this.Status, function(key, val){
				if(key != self.status())
					self._info.status.push({status: key, value:val});
			});

			self.payment_save	= parent.payment_save;
			self.payment		= parent.payment;
			self.payment_remove	= parent.payment_remove;

			var load_details	= function(response, isImport){
				if (!isImport) self.details([]);

				if (response.details && Object.keys(response.details).length == 2)
				{
					var count	= 1, tmp = null, tmpArr	= [];
					response.details	= response.details.otvalues.setKeys(response.details.otkeys, function(val){
						val.is_tax1 	= !!(val.is_tax1-"");
						val.is_tax2 	= !!(val.is_tax2-"");
						val.is_tax3 	= !!(val.is_tax3-"");
						if (isImport && self._info.date_filter_type()!= "ALL" && !self._info.gp_activity() && self._info.gp_date()) {
							var from_date = new Date(self.date_filter.from_date()).format(Otime.dateFormat);			
							var to_date = new Date(self.date_filter.to_date()).format(Otime.dateFormat);
							var daterange = (from_date != to_date) ? ' ['+ from_date + ' to ' + to_date + '] ' :' ['+ from_date + '] ';
							val.description = val.description.replace("#", daterange);
						}

						val.serial_no	= (val.serial_no > 0) ? val.serial_no : count;
						self.tax1_enable(val.is_tax1 || self.tax1_enable());
						self.tax2_enable(val.is_tax2 || self.tax2_enable());
						self.tax3_enable(val.is_tax3 || self.tax3_enable());

						tmp	= new _this.InvoiceItemModel(val, self);
						if (isImport) tmp.serial_no.isDirty(true);
//						tmpArr.push(tmp);
						self.details.push(tmp);
						count++;
					});
					/*self.tax2_enable(self.tax3_enable() || self.tax2_enable());
					self.tax1_enable(self.tax2_enable() || self.tax1_enable());*/					

//					self.details(tmpArr);
				}
			};

			var load_payments	= function(response, isImport){
				self._info.payment_list([]);
				if (response.payments && Object.keys(response.payments).length == 2)
				{
					response.payments	= response.payments.otvalues.setKeys(response.payments.otkeys);
					$.each(response.payments, function(key, val){
						self._info.payment_list.push(new _this.PaymentModel(val));
					});
				}
			};

			var reset_details	= function(){
				// delete existing items
				var details	= self.details();
				var key	= 0, val = null;
				for (var i=0, iLen=details.length; i<iLen; i++)
				{
					val	= details[key];
					self.deleteDetail(val)
					// if not removed check next element
					if (val._destroy)
						key++;
				}
			};

			var get_recurring_invoice_date	= function(newVal){
				if(newVal)
				{
					var mode	= newVal.substring(0, 1),
						value	= newVal.slice(1),
						rec_inv_date = new Date(self.invoice_date());

					if(mode == 'D')
					{
						rec_inv_date.addDays(parseInt(value));
					}
					if(mode == 'M')
					{
						rec_inv_date.addMonth(parseInt(value));
					}
					if(mode == 'B')
					{
						rec_inv_date.addMonth(1);
						if(value == 'MF')
						{
							rec_inv_date	= rec_inv_date.getMonthStart();
						}
						else
						{
							rec_inv_date	= rec_inv_date.getMonthEnd();
						}
					}
					self.recurring_next_inv_date(rec_inv_date);
				}
			};

			var get_due_date	= function(newVal) {
				if (!newVal)
				{
					return false;
				}
				var mode = newVal.substring(0,1);
				var value = newVal.slice(1);

				if (mode == 'D'){
					var due_date = new Date(self.invoice_date());
					due_date.setDate((parseInt(due_date.getDate()) + parseInt(value)));
				}
				if (mode=='M'){
					var due_date = new Date(self.invoice_date());
					due_date.setMonth(parseInt(due_date.getMonth()) + parseInt(value));
				}
				if (mode!='C') {
					self.due_date(due_date);
//					self.due_dt(Otime.FormatDate(due_date));
				}
			};

			self.invoice_date.subscribe(function(newVal){
//				self.invoice_dt(new Date(newVal).format(Otime.dateFormat || "MMM dd, yyyy"));
				get_due_date(self.due_date_mode());
				get_recurring_invoice_date(self.recurring_mode());
			});
//			self.due_date.subscribe(function(newVal){
//				self.due_dt(new Date(newVal).format(Otime.dateFormat || "MMM dd, yyyy"));
//			});

			self.due_date_mode.subscribe(get_due_date);
			self.recurring_mode.subscribe(get_recurring_invoice_date);

		/*	self.getClients	= function(){
				if (Object.keys(_this.Clients).length > 0)
				{
					var _return	= [];
					$.each(_this.Clients, function(key, val){
						_return.push({
							id: val.client_id,
							label: val.client_name,
							value: val.client_name
						});
					});
					return _return;
				}
				return false;
			}; */

			self.edit	= parent.edit;

			self.print	= function(){
				Otime.app.loadData(new Otime.ContextModel('pdf/' + self.invoice_id(), null, function(cont){
					if (cont.response) {
						if($.browser.mozilla) {
							window.location.href = Otime.baseUrl + 'uploads/'+cont.response.file;					
							
						} else {
							$('#iframe_download').attr('src',Otime.baseUrl + 'uploads/'+cont.response.file);
							$('#iframe_download').load(function() {
								 var tempFrame = $('#iframe_download')[0];
								 var tempFrameWindow = tempFrame.contentWindow? tempFrame.contentWindow : tempFrame.contentDocument.defaultView;
								 tempFrameWindow.focus();
								 tempFrameWindow.print();
						    });
						}
						return true;
					}else
					{
						console.log("No Data");
					}
				}));				
				//Otime.app.loadData(new Otime.ContextModel('print', null, function(){}));
				return true;
			};

			self.duplicate	= function(){
				Otime.app.loadData(new Otime.ContextModel('duplicate/' + self.invoice_id(), null, function(){}));
				_this.listModel.refresh();
				return true;
			};

			self.closeItem	= function(item){
				parent.is_edit_mode(false);
				parent.is_view_mode(false);			
				self.is_edit_mode(false);
				item.is_view_mode(false);
				self.is_view_mode(false);
			}

			self.export_quickbook	= function(){
				Otime.app.loadData(new Otime.ContextModel('export_quickbook/' + self.invoice_id(), null, function(cont){
					if (cont.response) {
						console.log(cont.response);
						return true;
					}else{
						console.log("No Data");
					}
				}));
				return true;
			};

			self.download_pdf = function(){
				Otime.app.loadData(new Otime.ContextModel('pdf/' + self.invoice_id(), null, function(cont){
					if (cont.response) {
						$('#iframe_download').attr('src',Otime.siteUrl + '/invoice/download/'+cont.response.file);
						return true;
					}else
					{
						console.log("No Data");
					}
				}));
				return true;
			};

		/*	self.setClient	= function(event, ui){
				if (ui.item.id)
				{
					if (self._info.client_name())
					{
						var has_Record = false;
						$.each(self.details(), function(key, val){
							if (val.description()){
								has_Record = true;
							}
						});
						if (has_Record && confirm("REMOVE_ITEMS_CONFIRM_MSG") == true) {
							// reset details when client change
							var dn = self.details().length; 
							reset_details();
							for (var i=0;i<dn;i++)
								self.details.push(new _this.InvoiceItemModel(null, self));
						}
					}
					self.client_id(ui.item.id);
				}
			}; */
			 
			self.is_discount.subscribe(function(){
				$("#dtype").selectpicker('refresh');
				/*if (self.is_discount()) {
					var cli_id = self.client_id() - 0;
					if (!cli_id) {
						Otime.error_message(_this.language['CLIENT_DETAILS_REQUIRED'], $("#alert_message"), 2000);
						return false;
					}

					Otime.app.postData(new Otime.ContextModel('discount_details/' + cli_id, {}, function(cont){
							
					}));
				}*/
			});

			self.tax1_enable.subscribe(function(newVal){
				self.tax2_enable(false);
				self.tax3_enable(false);

				$.each(self.details(), function(key, val){
					val.is_tax1(newVal);
				});
			});

			self.tax2_enable.subscribe(function(newVal){
				self.tax3_enable(false);
				$.each(self.details(), function(key, val){
					val.is_tax2(newVal);
				});
			});

			self.tax3_enable.subscribe(function(newVal){
				$.each(self.details(), function(key, val){
					val.is_tax3(newVal);
				});
			});
			
			self.show_comments	= parent.show_comments;

//			self.discount_value(self.discount_percentage() || self.discount_amount() || 0);

			var pre_client;
			self.client_id.subscribe(function (previousValue) {
				pre_client = previousValue;
			}, this, 'beforeChange');

			self.client_id.subscribe(function(newVal){
				self._info.contacts(new Array({client_contact_id:0, name:'No Contacts found'}));
				var tmpFn	= function(){
					self._info.contacts([]);
					self._info.client_code(_this.Clients[self.client_id()].client_code || "");
					self._info.client_name(_this.Clients[self.client_id()].client_name || "");
					var cont	= _this.Clients[newVal].contacts;
					/*if (cont == undefined)
					{*/
						var post_data = {};
						if (self.invoice_id()) { post_data.invoice_id = self.invoice_id();}
						console.log(_this.deposit);
						post_data.is_deposit = (_this.deposit==true)?1:0;
						// Otime.app.loadData(new Otime.ContextModel('client_details/' + newVal, post_data, function(cont){
						Otime.app.postData(new Otime.ContextModel('client_details/' + newVal, post_data, function(cont){
							if (cont.response)
							{
								var contacts	= cont.response.contacts;
								self._info.contacts([]);
								if (contacts.otvalues != undefined)
								{
									_this.Clients[self.client_id()].contacts	= {};
									contacts	= contacts.otvalues.setKeys(contacts.otkeys, function(val, key){
										_this.Clients[self.client_id()].contacts[val.client_contact_id]	= val;
										self._info.contacts.push(val);
									});
								}

								_this.Clients[self.client_id()].cli_details	= cont.response.cli_details;
								if (cont.response.cli_details)
								{

									/*self._info.invoice_hours		= Otime.o(true);
									self._info.detail_hours 		= Otime.o(data.detail_hours || '');
									self._info.invoice_expenses		= Otime.o(true);
									self._info.detail_expenses 		= Otime.o(data.detail_expenses || 'C');
									self._info.uninvoiced_hours			= Otime.o(0);
									self._info.uninvoiced_expenses		= Otime.o(0);
									self._info.gp_project		= Otime.o(true);
									self._info.gp_tasktype		= Otime.o(false);
									self._info.gp_member		= Otime.o(false);
									self._info.gp_date			= Otime.o(false);
									self._info.gp_activity		= Otime.o(false);*/

									self.address(cont.response.cli_details['address']);
									self.currency_code(cont.response.cli_details['currency_code']);
									self.client_contact_id(cont.response.cli_details['client_contact_id'] || '');
									self._info.uninvoiced_hours(cont.response.cli_details['uninvoiced_hours'] || 0);
									self._info.uninvoiced_expenses(cont.response.cli_details['uninvoiced_expenses'] || 0);
									if (cont.response.cli_details['discount_percentage']) {
										self.discount_percentage(cont.response.cli_details['discount_percentage'] - 0);
										self.discount_value(self.discount_percentage() - 0);
										self.discount_type('P');
									} else if(cont.response.cli_details['discount_amount'])
									{
										self.discount_amount(cont.response.cli_details['discount_amount'] - 0);
										self.discount_value(self.discount_amount() - 0);
										self.discount_type('A');
									}

									if (cont.response.cli_details['tax1_percentage']) {
										self.tax1_percentage(cont.response.cli_details['tax1_percentage'] - 0);
										self.tax1_name(cont.response.cli_details['tax1_name']);
									}

									if (cont.response.cli_details['tax2_percentage']) {
										self.tax2_percentage(cont.response.cli_details['tax2_percentage'] - 0);
										self.tax2_name(cont.response.cli_details['tax2_name']);
									}

									if (cont.response.cli_details['tax3_percentage']) {
										self.tax3_percentage(cont.response.cli_details['tax3_percentage'] - 0);
										self.tax3_name(cont.response.cli_details['tax3_name']);
									}

									if (!_this.date_filter().date_filter_type && cont.response.cli_details['date_filter_type'])
									{
										if (cont.response.cli_details['date_filter_type'] == 'CU')
										{
											var start_date = new Date(cont.response.cli_details['from_date']);
											var end_date   = new Date(cont.response.cli_details['to_date'])
											var diff = (new Date(end_date - start_date))/864E5;
											if (!self.invoice_id()) {
												self.date_filter.from_date(end_date.addDays(1));
												end_date = new Date(end_date).addDays(diff);
												self.date_filter.to_date(end_date);
											} else {
												self.date_filter.from_date(start_date);
												self.date_filter.to_date(end_date);
											}
											self.date_filter.fd_td_apply();
										} else {
											self.date_filter.applyDFT(cont.response.cli_details['date_filter_type']);
										}
									}

									if (cont.response.cli_details['import_config']) {
										var imp_conf = JSON.parse(cont.response.cli_details['import_config']);
										if (imp_conf.ids) {
											self._info.project_ids(imp_conf.ids);
										}
										if (imp_conf.hours) {
											self._info.invoice_hours(true);
											self._info.gp_project(!!(imp_conf.hours[0]-0));
											self._info.gp_tasktype(!!(imp_conf.hours[1]-0));
											self._info.gp_member(!!(imp_conf.hours[2]-0));
											self._info.gp_date(!!(imp_conf.hours[3]-0));
											self._info.gp_activity(!!(imp_conf.hours[4]-0));
										} else {
											self._info.invoice_hours(false);
											self._info.gp_project(false);
											self._info.gp_tasktype(false);
											self._info.gp_member(false);
											self._info.gp_date(false);
											self._info.gp_activity(false);
										}

										if (imp_conf.expenses) {
											self._info.invoice_expenses(true);
											self._info.detail_expenses(imp_conf.expenses);
										} else {
											self._info.invoice_expenses(false);
											self._info.detail_expenses(false);
										}
									}
								}
								if(_this.client_id()>0)
									self.import_projects_from_report();
							}
							if (self._info.import_config()) {
								$("#import_data").html('');
								$("#btn-import").hide();
								$("#import-label").html('Reimport project hours & expenses');
								$(".alert").show();
							} else {
								$("#btn-import").show();
								$(".alert").hide();
							}
							if (pre_client && pre_client !=newVal) {
								reset_details();
								self.details.push(new _this.InvoiceItemModel(null, self));
								self.details.push(new _this.InvoiceItemModel(null, self));
								self.details.push(new _this.InvoiceItemModel(null, self));
								self.details.push(new _this.InvoiceItemModel(null, self));
							}
						}));
					/*}
					else
					{

						$.each(_this.Clients[self.client_id()].contacts, function(key, val){
							self._info.contacts.push(val);
						});


						if (_this.Clients[self.client_id()].cli_details)
						{
							cli_details	= _this.Clients[self.client_id()].cli_details;
							self.address(cli_details['address']);
							self.currency_code(cli_details['currency_code']);
							self.client_contact_id(cli_details['client_contact_id'] || '');
							self.uninvoiced_hours(cli_details['uninvoiced_hours'] || 0);
						}
					}*/
				};
				if(newVal == '-1')
				{
					newClient({
						onSave: function(clientData){
							
							self.clients.push(clientData);							
							_this.Clients[clientData.client_id] = clientData;
							self.client_id(clientData.client_id);							
						},
						onCancel: function(){
							self.client_id(0);
						}
					});
					return true;
				}
				else if (_this.Clients[newVal]== undefined)
				{
					return false;
				}
				tmpFn();
			});

			self.client_contact_id.subscribe(function(newVal){
				if (_this.Clients[self.client_id()]== undefined)
				{
					self._info.contacts(new Array({client_contact_id:0, name:'No Contacts found'}));
					return false;
				}
				var cont	= (_this.Clients[self.client_id()].contacts) ? _this.Clients[self.client_id()].contacts[newVal] : '';
				if (cont)
				{
					self._info.contact_name(cont.name || "");
					self._info.contact_email(cont.email || "");
				}
			});

			self.details	= Otime.a([]);

			self.is_new			= Otime.o(false);
			self.is_edit_mode	= Otime.o(false);
			self.is_view_mode	= Otime.o(false);
			self.check_all		= Otime.o(false);

			self.import_cancel	= function(){
				console.log("********_this.listModel",_this.listModel)
				if(_this.listModel.is_slide_modes()==true)
				{
					_this.listModel.is_slide_modes(false);
					$("#view-layout").removeClass( "opened" ).addClass( "closed" );
					$("#project-invoice-container").removeClass( "opened" ).addClass( "closed" );
					_this.is_slide_opened(false);
					return;
				}
			};
			
			self.check_all.subscribe(function(newVal){				
				if (self.project_listing().length) {
					$.each(self.project_listing(), function(key, val){
						val.is_checked(newVal);
					});
				}
			});

			self.import_projects = function(){
				if(_this.listModel.is_slide_modes()==true)
				{
					if (self.project_listing().length) {
						self.imported_data	= Otime.a([]);
						var project_ids	= [];
						self.imported_projects_names	= Otime.a([]);
						
						$.each(self.project_listing(), function(key, val){
							if (val.is_checked())
							{
								project_ids.push(val.project_id());
								self.imported_projects_names.push(val.project_name());
							}
						});
//						if(project_ids.length && self._info.invoice_hours() && !self._info.detail_hours()){
//							alert(_this.language["SELECT_DETAIL_HOURS"]);
//							return false;
//						}
//						if(project_ids.length && self._info.invoice_expenses() && !self._info.detail_expenses()){
//							alert(_this.language["SELECT_DETAIL_EXPENSES"]);
//							return false;
//						}

						if (project_ids.length &&  confirm(_this.language["IMPORT_ITEMS_CONFIRM_MSG"]) == true)
						{
							self.imported_data({
								project_ids: project_ids,
								invoice_hours : Number(self._info.invoice_hours()),
								//detail_hours 	 : self._info.detail_hours(),
								invoice_expenses : Number(self._info.invoice_expenses()),
								detail_expenses : self._info.detail_expenses(),
								group_by : {
									project : Number(self._info.gp_project()), 
									tasktype : Number(self._info.gp_tasktype()),
									member : Number(self._info.gp_member()),
									date : Number(self._info.gp_date()),
									activity : Number(self._info.gp_activity())
								}
							});
//console.log(self._info);
							if (self._info.date_filter_type()!='ALL')
							{
								$.extend(self.imported_data(),{
									start_date : new Date(self.date_filter.from_date()).format(Otime.sdf),
									finish_date : new Date(self.date_filter.to_date()).format(Otime.sdf)
								});
							}
							if (self.invoice_id())
							{
								$.extend(self.imported_data(),{invoice_id:self.invoice_id()});
							}

							Otime.app.postData(new Otime.ContextModel('import_projects', self.imported_data(), function(cont){
								self.import_cancel();
								reset_details();
								var sub_msg = '';
								if (self._info.date_filter_type() !='ALL') {
									sub_msg = self.imported_projects_names()+" are imported on / between "+self.date_disp();
								} else {
									sub_msg = self.imported_projects_names()+" are imported";
								}
								load_details(cont.response, true);
								self.details.push(new _this.InvoiceItemModel(null, self));
								if (!self.subject.isLocked || !self.subject())
								{
									self.subject.isLocked	= false;
									self.subject(sub_msg);
								}
								$("#import_data").html(sub_msg);
								$("#btn-import").hide();
								$("#import-label").html('REIMPORT');
								$(".alert").show();
							}));
							self.is_discount(false);
							self.tax1_enable(false);
							self.tax2_enable(false);
							self.tax3_enable(false);
						}
						else if (!project_ids.length)
						{
							alert(_this.language["SELECT_PROJECTS"]);
							return false;
						}
					}
				}
			};

			self.import_projects_from_report = function() {
				if (_this.project_ids().length) {
					self.imported_data	= Otime.a([]);
											
					if (_this.project_ids().length>0)
					{
						var post_data = {
							project_ids: _this.project_ids(),
							invoice_hours 	 : 1,
							detail_hours 	 : 'T',
							invoice_expenses : 1,
							detail_expenses : 'C'
						};

						if (self._info.date_filter_type()!='ALL') {
							$.extend(post_data, {
								start_date : new Date(self.date_filter.from_date()).format(Otime.sdf),
								finish_date : new Date(self.date_filter.to_date()).format(Otime.sdf)
							});
						}
						self.imported_data(post_data);
						Otime.app.postData(new Otime.ContextModel('import_projects', self.imported_data(), function(cont){
							self.import_cancel();
							reset_details();
							load_details(cont.response, true);
							self.details.push(new _this.InvoiceItemModel(null, self));
							$("#import_data").html(_this.project_names()+" are imported on / between "+self.date_disp());
							$("#btn-import").hide();
							$("#import-label").html('REIMPORT');
							$(".alert").css("display", "block");
						}));
					}
				}
			};

			self.model_timesheet	= Otime.o(null);
			self.model_approve	= Otime.o(null);

			self.ts_nb_approve = function(item) {
				ts_approve(item, 0);
			};
			self.ts_b_approve = function(item){
				ts_approve(item, 1);
			};

			self.ts_update_billable = function (item) {
				ts_billable_change(item, 0);
			}

			var ts_billable_change = function(item, billable) {
				//var hours_list_container_new	= $('#approved_hours .modal-body');

				self.model_approve(new Otime.TimeSheetApprove.UserApprovedListModel({
					project_id	 : item.project_id(),
					project_name : item.project_name(),
					billable	 : billable,
					// date_disp 	 : self._info.date_filter_type()=='ALL'?self._info.date_filter_type():(self.date_filter.fd_disp()+' - '+self.date_filter.td_disp()),
					date_disp 	: (self._info.date_filter_type()=='ALL')?self._info.date_filter_type():self.date_disp(),
					from_date	: self.date_filter.from_date(),
					to_date 	: self.date_filter.to_date(), 
					popup_close: function(){
						Otime.app.loadData(new Otime.ContextModel('invoice_details', _this.approve_data, function(cont){
							var data	= cont.response || {};
							if (Object.keys(data.items || {}).length)
							{
								data.items	= data.items.otvalues.setKeys(data.items.otkeys, function(val){
									if (val.billable_hours)
										item.billable_hours(parseFloat(val.billable_hours).toFixed(2));
									if (val.unap_billable_hours)
										item.unap_billable_hours(parseFloat(val.unap_billable_hours).toFixed(2));
									if (val.non_billable_hours)
										item.non_billable_hours(parseFloat(val.non_billable_hours).toFixed(2));
									if (val.unap_non_billable_hours)
										item.unap_non_billable_hours(parseFloat(val.unap_non_billable_hours).toFixed(2));
								});
							}
						}));
						$("#approved_hours").modal('hide');
					}
				}));
				
				self.model_approve().refresh();
				
				_this.approve_data = {client_id : self.client_id(), invoice_id : self.invoice_id(), project_id : item.project_id(), task : 'timesheet'};
				if (self._info.date_filter_type()!='ALL') {
					$.extend(_this.approve_data, {
						start_date : new Date(self.date_filter.from_date()).format(Otime.sdf),
						finish_date : new Date(self.date_filter.to_date()).format(Otime.sdf)
					});
				}
				if (!ko.dataFor($('#approved_hours').get(0)))
				{
					ko.applyBindings({modTimesheet:self.model_timesheet, modApprove:self.model_approve}, $('#approved_hours').get(0));
				}
				
			}

			var ts_approve = function(item, billable){
				var list_container_new	= $('#timsheet_approve .modal-body');

				self.model_timesheet(new Otime.TimeSheetApprove.TimesheetApproveModel({
					popup_close: function(){
						Otime.app.loadData(new Otime.ContextModel('invoice_details', _this.approve_data, function(cont){
							var data	= cont.response || {};
							if (Object.keys(data.items || {}).length)
							{
								data.items	= data.items.otvalues.setKeys(data.items.otkeys, function(val){
									if (val.billable_hours)
										item.billable_hours(parseFloat(val.billable_hours).toFixed(2));
									if (val.unap_billable_hours)
										item.unap_billable_hours(parseFloat(val.unap_billable_hours).toFixed(2));
									if (val.non_billable_hours)
										item.non_billable_hours(parseFloat(val.non_billable_hours).toFixed(2));
									if (val.unap_non_billable_hours)
										item.unap_non_billable_hours(parseFloat(val.unap_non_billable_hours).toFixed(2));
								});
							}
						}));
						$("#timsheet_approve").modal('hide');
					}
				}));

				_this.approve_data = {client_id : self.client_id(), invoice_id : self.invoice_id(), project_id : item.project_id(), billable : billable, task : 'timesheet'};
				if (self._info.date_filter_type()!='ALL') {
					$.extend(_this.approve_data, {
						start_date : new Date(self.date_filter.from_date()).format(Otime.sdf),
						finish_date : new Date(self.date_filter.to_date()).format(Otime.sdf)
					});
				}

				if (!Otime.app.hasBinding(list_container_new))
				{
					Otime.app.load_template(Otime.siteUrl + "/" + Otime.TimeSheetApprove.name + "/approve/1", function(response){
						list_container_new.html($.trim(response));
						ko.applyBindings({modTimesheet:self.model_timesheet, modApprove:self.model_approve}, $('#timsheet_approve .modal-content').get(0));
						ts_approve(item, billable);
					}, true);
					return true;
				}

				var post_data  = {'project_id':item.project_id(), 'billable': billable, 'unsubmitted':true};
				if (self._info.date_filter_type() != 'ALL') {
					$.extend(post_data, {
						from_date : new Date(self.date_filter.from_date()).format(Otime.sdf),
						to_date : new Date(self.date_filter.to_date()).format(Otime.sdf)
					});
				}
				var context	= new Otime.ContextModel(Otime.siteUrl + "/" + Otime.TimeSheetApprove.name +'/project_timesheet', post_data, self.model_timesheet().load);
				//context.prepare	= "items";
				Otime.app.loadData(context,true);
			};

			self.model_expenses		= Otime.o({
				item: Otime.a([]),
				approve_total_amount: Otime.o(0),
				appr_listing: Otime.a([]),
				popup_close: function(itm){
					_this.approve_data = {client_id : self.client_id(), invoice_id : self.invoice_id(),filter_project_id : self.model_expenses().item().project_id(), task : 'expenses'};
					Otime.app.loadData(new Otime.ContextModel('invoice_details', _this.approve_data, function(cont){
						var data	= cont.response || {};
						if (Object.keys(data.items).length)
						{
							data.items	= data.items.otvalues.setKeys(data.items.otkeys, function(val){
								val.expense_total && itm.item().expense_total(parseFloat(val.expense_total).toFixed(2));
								val.unap_expense_total && itm.item().unap_expense_total(parseFloat(val.unap_expense_total).toFixed(2));
							});
						}
					}));
					$("#expenses_approve").modal('hide');
				},
				approve_entry: function(item){
					var data	= {
						project_id: parseInt(self.model_expenses().item().project_id())
					};
					if(item.hasOwnProperty('expense_id'))
					{
						data.expense_id	= item.expense_id();
					}
					var context	= new Otime.ContextModel(Otime.siteUrl + "/" + Otime.Expenses.name +'/approve', data, function(context){
						var response	= context.response;
						self.approve_exp();
					});
					Otime.app.postData(context, true);

					return true;
				},
				remove :  function(item){
					if (item.expense_id() > 0 && confirm(_this.language["CONFIRM_DELETE"]) == true)
					{
						var context	= new Otime.ContextModel(Otime.siteUrl + "/" + Otime.Expenses.name +'/delete/'+item.expense_id(), {}, function(context){
							self.model_expenses().appr_listing.remove(item);
						});
						Otime.app.postData(context, true);
					}
				}
			});

			self.expenses_approve	= function(item){
				var list_container_new	= $('#expenses_approve .modal-body');
				if (!Otime.app.hasBinding(list_container_new))
				{
					var url	= Otime.siteUrl + '/' + Otime.Expenses.name + '/tmpl';
					$.get(url, {
						v: Otime.version,
						r: Otime.usr,
						m: 1
					}, function(content){
						list_container_new.html(content);
						ko.applyBindings(self.model_expenses, $('#expenses_approve .modal-content').get(0));
						self.expenses_approve(item);
					});
					return true;
				}
				self.model_expenses().item(item);
				self.approve_exp();
			};
			self.approve_exp = function() {
				var post_data = {
					filter_project_id: parseInt(self.model_expenses().item().project_id())
				};
				if (self._info.date_filter_type() != 'ALL') {
					$.extend(post_data, {
						start_date : new Date(self.date_filter.from_date()).format(Otime.sdf),
						finish_date : new Date(self.date_filter.to_date()).format(Otime.sdf)
					});
				}
				var cont	= new Otime.ContextModel(Otime.siteUrl + "/" + Otime.Expenses.name + "/project_expenses/approve", post_data, function(cont_items){
					var apprItems	= [],
						appr_total	= 0;
					if(cont_items.response.approve_items.otvalues != undefined) {
						cont_items.response.approve_items	= cont_items.response.approve_items.otvalues.setKeys(cont_items.response.approve_items.otkeys, function(item){
						apprItems.push(new Otime.Expenses.ExpenseDetailModel(item));
						appr_total	+= parseFloat(item.amount || 0);
					});
					
					}
					self.model_expenses().appr_listing(apprItems);
					self.model_expenses().approve_total_amount(appr_total);
					$("#expenses_approve").modal('show');
				});
				Otime.app.loadData(cont, true);
			};

			self.update_status	= function(status, popup){
				popup = popup ? popup : false;
				if (self.status() == status)
				{
					return;
				}

				if (status.toUpperCase() == 'S')
				{
					if(popup) {
						parent.emailPopUp(self);
						self.prepareMail(popup);
						return true;
					} else {
						self.prepareMail(popup);
						self.change_status(status);
					}
				} else {
					// self.change_status(status);
					Otime.app.postData(new Otime.ContextModel('update_status', {
							invoice_id: self.invoice_id(),
							status: status
						}, function(cont){
							self.change_status(status);
						}
					));
				}

			};

			self.change_status	= function(status){
				self.status(status);
				self.status_class(_this.status_class[status]);
				var status_text = (self.status() != 's') ? _this.Status[self.status()] : 'Sent';
				self.status_display(status_text);
				_this.listModel.refresh();
			};

			self.prepareMail	= function(popup){
				Otime.app.postData(new Otime.ContextModel('prepareMail/'+Number(popup), {
					invoice_id		: self.invoice_id(),
					invoice_number	: self.invoice_number(),
					total			: self.amount(),
					currency_code	: self.currency_code(),
					invoice_date	: new Date(self.invoice_date()).format(Otime.dateFormat || "MMM dd, yyyy"),
					client_id		: self.client_id(),
					client_name	: (self._info.client_code()?self._info.client_code()+" - ":"")+self._info.client_name()
					}, function(cont){
					self.email_to(cont.response.to);
					self.email_cc(cont.response.cc);
					self.email_subject(cont.response.subject);
					self.email_message(cont.response.message);
					if (cont.response['attachment']) {
						self.email_file(cont.response['attachment']['file']);
						self.email_url(cont.response['attachment']['url']);
						self.email_filepath(cont.response['attachment']['filepath']);
					}
					if(popup)
					$("#e-mails").modal('show');
				}));
			};

			self.send	= function(item){
				Otime.app.loadData(new Otime.ContextModel('send', {
					invoice_id		: self.invoice_id(),
					invoice_number	: self.invoice_number(),
					to				: self.email_to(),					
					cc				: self.email_cc(),					
					filepath		: self.email_filepath(),
					message			: self.email_message(),
					status			: 's'
				}, function(){
					self.change_status('s');
				}));
				$("#e-mails").modal('hide');
				return true;
			};

			self.sortDetail	= function(item){
				$.each(self.details(), function(key, val){
					val.serial_no(key);
				});
			};

			self.prepareData	= function(){
				if (!(self.client_id() > 0) || $.trim(self.invoice_number()) == "" || !(self.client_contact_id() > 0))
				{
					Otime.error_message(_this.language['CLIENT_DETAILS_REQUIRED'], $("#alert_message"), 2000);
					return false;
				}
				if (self.sub_total() <= 0 || self._info.total() < 0)
				{
					Otime.error_message(_this.language['INVALID_PRODUCT_SERVICE_ITEMS'], $("#alert_message"), 2000);
					return false;
				}
				var error = false;
				$.each(self.details().slice(), function(key, val){
					if(!$.trim(val.description())) {
						if ((val.amount()-0) <= 0 && val.invoice_item_id() <= 0)
						{
							self.details.remove(val);
						} else {
							error=true;
							return false;
						}
					}
				});

				if (error) {
					Otime.error_message(_this.language['INVALID_PRODUCT_SERVICE_DESC_NOT_EMPTY'], $("#alert_message"), 2000);
					return false;
				}

				
				var data	= JSON.parse(ko.toJSON(self));

				// Remove unwanted.
				delete data.before_tax;
				delete data.check_all;
				delete data.date_filter;
				delete data.date_disp;
				delete data.date_disp;
				delete data._info;
				delete data.format_date;
				delete data.hasChanges;
				delete data.overdue;
				delete data.is_edit_mode;
				delete data.is_new;
				delete data.is_view_mode;
				delete data.model_expenses;
				delete data.model_timesheet;
				delete data.project_listing;
				delete data.status_class;
				delete data.status_display;
				delete data.today;
				delete data.clients;

				data.date_filter_type	= self._info.date_filter_type();
				data.from_date	= new Date(self.date_filter.from_date()).format(Otime.sdf);
				data.to_date	= new Date(self.date_filter.to_date()).format(Otime.sdf);

				data.deleted	= [];

				data.invoice_date	= new Date(data.invoice_date).format(Otime.sdf);
				data.due_date		= new Date(data.due_date).format(Otime.sdf);

				data.recurring_next_inv_date	= new Date(data.recurring_next_inv_date).format(Otime.sdf);
				data.recurring_auto	= (data.recurring_auto-0);

				if (data.discount_type == "A")
				{
					data.discount_percentage	= 0;
				}

				if (!data.is_discount)
				{
					data.discount_percentage	= 0;
					data.discount_amount	= 0;
				}

				var details	= data.details.slice();
				data.details	= [];
				$.each(details, function(key, val){
					if (val.isDirty)
					{
						val.is_tax1	= val.is_tax1-0;
						val.is_tax2	= val.is_tax2-0;
						val.is_tax3	= val.is_tax3-0;

						data.details.push(val);
					}

					if (val.invoice_item_id > 0 && val._destroy)
					{
						data.deleted.push(val.invoice_item_id);
					}
				});

				if (!data.tax1_amount) {
					data.tax1_enable	= 0;
					data.tax1_name		= '';
				}
				if (!data.tax2_amount) {
					data.tax2_enable	= 0;
					data.tax2_name		= '';
				}
				if (!data.tax3_amount) {
					data.tax3_enable	= 0;
					data.tax3_name		= '';
				}
				data.tax1_enable	= data.tax1_enable-0;
				data.tax2_enable	= data.tax2_enable-0;
				data.tax3_enable	= data.tax3_enable-0;

				return data;
			};

			self.save	= function(){
				var data	= self.prepareData();
				if (!data)
				{
					return data;
				}
//return false;
				if (_this.deposit)
				{
					data.is_deposit	= 1;
				}

				Otime.app.postData(new Otime.ContextModel('save', data, function(cont){
					var resp	= cont.response;
					if (self.invoice_id() <= 0)
					{
						self.invoice_id(resp.invoice_id);
					}					
					
					$.each(data.details, function(key, val){
						if(data.tax1_enable)
						{
							val.is_tax1	= Number(val.is_tax1);
						}
						if(data.tax2_enable)
						{
							val.is_tax1	= Number(val.is_tax2);
						}
						if(data.tax3_enable)
						{
							val.is_tax1	= Number(val.is_tax3);
						}
					});

					var out_cr	= 0;
					if (resp.ot_credit && resp.ot_credit.deposit_balance)
					{
						out_cr	= (Number(resp.ot_credit.deposit_balance) || 0);
					}
					self._info.out_cr(out_cr);

					if (resp.items && resp.items.length > 0)
					{
						var count	= 0;
						$.each(self.details(), function(key, val){
							if (val.invoice_item_id() <= 0)
							{
								val.invoice_item_id(resp.items[count]);
								count++;
							}
						});
					}
					self.is_view_mode(true);
//					self.commit && self.commit();

					if (self.is_new())
					{
						_this.listModel.items.push(self);
						self.is_new(false);
					}
					self.is_edit_mode(false);
				}));
				_this.listModel.refresh();
			};

			self.cancelEdit	= function(){
				// prepareData
				// call parent.viewItem(self) if any modified
				// else just change to the edit mode.

//				parent.viewItem(self);

				$.each(self.details(), function(key, val){
					if (val._destroy)
					{
						delete val._destroy;
					}
				});
//				self.rollback && self.rollback();
				if(self.invoice_id()>0 && !self.is_view_mode())
				{
					parent.is_edit_mode(false);
				}
				else
				{
					self.is_view_mode(false);
					parent.is_edit_mode(false);
					parent.selectedItem(new _this.InvoiceContentModel(null, parent));
				}
			};

			self.pay_in_dep	= function(){
				if (confirm(_this.language['CONFIRM_PAY_FROM_DEPOSIT']))
				{
					var data	= {
						client_id : self.client_id(),
						currency_code : self.currency_code(),
						invoice_id : self.invoice_id(),
						invoice_number : self.invoice_number(),
						client_name : (self._info.client_code()?self._info.client_code()+" - ":"")+self._info.client_name(),
						payment_date : new Date().format(Otime.sdf),						
						amount : self.amount(),
						deposit_payment : 1
					};

					Otime.app.loadData(new Otime.ContextModel('payment_save', data, function(cont){
						
						if (cont.response && Object.keys(cont.response).length >= 2)
						{
							var status = cont.response.status;
							var newPaymentList	= [];
							cont.response	= cont.response.otvalues.setKeys(cont.response.otkeys);
							$.each(cont.response, function(key, val){
								newPaymentList.push(new _this.PaymentModel(val));
							}); 
							alert(_this.language['PAYMENT_MADE_FROM_DEPOSIT_INVOICE']);
							self._info.payment_list(newPaymentList);
							self.change_status(status);
						}
					}));
				}
			};

			self.load	= function(context){
				var response	= context.response;

				if (!_this.deposit && response.ot_credit)
				{
					self._info.out_cr(Number(response.ot_credit.deposit_balance) || 0);
				}
				
				self._info.import_config(response.import_config || '');
				self.tax1_enable(Number(response.tax1_percentage)?true:false);
				self.tax2_enable(Number(response.tax2_percentage)?true:false);
				self.tax3_enable(Number(response.tax3_percentage)?true:false);

				// payment_amount
				self.recurring_auto(Boolean(response.recurring_auto));
				self._info.uninvoiced_hours(response.uninvoiced_hours || 0);
				self._info.uninvoiced_hours(response.uninvoiced_expenses || 0);

				self.invoice_date(new Date(response.invoice_date));
				response.due_date = response.due_date.replace(/-/g,'/');
				self.due_date(new Date(response.due_date));		
				self.recurring_next_inv_date(new Date(response.recurring_next_inv_date));

				delete response.invoice_date;
				delete response.due_date;

				$.each(response, function(key, val){
					if ((typeof val == "string" || typeof val == "number") && self[key])
					{
						if (key == "invoice_number" || isNaN(val) || val=='')
						{
							self[key](val);
						}
						else
						{
							self[key](val-0);
						}
					}
				});

				if (response.contacts && Object.keys(response.contacts).length == 2)
				{
					response.contacts	= response.contacts.otvalues.setKeys(response.contacts.otkeys);
					var contacts	= [];
					$.each(response.contacts, function(key, val){
						contacts.push(val);
					});
					self._info.contacts(contacts);
				}

				self.status(response.status || "d");
				self.status_class(_this.status_class[self.status()]);

				// load item details
				load_details(response);
				load_payments(response);
				self.is_discount(true);
				if (self.discount_percentage() > 0)
				{
					self.discount_value(self.discount_percentage());
					self.discount_type('P');
				}
				else if(self.discount_amount() > 0)
				{
					self.discount_value(self.discount_amount());
					self.discount_type('A');
				}
				else
				{
					self.discount_value(0);
					self.discount_type('P');
					self.is_discount(false);
				}

				return true;
			};

			self.addNewDetail	= function(item){
				if (item == undefined || (self.details().indexOf(item) == self.details().length-1 && $.trim(item.description()) != ""))
				{
					self.details.push(new _this.InvoiceItemModel(null, self));
				}
			};

			self.deleteDetail	= function(item){
				if (item.invoice_item_id() > 0)
				{
					self.details.destroy(item);
				}
				else
				{
					self.details.remove(item);
				}
			};

			self.compute	= Otime.c(function(){
				_this.Compute(self);
				self.is_tax_enable(self.tax1_enable() || self.tax2_enable() || self.tax3_enable());
			});
		};

		_this.Compute	= function(self){
			var total_taxes	= 0;
			self.sub_total(0);self.before_tax(0);
			if (self.details().length > 0)
			{
				var tot	= 0, tx1 = 0, tx2 = 0, tx3 = 0, amt = 0, dp = 0;

				$.each(self.details(), function(key, val){
					if (val._destroy == undefined || val._destroy == false)
					{
						tot	+= parseFloat(val.amount());
					}
				});

				self.sub_total(tot.toFixed(2));
				self.before_tax(self.sub_total());

				dp	= 0;
				if (self.is_discount())
				{
					switch(self.discount_type())
					{
						case "A":
							if (self.sub_total() > 0)  {
								self.discount_amount(self.discount_value() || 0);
								dp	= (self.discount_amount() / self.sub_total())*100;
							}
							break;
						case "P":
							self.discount_percentage(self.discount_value());
							if(self.sub_total()>0 && self.discount_value())
								self.discount_amount(((self.sub_total() * self.discount_value())/100).toFixed(2));
							else
								self.discount_amount(0);
							dp	= self.discount_percentage();
							break;
					}
					self.before_tax(self.sub_total() - self.discount_amount());
				}

				self.tax1_amount(0); self.tax2_amount(0); self.tax3_amount(0);
				$.each(self.details(), function(key, val){
//					if (val._destroy && self.sub_total() > 0)
					if (!val._destroy) {
//						return false;
						amt	= val.amount();
						amt	= amt - ((amt * dp)/100);
						if (self.tax1_enable() && val.is_tax1() && self.tax1_percentage())
						{
							tx1	= ((amt * self.tax1_percentage())/100).toFixed(2);
							self.tax1_amount((parseFloat(self.tax1_amount()) + parseFloat(tx1)).toFixed(2));
						}
						if (self.tax2_enable() && val.is_tax2() && self.tax2_percentage())
						{
							tx2	= ((amt * self.tax2_percentage())/100).toFixed(2);
							self.tax2_amount((parseFloat(self.tax2_amount()) + parseFloat(tx2)).toFixed(2));
						}
						if (self.tax3_enable() && val.is_tax3() && self.tax3_percentage())
						{
							tx3	= ((amt * self.tax3_percentage())/100).toFixed(2);
							self.tax3_amount((parseFloat(self.tax3_amount()) + parseFloat(tx3)).toFixed(2));
						}
					}
				});

				self._info.total((parseFloat(self.before_tax()) + parseFloat(self.tax1_amount()) + parseFloat(self.tax2_amount()) + parseFloat(self.tax3_amount())).toFixed(2));
				var payment_total = 0;
				$.each(self._info.payment_list(), function(key, val) {
					payment_total = parseFloat(payment_total)+ parseFloat(val.amount());
				});

				self.amount((parseFloat(self._info.total()) - parseFloat(payment_total)).toFixed(2));
			}
		};

		_this.InvoiceItemModel	= function(data, parent){
			var self	= this;

			data	= data || {};

			self.invoice_item_id	= Otime.o(data.invoice_item_id || 0);
			self.invoice_id		= Otime.o(data.invoice_id || 0);
			self.name				= Otime.o(data.name || "").extend({trackChange: true});

			self.description		= Otime.o(data.description || "").extend({trackChange: true});
			self.description.subscribe(function(){
				if (parent.details().length-1 == parent.details.indexOf(self))
				{
					parent.addNewDetail();
				}
			});

			self.quantity	= Otime.o(data.quantity || 0.00).extend({trackChange: true});
			self.rate		= Otime.o(data.rate || 0.00).extend({trackChange: true});
			self.amount		= Otime.o(0.00);

			if (Object.keys(data).length)
			{
				self.is_tax1	= Otime.o(data.is_tax1).extend({trackChange: true});
				self.is_tax2	= Otime.o(data.is_tax2).extend({trackChange: true});
				self.is_tax3	= Otime.o(data.is_tax3).extend({trackChange: true});
			}
			else
			{
				self.is_tax1	= Otime.o(parent.tax1_enable()).extend({trackChange: true});
				self.is_tax2	= Otime.o(parent.tax2_enable()).extend({trackChange: true});
				self.is_tax3	= Otime.o(parent.tax3_enable()).extend({trackChange: true});
			}

			self.serial_no		= Otime.o(data.serial_no || 0).extend({trackChange: true});
			self.enabled_tax	= Otime.a([]);
			self.is_imported	= Otime.o(data.is_imported || 0);

			self.isDirty	= Otime.c(function(){
				self.amount((parseFloat(self.quantity()-0) * parseFloat(self.rate()-0)).toFixed(2));

				self.enabled_tax([]);

				if (self.is_tax1())
				{
					self.enabled_tax.push("1");
				}
				if (self.is_tax2())
				{
					self.enabled_tax.push("2");
				}
				if (self.is_tax3())
				{
					self.enabled_tax.push("3");
				}

				for (var key in self)
				{
					if (self.hasOwnProperty(key) && Otime.i(self[key]) && typeof self[key].isDirty === 'function' && self[key].isDirty())
					{
						return true;
					}
				}
			});
		};

		_this.ProjectInvoiceListModel	= function(data) {
			var self	= this;

			data	= data || {};
			self.project_id 			= Otime.o(data.project_id || 0);
			self.project_name 			= Otime.o(data.project_name || '');
			self.project_code 			= Otime.o(data.project_code || '');
			self.billable_hours			= Otime.o(parseFloat(data.billable_hours || 0).toFixed(2));
			self.non_billable_hours 	= Otime.o(parseFloat(data.non_billable_hours || 0).toFixed(2));
			self.unap_billable_hours 	= Otime.o(parseFloat(data.unap_billable_hours || 0).toFixed(2));
			self.unap_non_billable_hours= Otime.o(parseFloat(data.unap_non_billable_hours || 0).toFixed(2));
			self.expense_total 			= Otime.o(parseFloat(data.expense_total || 0).toFixed(2));
			self.unap_expense_total 	= Otime.o(parseFloat(data.unap_expense_total || 0).toFixed(2));
			self.is_checked				= Otime.o(data.is_checked || false);
			self.last_invoiced			= Otime.o(data.last_invoiced || 0);
			
		};

		_this.PaymentModel	= function(data) {
			var self	= this;

			data	= data || {};
			self._info	= {};

			self.invoice_payment_id 	= Otime.o(data.invoice_payment_id || 0);
			self.invoice_id 			= Otime.o(data.invoice_id || 0);
			self.invoice_number			= Otime.o(data.invoice_number || 0);
			self.payment_number			= Otime.o(data.payment_number || '');
			self.amount					= Otime.o(parseFloat(data.amount || 0).toFixed(2));
			self.description			= Otime.o(data.description || '');
			self.deposit_invoice_id		= Otime.o(data.deposit_invoice_id || 0);

			data.payment_date			= (data.payment_date ? Otime.stoj(data.payment_date) : new Date().getTime());
			self.payment_date			= Otime.o(new Date(data.payment_date));
			self.nav_date				= Otime.o(new Date(self.payment_date()).format(Otime.dateFormat || "MMM dd, yyyy"));

			self.payment_date.subscribe(function(newVal){
				self.nav_date(new Date(newVal).format(Otime.dateFormat || "MMM dd, yyyy"));
			});

			_this.pre_amount = 0;
			self.amount.subscribe(function (previousValue) {
				_this.pre_amount = (_this.pre_amount)?_this.pre_amount:previousValue;
			}, this, 'beforeChange');


			self.dtchange	= function(val){
				return function(item, elem){
					var dt	= new Date(self.payment_date());
					elem	= $("#date-picker");
					if (dt != null)
					{
						dt.addDays(Number(val));
						elem.datepicker("update", dt);
						elem.change();
					}
				};
			};
		};

		_this.date_changed	= function(item){
			if(_this.listModel.is_slide_modes && _this.listModel.is_slide_modes()==true)
				item.projects_invoices(item);
		};

		_this.UpdateContainers	= function(){
			_this.list_container	= $("#invoice-container");
			_this.view_container	= $("#view-layout");
			_this.edit_container	= $("#edit-layout");
			_this.add_container		= $("#edit-layout");
			_this.comment_container	= $("#comment_layout");
			_this.invoice_comment_container	= $("#invoice_comment_layout");
			_this.client_container	= $("#addclient");
		};

		_this.initVars = function(){
			_this.is_slide_opened	= Otime.o(false);
			_this.payment_selected	= Otime.o(null);
			_this.client_id		= _this.client_id || Otime.o(0);
			_this.project_ids	= _this.project_ids || Otime.a([]);
			_this.project_names	= _this.project_names || Otime.a([]);
			_this.date_filter	= _this.date_filter || Otime.a([]);
		};
		_this.init	= function(){

			_this.UpdateContainers();
			Otime.unbind();
			_this.initVars();

			_this.listModel	= Otime.app.model	= new _this.InvoiceListModel();
			_this.listModel.loadFilters(_this.listModel.refresh);

			ko.applyBindings(_this.listModel, _this.list_container.get(0));

			$(".page-container").unbind("scroll").scroll(function(){
				if($(".page-container")[0].scrollHeight == $(".page-container").scrollTop()+$(".page-container").height() && _this.listModel.finish() == false && _this.listModel.is_edit_mode()!=true)
				{
					_this.listModel.finish(-1);
					_this.listModel.load_more();
				}
				if (_this.listModel.finish()==true)
				{
					Otime.unbind();
				}
			});			
		};
	};
}(window.Otime));
