﻿(function(Otime){

	Otime.InvoicePopup	= new function InvoicePopup(){
//		"use strict";

		var _this	= this;

		_this.name	= "invoice";

		_this.page	= "details";

		_this.isDeposit	= false;

		_this.model	= "InvoiceContentModel";

		_this.language	= null;		
		
		_this.date_filter	= null;

        _this.filter_labels = null;

		_this.InvoicePopupModel = function(){
			var self = this;
			
			self.selectedItem = Otime.o();

			self.payment_save = function(){};

			self.payment = function(){};

			self.payment_remove = function(){};			
		};			
		
		_this.project_invoices = function(inv){
			var post_data = {client_id : inv.client_id(), invoice_id : inv.invoice_id()};

			if (inv._info.date_filter_type()!='ALL') {
				$.extend(post_data, {
					start_date : new Date(inv.date_filter.from_date()).format(Otime.sdf),
					finish_date : new Date(inv.date_filter.to_date()).format(Otime.sdf)
				});
			}
			if(Otime.Invoice.project_ids().length>0) {
				$.extend(post_data, {'project_id': Otime.Invoice.project_ids(), 'filter_project_id':  Otime.Invoice.project_ids()});
			}

			Otime.app.loadData(new Otime.ContextModel('invoice_details', post_data, function(cont){
				var data	= cont.response || {};
				inv.check_all(false);
				inv.project_listing([]);
				inv._info.enable_check_all(false);
				if (Object.keys(data.items).length) {
					var p_invoices	= {};
					if (data.p_invoices && Object.keys(data.p_invoices).length) {
						p_invoices	= data.p_invoices.otvalues.setKeys(data.p_invoices.otkeys, null,'project_id');
					}
					data.items	= data.items.otvalues.setKeys(data.items.otkeys, function(val){
						val.last_invoiced = (p_invoices[val.project_id])?p_invoices[val.project_id].invoice_id:0;
						val.is_checked = false;
						if (inv.imported_data && (inv.imported_data().project_ids && $.inArray(val.project_id, inv.imported_data().project_ids)!=-1) || (inv._info.project_ids() && $.inArray(val.project_id, inv._info.project_ids())!=-1)) {
							if (Number(val.billable_hours) || Number(val.unap_billable_hours) || Number(val.expense_total) || Number(val.unap_expense_total)) {
								val.is_checked = true;
							}							
						}
						if ((Number(val.billable_hours) >0 ||  Number(val.unap_billable_hours) >0 || Number(val.expense_total) >0)) {
							inv._info.enable_check_all(inv._info.enable_check_all() + true);
						}
						inv.project_listing.push(new Otime.Invoice.ProjectInvoiceListModel(val));
					});
				}				
			}));
		};
		
		_this.date_changed	= function(item){
//console.log("date_changed : ", item._info.date_filter_type(), item.date_filter.from_date(), item.date_filter.to_date());
			//if(Otime.Invoice.listModel.is_slide_modes && Otime.Invoice.listModel.is_slide_modes()==true)
				_this.project_invoices(item);
		};

		_this.init	= function(){
			Otime.Invoice.initVars();
			Otime.Invoice.listModel = new _this.InvoicePopupModel();			
//console.log("***otime invoice",Otime.Invoice);
		
			var inv = new Otime.Invoice.InvoiceContentModel({}, Otime.Invoice.listModel);			
			Otime.date_filter(inv, _this);		
			inv.import_cancel = function() {
			}
			inv.import_projects = function() {
				var self = inv;
				
				if (self.project_listing().length) {
						self.imported_data	= Otime.a([]);
						var project_ids	= [];
						self.imported_projects_names	= Otime.a([]);
						
						$.each(self.project_listing(), function(key, val){
							if (val.is_checked())
							{
								project_ids.push(val.project_id());
								self.imported_projects_names.push(val.project_name());
							}
						});

						if (project_ids.length &&  confirm(Otime.Invoice.language["IMPORT_ITEMS_CONFIRM_MSG"]) == true)
						{
							self.imported_data({
								project_ids: project_ids,
								invoice_hours : Number(self._info.invoice_hours()),
								//detail_hours 	 : self._info.detail_hours(),
								invoice_expenses : Number(self._info.invoice_expenses()),
								detail_expenses : self._info.detail_expenses(),
								group_by : {
									project : Number(self._info.gp_project()), 
									tasktype : Number(self._info.gp_tasktype()),
									member : Number(self._info.gp_member()),
									date : Number(self._info.gp_date()),
									activity : Number(self._info.gp_activity())
								}
							});
//console.log(self._info);
							if (self._info.date_filter_type()!='ALL')
							{
								$.extend(self.imported_data(),{
									start_date : new Date(self.date_filter.from_date()).format(Otime.sdf),
									finish_date : new Date(self.date_filter.to_date()).format(Otime.sdf)
								});
							}
							if (self.invoice_id())
							{
								$.extend(self.imported_data(),{invoice_id:self.invoice_id()});
							}
//console.log("*******self.imported_data()",self.imported_data())
							Otime.app.postData(new Otime.ContextModel('import_projects', self.imported_data(), function(cont){								
								window.opener.importResponse(JSON.stringify(cont.response));
							}));
						}
						else if (!project_ids.length)
						{
							alert(Otime.Invoice.language["SELECT_PROJECTS"]);
							return false;
						}
					}
			}
			ko.applyBindings(inv, $("#invoice-container").get(0));
			
			inv.client_id("<?php echo isset($_GET['client_id']) ? $_GET['client_id'] : '58';?>");
			//_this.project_invoices(inv);

		};
	};
}(window.Otime));
