(function (Otime) {

	Otime.MyTasks = new function MyTasks() {
		// "use strict";

		var _this = this;

		_this.name = "tasks";

		_this.model = "MyTasksListModel";

		_this.language = "tasks";

		_this.appModel = null;

		_this.fromPage = "";

		_this.custom_mod = [];
		_this.custom_mod_storage = [];
		_this.cfByFCode = {};

		_this.details = {
			//			all_users: {},
			//			projects: {},
			//			task_status: {},
			//			task_types: {},
			//			project_users: {},
			//			project_task_types: {},
			followers: {}
		};

		var repeat_params = function (self) {
			self.repeat_options = Otime.a([
				{ 'value': '-1', 'name': 'None', 'enabled': ko.observable(true) },
				{ 'value': 'D', 'name': 'Every Day', 'enabled': ko.observable(true) },
				{ 'value': 'WD', 'name': 'Every Weekday', 'enabled': ko.observable(true) },
				{ 'value': 'W', 'name': 'Every Week', 'enabled': ko.observable(true) },
				{ 'value': 'MD', 'name': 'Every Month', 'enabled': ko.observable(true) },
				{ 'value': 'M', 'name': Otime.o('Every Month'), 'enabled': ko.observable(true) }
			]);
			self.repeat_frequency = {
				'W': [{ value: 0, name: 'Sunday' }, { value: 1, name: 'Monday' }, { value: 2, name: 'Tuesday' }, { value: 3, name: 'Wednesday' }, { value: 4, name: 'Thursday' }, { value: 5, name: 'Friday' }, { value: 6, name: 'Saturday' }]
				//'MH' :[{value:1,name:'1st'},{value:2, name:'2nd'}],
			};
		}

		var flagFollowers = false;

		var weekAndDay = function (date) {
			if (!date) {
				date = new Date;
			} else {
				date = new Date(date);
			}
			var days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday',
				'Thursday', 'Friday', 'Saturday'];
			var prefixes = ['1st', '2nd', '3rd', '4th', '5th'];

			return prefixes[0 | Math.floor(date.getDate() / 7)] + ' ' + days[date.getDay()];
		}


		_this.MyTasksListModel = function (data) {
			var self = this;

			data = data || {};

			var is_On_Load = false;

			self.filters = Otime.o({});
			self.show_chart = Otime.o(false);			
			self.lineChart = Otime.a([]);
			self.labels = Otime.a([]);
			
			self.task_status = Otime.a(Object.values(Otime.Details.all_task_status));
			//self.sprint = Otime.a();

			self.custom_fields = Otime.a([]);
			self.custom_options = {};
			self.cfOptionsByVal = {};
			
			//if(self.fromPage != 'sprint'){
				//self.sprint = Otime.a(Object.values(Otime.Details.all_sprint));
			//}
			
			self.show_chart((_this.fromPage=='sprint')?true:false);
			self.task_types = Otime.a([]);
			self.addSprintPopup = Otime.o(null);
			self.sprintReportPopup = Otime.o(null);
			self.burndownChartPopup = Otime.o(null);
			self.completeSprintPopup = Otime.o(null);

			self.is_detail = Otime.o(false);
			self.inc_follow_tasks = Otime.o(Otime.Storage.get('inc_follow_tasks') - 0 || 0);

			self.inc_follow_tasks.subscribe(function (newVal) {
				self.loadData(true);
				Otime.Storage.set('inc_follow_tasks', (newVal - 0));
			});

			//			self.show_details	= function(item){
			//				self.is_detail(true);
			//				if (item && item.rp)
			//				{
			//					// item.rp().is_all(false);
			//					item.rp().onChangePane(-1)();
			//				}
			//			};
			self.swapDetails = function () {
				/*
				if (!self.rp_min_view() && !self.is_detail())
				{
					self.rp_min_view(true);
					return;
				}*/

				if (self.is_detail()) {
					self.is_detail(false);
					self.rp_min_view(true);
				}
				else {
					self.is_detail(true);
					self.rp_min_view(false);
				}
			};

			self.swapPane = function () {				
				self.selectedItem(null);
			};
			self.get_users = function (project_id) {
				var ret = [];
				ret.push({ user_id: 0, first_name: "Any User", last_name: "", user_image: "", is_active: 1 });
				$.each(Otime.Details.project_users[project_id()], function (key, val) {
					ret.push(Otime.Details.all_users[val]);
				});
				return ret;
			};

			// self.isProgFtr = Otime.o(false);
			self.projects = Otime.a([]);
			self.sprintproject_id = Otime.o("");
			//if(self.fromPage != 'sprint')		

			self.projects(Otime.Details.getActiveProjects());
			// Project filter
			self.project_id = Otime.a([]);
			var _projectid = "";

			self.onMyTasksProjectsChange = function() {				
				Otime.Storage.set("mytasks_project_id", self.project_id());
			}

			if(_this.fromPage != 'sprint'){			
				if (Otime.Storage.get("mytasks_project_id")) {	
					if((Otime.Storage.get("mytasks_project_id").length)>0){
						self.project_id(Otime.Storage.get("mytasks_project_id").split(","));		
					}
				}
			}else{				
				if(Number(Otime.Storage.get("tasks_project_id"))>0){				
					self.sprintproject_id(Number(Otime.Storage.get("tasks_project_id")));
					_projectid = Number(Otime.Storage.get("tasks_project_id"));
				}
			}
			
			// Sprint filter
			self.sprint = Otime.a([]);
			self.all_complete_sprint = Otime.a([]);
			self.completesprint_reportid = Otime.o("");
			self.sprintcompletetask_count = Otime.o(0);
			self.sprintpendingtask_count = Otime.o(0);
			self.sprintnewtask_count = Otime.o(0);
			self.sprint_id = Otime.a([]);
			var tmpArr = [];
			$.each(Otime.Details.all_sprint, function (key, val) {
				if(val.project_id == _projectid){
					tmpArr.push(val)
				}
			});
			self.sprint(tmpArr);
			tmpArr = [];
			var index = 0;
			$.each(Otime.Details.completed_sprint, function (key, val) {
				if(val.project_id == _projectid){
					tmpArr.push(val)
					if(index==0){
						self.sprintcompletetask_count(val.task_count);
						self.sprintpendingtask_count(val.pending_task_ids != "" ? JSON.parse(val.pending_task_ids).length : 0);
						self.sprintnewtask_count(val.new_task_ids != "" ? JSON.parse(val.new_task_ids).length : 0);
					}
					index++;
				}
			});
			self.all_complete_sprint(tmpArr);
			self.project_sprint_id = Otime.o("");			
			
			self.get_tasktypes = function (project_id) {
				var ret = [];
				$.each(Otime.Details.project_task_types[project_id()], function (key, val) {
					ret.push(Otime.Details.all_task_types[val]);
				});
				return ret;
			};

			self.filter = Otime.o(Otime.Storage.get("mytasks_filter", "over_due"));

			self.selectFilter = function (item) {
				self.filter(item.key);
			};
			self.trig_load = true;
			self.filter.subscribe(function (newVal) {
				if (!newVal || newVal === "undefined") {
					return false;
				}

				self.selectedItem(null);
				Otime.Storage.set("mytasks_filter", newVal);
				self.trig_load && self.loadData(is_On_Load);
				self.trig_load = true;
				is_On_Load = false;
			});

			self.listing = Otime.a([]);
			self.selectedItem = Otime.o();

			repeat_params(self);

			var is_details_loaded = false;
			self.loadDetails = function (clbk) {
				if (is_details_loaded) {
					typeof clbk === "function" && clbk();
					return;
				}

				is_details_loaded = true;
				var filters = {
					"over_due": {
						key: "over_due",
						count: Otime.o(0),
						value: "Overdue",
						is_visible: Otime.o(true)
					},
					"due_today": {
						key: "due_today",
						count: Otime.o(0),
						value: "Due Today",
						is_visible: Otime.o(true)
					},
					"due_week": {
						key: "due_week",
						count: Otime.o(0),
						value: "Due This Week",
						is_visible: Otime.o(true)
					}
				};

				/* Task Users Begins */
				// _this.details.all_users	= Otime.Details.all_users;
				/* Task Users End */

				/* Task Projects Begins */
				// _this.details.projects	= Otime.Details.all_projects;
				/* Task Projects End */

				/* Task Status Begins */
				//_this.details.default_status	= "";
				var style = "<style type='text/css'>";
				var rule = ".mytasks .filters.ft##ID##{background-color:##BGCOLOR##;border-bottom-color:##BGCOLOR##;color:##FGCOLOR##;}.mytasks .filters.ft##ID##.active{color:##BGCOLOR##;}";

				// _this.details.task_status	= Otime.Details.all_task_status;
				//_this.details.default_status	= Otime.Details.default_status;
				// _this.details.open_status	= Otime.Details.open_status;
				$.each(Otime.Details.all_task_status, function (key, itm) {
					if (!(itm.is_closed - 0)) {
						filters[itm.task_status_id - 0] = {
							key: itm.task_status_id - 0,
							count: Otime.o(0),
							value: itm.name,
							is_visible: Otime.o(false)
						};
						style += rule.replace(/##ID##/g, itm.task_status_id).replace(/##BGCOLOR##/g, itm.bg_color).replace(/##FGCOLOR##/g, itm.text_color);
					}
				});

				// self.task_status(Object.values(Otime.Details.all_task_status));
				style += "</style>";
				$(style).appendTo("head");

				self.filters(filters);
				/* Task Status End */

				// _this.details.task_types	= Otime.Details.all_task_types;

				// _this.details.project_users	= Otime.Details.project_users;
				// _this.details.project_task_types	= Otime.Details.project_task_types;

				typeof clbk === "function" && clbk();
			};

			var toggleView = function (isHide) {
				$("#mytasks-container")[isHide ? "hide" : "show"]();
			};

			self.beforeMove = function (params) {
				if (params.targetParent.filter_type == params.sourceParent.filter_type) {
					params.cancelDrop = true;
				}
				if (self.groupType() == "date" && params.targetParent.filter_type == "is_over_due") {
					params.cancelDrop = true;
					Otime.error_message("Cannot move task to overdue!", $("#alert_message"));
				}
			};

			self.afterMove = function (params) {

				switch (self.groupType()) {
					case "date":
						var cur_date = Otime.Date();
						switch (params.targetParent.filter_type) {
							case "is_over_due":
								// cur_date.addDays(-7);
								return;
								break;
							case "is_tomorrow":
								cur_date.addDays(1)
								break;
							case "is_today":
								break;
							default:
								cur_date.addDays(7);
								break;
						}
						params.item.finish_date(cur_date);
						break;
					case "status":
						params.item.task_status_id(params.targetParent.filter_type);
						break
					case "tasktypes":
						params.item.task_type_id(params.targetParent.filter_type);
						break;
				}

				if (self.is_detail())
					self.save(params.item);
			};

			var groups = {
				date: [
					{ name: 'Over Due', value: 'is_over_due', count: Otime.o(0), closed_count: Otime.o(0), bg: '#f2dede', tc: '#a94442' },
					{ name: 'Today', value: 'is_today', count: Otime.o(0), closed_count: Otime.o(0), bg: '#dff0d8', tc: '#3c763d' },
					{ name: 'Tomorrow', value: 'is_tomorrow', count: Otime.o(0), closed_count: Otime.o(0), bg: '#fcf8e3', tc: '#8a6d3b' },
					{ name: 'Later', value: 'is_later', count: Otime.o(0), closed_count: Otime.o(0), bg: '#337ab7', tc: '#fff' }
				],
				status: [],
				tasktypes: [],
				alltasks: [],
				mytasks: [],
				bystatus: [],
				byassignee: [],
				bytasktypes: []
			};

			self.active_tasks = Otime.o();
			self.active_sprint = Otime.a([]);
			self.current_sprint = Otime.a([]);
			self.active_projects = Otime.a([]);
			self.listing_groups = Otime.a();
			self.fromPage = _this.fromPage//Otime.o();			
			self.groupType = Otime.o();	// date | status
			self.groupType.subscribe(function (newVal) {
				if(self.fromPage != 'sprint'){
					self.listing_groups(groups[newVal]);
					self.applySlimScroll();
				}
			});
			self.groupTypeBy = Otime.o();	
			self.groupTypeBy.subscribe(function (newVal) {
				self.listing_groups(groups[newVal]);
				self.applySlimScroll();
			});

			self.isShowClosed = {};

			self.showClosed = function (itm, e) {
				self.isShowClosed[itm.value](!self.isShowClosed[itm.value]());
				if (self.isShowClosed[itm.value]()) {
					e.currentTarget.scrollIntoView();
				}
			};

			//self.groupType("status");
			var grouped_data = {};
			var closed_data = {};
			var filters = {
				date: function (filter_type, index, isClosed) {
					if (!self.isShowClosed[filter_type]) {
						self.isShowClosed[filter_type] = Otime.o(false);
					}
					if (isClosed && closed_data[filter_type]) {
						return closed_data[filter_type];
					}

					var ret = [];
					var closed = [];
					ko.utils.arrayForEach(self.listing(), function (task) {
						if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0) {
							return;
						}

						// disable closed status tasks
						if (Otime.Details.all_task_status[task.task_status_id()] && Otime.Details.all_task_status[task.task_status_id()].is_closed - 0 && !task.is_closed_today()) {
							return;
						}

						if (task[filter_type]()) {
							if (task.is_closed_today()) {
								closed.push(task);
							} else {
								ret.push(task);
							}
						}
					});

					/*
										var ret	= ko.utils.arrayFilter(self.listing(), function(task){
											if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0)
											{
												  return false;
											}
					
											// disable closed status tasks
											if (Otime.Details.all_task_status[task.task_status_id()] && Otime.Details.all_task_status[task.task_status_id()].is_closed-0 && !task.is_closed_today()) {
												return false;
											}
					
											return task[filter_type]();
										});
					*/

					groups[self.groupType()][index].count(ret.length);
					groups[self.groupType()][index].closed_count(closed.length);

					if (!grouped_data[filter_type]) {
						grouped_data[filter_type] = Otime.a();
						closed_data[filter_type] = Otime.a();
					}
					grouped_data[filter_type](ret);
					closed_data[filter_type](closed);

					grouped_data[filter_type].filter_type = filter_type;
					closed_data[filter_type].filter_type = filter_type;

					return grouped_data[filter_type];
				},
				status: function (filter_type, index, isClosed) {
					if (!self.isShowClosed[filter_type]) {
						self.isShowClosed[filter_type] = Otime.o(false);
					}
					if (isClosed && closed_data[filter_type]) {
						return closed_data[filter_type];
					}

					var ret = ko.utils.arrayFilter(self.listing(), function (task) {
						if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0) {
							return false;
						}

						return task.task_status_id() == filter_type;
					});
					groups[self.groupType()][index].count(ret.length);
					if (!grouped_data[filter_type]) {
						grouped_data[filter_type] = Otime.a();
					}
					grouped_data[filter_type](ret);
					grouped_data[filter_type].filter_type = filter_type;
					return grouped_data[filter_type];
				},
				bystatus: function (filter_type, index, isClosed) {
					if (!self.isShowClosed[filter_type]) {
						self.isShowClosed[filter_type] = Otime.o(false);
					}
					if (isClosed && closed_data[filter_type]) {
						return closed_data[filter_type];
					}
					var arrSprint = [];
					var ret = ko.utils.arrayFilter(self.listing(), function (task) {
						if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0) {
							return false;
						}

						if (self.sprint_id().length && self.sprint_id()[0]!="-1" && self.sprint_id().indexOf(task.sprint_id()) < 0) {
							return false;
						}

						if (self.groupType()=='mytasks' && task.assignee_id() - 0 != Otime.UID) {
							return false;
						}

						if(arrSprint.indexOf(task.sprint_id())<0) arrSprint.push(task.sprint_id());

						$.each(Otime.Details.all_sprint, function (key, val) {
							if (task.sprint_id() == val.sprint_id) {
								self.current_sprint(val);
							}
						});
						if(self.sprint_id().length && self.sprint_id()[0]=="-1" && Otime.Details.close_status == (task.task_status_id() - 0)){
							return false;
						}
						return task.task_status_id() == filter_type;
					});
					groups[self.groupTypeBy()][index].count(ret.length);
					if (!grouped_data[filter_type]) {
						grouped_data[filter_type] = Otime.a();
					}
					grouped_data[filter_type](ret);
					grouped_data[filter_type].filter_type = filter_type;
					return grouped_data[filter_type];
				},
				bytasktypes: function (filter_type, index, isClosed) {
					if (!self.isShowClosed[filter_type]) {
						self.isShowClosed[filter_type] = Otime.o(false);
					}
					if (isClosed && closed_data[filter_type]) {
						return closed_data[filter_type];
					}					
					var ret = [];
					var closed = [];
					var arrSprint = [];
					ko.utils.arrayForEach(self.listing(), function (task) {
						if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0) {
							return;
						}

						if (self.sprint_id().length && self.sprint_id()[0]!="-1" && self.sprint_id().indexOf(task.sprint_id()) < 0) {
							return false;
						}

						if (self.groupType()=='mytasks' && task.assignee_id() - 0 != Otime.UID) {
							return false;
						}

						if(arrSprint.indexOf(task.sprint_id())<0) arrSprint.push(task.sprint_id());

						$.each(Otime.Details.all_sprint, function (key, val) {
							if (task.sprint_id() == val.sprint_id) {
								self.current_sprint(val);
							}
						});
						if(self.sprint_id().length && self.sprint_id()[0]=="-1" && Otime.Details.close_status == (task.task_status_id() - 0)){
							return false;
						}
						if (task.task_type_id() == filter_type) {
							if (Otime.Details.close_status == (task.task_status_id() - 0)) {
								closed.push(task);
							} else {
								ret.push(task);
							}
						}
					});

					groups[self.groupTypeBy()][index].count(ret.length);
					groups[self.groupTypeBy()][index].closed_count(closed.length);

					if (!grouped_data[filter_type]) {
						grouped_data[filter_type] = Otime.a();
					}
					grouped_data[filter_type](ret);

					if (!closed_data[filter_type]) {
						closed_data[filter_type] = Otime.a();
					}
					closed_data[filter_type](closed);

					grouped_data[filter_type].filter_type = filter_type;
					closed_data[filter_type].filter_type = filter_type;
					return grouped_data[filter_type];
				},
				tasktypes: function (filter_type, index, isClosed) {
					if (!self.isShowClosed[filter_type]) {
						self.isShowClosed[filter_type] = Otime.o(false);
					}
					if (isClosed && closed_data[filter_type]) {
						return closed_data[filter_type];
					}

					/*
					var ret	= ko.utils.arrayFilter(self.listing(), function(task){
						if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0)
						{
							return false;
						}

						return task.task_type_id() == filter_type;
					});
					*/
					var ret = [];
					var closed = [];
					var arrSprint = [];
					ko.utils.arrayForEach(self.listing(), function (task) {
						if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0) {
							return;
						}

						if (self.sprint_id().length && self.sprint_id().indexOf(task.sprint_id()) < 0) {
							return false;
						}

						if(arrSprint.indexOf(task.sprint_id())<0) arrSprint.push(task.sprint_id());

						$.each(Otime.Details.all_sprint, function (key, val) {
							if (task.sprint_id() == val.sprint_id) {
								self.current_sprint(val);
							}
						});

						if (task.task_type_id() == filter_type) {
							if (Otime.Details.close_status == (task.task_status_id() - 0)) {
								closed.push(task);
							} else {
								ret.push(task);
							}
						}
					});

					groups[self.groupType()][index].count(ret.length);
					groups[self.groupType()][index].closed_count(closed.length);

					if (!grouped_data[filter_type]) {
						grouped_data[filter_type] = Otime.a();
					}
					grouped_data[filter_type](ret);

					if (!closed_data[filter_type]) {
						closed_data[filter_type] = Otime.a();
					}
					closed_data[filter_type](closed);

					grouped_data[filter_type].filter_type = filter_type;
					closed_data[filter_type].filter_type = filter_type;
					return grouped_data[filter_type];
				},
				mytasks: function (filter_type, index, isClosed) {
					if (!self.isShowClosed[filter_type]) {
						self.isShowClosed[filter_type] = Otime.o(false);
					}
					if (isClosed && closed_data[filter_type]) {
						return closed_data[filter_type];
					}
					var arrSprint = [];
					var ret = ko.utils.arrayFilter(self.listing(), function (task) {						
						if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0) {
							return false;
						}

						if (self.sprint_id().length && self.sprint_id().indexOf(task.sprint_id()) < 0) {
							return false;
						}

						if (task.assignee_id() - 0 != Otime.UID) {
							return false;
						}

						if(arrSprint.indexOf(task.sprint_id())<0) arrSprint.push(task.sprint_id());

						$.each(Otime.Details.all_sprint, function (key, val) {
							if (task.sprint_id() == val.sprint_id) {
								self.current_sprint(val);
							}
						});
						return task.task_status_id() == filter_type;
					});										
					groups[self.groupType()][index].count(ret.length);
					if (!grouped_data[filter_type]) {
						grouped_data[filter_type] = Otime.a();
					}
					grouped_data[filter_type](ret);
					grouped_data[filter_type].filter_type = filter_type;
					return grouped_data[filter_type];
				},
				alltasks: function (filter_type, index, isClosed) {
					if (!self.isShowClosed[filter_type]) {
						self.isShowClosed[filter_type] = Otime.o(false);
					}
					if (isClosed && closed_data[filter_type]) {
						return closed_data[filter_type];
					}
					var arrSprint = [];
					var ret = ko.utils.arrayFilter(self.listing(), function (task) {
						if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0) {
							return false;
						}

						if (self.sprint_id().length && self.sprint_id().indexOf(task.sprint_id()) < 0) {
							return false;
						}

						if(arrSprint.indexOf(task.sprint_id())<0) arrSprint.push(task.sprint_id());

						$.each(Otime.Details.all_sprint, function (key, val) {
							if (task.sprint_id() == val.sprint_id) {
								self.current_sprint(val);
							}
						});
						return task.task_status_id() == filter_type;
					});										
					groups[self.groupType()][index].count(ret.length);
					if (!grouped_data[filter_type]) {
						grouped_data[filter_type] = Otime.a();
					}
					grouped_data[filter_type](ret);
					grouped_data[filter_type].filter_type = filter_type;
					return grouped_data[filter_type];
				},
				byassignee: function(filter_type, index, isClosed) {
					if (!self.isShowClosed[filter_type]) {
						self.isShowClosed[filter_type] = Otime.o(false);
					}
					if (isClosed && closed_data[filter_type]) {
						return closed_data[filter_type];
					}
					var arrSprint = [];
					var ret = ko.utils.arrayFilter(self.listing(), function (task) {						
						if (self.project_id().length && self.project_id().indexOf(task.project_id()) < 0) {
							return false;
						}

						if (self.sprint_id().length && self.sprint_id()[0]!="-1" && self.sprint_id().indexOf(task.sprint_id()) < 0) {
							return false;
						}

						if(arrSprint.indexOf(task.sprint_id())<0) arrSprint.push(task.sprint_id());

						$.each(Otime.Details.all_sprint, function (key, val) {
							if (task.sprint_id() == val.sprint_id) {
								self.current_sprint(val);
							}
						});
						if(self.sprint_id().length && self.sprint_id()[0]=="-1" && Otime.Details.close_status == (task.task_status_id() - 0)){
							return false;
						}
						return task.assignee_id() == filter_type;
					});
					groups[self.groupTypeBy()][index].count(ret.length);
					if (!grouped_data[filter_type]) {
						grouped_data[filter_type] = Otime.a();
					}
					grouped_data[filter_type](ret);
					grouped_data[filter_type].filter_type = filter_type;
					return grouped_data[filter_type];
				}
			};

			self.taskFilter = function (filter_type, index, isClosed) {
				filter_type = filter_type || self.listing_groups()[0];
				if(self.fromPage == 'sprint' && self.groupType() != undefined && self.groupType() != '' && (self.groupTypeBy() == undefined || self.groupTypeBy()=='')){
					self.groupTypeBy(Otime.Storage.get("mytasks_view_by") || "bystatus");
				}
				return (self.groupTypeBy() && typeof filters[self.groupTypeBy()] === "function" ? filters[self.groupTypeBy()](filter_type, index, isClosed) : (self.groupType() && typeof filters[self.groupType()] === "function" ? filters[self.groupType()](filter_type, index, isClosed) : ""));
			};

			self.applySlimScroll = function () {
				$('.task-list-group').css('min-height', ($(window).innerHeight() - 150) + 'px');
				$('.task-list-group').css('maxHeight', ($(window).innerHeight() - 150) + 'px');
				$('.task-list-group').css('overflow-y', 'scroll');
				$('ul.list-group').css('min-height', ($(window).innerHeight() - 150) + 'px');
				/*$('ul.list-group').slimScroll({
					maxHeight:($(window).innerHeight()-180),
					alwaysVisible: true
				});
				$('.slimScrollDiv').css('overflow', '');*/
			}

			self.loadData = function (isOnLoad) {
				is_On_Load = isOnLoad;
				self.loadDetails(function () {
					var postData = {
						task_follow: self.inc_follow_tasks() - 0,
						project_id: (Array.isArray(self.project_id()) ? self.project_id().join(',') : self.project_id())
					};
					if(self.fromPage=="sprint")
						postData["sprint"] = self.project_sprint_id();//(self.sprint_id().length > 0 ) ? self.sprint_id().length : [0];
					Otime.app.loadData(new Otime.ContextModel("myactive_tasks", postData, function (cont) {
						var resp = cont.response;
						if (resp.followers) {
							_this.details.followers = resp.followers;
						}

						var arr = [], arrSprint = [], arrProjects = [];
						var statusList = {}, tmp_tasks = {}, timesheets = {}, status_cnt = {}, tasktypesList = [];
						if (resp.timesheets && Object.keys(resp.timesheets).length) {
							resp.timesheets = resp.timesheets.otvalues.setKeys(resp.timesheets.otkeys, null, 'project_task_id');
						}

						if (resp.par_items && Object.keys(resp.par_items).length) {
							resp.par_items = resp.par_items.otvalues.setKeys(resp.par_items.otkeys, null, 'task_id');
						} else {
							resp.par_items = [];
						}
						
						if (resp.items && Object.keys(resp.items).length) {
							_this.Keys = resp.items.otkeys;
							resp.items.otvalues = Object.values(resp.items.otvalues);
							resp.items = resp.items.otvalues.setKeys(_this.Keys, function (val, key) {
								var tmp_status = (val.task_status_id - 0) || Otime.Details.default_status;
								status_cnt[tmp_status] = 1;
								val.timesheet = {};

								// apply running timesheet if exist in task
								if (resp.par_items[val.parent_task_id]) {
									val.parent_task_name = resp.par_items[val.parent_task_id].name;
								}

								// apply running timesheet if exist in task
								if (resp.timesheets && resp.timesheets[val.task_id + ""]) {
									val.timesheet = resp.timesheets[val.task_id + ""];
								}
								tmp_tasks = new _this.MyTasksContentModel(val, self);

								// set in active tasks when timesheet running
								if (tmp_tasks.timesheet() && tmp_tasks.timesheet().tsheet._info.is_running()) {
									self.active_tasks(tmp_tasks.timesheet().tsheet);
									Otime.app.running_process(tmp_tasks.timesheet());
								}
								if(arrSprint.indexOf(tmp_tasks.org_data.sprint_id)<0) arrSprint.push(tmp_tasks.org_data.sprint_id);
								if(arrProjects.indexOf(tmp_tasks.org_data.project_id)<0) arrProjects.push(tmp_tasks.org_data.project_id)
								arr.push(tmp_tasks);
							});
						}
						if (resp.custom_mod && resp.custom_mod.otvalues) {
							_this.custom_mod.forEach(function (itm) {
								itm.fEnable = 0;
							});

							// Convert resp.custom_mod.otvalues to a Set of fNames
							const respFNamesSet = new Set(resp.custom_mod.otvalues.map(val => val[1])); // Assuming fName is the second element in each inner array

							// Filter _this.custom_mod to keep only objects with fName present in respFNamesSet
							_this.custom_fields = _this.custom_mod.filter(item => respFNamesSet.has(item.fName));
							_this.custom_mod = _this.custom_mod.filter(item => respFNamesSet.has(item.fName));	
	
							resp.custom_mod = resp.custom_mod.otvalues.setKeys(resp.custom_mod.otkeys, function (val) {
								val.id = val.id - 0;
								val.fEnable = 1;
								val.fCode = val.fCode || ("cf_" + val.id);								
								_this.custom_mod.push(val);								
								
							});
						}
						if (resp.custom_fields && resp.custom_fields.otvalues) {
							var cust_fields = [];
							resp.custom_fields = resp.custom_fields.otvalues.setKeys(resp.custom_fields.otkeys, function (val) {
								val.id = val.id - 0;
								val.isSys = val.isSys - 0;
	
								val.fCode = "cf_" + val.id;
	
								if (_this.cfByFCode[val.fCode]) {
									val.fEnable = 1;
									_this.cfByFCode[val.fCode] = Object.assign(_this.cfByFCode[val.fCode], val);
								}
								else {
									val.fEnable = 1;
									_this.cfByFCode[val.fCode] = val;
								}
	
								if (val.fOptions) {
									val.fOptions = JSON.parse(val.fOptions);
	
									if (val.fOptions.items && val.fOptions.items.length) {
										if (typeof val.fOptions.items == "string") {
											val.fOptions.items = val.fOptions.items.split(",");
										}
										_this.appModel.custom_options[val.fCode] = val.fOptions.items;
	
										if (!_this.appModel.cfOptionsByVal[val.fCode]) {
											_this.appModel.cfOptionsByVal[val.fCode] = {};
										}
	
										$.each(val.fOptions.items, function (key, fOpt) {
											_this.appModel.cfOptionsByVal[val.fCode][fOpt.val] = fOpt;
										});
									}
								}
								_this.custom_mod.push(val);
							});
	
							_this.custom_fields = resp.custom_fields;
							_this.appModel.custom_fields(resp.custom_fields);
						}
						self.active_sprint(arrSprint);
						self.active_projects(arrProjects);
						// else {

						if (!groups.status.length) {
							$.each(Otime.Details.all_task_status, function (key, val) {
								if (val.task_status_id - 0) {
									statusList[val.sort_order] = {
										name: val.name,
										value: val.task_status_id,
										count: Otime.o(0),
										closed_count: Otime.o(0),
										bg: val.bg_color,
										tc: val.text_color,
										system_defined: val.system_defined
									};
								}
							});
							groups.status = Object.values(statusList);
						}

						if (!groups.bystatus.length) {
							$.each(Otime.Details.all_task_status, function (key, val) {
								if (val.task_status_id - 0) {
									statusList[val.sort_order] = {
										name: val.name,
										value: val.task_status_id,
										count: Otime.o(0),
										closed_count: Otime.o(0),
										bg: val.bg_color,
										tc: val.text_color,
										system_defined: val.system_defined
									};
								}
							});
							groups.bystatus = Object.values(statusList);
						}

						if (!groups.byassignee.length) {
							statusList = {};
							var tmp_tt = [];
							$.each(Otime.Details.getProjects(), function (key, val) {
								if (Otime.Details.project_users[val.project_id]) {
									tmp_tt = tmp_tt.concat(Otime.Details.project_users[val.project_id]);
								}
							});
							var pro_tt = [];
							$.each(tmp_tt, function (i, el) {
								if ($.inArray(el, pro_tt) === -1) pro_tt.push(el);
							});
							$.each(Otime.Details.getAllUsers(), function (key, val) {
								if ($.inArray(val.user_id, pro_tt) !== -1) {
									if (val.is_active-0) {
										statusList[val.user_id] = {
											name: val.first_name + (val.last_name ? " " + val.last_name : ""),
											value: val.user_id,
											count: Otime.o(0),
											closed_count: Otime.o(0),
											bg: "#dff0d8",
											tc: "#3c763d",
											system_defined: ""
										};
									}
								}
							});
							groups.byassignee = Object.values(statusList);
						}

						if (!groups.tasktypes.length) {
							var tmp_tt = [];
							$.each(Otime.Details.getProjects(), function (key, val) {
								if (Otime.Details.project_task_types[val.project_id]) {
									tmp_tt = tmp_tt.concat(Otime.Details.project_task_types[val.project_id]);
								}
							});
							var pro_tt = [];
							$.each(tmp_tt, function (i, el) {
								if ($.inArray(el, pro_tt) === -1) pro_tt.push(el);
							});
							$.each(Otime.Details.getTaskTypes(), function (key, val) {
								if ($.inArray(val.task_type_id, pro_tt) !== -1) {
									groups.tasktypes.push({
										name: val.name,
										value: val.task_type_id,
										count: Otime.o(0),
										closed_count: Otime.o(0),
										bg: '#dff0d8',
										tc: '#3c763d',
										system_defined: ''
									});
								}
							});
						}

						if (!groups.bytasktypes.length) {
							var tmp_tt = [];
							$.each(Otime.Details.getProjects(), function (key, val) {
								if (Otime.Details.project_task_types[val.project_id]) {
									tmp_tt = tmp_tt.concat(Otime.Details.project_task_types[val.project_id]);
								}
							});
							var pro_tt = [];
							$.each(tmp_tt, function (i, el) {
								if ($.inArray(el, pro_tt) === -1) pro_tt.push(el);
							});
							$.each(Otime.Details.getTaskTypes(), function (key, val) {
								if ($.inArray(val.task_type_id, pro_tt) !== -1) {
									groups.bytasktypes.push({
										name: val.name,
										value: val.task_type_id,
										count: Otime.o(0),
										closed_count: Otime.o(0),
										bg: '#dff0d8',
										tc: '#3c763d',
										system_defined: ''
									});
								}
							});
						}

						if (!groups.alltasks.length) {	
							statusList = {};
							$.each(Otime.Details.all_task_status, function (key, val) {
								if(self.fromPage=="sprint"){
									if(val.name != ''){
										statusList[val.sort_order] = {
											name: val.name,
											value: val.task_status_id,
											count: Otime.o(0),
											closed_count: Otime.o(0),
											bg: val.bg_color,
											tc: val.text_color,
											system_defined: val.system_defined
										};
									}
								}else{
									if (val.system_defined != '') {
										statusList[val.sort_order] = {
											name: val.name,
											value: val.task_status_id,
											count: Otime.o(0),
											closed_count: Otime.o(0),
											bg: val.bg_color,
											tc: val.text_color,
											system_defined: val.system_defined
										};
									}
								}
							});
							groups.alltasks = Object.values(statusList);
						}

						if (!groups.mytasks.length) {	
							statusList = {};
							$.each(Otime.Details.all_task_status, function (key, val) {
								if(self.fromPage=="sprint"){
									if(val.name != ''){
										statusList[val.sort_order] = {
											name: val.name,
											value: val.task_status_id,
											count: Otime.o(0),
											closed_count: Otime.o(0),
											bg: val.bg_color,
											tc: val.text_color,
											system_defined: val.system_defined
										};
									}
								}else{
									if (val.system_defined != '') {
										statusList[val.sort_order] = {
											name: val.name,
											value: val.task_status_id,
											count: Otime.o(0),
											closed_count: Otime.o(0),
											bg: val.bg_color,
											tc: val.text_color,
											system_defined: val.system_defined
										};
									}
								}
							});
							groups.mytasks = Object.values(statusList);
						}

						self.listing(arr);
						if(self.fromPage=="sprint" && is_On_Load){
							self.swap_view_tasks(Otime.Storage.get("mytasks_view_sprint") || "alltasks")();
						}else{
							self.swap_view(Otime.Storage.get("mytasks_view") || "date")();
						}						
						self.applySlimScroll();						

						//self.groupType(Otime.Storage.get("mytasks_view_sprint") || "alltasks");
						//self.taskFilter(Otime.Storage.get("mytasks_view_sprint") || "alltasks", 0, 0)
					}));
				});
			};

			self.swap_view_tasks = function(view){
				return function() {
					if(self.fromPage=="sprint"){
						self.groupTypeBy(Otime.Storage.get("mytasks_view_by") || "bystatus");
					}
					Otime.Storage.set("mytasks_view_sprint", view);
					self.selectedItem(null);
					self.groupType(view);
					if(self.fromPage=="sprint"){
						self.swap_view_by(Otime.Storage.get("mytasks_view_by") || "bystatus");
					}
				}
			}

			self.swap_view = function (view) {
				return function () {					
					Otime.Storage.set("mytasks_view", view);
					self.selectedItem(null);
					self.groupType(view);					
				}
			};

			self.swap_view_by = function(view) {
				return function () {
					Otime.Storage.set("mytasks_view_by", view);
					self.selectedItem(null);
					self.groupTypeBy(view);
				}
			};

			self.onProjectsChange = function() {		
				var _projectid = self.sprintproject_id();//self.project_id()[0];											
				Otime.app.loadData(new Otime.ContextModel("current_week_sprint", {"project_id":self.sprintproject_id()}, function (cont) {				
					var _projectval = [];
					_projectval.push(_projectid);
					self.project_id(_projectid);
					Otime.Storage.set("tasks_project_id", _projectid);
					var tmpArr = [];
					$.each(Otime.Details.all_sprint, function (key, val) {
						if (_projectid == val.project_id) {
							tmpArr.push(val)
						}
					});
					tmpArr.push({sprint_id: -1,name: "All Open Tasks"});
					self.sprint(tmpArr);
					tmpArr = [];
					var index = 0;
					$.each(Otime.Details.completed_sprint, function (key, val) {
						if(val.project_id == _projectid){
							tmpArr.push(val)
							if(index==0){
								self.sprintcompletetask_count(val.task_count);
								self.sprintpendingtask_count(val.pending_task_ids != "" ? JSON.parse(val.pending_task_ids).length : 0);
								self.sprintnewtask_count(val.new_task_ids != "" ? JSON.parse(val.new_task_ids).length : 0);
							}
							index++;
						}						
					});
					self.all_complete_sprint(tmpArr);
					var resp = cont.response;
					var sprintArr = [];
					if(resp.length > 0){
						sprintArr.push(resp[0].sprint_id);
					}else{
						sprintArr.push(tmpArr.length > 0?tmpArr[0].sprint_id:"");
					}
					self.sprint_id(sprintArr)
					self.project_sprint_id(sprintArr);
					/*self.taskFilter("sprint", 0, 0);*/
				}));
			}

			self.onSprintdrpChange = function() {
				var _sprintval = []
				_sprintval.push(self.project_sprint_id());				
				self.sprint_id(_sprintval);
				self.taskFilter("sprint", 0, 0);
				//self.swap_view_tasks(Otime.Storage.get("mytasks_view_sprint") || "alltasks")();
				self.loadData(true);
			}
			
			self.sprint_name = "";
			self.sprint_duration = "";
			self.start_time = "";
			self.end_time = "";
			self.pendingsprint_id = Otime.o("");			
			self.completesprint_id = Otime.o("");
			self.completesprint_name = Otime.o("");
			self.pendingtasks = Otime.o(0);
			self.closedtasks = Otime.o(0);
			self.pendingtasks_taskids = Otime.o([]);
			self.sprintstart_date = new Date().format(Otime.sdf);
			self.sprintend_date = Otime.o(new Date(new Date().getTime()+(7*24*60*60*1000)).format(Otime.sdf));

			self.onSprintChange = function() {				
				if(self.sprint_duration != 0){
					self.sprintend_date(new Date(new Date(self.sprintstart_date).getTime()+(self.sprint_duration*24*60*60*1000)));
				}
			};

			self.onCompleteSprintReportChange = function(){
				$.each(self.all_complete_sprint(), function (key, val) {				
					if (self.completesprint_reportid() == val.sprint_id){
						self.sprintcompletetask_count(val.task_count);
						self.sprintpendingtask_count(val.pending_task_ids != "" ? JSON.parse(val.pending_task_ids).length : 0);
						self.sprintnewtask_count(val.new_task_ids != "" ? JSON.parse(val.new_task_ids).length : 0);
					}
				});
			}

			self.onPendingSprintChange = function() {
				//console.log("**********pendingsprint_id",self.pendingsprint_id(),self.pendingtasks_taskids())
			};

			self.savePendingTasks = function() {
				var _projectid = self.project_id()[0];
				var projectcode = "";				
				$.each(Otime.Details.all_projects, function (key, val) {
					if (val.project_id == _projectid) {
						projectcode = val.project_code;
						return false;
					}
				});	
				var url = Otime.siteUrl + "/sprint/complete";
                Otime.app.postData(new Otime.ContextModel(url, {"sprint_id":self.completesprint_id(),"pendingTaskId": self.pendingtasks_taskids()},  function(cont){
					var postData = {
						pendingTaskId: self.pendingtasks_taskids(),						
						project_id: _projectid,
						project_code: projectcode
					}
					if(self.pendingsprint_id()==0){
						Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/sprint/new_sprint", postData,  function(cont){
							var resp = cont.response;
							postData["sprint_id"] = resp.id;
							Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/sprint/update_sprint", postData,  function(cont){
								$("#completesprint-modal").modal('hide');
								var _sprintval = []
								_sprintval.push(resp.id);
								self.sprint_id(_sprintval);
								self.project_sprint_id(_sprintval);
							}),true);
						}),true);
					}else{
						postData["sprint_id"] = self.pendingsprint_id();
						Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/sprint/update_sprint", postData,  function(cont){
							$("#completesprint-modal").modal('hide');
							var _sprintval = []
							_sprintval.push(self.pendingsprint_id());	
							self.sprint_id(_sprintval);			
							self.project_sprint_id(_sprintval);
						}),true);
					}
                }),true);
			}
			
			self.onCompleteSprintChange = function() {
				self.pendingtasks(0);
				self.closedtasks(0);
				var pendingtasks = 0, closedtasks = 0, pendingissueIds = [];
				ko.utils.arrayForEach(self.listing(), function (task) {
					if (self.completesprint_id() != "" && self.completesprint_id()==task.sprint_id()) {
						if(task.org_data.is_closed==1)
							closedtasks += 1;
						else{
							pendingissueIds.push(task.task_id())
							pendingtasks += 1;
						}
					}
				});
				self.pendingtasks_taskids(pendingissueIds);
				$.each(Otime.Details.all_sprint, function (key, val) {
					if (self.completesprint_id() == val.sprint_id)
						self.completesprint_name(val.name);						
					else
						if(self.pendingsprint_id() == "") self.pendingsprint_id(val.sprint_id);
				});
				self.pendingtasks(pendingtasks);
				self.closedtasks(closedtasks);
			}

			self.cancelSPrint = function () {
				$("#addsprint-modal").modal('hide');
			}

			self.addSprint = function() {
				$("#addsprint-modal").modal('show');				
				self.addSprintPopup(self);
				const ms = 1000 * 60 * 30;
				var _currenttime = new Date(Math.round(new Date().getTime() / ms) * ms);
				$('#starttimepicker').timepicker({
					timeFormat: 'h:mm p',
					interval: 30,
					dynamic: false,
					dropdown: true,
					scrollbar: true,
					defaultTime: _currenttime.getHours() + ":" +_currenttime.getMinutes()
				});
				
				$('#endtimepicker').timepicker({
					timeFormat: 'h:mm p',
					interval: 30,
					dynamic: false,
					dropdown: true,
					scrollbar: true,
					defaultTime: _currenttime.getHours() + ":" +_currenttime.getMinutes()
				});
			};			

			self.saveSprint = function(item) {
				var postData = {
					name: self.sprint_name,
					duration: self.sprint_duration,
					start_date: self.sprintstart_date,
					end_date: self.sprintend_date(),
					start_time: $("#starttimepicker").val(),
					end_time: $('#endtimepicker').val()
				};
				if (self.sprint_name == '') {
					alert("Sprint Name Required.");
					return false;
				}
				if(new Date(self.sprintstart_date) > new Date(self.sprintend_date()))
				{
					alert('Start date should not be greater than End date');
					return false;
				}
				/*var url    = Otime.siteUrl + "/sprint/save";
                Otime.app.postData(new Otime.ContextModel(url, postData,  function(cont){
                    console.log("***********cpmt",cont);
                }), true);*/
			};

			self.burndownData = [];
			self.burndownType = Otime.o("E");
			self.burndownTitle = Otime.o("Estimated Hours");

			self.changeBurndownType = function(type){
				return function(item, elem){
					self.burndownType(type);
					self.burndownTitle(type=="S"?"Sprint Score":"Estimated Hours");
					self.openBurndownChart();
				};
			};

			self.scorePointCalc = function(total_est_hrs, est_hrs_list) {
				var date1 = new Date(self.current_sprint().start_date);
				var date2 = new Date(self.current_sprint().end_date);	
				var Difference_In_Time = date2.getTime() - date1.getTime();							
				var Difference_In_Days = Difference_In_Time / (1000 * 3600 * 24);
				var arrData = [];
				var totalHrs = parseInt(total_est_hrs);
				for (let i = 0; i <= Difference_In_Days; i++) {	
					var dateFound = false;	
					if(i > 0){
						dateFound = est_hrs_list.some(function (el) {
							return new Date(el.actual_finish_date).format("MM/dd/yyyy") === new Date(date1).addDays(i - 1).format("MM/dd/yyyy");
						});
						if(dateFound){
							var _objesttask = est_hrs_list.filter((_item) => new Date(_item.actual_finish_date).format("MM/dd/yyyy") === new Date(date1).addDays(i - 1).format("MM/dd/yyyy"))
							totalHrs -= parseInt(_objesttask[0].points);
						}
					}
					arrData.push([new Date(date1).addDays(i).getTime(),totalHrs])						
				} 
				self.burndownData = arrData;
				$("#burndownchart-modal").modal('show');
				self.burndownChartPopup(self);
			};

			self.openBurndownChart = function() {	
				var url = (self.burndownType()=="E")?"burndown_report_esthrs":"burndown_report_score"
				Otime.app.loadData(new Otime.ContextModel(url, {
					sprint_id: self.sprint_id().toString(),
					start_date: new Date(self.current_sprint().start_date).format(Otime.sdf),
					end_date: new Date(self.current_sprint().end_date).format(Otime.sdf)
				}, function (cont) {
					var resp = cont.response.otvalues;
					var count = resp[0];
					var total_est_hrs = count[0].totalpoints;
					var est_hrs_list = resp[1];		
					self.scorePointCalc(total_est_hrs, est_hrs_list);		
				}));
			};

			self.sprintReport = function() {
				$("#sprint_report_modal").modal('show');
				self.sprintReportPopup(self);
			};

			self.completeSprint = function() {
				$("#completesprint-modal").modal('show');
				self.completeSprintPopup(self);				
				self.completesprint_id(self.sprint_id().toString());
				self.onCompleteSprintChange();
			};

			self.addItem = function () {
				self.is_detail(true);
				self.rp_min_view(false);				
				var project_id = (self.project_id().length)?self.project_id()[0]:Object.keys(Otime.Details.all_projects)[0];
				var objData = {
					project_id: project_id,
					created_by: Otime.UID,
					assignee_id: Otime.UID
					// followers:[Otime.UID+""]
				}
				if(self.fromPage == 'sprint')
					objData["sprint_id"] = self.sprint_id()[0];
				var newItem = new _this.MyTasksContentModel(objData, self);
				newItem.project_id.subscribe(function (newVal) {
					var tmp = Otime.Details.all_projects[newVal] || {};
					newItem.project_name(tmp.project_name);
				});
				self.selectedItem(newItem);
			};

			self.rp_min_view = Otime.o(true);
			self.toggle_rpview = function (item) {
				self.rp_min_view(!self.rp_min_view());
			};

			var start = function (time_sheet_id, item, task_ts) {
				if (!time_sheet_id) {
					return false;
				}

				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/timesheet/start', {
					time_sheet_id: time_sheet_id
				}, function (cont) {
					var resp = cont.response;

					if (self.active_tasks()) {
						var ts = self.active_tasks();
						ts._info.is_running(false);
						Otime.app.running_process(null);
						Otime.TimeSheet.ClearInterval();
						ts._info.hours_disp("");
						ts._info.is_running(false);
					}

					if ($("#popover").is(":visible"))
						$("#popover").hide();
					Otime.TimeSheet.curTime = resp.cur_time;
					Otime.Menu.curTime = resp.cur_time;

					item._info.is_running(true);
					self.active_tasks(item);
					Otime.app.running_process(task_ts);

					Otime.TimeSheet.SetInterval(resp.time, item, (Number(item.hours()) * 60 * 60), 'HH:NN<sub>SS</sub>');

					//					Otime.TimeSheet.SetInterval(cell._info.from_time, cell, (Number(cell.hours()) * 60 * 60), 'HH<span class="blink">:</span>NN');

					Otime.Menu.activeTask = {
						time_sheet_id: resp.time_sheet_id,
						activity_name: item.activity_name(),
						project_name: item._info.project_name(),
						is_progress: true,
						from_time: resp.time,
						hours: 0
					};
					Otime.Menu.initProgress();
				}), true);
			};

			self.stop = function (time_sheet_id, ts, clbk) {
				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/timesheet/stop', {
					time_sheet_id: time_sheet_id
				}, function (cont) {
					var resp = cont.response;

					ts._info.is_running(false);
					Otime.app.running_process(null);
					var prog = Otime.Menu.progress();
					if (prog) {
						prog.hours(resp.hours);
						prog.time_sheet_id(resp.time_sheet_id);
						resp.entry_date && prog.entry_date(Otime.stoj(resp.entry_date).format(Otime.jdf));
					}
					Otime.TimeSheet.ClearInterval();
					ts._info.hours_disp("");
					ts._info.is_running(false);
					self.active_tasks(null);
				}), true);
			};

			self.tsDetails = Otime.o();
			self.tsSaveStart = function (task_ts, save_only) {
				var item = task_ts.tsheet;

				if (!save_only && item.time_sheet_id()) {
					if (item._info.is_running()) {
						self.stop(item.time_sheet_id(), item);
					}
					else {
						start(item.time_sheet_id(), item, task_ts);
					}
					return false;
				}

				Otime.TimeSheet.TimeSheetSave(item, function (resp) {
					$("#popover").hide();
					if (!save_only) {
						start(resp.time_sheet_id, item, task_ts);
					}
				});
			};

			var _INITIALIZE_COMMENTS = function (item, clbk) {
				item.imgbox = Otime.o(null);
				new Otime.Comments.init({
					module_type: "T",
					module_id: item.task_id(),
					elem: "",
					parent: self,
					model: item,
					onToggleMinimize: function (isMin) {
						self.rp_min_view(isMin);
					},
					isSeparate: true,
					dropZone: "#comments-container",
					//					fileApi_buttonValue: '&nbsp;', // '<span class="icon icon-paper-clip"></span>',
					//					fileApi_buttonClass: 'dn',
					fileApi_buttonClass: 'blue anchor',
					noBind: true,
					onAddFile: function (newAttachItem) {
						newAttachItem && newAttachItem.save && newAttachItem.save();
					},
					onPaneChange: function (newVal) {
						self.is_detail(newVal <= 0 ? true : false);
					},
					onChangeCheckList: function (chk) {
						var chk_active = chk.checklist().filter(function (_itm) {
							return !_itm.is_closed();
						}).length;
						item.chkl_count(chk_active);
					},
					clbk: clbk
				});
			};

			self.showComments = function (item) {
				_INITIALIZE_COMMENTS(item, function (module) {
					module.paneType(module.paneTypes.COMMENT);
				});
				self.selectedItem(item);
				self.rp_min_view(false);
			};

			self.showAttachments = function (item) {
				_INITIALIZE_COMMENTS(item, function (module) {
					module.paneType(module.paneTypes.DOCUMENT);
				});
				self.selectedItem(item);
				self.rp_min_view(false);
			};

			self.edit = function (item) {
				_INITIALIZE_COMMENTS(item);
				self.selectedItem(item);
			};

			var isSave = false;
			self.save = function (item) {
				// if (isSave) { return; }
				isSave = true;
				var isNew = !item.task_id();
				_this.taskSave(item, self.rp_min_view(), function () {
					isSave = false;
					if (isNew && item.assignee_id() - 0 == Otime.UID) {
						self.listing.push(item);
					}
				});
			};
		};

		_this.taskSave = function (item, is_min_view, clbk) {
			if (!item.name()) {
				Otime.error_message("Task Name Required.", $("#alert_message"));
				return false;
			}

			var postData = {
				project_id: item.project_id(),
				sprint_id: item.sprint_id(),
				items: []
			};

			if (item.followers().indexOf(item.assignee_id() + "") < 0) {
				flagFollowers = true;
				item.followers.push(item.assignee_id());
				flagFollowers = false;
			}

			var data = {};
			if (item.task_type_id.isDirty())
				data.task_type_id = item.task_type_id();
			if (item.task_status_id.isDirty())
				data.task_status_id = item.task_status_id();
			if (item.assignee_id.isDirty())
				data.assignee_id = item.assignee_id() - 0;
			if (item.followers.isDirty())
				data.followers = item.followers();
			if (item.description.isDirty())
				data.description = item.description();
			if (item.finish_date.isDirty())
				data.finish_date = new Date(item.finish_date()).format(Otime.sdf);
			if (item.start_date.isDirty())
				data.start_date = new Date(item.start_date()).format(Otime.sdf);
			if (item.duration.isDirty())
				data.duration = item.duration();
			if (item.percentage_complete.isDirty())
				data.percentage_complete = item.percentage_complete();
			if (item.is_closed)
				data.is_closed = item.is_closed() ? 1 : 0;

			if (item.is_repeat.isDirty())
				data.is_repeat = item.is_repeat() == '-1' ? '' : item.is_repeat();
			if (item.is_repeat() != 'W' && item.is_repeat() == 'MD' && item.is_repeat() == 'M') {
				item.repeat_on('');
			}
			if (item.repeat_on.isDirty())
				data.repeat_on = item.repeat_on();

			if (!is_min_view) {
				if (item.name.isDirty())
					data.name = item.name();
				if (item.task_type_id.isDirty())
					data.task_type_id = item.task_type_id();
				// if (item.percentage_complete.isDirty())
				// 	data.percentage_complete = item.percentage_complete();
				if (item.task_priority.isDirty())
					data.task_priority = item.task_priority();
				if (item.estimated_hours.isDirty())
					data.estimated_hours = item.estimated_hours();
			}

			if (!item.task_id() && item.name()) {
				data.project_id = item.project_id();
				if(this.appModel.fromPage=="sprint") data.sprint_id = item.sprint_id();
				data.task_type_id = item.task_type_id();
				data.task_status_id = item.task_status_id();
				// data.assignee_id	= Otime.isA ? 0 : item.assignee_id();
				data.assignee_id = item.assignee_id() - 0;
			}

			if (Object.keys(data).length) {
				data.task_id = item.task_id();
				postData.items.push(data);
			}
			else {
				return false;
			}
			
			Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/tasks/save", postData, function (cont) {
				item.task_status_id.update();
				item.assignee_id.update();
				item.followers.update();
				item.description.update();
				item.name.update();
				item.task_type_id.update();
				item.percentage_complete.update();
				item.task_priority.update();
				item.estimated_hours.update();

				if (cont.response) {
					// var isNew	= !item.task_id();
					var resp = cont.response;
					!item.task_id() && item.task_id(resp.task_ids[0]);
					item.task_number();

					item.timesheet().tsheet.project_id(item.project_id() - 0);
					item.timesheet().tsheet.task_type_id(item.task_type_id() - 0);
					item.timesheet().tsheet.activity_name(item.name());
					item.timesheet().tsheet.project_task_id(item.task_id());

					typeof clbk === "function" && clbk(item);
				}
			}), true);
		};

		_this.MyTasksContentModel = function (data, parent) {
			var self = this;

			data = data || {};

			self.org_data = data;

			data.timesheet = data.timesheet || {};

			self._info = {};
			self._info.new_desc = Otime.o(true);
			self.task_id = Otime.o(data.task_id || "");
			self.parent_task_id = Otime.o(data.parent_task_id || 0);
			self.name = Otime.o(data.name || "").extend({
				taskChange: true
			});

			self.parent_task_name = Otime.o(data.parent_task_name || "").extend({
				taskChange: true
			});
			self.description = Otime.o(data.description || "").extend({
				taskChange: true
			});
			self.description.subscribe(function () {
				!parent.is_detail() && parent.save(self);
				self._info.new_desc(true);
			});

			self.task_number = Otime.o(data.task_number || "");			
			self.project_id = Otime.o(data.project_id || "");
			self.sprint_id = Otime.o(data.sprint_id || "");
			self.story_point = Otime.o(data.story_point || "0");
			self.is_billable = Otime.o(data.is_billable || 1);

			self.custom_values = {}
			data.custom_values = data.custom_values || {};
//console.log("********data",_this.custom_fields)
			$.each(_this.custom_fields, function (key, val) {
				var k = "cf_" + val.id;
				switch (val.fType) {
					case "user":
						self.custom_values[k] = Otime.o();
						self._info[k] = Otime.o();
						self.custom_values[k].subscribe(function (newVal) {
							updateChangeData(k, newVal, true);

							var usrs = Otime.Details.all_users;
							self._info[k]((usrs && usrs[newVal]) ? usrs[newVal].first_name : '');
						});
						self.custom_values[k](data.custom_values[k] || "");
						break;
					case "users":
						self.custom_values[k] = Otime.a([]);
						self._info[k] = Otime.o();
						self.custom_values[k].subscribe(function (newVal) {
							updateChangeData(k, newVal, true);

							var usrs = Otime.Details.all_users;// _this.appModel.users();
							var opt = [];

							for (var i = 0, iLen = newVal.length; i < iLen; i++) {
								if (usrs && usrs[newVal[i]]) {
									opt.push(usrs[newVal[i]].first_name);
								}
								else if (newVal[i] == Otime.UID) {
									opt.push(Otime.UFNAME);
								}
							}

							self.form._info[k](opt.join(", "));
						});
						if (data.custom_values[k] && !Array.isArray(data.custom_values[k])) {
							data.custom_values[k] = data.custom_values[k].split(",");
						}
						self.custom_values[k](data.custom_values[k] || []);
						break;
					default:
						var bg = "";
						if (val.fType == "select" && val.fOptions) {
							if (data.custom_values[k] && !Array.isArray(data.custom_values[k])) {
								data.custom_values[k] = data.custom_values[k].split(",");
							}
							self.custom_values[k] = Otime.a(data.custom_values[k] || []);							
						}else{
							self.custom_values[k] = Otime.o(data.custom_values[k] || "");
						}
						break;
				}
			});

			self.task_type_id = Otime.o(data.task_type_id || "").extend({
				taskChange: true
			});
			self.task_type_id.subscribe(function (newVal) {
				!parent.is_detail() && parent.save(self);
			});

			self.percentage_complete = Otime.o(data.percentage_complete || "").extend({
				taskChange: true
			});
			self.worked_hours = Otime.o(data.worked_hours || "");

			self.task_priority = Otime.o(data.task_priority || 2).extend({
				taskChange: true
			});
			self.estimated_hours = Otime.o(data.estimated_hours || "").extend({
				taskChange: true
			});
			self.is_milestone = Otime.o(!!(data.is_milestone - 0)).extend({
				taskChange: true
			});
			self.is_parent = Otime.o(!!(data.is_parent - 0)).extend({
				taskChange: true
			});
			var flagD = false, flagS = false, flagF = false;
			self.duration = Otime.o(data.duration || "").extend({
				taskChange: true
			});
			self.duration.subscribe(function (newVal) {
				if (flagD) {
					return;
				}

				if (self.start_date()) {
					var finish = null;
					finish = new Date(self.start_date());
					finish.addDays(self.duration() - 0);

					flagF = true;
					self.finish_date(finish);
					flagF = false;
				}

				!parent.is_detail() && parent.save(self);
			});

			self.actual_finish_date = Otime.o(null);
			self.is_closed_today = Otime.o(false);

			self.actual_finish_date.subscribe(function (newVal) {
				var afd = new Date(newVal);
				self.is_closed_today(afd.isToday());
			});

			self.actual_finish_date(Otime.stoj(data.actual_finish_date));
			self.start_date = Otime.o(Otime.stoj(data.start_date)).extend({
				taskChange: true
			});

			self.start_date.subscribe(function (newVal) {
				var start = new Date(self.start_date());
				start.addDays(self.duration() - 0);

				flagF = true;
				self.finish_date(start);
				flagF = false;

				var tmp = parent.repeat_options();
				if (newVal) {
					tmp[5].name('Every Month (on ' + weekAndDay(newVal) + ')');
				} else {
					tmp[5].name('Every Month (on ' + weekAndDay(new Date()) + ')');
					//is_enb = false;
				}
				parent.repeat_options(tmp)
				reload_chosen(self);

				!parent.is_detail() && parent.save(self);
			});
			self.finish_date = Otime.o(Otime.stoj(data.finish_date)).extend({
				taskChange: true
			});
			self.is_over_due = Otime.o(false);
			self.is_today = Otime.o(true);
			self.is_tomorrow = Otime.o(false);
			self.is_later = Otime.o(false);
			self.chkl_count = Otime.o(data.chkl_count - 0 || 0);

			if (self.finish_date()) {
				var fDt = new Date(self.finish_date());
				self.is_over_due = Otime.o(fDt.isPast() && !fDt.isToday());
				self.is_today = Otime.o(fDt.isToday());
				self.is_tomorrow = Otime.o(fDt.isTomorrow());
				self.is_later = Otime.o(!self.is_over_due() && !self.is_today() && !self.is_tomorrow());
			} else if (self.start_date()) {
				var fDt = new Date(self.start_date());
				self.is_today = Otime.o(fDt.isPast() || fDt.isToday());
				self.is_tomorrow = Otime.o(fDt.isTomorrow());
				self.is_later = Otime.o(!self.is_over_due() && !self.is_today() && !self.is_tomorrow());
			}

			self.finish_date.subscribe(function (newVal) {
				var finish = new Date(self.finish_date());
				self.is_over_due(finish.isPast() && !finish.isToday());
				self.is_today(finish.isToday());
				self.is_tomorrow(finish.isTomorrow());
				self.is_later(!self.is_over_due() && !self.is_today() && !self.is_tomorrow());

				if (flagF) {
					return;
				}

				if (self.start_date()) {
					var start = new Date(self.start_date());
					var diff = (finish - start) / (1000 * 60 * 60 * 24);

					flagD = true;
					if (diff > 0) {
						self.duration(Math.round(diff));
					}
					else {
						self.duration("");
					}
					flagD = false;
				}

				!parent.is_detail() && parent.save(self);
			});

			self.created_by = Otime.o(Otime.Details.all_users[data.created_by]!=undefined?Otime.Details.all_users[data.created_by].first_name:"");
			self.has_attachments = Otime.o(!!(data.has_attachments - 0));
			self.has_comments = Otime.o(!!(data.has_comments - 0));

			var tmp = Otime.Details.all_projects[data.project_id] || {};
			self.project_name = Otime.o(data.project_name || tmp.project_name || "");
			self.project_color = Otime.o(data.bg_color || tmp.bg_color || "");
			var tmp = Otime.Details.all_users[data.assignee_id] || {};
			self.user_name = Otime.o(tmp.first_name || "");
			self.user_image = Otime.o(tmp.user_image || "assets/img/noimg_32.png");

			tmp = "";
			if (!!(self.task_type_id() - 0) && Otime.Details.all_task_types[self.task_type_id()]) {
				tmp = Otime.Details.all_task_types[self.task_type_id()].name;
			}
			self.task_type_name = Otime.o(tmp);

			data.task_status_id = ((data.task_status_id - 0) || Otime.Details.default_status) + "";
			self.task_status_id = Otime.o(data.task_status_id).extend({
				taskChange: true
			});
			self.task_status_id.subscribe(function (newVal) {
				self.task_status(Otime.Details.all_task_status[newVal] || {});
				if (!!(self.task_status().is_closed - 0)) {
					self.actual_finish_date(new Date());
				} else {
					self.is_closed(false);
					self.is_closed_today(false);
					self.actual_finish_date(null);
				}

				!parent.is_detail() && parent.save(self);
			});

			self.is_closed = Otime.o(!!(data.is_closed - 0));

			tmp = Otime.Details.all_task_status[data.task_status_id];
			self.task_status = Otime.o(tmp || {});

			self.is_repeat = Otime.o((data.is_repeat || 0) + "").extend({
				taskChange: true
			});
			self.repeat_on = Otime.o(data.repeat_on || 1).extend({
				taskChange: true
			});

			/*self.is_repeat 	= Otime.o((data.is_repeat || 0)+"");
			self.repeat_on	= Otime.o(data.repeat_on || 1);*/
			self.is_repeat.subscribe(function (newVal) {
				if (newVal == 'M') {
					var tmp_date = self.start_date() ? new Date(self.start_date()) : new Date();
					self.repeat_on(Math.floor(tmp_date.getDate() / 7) + "" + tmp_date.getDay());
				}
			});
			self.repeat_on.subscribe(function (newVal) {
				if (self.is_repeat() != 'M' && newVal) {
					if (newVal > 31) { self.repeat_on(31); return; }
					if (newVal <= 0) { self.repeat_on(1); return; }
				}
			});

			var reload_chosen = function (self) {
				$('#is_repeat').trigger("chosen:updated");
				if (self.is_repeat() == 'M') {
					var tmp_date = self.start_date() ? new Date(self.start_date()) : new Date();
					self.repeat_on(Math.floor(tmp_date.getDate() / 7) + "" + tmp_date.getDay());
				}
			}
			if (typeof data.followers == 'string') {
				data.followers = data.followers.split(',');
			}
			var followers = data.followers || (_this.details.followers[data.task_id] && $.unique(_this.details.followers[data.task_id].split(",")) || []);

			var _followers = [];
			$.each(followers, function (key, val) {

				val = $.trim(val + "");
				if (_followers.indexOf(val) < 0) {
					_followers.push(val);
				}
			});
			self.followers = Otime.a(_followers).extend({
				taskChange: true
			});
			self.followers_disp = Otime.o("");
			var setFollowersDisp = function (newVal) {
				if (newVal) {
					newVal = $.unique(newVal);
					var tmp = "", res = [];
					var followers = self.followers();
					for (var i = 0, iLen = followers.length; i < iLen; i++) {
						tmp = Otime.Details.all_users[followers[i]];
						tmp && tmp.first_name && res.push(tmp.first_name);
					}
					self.followers_disp(res.join(", "));
				}
			};

			self.followers.subscribe(function (newVal) {
				setFollowersDisp(newVal);
				!flagFollowers && !parent.is_detail() && parent.save(self);
			});
			setFollowersDisp(self.followers());
			self.assignee_id = Otime.o(((data.assignee_id - 0) ? data.assignee_id : 0) || "").extend({
				taskChange: true
			});
			self.assignee = Otime.o("");
			var setAssignee = function (newVal) {
				tmp = Otime.Details.all_users[newVal];
				self.assignee(tmp ? tmp.first_name : "");
				if (typeof newVal !== 'string') {
					newVal = newVal + "";
				}
				if (self.followers().indexOf(newVal) < 0) {
					flagFollowers = true;
					self.followers.push(newVal);
					flagFollowers = false;
				}
				return true;
			};

			setAssignee(self.assignee_id());
			self.assignee_id.subscribe(function (newVal) {
				setAssignee(newVal) && !parent.is_detail() && parent.save(self);
			});

			self.worked_hours = Otime.o(data.worked_hours);

			var tooltip = "";
			//console.log("**********data",data,data.start_date.split("-")[0].length);
			tooltip += (!data.start_date || data.start_date == "0000-00-00" || data.start_date == "0000-00-00 00:00:00" || data.start_date.split("-")[0].length>4) ? "" : ("Start Date		:  " + Otime.stoj(data.start_date).format(Otime.dateFormat) + "\n");
			tooltip += (!data.finish_date || data.finish_date == "0000-00-00" || data.finish_date == "0000-00-00 00:00:00" || data.finish_date.split("-")[0].length>4) ? "" : ("Finish Date	:  " + Otime.stoj(data.finish_date).format(Otime.dateFormat) + "\n");
			tooltip += !(data.duration - 0) ? "" : "Duration		:  " + (data.duration + "\n");
			tooltip += !data.estimated_hours ? "" : ("Estimated Hrs	:  " + data.estimated_hours + "\n");
			tooltip += !data.worked_hours ? "" : ("Actual Hrs	:  " + data.worked_hours + "\n");

			self.tooltip = Otime.o(tooltip);

			// self.is_ts_running	= Otime.o(false);
			self.rp = Otime.o(null);// Right pane comments,attach,activities

			var entry_date = data.timesheet.entry_date ? Otime.stoj(data.timesheet.entry_date) : new Date();
			self.timesheet = Otime.o();

			var ttypes = parent.get_tasktypes(self.project_id);
			ttypes.splice(0, 0, {
				task_type_id: "0",
				name: "Select Task Types"
			});
			var newTsItem = {};
			if (data.timesheet.time_sheet_id) {

				data.timesheet.task_types = ttypes;
				data.timesheet.is_task_page = true;

				newTsItem = new Otime.TimeSheet.TimeSheetDetailModel(data.timesheet);
				newTsItem.addHoursDetail();
			}
			else {
				newTsItem = new Otime.TimeSheet.TimeSheetDetailModel({
					task_types: ttypes,
					time_sheet_id: 0,
					project_id: self.project_id() - 0,
					task_type_id: self.task_type_id() - 0,
					project_task_id: self.task_id() - 0,
					task_number: self.task_number() - 0,
					entry_date: entry_date,
					is_billable: self.is_billable() - 0,
					project_code: 0,
					project_name: self.project_name(),
					activity_name: self.name(),
					is_task_page: true
				});
				newTsItem.addHoursDetail();
			}

			var saveStart = function (_itm, elem, save_only) {
				save_only = save_only || false;
				//if (!$("#popover").is(":visible") && !_itm._info.is_running())
				if (!(_itm.task_type_id() - 0)) {
					parent.tsDetails(self.timesheet());
					$("#popover").show();
					return false;
				}
				return parent.tsSaveStart(self.timesheet(), save_only);
			};

			self.timesheet({
				tsheet: newTsItem,
				save: function (_itm, elem) {
					saveStart(_itm, elem, true)
				},
				start: saveStart,
				saveStart: saveStart,
				stop: function () {
					// Otime.app.running_process(null);
					newTsItem._info.hours_disp("");
					newTsItem._info.is_running(false);
					// parent.active_tasks(null);
				},
				cancel: function (_itm) {
					$("#popover").hide();
				}
			});
		};

		_this.showTask = function (ts_item, appModel) {
			var task_id = ts_item.project_task_id();
			var project_id = ts_item.project_id();

			if (!task_id || !project_id || !appModel) {
				return false;
			}

			Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + "/tasks/item", {
				project_id: project_id,
				task_id: task_id,
				module: "TS"
			}, function (cont) {
				var resp = cont.response;
				var data = resp.item;

				if (resp.users && resp.users.otvalues && Object.keys(resp.users.otvalues).length > 0) {
					var _users = {
						"0": {
							user_id: 0,
							first_name: "Any User",
							is_active: "1",
							last_name: "",
							user_role: "",
							user_image: ""
						}
					};
					resp.users = resp.users.otvalues.setKeys(resp.users.otkeys, function (val) {
						val.user_image = Otime.USIP + (val.user_image || "no_user.jpg");
						if (!!(val.is_active - 0)) {
							_users[val.user_id] = val;
						}
					}, "user_id");
					resp.users = _users;
				}
				/*
								if (resp.all_users && resp.all_users.otvalues && Object.keys(resp.all_users.otvalues).length > 0)
								{
									_this.details.all_users	= resp.all_users.otvalues.setKeys(resp.all_users.otkeys, null, "user_id");
								}
				
								if (resp.task_status && Object.keys(resp.task_status).length > 0)
								{
									var default_status;
									resp.task_status	= resp.task_status.otvalues.setKeys(resp.task_status.otkeys, function(val, key){
										if (!!(val.is_default-0))
										{
											default_status	= val.task_status_id;
											// _this.appModel.default_status	= val.task_status_id;
										}
				//						if (val.is_closed-0) {
				//							_this.appModel._info.closedStatusId	= val.task_status_id;
				//						}
									}, "task_status_id");
									/*
									resp.task_status["0"]	= {
										bg_color: "#FFF",
										is_closed: "0",
										is_default: "0",
										name: "",
										system_defined: "0",
										task_status_id: "0",
										text_color: "#FFF"
									};
									* /
									// _this.details.task_status	= resp.task_status;
									_this.details.default_status	= default_status;
				
									appModel.task_status(Object.values(resp.task_status));
								}
								if (resp.task_types && Object.keys(resp.task_types).length > 0)
								{
									resp.task_types	= resp.task_types.otvalues.setKeys(resp.task_types.otkeys, function(val){
										val.label	= val.name;
										val.value	= val.name;
										val.id	= val.task_type_id;
									}, "task_type_id");
									_this.details.task_types	= resp.task_types;
								}
				*/
				var taskObj = new function () {
					var self = this;
					self.isPane = Otime.o(true);
					self.is_pinned = Otime.o(true);
					self.swapPane = function () {
						appModel.isRightPane(false);
						appModel.task_detail(null);
					};
					self.swapDetails = function () {
						if (taskObj.is_detail()) {
							taskObj.is_detail(false);
							taskObj.rp_min_view(true);
						}
						else {
							taskObj.is_detail(true);
							taskObj.rp_min_view(false);
						}
					};
					self.showTimeLine = function () {
					};
					self.task_status = Object.values(Otime.Details.all_task_status);// Object.values(resp.task_status);
					self.get_tasktypes = function (project_id) {
						return Object.values(Otime.Details.getProjectTaskTypes(project_id()));
						//						return Object.values(Otime.Details.task_types);
					};
					self.get_users = function (project_id) {
						// ret.push({user_id:0,first_name:"Any User",last_name:"",user_image:"",is_active:1});
						return Object.values(Otime.Details.getProjectUsers(project_id()));
						// return Object.values(resp.users);
					};
					self.save = function (item) {
						_this.taskSave(item, self.rp_min_view());
					};
					repeat_params(self);
					self.selectedItem = Otime.o(null);
					self.selectedItem.subscribe(function (newItem) {
						var tmp = self.repeat_options();
						var is_enb = true;
						if (newItem.start_date()) {
							tmp[5].name('Every Month (on ' + weekAndDay(newItem.start_date()) + ')');
						} else {
							tmp[5].name('Every Month (on ' + weekAndDay(new Date()) + ')');
							//is_enb = false;
						}
						self.repeat_options(tmp);
						$('#is_repeat').trigger("chosen:updated");
					});
					self.selectedItem(new _this.MyTasksContentModel(data, self));
					self.rp_min_view = Otime.o(true);
					self.is_detail = Otime.o(false);
				};

				var targ = taskObj.selectedItem();
				new Otime.Comments.init({
					module_type: "T",
					module_id: task_id,
					parent: taskObj, //_this.appModel,
					model: targ,
					isSeparate: true,
					noBind: true,
					//fileApi_buttonValue: '<span class="icon icon-paper-clip blue"></span>',
					fileApi_buttonClass: 'blue anchor',
					onAddFile: function (newAttachItem) {
						newAttachItem && newAttachItem.save && newAttachItem.save();
					},
					onToggleMinimize: function (isMin) {
						taskObj.is_detail(false);
						taskObj.rp_min_view(isMin);
					},
					onChangeCheckList: function (chk) {
						if (ts_item.chkl_count) {
							// ts_item.chkl_count(chk.checklist().length);
							var chk_active = chk.checklist().filter(function (_itm) {
								return !_itm.is_closed();
							}).length;
							ts_item.chkl_count(chk_active);
						}
					}
				});

				appModel.isRightPane(true);
				appModel.task_detail(taskObj);
			}), true);
		};

		_this.UpdateContainers = function () {
			_this.bodyCont = $("#body-container");
			_this.myTasksCont = $("#mytasks-container");
		};

		_this.loadTemplates = function (fromPage, clbk) {
			var url = Otime.siteUrl + '/tasks/mytasks_tmpl';
			_this.fromPage = fromPage
			if(fromPage=="sprint")
				Otime.Storage.set("mytasks_view", "sprint");
			else{
				if(Otime.Storage.get("mytasks_view")=="sprint")
					Otime.Storage.set("mytasks_view", "status");
			}
			Otime.loadTemplates(url, {
				v: Otime.version,
				r: Otime.usr
			}, function (content) {
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
				$('#list-container').css('height', ($(window).innerHeight() - 100));					
			}, "mytasks_" + Otime.version);
		};

		_this.Refresh = function () {					
			_this.appModel.loadData(true);
		};

		_this.init = function () {
			_this.UpdateContainers();
			if (Object.keys(Otime.Details.all_projects).length <= 0) {
				_this.myTasksCont.removeClass("dib").hide();
				$("body").addClass("loading");
				if (!Otime.Details.isInitialized) {
					Otime.Details.onReady(_this.init);
					return false;
				}
				Otime.show_propop('Track Your Time', 'Create your project to track your time');
				return false;
			}
			_this.myTasksCont.show().addClass("dib");
			$("body").removeClass("loading");

			_this.appModel = new _this.MyTasksListModel();

			ko.applyBindings(_this.appModel, _this.myTasksCont.get(0));
			//			ko.bindingHandlers.sortable.beforeMove	= _this.appModel.beforeMove;
			//			ko.bindingHandlers.sortable.afterMove	= _this.appModel.afterMove;
			if(_this.fromPage!='sprint') _this.Refresh();
		};
	};

}(window.Otime));
