(function (Otime) {

	Otime.Project = new function Project() {
		//		"use strict";

		var _this = this;

		_this.name = "project";

		_this.model = "ProjectListModel";

		_this.language = null;

		_this.clients = [];

		_this.budget_type = "AT";

		_this.budget_types = null;

		_this.invoice_types = null;

		_this.active_roles = null;

		_this.project_status = null;

		_this.fileApi = null;

		_this.CommentsHandler = null;

		_this.listModel = null;

		_this.currency_symbol = "";

		_this.dt_format = "";

		_this.addNew = function () {
			_this.listModel.addNew();
		};

		var project_ids = [];

		var newUser = function (data) {
			data = data || {};
			_this.listModel.isNewAdd(2);

			var assignModel = function () {
				var saveCallback = function (item, self) {
					Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/users/save", Otime.Users.prepareData(item), function (cont) {
						var response = cont.response;
						var isNew = (item.user_id() <= 0);
						if (isNew == true) {
							item.user_id(response.items.user_id);
							item._info.is_edit_permission(response.items.is_edit_permission);
						}

						if (response.items.user_image) {
							item.user_image(response.items.user_image);
							item.user_image_path(Otime.UMIP + response.items.user_image + "?time=" + new Date().getTime());
							item.oldImage(Otime.UMIP + response.items.user_image + "?time=" + new Date().getTime());
						}

						if (response.items.user_id) {
							data.onSave && data.onSave({
								first_name: item.first_name(),
								last_name: item.last_name(),
								user_name: item.first_name() + " " + item.last_name(),
								user_id: response.items.user_id,
								hourly_rate: item.hourly_rate(),
								user_image: item.user_image(),
								user_role: item.user_role()
							});
							_this.listModel.isNewAdd(0);
						}
					}), true);
				};
				var _newUser = new Otime.Users.UsersContentModel(null, {
					save: function (item) {
						if ((item.first_name.isValid() && item.email.isValid() && item.user_role() != '0')) {
							var comp_image = item.profile_image();
							if (comp_image) {
								Otime.Users.fileApi.url = Otime.siteUrl + '/attachment/users_image_upload/0/?cropData=' + JSON.stringify(item.cropData());
								Otime.Users.fileApi.onAfterUpload = function (data) {
									if (data && !data[0]) {
										// error(data[1]);
										Otime.error_message(data[1], $("#alert_message"));
										return;
									}

									item.user_image(data[2].file_name);
									item.user_image_path(Otime.UMIP + data[2].file_name + "?time=" + new Date().getTime());
									item.oldImage(Otime.UMIP + data[2].file_name + "?time=" + new Date().getTime());

									saveCallback(item);
								};
								Otime.Users.fileApi.uploadQueue();
							}
							else {
								saveCallback(item);
							}
						}
						else {
							if (item.email.isValid() == false && item.email())
								alert('Invalid Email id');
							else
								alert("Required field missing, please check.");
							return false;
						}
						return true;
					},
					cancel: function () {
						data.onCancel && data.onCancel();
						_this.listModel.isNewAdd(0);
					},
					removeImage: function (item) {
						Otime.Users.removeImage(item);
					},
					cropApply: function (item) {
						if (Otime.Users._cropObj) {
							_newUser.cropData(Otime.Users._cropObj.getCropData());
						}
					}
				});
				_this.listModel.newUser(_newUser);
				Otime.Users.applyFileApi(_newUser);
			};

			if (!Otime.app.hasBinding(_this.user_container)) {
				Otime.app.loadData(new Otime.ContextModel({
					url: Otime.siteUrl + "/users/template/edit",
					data: {
						module_type: "P"
					},
					type: "POST",
					dataType: "HTML",
					callback: function (response) {
						_this.UpdateContainers();
						_this.user_container.attr("data-bind", "with:newUser").html($("#user-panel").html());
						$(".panel-body", _this.user_container).html($.trim(response));

						Otime.Users.searchArray = {
							departments: []
						};

						if (Object.keys(Otime.Users.departments).length > 0) {
							var lbl = "";
							$.each(Otime.Users.departments, function (key, val) {
								lbl = val.department;
								Otime.Users.searchArray.departments.push({
									label: lbl,
									value: lbl,
									id: val.user_dept_id
								});
							});
						}

						//Otime.Users.fileApi	= Otime.Users.fileApi || new FileAPI();
						//Otime.Users.fileApi.fileField	= $("#profile_image", _this.user_container).get(0);
						//Otime.Users.fileApi.init();

						assignModel();
						ko.applyBindings({ newUser: _this.listModel.newUser }, _this.user_container.get(0));
					}
				}), true);
				return false;
			}
			else {
				assignModel();
			}
		};

		var newClient = function (data) {
			data = data || {};
			_this.listModel.isNewAdd(1);

			var assignModel = function () {
				var _newClient = new Otime.Client.ClientContentModel();
				_newClient.save = function (item) {
					if (item.contacts()[0].name() == '') {
						alert("at least 1 contact needed");
						return false;
					}
					var postData = Otime.Client.prepareData(item);
					Otime.app.postData(new Otime.ContextModel({
						url: Otime.siteUrl + "/clients/save",
						global: false,
						data: postData,
						callback: function (cont) {
							var response = cont.response;
							if (response.client_id) {
								data.onSave && data.onSave({
									client_id: response.client_id,
									client_name: (item.client_code() ? item.client_code() + " - " : "") + item.client_name()
								});
							}
							_this.listModel.isNewAdd(0);
						}
					}), true);
				};

				_newClient.cancel = function (item) {
					data.onCancel && data.onCancel();
					_this.listModel.isNewAdd(0);
				};
				_this.listModel.newClient(_newClient);
			};

			if (!Otime.app.hasBinding(_this.client_container)) {
				Otime.app.load_template(Otime.siteUrl + "/clients/template/edit", function (response) {
					$($.trim(response)).attr("data-bind", "with:newClient").appendTo(_this.client_container);
					assignModel();
					ko.applyBindings({ newClient: _this.listModel.newClient }, _this.client_container.get(0));
				}, true);
				return false;
			}
			else {
				assignModel();
			}
		};		

		_this.ProjectListModel = function (data) {
			var self = this;

			data = data || {};
			self._info = {};
			self._info.project_documents = Otime.o(true);
			self._info.project_users = Otime.o(true);
			self._info.project_tasks = Otime.o(true);
			self._info.tasks_checklist = Otime.o(true);
			self._type = Otime.o("");

			self.is_list_view = Otime.o(false);

			self.CommentsHandler = Otime.o(null);
			self.search_project = Otime.o('');

			self.export_project = function() {
				self.loadColumns();
				project_ids = [];

				var selectedColumns = self.availableColumns().filter(function(col) {
					return col.isSelected();
				});
				
				var columnNames = selectedColumns.map(function(col) {
					return col.column;
				});

				var fieldNames = selectedColumns.map(function(col) {
					return col.field_name;
				});	

				var data = {
					active: self.active(),
					filter_client_id: (self.sel_client().length > 0 ? self.sel_client() : []).join(","),
					onInit: 1,
					export: 1,
					project_name : self.search_project(),
					available_column: columnNames,
					field_names: fieldNames,
				};

				Otime.app.loadData(new Otime.ContextModel("export_csv", data, function (cont) {
					var file_name = cont.response.name.replace(' ', '_').replace(/-/g, '');
					$('#iframe_download').attr('src', Otime.siteUrl + '/report/download/' + file_name + "/project_report");
					return true;
				}));
			};

			self.search	= function(item, event){
				if (event.keyCode == 13)
				{	
					(self.refresh(self.active()))();
				}
				return true;
			};

			self.clearSearch = function () {
				if (self.search_project()) {
					self.search_project("");
					(self.refresh(self.active()))();
				}
			};
			
			self.lastSortedProperty = Otime.o(null);
			self.isAscending = Otime.o(true);

			self.sort = function (property) {
				var isAscending = true;
			
				if (self.lastSortedProperty === property) {
					isAscending = !self.isAscending;
				}
			
				self.items.sort(function (a, b) {
					var valueA, valueB;
			
					switch (property) {
						case 'project_name':
							valueA = a.project.project_name();
							valueB = b.project.project_name();
							break;
						case 'members_count':
							valueA = parseFloat(a.members_count()) || 0;
							valueB = parseFloat(b.members_count()) || 0;
							break;
						case 'client_name':
							valueA = a.client_name();
							valueB = b.client_name();
							break;							
						case 'status_name':
							valueA = a.status_name();
							valueB = b.status_name();
							break;						
						case 'actual_value':
							valueA = a.budget()._info.actual_hours();
							valueB = b.budget()._info.actual_hours();
							break;
						case 'budget_value':
							valueA = a.budget()._info.total_hours();
							valueB = b.budget()._info.total_hours();
							break;
						case 'uninvoiced_hours':
							valueA = parseFloat(a._info.uninvoiced_hours())|| 0;
							valueB = parseFloat(b._info.uninvoiced_hours()) || 0;
							break;
						case 'start_date':
							valueA = a.start_date();
							valueB = b.start_date();
							break;
						case 'target_date':
							valueA = a.target_date();
							valueB = b.target_date();
							break;
						default:
							return 0;
					}
			
					valueA = valueA || (typeof valueA === 'string' ? '' : 0);
					valueB = valueB || (typeof valueB === 'string' ? '' : 0);
			
					if (valueA < valueB) return isAscending ? -1 : 1;
					if (valueA > valueB) return isAscending ? 1 : -1;
					return 0;
				});
			
				self.isAscending = isAscending;
				self.lastSortedProperty = property;
			};
			
			self.swap_view = function () {
				self.loadColumns();
				self.is_list_view(!self.is_list_view());
				if (!self.is_list_view()) {
					_this.list_container.masonry("reload");
				}
				else {
					_this.list_container.css("height", "auto");
				}
			};

			 self.availableColumns = ko.observableArray([
				{ column: "Project", isSelected: ko.observable(true), "field_name":"project_name", "cssClass": "col-sm-2" },
				{ column: "Members Count", isSelected: ko.observable(true), "field_name":"members_count", "cssClass": "col-sm-1" },
				{ column: "Client", isSelected: ko.observable(false), "field_name":"client_name", "cssClass": "col-sm-1" },
				{ column: "Status", isSelected: ko.observable(true), "field_name":"status_name", "cssClass": "col-sm-1"},
				{ column: "Actual", isSelected: ko.observable(true), "field_name":"actual_value", "cssClass": "col-sm-1 ar" },
				{ column: "Budget", isSelected: ko.observable(false), "field_name":"budget_value", "cssClass": "col-sm-1 ar" },
				{ column: "Un-invoiced Hrs", isSelected: ko.observable(false), "field_name":"uninvoiced_hours", "cssClass": "col-sm-1 ar" },
				{ column: "Start Date", isSelected: ko.observable(true), "field_name":"start_date", "cssClass": "col-sm-1 ar" },
				{ column: "Target Date", isSelected: ko.observable(true), "field_name":"target_date", "cssClass": "col-sm-1 ac" },
				{ column: "", isSelected: ko.observable(true), field_name: "", cssClass: "col-sm-1 ac" }
			]);

			self.isColumnVisible = function (columnName) {
				return self.availableColumns().some(col => col.field_name === columnName && col.isSelected());
			};			
		
			self.saveColumns = function () {
				const selectedColumns = self.availableColumns()
					.filter(col => col.isSelected())
					.map(col => col.column);

				Otime.Storage.set("project_columns", selectedColumns);
				self.closeColumns();
			};
		
			self.loadColumns = function () {
				const savedColumns = Otime.Storage.get("project_columns");
				if (savedColumns) {
					self.availableColumns().forEach(col => {
						col.isSelected(savedColumns.includes(col.column));
					});
					self.availableColumns.push();
				}
			};			
		
			self.showColumns = function () {				
				$("#columnsModal").modal("show");
			};
		
			self.closeColumns = function () {
				$("#columnsModal").modal("hide");
			};

			self.items = Otime.a([]);
			self.selectedItem = Otime.o(null);
			self.duplicatePopUp = Otime.o(null);
			self.is_new_mode = Otime.o(false);

			self.show_loading = Otime.o(false);
			self.show_more = Otime.o(false);
			self.finish = Otime.o(true);
			self.is_edit_mode = Otime.o(false);
			self.is_comment_mode = Otime.o(false);
			self.is_show_comments = Otime.o(false);
			self.archive_count = Otime.o(0);
			self.active_count = Otime.o(0);
			self.page = 1;
			self.active = Otime.o(1);

			/*self.users			= Otime.a([]);
			self.projects		= Otime.a([]);
			self.sel_project	= Otime.o(["0"]);
			self.sel_user		= Otime.o(["0"]); */
			self.clients = Otime.a([]);
			self.sel_client = Otime.o(["0"]);

			/***
			 * 0 - None
			 * 1 - Client
			 * 2 - User
			 */
			self.isNewAdd = Otime.o(0);
			//			self.is_addclient	= Otime.o(false);
			//			self.is_adduser		= Otime.o(false);
			self.newClient = Otime.o(null);
			self.newUser = Otime.o(null);

			var ret = false, oldVal = [];
			/*self.sel_project.subscribe(function(oldValue){
				oldVal	= oldValue;
			}, null, "beforeChange");
			self.sel_project.subscribe(function(newVal){
				if (ret)
				{
					ret	= false;
					self.refresh(self.active());
					return true;
				}
				if (newVal.length <= 0)
				{
					ret	= true;
					self.sel_project(["0"]);
					return true;
				}
				if (Number(newVal[0]) <= 0)
				{
					ret	= true;
					if (oldVal.length==1 && newVal.length == 2)
					{
						newVal.splice(Number(oldVal[0] == newVal[1]), 1);
						self.sel_project(newVal);
						return true;
					}
					self.sel_project(["0"]);
					return true;
				}
				self.refresh(self.active());
			}); */

			self.sel_client.subscribe(function (oldValue) {
				oldVal = oldValue;
			}, null, "beforeChange");
			self.sel_client.subscribe(function (newVal) {
				if (ret) {
					ret = false;
					(self.refresh(self.active()))();
					return true;
				}
				if (newVal.length <= 0) {
					ret = true;
					self.sel_client(["0"]);
					return true;
				}
				if (Number(newVal[0]) <= 0) {
					ret = true;
					if (oldVal.length == 1 && newVal.length == 2) {
						newVal.splice(Number(oldVal[0] == newVal[1]), 1);
						self.sel_client(newVal);
						return true;
					}
					self.sel_client(["0"]);
					return true;
				}
				(self.refresh(self.active()))();
			});

			/*	var user_ret = false, user_oldVal	= [];
				self.sel_user.subscribe(function(oldValue){
					user_oldVal	= oldValue;
				}, null, "beforeChange");
				self.sel_user.subscribe(function(newVal){
					if (user_ret)
					{
						user_ret	= false;
						self.refresh(self.active());
						return true;
					}
					if (newVal.length <= 0)
					{
						user_ret	= true;
						self.sel_user(["0"]);
						return true;
					}
					if (Number(newVal[0]) <= 0)
					{
						user_ret	= true;
						if (user_oldVal.length==1 && newVal.length == 2)
						{
							newVal.splice(Number(user_oldVal[0] == newVal[1]), 1);
							self.sel_user(newVal);
							return true;
						}
						self.sel_user(["0"]);
						return true;
					}
					self.refresh(self.active());
				}); */

			self.swapMode = function () {
				self.selectedItem(new _this.ProjectContentModel(null, self));
				self.is_new_mode(false);
				self.is_edit_mode(false);
				Otime.Menu.ReplaceURL(_this.name);
			};

			self.rp_min_view = Otime.o(true);
			self.is_detail = Otime.o(false);
			var initComments = function () {
				var item = self.selectedItem();
				self.CommentsHandler(new Otime.Comments.init({
					module: "projects",
					module_type: "P",
					module_id: item.project_id(),
					model: item,
					parent: self,
					isSeparate: true,
					noBind: true,
					onToggleMinimize: function (isMin) {
						self.rp_min_view(isMin);
					},
					onAddFile: function (newAttachItem) {
						newAttachItem && newAttachItem.save && newAttachItem.save();
					}
				}));
			};

			self.show_comments = function () {
				_this.UpdateContainers();
				if (self.is_comment_mode() == true) {
					self.is_comment_mode(false);
					_this.comment_container.removeClass("opened").addClass("closed");
					return;
				}
				else {
					initComments();
					self.is_comment_mode(true);
					_this.comment_container.addClass('opened').removeClass('closed');
				}
			};

			self.save = function (item, elem) {
				item = self.selectedItem();

				if (item.is_valid() != true) {
					alert("Required field missing, please check.");
					return false;
				}
				if (item.project_id() <= 0) {
					item._info.isNew(true);
				}
				var data = JSON.parse(ko.toJSON(item.project));

				Otime.app.postData(new Otime.ContextModel({
					url: "save",
					global: false
				}, data, function (context) {
					var response = context.response;
					item.project.project_id(response.project_id);
					item.project_id(response.project_id);
					item.user_role(item.user_role() || response.user_role || "");
					self.items.unshift(item);
					self.swapMode();
					item.commit && item.commit();
					// reload common data
					Otime.Details.isInitialized = false;
					Otime.Details.init();
					self.view(item, elem, false);
				}));
			};

			self.saveAll = function (item, elem) {
				var item = self.selectedItem();
				var data = {};

				var project = item.project.prepareData();
				var budget = item.budget().prepareData();
				var config = item.config().prepareData();
				if (project === false || budget === false) {
					return false;
				}
				data.project = $.extend(project, budget, config);
				data.project.invoice_type = item.invoice.invoice_type();
				data.project.hourly_rate = item.invoice.hourly_rate();
				//				data.budget		= item.budget().prepareData();
				data.members = item.members().prepareData();
				data.task_types = item.task_types().prepareData();
				data.expense_types = item.expense_types().prepareData();
				data.document = item.document().prepareForNew();

				if (
					data.project === false ||
					data.project.invoice_type === false ||
					data.project.hourly_rate === false ||
					data.members === false ||
					data.task_types === false ||
					data.document === false
				) {
					return false;
				}

				Otime.app.postData(new Otime.ContextModel({
					url: "save_new",
					global: true
				}, data, function (context) {
					var newItem = new _this.ProjectContentModel({
						bg_color: data.project.bg_color
					}, self);

					newItem._info.isNew(false);
					newItem._info.isLoaded(true);
					self.is_new_mode(false);

					self.load(newItem, context);

					self.items.unshift(newItem);
					if (project_ids.indexOf(newItem.project_id()) == -1) {
						project_ids.push(newItem.project_id());
					}

					self.selectedItem(newItem);
					self.is_edit_mode(true);
					newItem.is_edit_mode(true);

					_this.fileApi.fileField = $('div#documentcontent .document').get(1);
					if (_this.fileApi.fileField)
					{
						_this.fileApi.init();
						_this.fileApi.url = Otime.siteUrl + '/attachment/image_upload';
					}

					item = null;
					// reload common data
					Otime.Details.isInitialized = false;
					Otime.Details.init();
				}));
			};

			self.cancel = function (item, elem) {
				item = self.selectedItem();

				if (!self.is_new_mode() && Otime.Menu.isAllow() > 0 && !confirm("Are you sure you want to navigate away from this page?")) {
					return false;
				}
				Otime.Menu.ReplaceURL(_this.name);

				item.project.is_edit_mode(false);
				item.task_types().is_edit_mode(false);
				item.budget()._info.is_edit_mode(false);
				item.config()._info.is_edit_mode(false);
				item.document().is_edit_mode(false);
				item.invoice.is_edit_mode(false);
				item.members().is_edit_mode(false);
				Otime.Menu.isAllow(0);

				if (self.is_comment_mode() == true) {
					self.is_comment_mode(false);
					_this.comment_container.removeClass("opened").addClass("closed");
					return;
				}
				item.rollback && item.rollback();
				item.project.project_name(item.project.project_code() + item.project.project_name());

				if (item.members())
					item.members_count(item.members().items().length);

				$('#view_layout').removeClass('opened');
				_this.comment_container.html("");
				self.swapMode();
				if (!self.is_list_view()) {
					_this.list_container.masonry("reload");
				}
				Otime.Menu.flag = false;
			};

			self.remove = function (item, elem) {
				if (item.budget()._info.actual_hours() - 0 > 0) {
					alert("You can't delete this project.");
					return false;
				}

				if (item.project_id() > 0 && confirm(_this.language["DELETE_PROJECT_CONFIRM_MSG"])) {
					Otime.app.postData(new Otime.ContextModel({
						url: "delete/" + item.project_id(),
						global: false
					}, null, function () {
						self.items.remove(item);
						if (!self.is_list_view()) {
							$('#list-container').masonry('reload');
						}
					}));
					return true;
				}
			};

			self.archiveItem = function (val) {
				return function (item, elem) {
					if (val == 1)
						var msg = 'Do you want to unarchive the project?';
					else
						var msg = 'Do you want to archive the project?';
					if (item.project_id() > 0 && confirm(msg) == true) {
						Otime.app.postData(new Otime.ContextModel({
							url: "archive/" + item.project_id(),
							global: false
						}, {
							is_active: val
						}, function () {
							item.project.is_active(val);
							self.items.remove(item);
							if (!self.is_list_view()) {
								$('#list-container').masonry('reload');
							}
							if (val == 1) {
								self.archive_count(Number(self.archive_count()) - 1);
								self.active_count(Number(self.active_count()) + 1);
								if (self.archive_count() <= 0) {
									self.active(0);
									(self.refresh(1))(item, elem);
								}
							}
							else {
								self.active_count(Number(self.active_count()) - 1);
								self.archive_count(Number(self.archive_count()) + 1);
								if (self.active_count() <= 0) {
									self.active(1);
									(self.refresh(0))(item, elem);
								}
							}
						}));
						return true;
					}
				};
			};

			self.duplicateItem = function (item) {
				self._info.project_documents(true);
				self._info.project_users(true);
				self._info.project_tasks(true);
				self._info.tasks_checklist(true);
				self.duplicatePopUp(item);
				$("#duplicate-modal").modal('show');
				// self.duplicatePopUp(item);
				// return function(item, elem){
				// 	if (item.project_id() > 0 && confirm('Are you sure you want to create a duplicate project of "'+item.project.project_name()+'" ?') == true)
				// 	{
				// 		Otime.app.postData(new Otime.ContextModel({
				// 			url: "duplicate/" + item.project_id(),
				// 			global: false
				// 		}, {}, function(context){
				// 			var response	= context.response;
				// 			Otime.success_message('Created Project "'+response.name+'" Successfully!',$('#alert_message'), 700);
				// 			project_ids	= [];
				// 			setTimeout(function() {(self.refresh(self.active()))()}, 1000);
				// 			// reload common data
				// 			Otime.Details.isInitialized = false;
				// 			Otime.Details.init();
				// 			return true;
				// 		}));
				// 		return true;
				// 	}
				// };
			};

			self.create_duplicate = function (item) {
				var post_data = {};
				post_data.project_id = item.project_id();
				post_data.project_documents = self._info.project_documents() - 0;
				post_data.project_users = self._info.project_users() - 0;
				post_data.project_tasks = self._info.project_tasks() - 0;
				post_data.tasks_checklist = post_data.project_tasks * (self._info.tasks_checklist() - 0);

				Otime.app.postData(new Otime.ContextModel({
					url: "duplicate/" + item.project_id(),
					global: false
				}, post_data, function (context) {
					var response = context.response;
					Otime.success_message('Created Project "' + response.name + '" Successfully!', $('#alert_message'), 700);
					project_ids = [];
					setTimeout(function () {
						$("#duplicate-modal").modal('hide');
						(self.refresh(self.active()))()
					}, 1000);
					Otime.Details.isInitialized = false;
					Otime.Details.init();
					return true;
				}));
			}

			self.view = function (item, elem, isNew) {
				if (item.project.is_active() == 0) {
					return false;
				}

				self.is_new_mode(!!isNew);
				self.selectedItem(item);

				if (!Otime.app.hasBinding(_this.view_container)) {
					Otime.app.load_template("view", function (response) {
						_this.view_container.html($.trim(response));
						ko.applyBindings(self.selectedItem, $("> div", _this.view_container).get(0));
						self.view(item, elem, isNew);
						item._info.isLoaded(false);
						self.is_edit_mode(false);
					});
					return false;
				}

				Otime.app.loadData(new Otime.ContextModel({
					url: item.project_id() ? ('info/' + item.project_id()) : 'info',
					global: false
				}, null, function (cont) {
					item._info.isNew(isNew);

					if (item.project_id()) {
						Otime.Menu.ReplaceURL(_this.name + "/" + item.project_id());
					}

					item._info.isLoaded(true);
					var filecont = (!isNew) ? 1 : 0;
					self.load(item, cont);
					_this.fileApi.fileField = $('div#documentcontent .document').get(filecont);
					if (_this.fileApi.fileField)
					{
						_this.fileApi.init();
						_this.fileApi.url = Otime.siteUrl + '/attachment/image_upload';
					}
					self.is_edit_mode(true);
				}));
			};

			self.addNew = function (item, elem) {
				var newItem = new _this.ProjectContentModel(null, self);
				self.view(newItem, elem, true);
				return true;
			};

			self.load = function (item, context) {
				var response = context.response;

				if (Object.keys(response.project || {}).length > 0) {
					item.project_id(Number(response.project.project_id) || 0);
					item.team_id(Number(response.project.team_id) || 0);

					item.project.project_id(Number(response.project.project_id) || 0);
					item.project.project_name(response.project.project_name || "");
					item.project.client_id(response.project.client_id || 0);
					item.project.client_name(response.project.client_name || "");
					item.project.description(response.project.description || "");
					item.created_by(response.project.created_by || "");
					item.budget().budget_type(response.project.budget_type || "");
					item.budget().budget_value(response.project.budget_value || 0);
					item.budget().budget_alert_percent(response.project.budget_alert_percent || 85);
					item.project.project_code_format(response.project.project_code || '');
					item.project.project_code(item.project.project_code_format());
					item._info.ts_hours(parseFloat(response.project.ts_hours || 0).toFixed(2));
					item.config().start_date(new Date(response.project.start_date));
					item.config().target_date(new Date(response.project.target_date));
					item.config().status_id(response.project.status_id || 0);
					//item.config.project_status_name(this.project_status && this.project_status[item.config.status_id()]?this.project_status[item.config.status_id()].name:'');

				}

				item.document(new _this.DocumentModel(response.attachements || {}, self));

				if (Object.keys(response.attachments || {}).length > 0) {
					var attachments = [];
					$.each(response.attachments, function (key, val) {
						attachments.push(new Otime.AttachmentDetailModel(val));
					});
					item.document().attachment_details(attachments);
				}
				var clients = [],
					tmp = {};
				clients.push({
					client_id: 0,
					client_name: _this.language['SELECT_CLIENT'] || "Select Client...",
					disabled: Otime.o(false)
				});
				if (Object.keys(response.clients).length == 2) {
					response.clients = response.clients.otvalues.setKeys(response.clients.otkeys, function (itm) {
						tmp[itm.client_id] = itm.client_name;
						itm.disabled = Otime.o(false);
						clients.push(itm);
					});
				}
				clients.push({
					client_id: "separator",
					client_name: "---------------------",
					disabled: Otime.o(true)
				});
				clients.push({
					client_id: "-1",
					client_name: _this.language['ADD_CLIENT'] || "Add New Client",
					disabled: Otime.o(false)
				});

				_this.clients = tmp;
				item.clients(clients);

				// if (Object.keys(response.task_types.items || {}).length == 2)
				// {
				// 	response.task_types.items	= response.task_types.items.otvalues.setKeys(response.task_types.items.otkeys);
				// }

				if (Object.keys(response.task_types.items || {}).length == 2) {
					response.task_types.items = response.task_types.items.otvalues.setKeys(response.task_types.items.otkeys);
				}

				if (Object.keys(response.task_types.task_types_list).length == 2) {
					if (!Object.keys(response.task_types.items || {}).length) {
						response.task_types.items = [];
						response.task_types.task_types_list = response.task_types.task_types_list.otvalues.setKeys(response.task_types.task_types_list.otkeys, function (val) {
							response.task_types.items.push({
								estimated_hours: 0,
								hourly_rate: val.hourly_rate,
								task_type_id: val.task_type_id,
								is_common: val.is_common
							});
						});
					}
					else {
						response.task_types.task_types_list = response.task_types.task_types_list.otvalues.setKeys(response.task_types.task_types_list.otkeys);
					}
				}

				item.task_types(new _this.TaskTypeListModel(response.task_types || null, self, item));
				item.members(new _this.TeamListModel(response.members || null, self, item));

				if (Object.keys(response.expense_types || {}).length == 2) {
					response.expense_types = response.expense_types.otvalues.setKeys(response.expense_types.otkeys);
				}
				item.expense_types(new _this.ExpenseTypeListModel({
					items: response.expense_types
				}, self, item));

				if (typeof response.invoice == 'object' && Object.keys(response.invoice).length > 0) {
					item.invoice.invoice_type(response.project.invoice_type || response.invoice.invoice_type);
					item.invoice.hourly_rate(response.project.hourly_rate || 0);
					item.invoice.invoiced_hours(parseFloat(response.invoice.invoiced_hours || 0).toFixed(2));
					item.invoice.uninvoiced_hours(parseFloat(response.invoice.uninvoiced_hours || 0).toFixed(2));
					item.invoice.expenses_count(response.invoice.expenses_count || 0);
					item.invoice.expenses_amount(parseFloat(response.invoice.expenses_amount || 0).toFixed(2));

					item.invoice.comments(response.invoice.comments || 0);
				}

				if (typeof response.tasks == 'object' && Object.keys(response.tasks).length > 0) {
					item.tasks.open_task_count(parseInt(response.tasks.open_task_count || 0));
					item.tasks.close_task_count(parseInt(response.tasks.close_task_count || 0));
					item.tasks.over_due_count(parseInt(response.tasks.over_due_count || 0));
					item.tasks.total_count(item.tasks.open_task_count() + item.tasks.close_task_count() + item.tasks.over_due_count());
					item.tasks.overdue_prg((100 / item.tasks.total_count()) * item.tasks.over_due_count());
					item.tasks.open_prg((100 / item.tasks.total_count()) * item.tasks.open_task_count());
				}

				if (item._info.isNew()) {
					item.project.edit();
					item.invoice.edit();
					item.budget().edit();
					item.config().edit();
				}
			};

			self.load_more = function () {
				if (self.finish()) {
					return false;
				}
				self.page++;

				var data = {
					active: self.active(),
					filter_client_id: (self.sel_client().length > 0 ? self.sel_client() : []).join(","),
					project_name : self.search_project(),
					//					filter_user_id: (self.sel_user().length > 0 ? self.sel_user() : []).join(","),
					//					filter_project_id: (self.sel_project().length > 0 ? self.sel_project() : []).join(",")
				};
				Otime.app.loadData(new Otime.ContextModel({
					url: "listing/" + self.page,
					data: data,
					callback: function (cont) {
						self.finish(cont.response.finish || false);
						if (cont.response.finish == true) {
							self.show_more(false);
						}
						if (Object.keys(cont.response.items).length > 0) {
							cont.response.items.otvalues.setKeys(cont.response.items.otkeys, function (item) {
								// Prevent appending already loaded item.
								if (project_ids.indexOf(item.project_id) > -1) {
									return true;
								}
								project_ids.push(item.project_id);
								self.items.push(new _this.ProjectContentModel(item, self));
							});
						}
						if (!self.is_list_view()) {
							_this.list_container.masonry("reload");
						}
					}
				}));
			};

			self.refresh = function (active) {
				return function (item, elem) {
					self.page = 1;
					project_ids = [];

					var data = {
						active: active,
						filter_client_id: (self.sel_client().length > 0 ? self.sel_client() : []).join(","),
						project_name : self.search_project(),	
						onInit: 1
						//						filter_user_id: (self.sel_user().length > 0 ? self.sel_user() : []).join(","),
						//						filter_project_id: (self.sel_project().length > 0 ? self.sel_project() : []).join(",")
					};

					Otime.app.loadData(new Otime.ContextModel("listing", data, function (cont) {
						var response = cont.response,
							_items = [],
							flag0 = false;
						var tmpArr = [];
						_this.clients = {};
						if ((response.clients && response.clients.otvalues) && Object.keys(response.clients.otvalues).length > 0) {							
							tmpArr.push({
								client_id: "0",
								client_name: _this.language['ALL_CLIENTS'] || "All Clients"
							});
							_this.clients["0"] = _this.language['ALL_CLIENTS'] || "All Clients";
							response.clients = response.clients.otvalues.setKeys(response.clients.otkeys, function (client) {
								tmpArr.push({
									client_id: client.client_id,
									client_name: client.client_name
								});
								_this.clients[client.client_id] = client.client_name;
							});							
						}
						self.clients(tmpArr);
						if (response.departments) {
							Otime.Users.departments = response.departments;
						}

						_this.currency_symbol = response.currency_symbol;
						_this.dt_format = response.dtFormat;
						self.finish(cont.response.finish || false);
						if (cont.response.finish == true) {
							self.show_more(false);
						}

						if (response.items && response.items.otvalues && response.items.otvalues.length > 0) {
							var tmp_item = null;
							response.items = response.items.otvalues.setKeys(response.items.otkeys, function (item) {
								project_ids.push(item.project_id);

								tmp_item = new _this.ProjectContentModel(item, self);
								if (_this.project_id && item.project_id == _this.project_id) {
									flag0 = true;
									self.is_edit_mode(true);
									self.selectedItem(tmp_item);
								}
								_items.push(tmp_item);
							});
						}
						self.items(_items);

						if (active == 1) {
							self.archive_count(response.archive_count);
						}
						else {
							self.active_count(response.active_count);
						}
						self.active(active);
						if (!self.is_list_view()) {
							_this.list_container.masonry("reload");
						}
						else {
							$('#list-container').css("height", "auto");
						}

						if (Otime.Menu.is_new) {
							self.addNew();
							Otime.Menu.is_new = false;
						}

						if (flag0 && self.selectedItem()) {
							flag0 = false;
							self.view(self.selectedItem());
						}
						else if (0 < _this.project_id - 0) {
							project_ids.push(_this.project_id);

							var tmpModel = new _this.ProjectContentModel({
								project_id: _this.project_id
							}, self);

							self.items.push(tmpModel);
							self.selectedItem(tmpModel);
							self.view(self.selectedItem());
						}
					}));
				};
			};

			self.loadFilters = function (callback) {
				if (typeof callback == "function") {
					callback();
				}
				return;
				/*
								Otime.app.loadData(new Otime.ContextModel('load_filters', null, function(context){
									var data	= context.response;
									var tmpArr	= [];
				
									/* if (data.projects.values && Object.keys(data.projects.values).length > 0)
									{
										tmpArr	= [];
										tmpArr.push({
											project_id: "0",
											project_name: "All Projects"
										});
										data.projects	= data.projects.values.setKeys(data.projects.keys, function(project){
											tmpArr.push({
												project_id: project.project_id,
												project_name: project.project_name
											});
										});
										self.projects(tmpArr);
									} * /
				
									if ((data.clients && data.clients.otvalues) && Object.keys(data.clients.otvalues).length > 0)
									{
										tmpArr	= [];
										tmpArr.push({
											client_id: "0",
											client_name: "All Clients"
										});
										data.clients	= data.clients.otvalues.setKeys(data.clients.otkeys, function(client){
											tmpArr.push({
												client_id: client.client_id,
												client_name: client.client_name
											});
										});
										self.clients(tmpArr);
									}
				
									/* if ((data.users && data.users.values) && Object.keys(data.users.values).length > 0)
									{
										tmpArr	= [];
										tmpArr.push({
											user_id: "0",
											user_name: "All Users"
										});
										data.users	= data.users.values.setKeys(data.users.keys, function(user){
											tmpArr.push({
												user_id: user.user_id,
												user_name: user.first_name + " " + user.last_name
											});
										});
										self.users(tmpArr);
									} * /
				
				
									if (typeof callback == "function")
									{
										callback();
									}
								}));
				*/
			};
		};

		_this.ProjectContentModel = function (data, parent) {
			var self = this;

			data = data || {};

			self.project_id = Otime.o(data.project_id || 0);
			self.project_code_format = Otime.o((data.project_code) ? $.trim(data.project_code) : '');
			data.project_code = self.project_code_format().replace('-', '');
			self.project_code = Otime.o(data.project_code);
			self.client_name = Otime.o(data.client_name || "");
			self.status_name = Otime.o(data.status_name || "");
			self.created_by = Otime.o(data.created_by || "");
			self.rp = Otime.o();
			self.team_id = Otime.o(data.team_id || 0);

			self.new_comments = Otime.o(data.new_comments - 0 || "");
			//			self.new_attachments	= Otime.o(data.new_attachments-0 || "");

			self.all_users = Otime.o(data.all_users || 0);
			self.members_count = Otime.o(data.members_count || 0);
			self.total_tasks = Otime.o(data.total_tasks || 0);
			self.over_due_tasks = Otime.o(data.over_due_tasks || 0);
			self.user_role = Otime.o(data.user_role || _this.user_role || '');

			self.project = new _this.ProjectData(data, parent, self);
			self.task_types = Otime.o(null);
			self.members = Otime.o(null);
			self.clients = Otime.a([]);
			self.teams = Otime.a(Otime.Details.teams);
			self.expense_types = Otime.o(null);

			var _budget = new _this.BudgetModel(data, parent);
			self.budget = Otime.o(_budget);

			_budget._info.total_hours(Number(data.budget_value || 0));
			_budget._info.actual_hours(Number(data.actual_value || 0));

			self.invoice = new _this.InvoiceModel(data, parent);
			self.config = Otime.o(new _this.ConfigModel(data, parent));
			self.document = Otime.o(null);
			self.tasks = {
				open_task_count: Otime.o(data.open_task_count || 0),
				close_task_count: Otime.o(data.close_task_count || 0),
				over_due_count: Otime.o(data.over_due_count || 0),
				total_count: Otime.o(0),
				open_prg: Otime.o(0),
				overdue_prg: Otime.o(0)
			};

			$.each(_this.clients, function (cid, cname) {
				self.clients.push({
					client_id: cid,
					client_name: cname
				});
			});

			self._info = {};
			self._info.uninvoiced_hours = Otime.o(parseFloat(data.uninvoiced_hours || 0).toFixed(2));
			data.start_date = (data.start_date ? new Date(Otime.stoj(data.start_date)) : '');
			self.start_date = Otime.o(data.start_date);
			data.target_date = (data.target_date ? new Date(Otime.stoj(data.target_date)) : '');
			self.target_date = Otime.o(data.target_date);
			self._info.isLoaded = Otime.o(false);
			self._info.isNew = Otime.o(false);
			self._info.ts_hours = Otime.o(parseFloat(data.ts_hours || 0).toFixed(2));
			self._info.team_diff_hours = Otime.o(parseFloat(data.team_diff_hours || 0).toFixed(2));
			self._info.tt_diff_hours = Otime.o(parseFloat(data.tt_diff_hours || 0).toFixed(2));


			// Can Archive & Delete.
			// Project is created by logged in user then he can able to delete or archive.
			data.created_by_role = data.created_by_role || "A";
			self._info.canAD = false;
			if (Otime.isA) {
				self._info.canAD = true;
			}
			else if (Otime.isPMF && (Otime.UID == (data.created_by - 0) || data.created_by_role == 'PM')) {
				self._info.canAD = true;
			}
			else if (Otime.isPM && (Otime.UID == (data.created_by - 0))) {
				self._info.canAD = true;
			}
			//			self._info.canAD	= (Otime.UID == (data.created_by-0));
			//			self._info.created_by	= Otime.o(data.created_by);

			self.is_edit_mode = Otime.o(false);
			self.is_comment_mode = parent.is_comment_mode;
			self.save = parent.save;
			self.cancel = parent.cancel;

			self.cancelEdit = function () {
				self.rollback && self.rollback();
				self.is_edit_mode(false);
			};

			self.edit = function () {
				ko.editable(self);
				self.beginEdit();
				self.is_edit_mode(true);
			};

			self.is_valid = function () {
				return (self.project.project_name.isValid() == true && self.project.client_id.isValid() == true);
			};

			self.parent = function () {
				return parent;
			};

			self.team_name = Otime.o();
			if (self.team_id()-0 && Otime.Details.teamsById && Otime.Details.teamsById[self.team_id()])
			{
				self.team_name(Otime.Details.teamsById[self.team_id()].team_name);
			}

			self.team_id.subscribe(function(newVal){
				if(!(newVal-0))
				{
					return false;
				}
				
				if (Otime.Details.teamsById && Otime.Details.teamsById[newVal])
				{
					self.team_name(Otime.Details.teamsById[newVal].team_name);
				}

				Otime.app.loadData(new Otime.ContextModel({
					url: Otime.siteUrl + "/team/users/" + newVal,
					data: {
						
					},
					callback: function (cont) {
						var resp = cont.response;
						if (resp && resp.otkeys && resp.otvalues)
						{
							var users = [];
							var _teamList = self.members();
							// _teamList.removeItem();

							var oldTeamList = {};
							$.each(_teamList.items(), function(key, val){
								oldTeamList[val.user_id()] = val;
								_teamList.items.destroy(val);
							});

							resp.otvalues.setKeys(resp.otkeys, function(usr){
								var temp_team = Otime.Details.all_users[usr.user_id];

								if (oldTeamList[usr.user_id])
								{
									oldTeamList[usr.user_id].user_role(usr.user_role);
									delete oldTeamList[usr.user_id]._destroy;
									return true;
								}

								temp_team = JSON.parse(JSON.stringify(temp_team));
								temp_team.user_role = usr.user_role;
								temp_team = new _this.TeamModel(temp_team, _teamList);
								temp_team.isDirty = true;

								_teamList.items.push(temp_team);
							});
						
							_teamList.items.valueHasMutated();

							// _teamList.items(users);
							// self.members_count(users.length);
						}
					}
				}), true);
			});

			self.compute = Otime.c(function () {
				if (!self._info.isLoaded()) {
					return true;
				}
				var tot = 0, act = 0,
					type = self.budget().budget_type();
				self.budget()._info.isBGVal(false);
				switch (type) {
					case 'HA':	// Total Project Hours
						self.budget()._info.isBGVal(true);
						tot = self.budget().budget_value();
						act = self.task_types() != null ? self.task_types().aht() : 0;
						break;
					case 'AA':	// Total Project Amount
						self.budget()._info.isBGVal(true);
						tot = self.budget().budget_value();
						act = self.task_types() != null ? self.task_types().ahta() : 0;
						break;
					case 'HT':	// Hours based on Task Type
						tot = self.task_types() != null ? self.task_types().eht() : 0;
						act = self.task_types() != null ? self.task_types().aht() : 0;
						break;
					case 'HP':	// Hours based on Person
						tot = self.members() != null ? self.members().eht() : 0;
						act = self.members() != null ? self.members().aht() : 0;
						break;
					case 'AT':	// Actual Hours based on Task Type
						tot = self.task_types() != null ? self.task_types().ehta() : 0;
						act = self.task_types() != null ? self.task_types().ahta() : 0;
						break;
					case 'AP':	// Actual Hours based on Person
						tot = self.members() != null ? self.members().ehta() : 0;
						act = self.members() != null ? self.members().ahta() : 0;
						break;
				}

				var _budget = self.budget();
				_budget._info.isAmt(type.substr(0, 1) == "A");
				_budget._info.total_hours(tot - 0);
				_budget._info.actual_hours(act - 0);
			});
		};

		_this.ProjectData = function (data, root, parent) {
			var self = this;

			data = data || {};

			self.is_edit_mode = Otime.o(false);
			self.project_id = Otime.o(data.project_id || 0);
			self.project_name = Otime.o(data.project_name || "").extend({ "required": "Project Name is Required." });
			self.project_code_format = Otime.o((data.project_code) ? $.trim(data.project_code) : '');
			data.project_code = self.project_code_format().replace('-', '');
			self.project_code = Otime.o(data.project_code);
			self.bg_color = Otime.o(data.bg_color || Otime.bgpicker_colors[Math.floor(Math.random() * Otime.bgpicker_colors.length)]);

			self.client_id = Otime.o(data.client_id - 0).extend({ "required": "Client is required." });
			self.is_active = Otime.o(data.is_active || 1);
			self.description = Otime.o(data.description || "");
			self.invoice_type = Otime.o(data.invoice_type || "T");
			self.client_name = Otime.o("");

			self.edit = function () {
				self.project_code($.trim(self.project_code().replace('-', '')));

				ko.editable(self);
				self.beginEdit();
				self.is_edit_mode(true);
			};

			self.is_edit_mode.subscribe(function (newVal) {
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			self.is_valid = function () {
				return (self.project_name.isValid() == true && self.client_id.isValid() == true);
			};

			self.getRoot = function () {
				return root;
			};

			self.prepareData = function () {
				self.project_code_format($.trim(self.project_code()) ? (self.project_code() + ' -') : '');
				if (self.is_valid() != true) {
					alert("Required field missing, please check.");
					return false;
				}

				var data = JSON.parse(ko.toJSON(self));

				delete data.hasChanges;
				delete data.is_edit_mode;
				delete data.client_name;
				if (!data.client_id)
					delete data.client_id;

				return data;
			};

			self.save = function () {
				var data = self.prepareData();

				if (!data) {
					return false;
				}

				Otime.app.postData(new Otime.ContextModel({
					url: "save",
					global: false
				}, data, function (context) {
					var response = context.response;
					self.commit();
					console.log(self.bg_color());
					self.project_code(self.project_code_format());
					self.is_edit_mode(false);
				}));
			};

			self.cancel = function () {
				self.rollback && self.rollback();
				self.project_code(self.project_code_format());
				self.is_edit_mode(false);
			};

			self.computed = Otime.c(function () {
				self.client_name(_this.clients[self.client_id()]);
			});

			self.client_id.subscribe(function (newValue) {
				if (newValue == '-1') {
					newClient({
						onSave: function (clientData) {
							if (!clientData.disabled) {
								clientData.disabled = Otime.o(false);
							}
							parent.clients.prependSingle(clientData, 1);
							/*
														parent.clients.push(clientData);
														var tmp_clients	= parent.clients();
							
														tmp_clients = tmp_clients.sort(function(a, b){
															var nameA	= a.client_name.toLowerCase(),
																nameB	= b.client_name.toLowerCase();
							
															var idA = parseInt(a.client_id),
																idB = parseInt(b.client_id);
							
															if ( idA <0 || idB <0 || !idA || !idB)
															{
																return idB > 0 ? 1 : -1;
															}
							
															if (nameA < nameB) // sort string ascending
																return -1;
															if (nameA > nameB)
																return 1;
															return 0 // default return value (no sorting)
														});
														parent.clients(tmp_clients);
							*/
							self.client_id(clientData.client_id);
							self.client_name(clientData.client_name);
						},
						onCancel: function () {
							self.client_id(0);
						}
					});
				}
			});
		};

		_this.CheckTaskTypeList = function (taskList, addedList) {
			var data = taskList;
			console.log(" taskList ==> ", taskList, addedList);
			return data;
		}

		_this.TaskTypeListModel = function (data, root, parent) {
			var self = this;

			data = data || {};

			self.is_edit_mode = Otime.o(false);

			self.task_types_list = data.task_types_list;

			self.project_id = Otime.o();

			self.items = Otime.a([]);

			self.tasktypeid = [];

			if (data.items) {
				$.each(data.items, function (key, item) {
					item.task_types_list = data.task_types_list;
					if (item.is_common == '1' || !root.is_new_mode()) {
						self.items.push(new _this.TaskTypeModel(item));
					}
					self.tasktypeid[item.task_type_id] = true;
				});
			}

			self.aht = Otime.o("");
			self.eht = Otime.o("");
			self.ehta = Otime.o("");
			self.ahta = Otime.o("");

			self.calculate = Otime.c(function () {
				if (self.items().length > 0) {
					var ahtS = 0, ehtS = 0, ahtaS = 0, ehtaS = 0;
					$.each(self.items(), function (key, item) {
						ahtS += Number(item.actual_hours());
						ehtS += Number(item.estimated_hours());
						ehtaS += (Number(item.estimated_hours()) * Number(item.hourly_rate()));
						ahtaS += (Number(item.actual_hours()) * Number(item.hourly_rate()));
					});

					self.aht(Number(ahtS).toFixed(2));
					self.eht(Number(ehtS).toFixed(2));
					self.ehta(Number(ehtaS).toFixed(2));
					self.ahta(Number(ahtaS).toFixed(2));

					var tot = 0;
					tot = parent._info.ts_hours() - Number(ahtS);
					parent._info.tt_diff_hours(tot);
					return true;
				}

				return false;
			});

			self.addNew = function (index, item) {
				var tmpLength = self.items().length - 1;
				$.each(self.items(), function (key, val) {
					val._destroy && tmpLength--;
				});

				//				if (index != undefined)
				//				{
				//					console.log(index(), self.items().length, item.task_type_id());
				//				}
				if (index == undefined || (index() == tmpLength && Number(item.task_type_id()) > 0)) {
					data = {};
					data.task_types_list = self.task_types_list;
					var newItm = new _this.TaskTypeModel(data);
					self.items.push(newItm);
				}
			};

			self.edit = function () {
				self.addNew();
				ko.editable(self);
				self.beginEdit();
				self.is_edit_mode(true);
			};

			self.is_edit_mode.subscribe(function (newVal) {
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			self.parent = function () {
				return root;
			};

			root.is_new_mode() && self.edit();

			self.cancel = function () {
				self.rollback();
				self.is_edit_mode(false);
				self.removelastdummy();
			};

			self.removelastdummy = function () {
				//remove last empty record
				if (self.items().length > 0) {
					self.removeItem(self.items()[self.items().length - 1]);
				}
			};

			self.removeItem = function (item) {
				if (item.project_task_type_id() > 0) {
					self.items.destroy(item);
				}
				else {
					self.items.remove(item);
				}
			};

			self.prepareData = function () {
				var tmpLength = self.items().length - 1;
				$.each(self.items(), function (key, val) {
					val._destroy && tmpLength--;
				});
				if (tmpLength <= 0) {
					alert("at least one task type required.");
					return false;
				}

				self.removelastdummy();
				var data = JSON.parse(ko.toJSON(self.items())),
					ret = {},
					ttIds = [];
				ret.deleted_items = [],
					ret.task_types = [];

				var val = null;
				for (var i = 0; i < data.length; i++) {
					val = data[i];
					delete val.task_types_list;
					if (val._destroy == true) {
						ret.deleted_items.push(val.project_task_type_id);
						continue;
					}
					ttIds.push(val.task_type_id);

					if ((val.isDirty == true || root.is_new_mode()) && val.task_type_id != undefined) {
						ret.task_types.push(val);
					}
				}

				if (ttIds.length != ttIds.filter(function (v, i, s) { return s.indexOf(v) === i; }).length) {
					alert("Duplicate exist.");
					return false;
				}
				return ret;
			};

			self.save = function () {
				data = self.prepareData();
				if (data === false) {
					return false;
				}
				if (data.task_types && data.task_types.length <= 0 && data.deleted_items.length <= 0) {
					self.cancel();
					return false;
				}
				var url = "store/" + _this.listModel.selectedItem().project_id() + "/task_types";
				Otime.app.postData(new Otime.ContextModel({
					url: url,
					global: false
				}, data, function (cont) {
					var response = cont.response;
					if (data.deleted_items && data.deleted_items.length > 0) {
						var tmpArr = [];
						for (var i = 0; i < self.items().length; i++) {
							if (self.items()[i]._destroy == undefined || self.items()[i]._destroy == false) {
								tmpArr.push(self.items()[i]);
							}
						}
						self.items(tmpArr);
					}
					if (response && response.project_task_type_id && response.project_task_type_id.length > 0) {
						var count = 0;
						for (var i = 0; i < self.items().length; i++) {
							var value = self.items()[i];
							if (Number(value.project_task_type_id() <= 0) && Number(value.task_type_id()) > 0) {
								value.project_task_type_id(response.project_task_type_id[count]);
								count++;
							}
						}
					}
					self.commit();
					self.is_edit_mode(false);
				}));
			};
		};

		_this.TaskTypeModel = function (data) {
			var self = this;

			data = data || {};

			self.project_task_type_id = Otime.o(data.project_task_type_id || 0);
			// self.is_common				= Otime.o(data.is_common || 0);
			self.task_types_list = Otime.a(data.task_types_list || []);
			self.task_type_id = Otime.o(data.task_type_id || 0).extend({ trackChange: true });
			self.estimated_hours = Otime.o(data.estimated_hours - 0 || "").extend({ trackChange: true });
			self.hourly_rate = Otime.o(data.hourly_rate - 0 || "").extend({ trackChange: true });
			self.actual_hours = Otime.o(data.actual_hours - 0 || "").extend({ trackChange: true });
			self.name_lbl = Otime.o();
			var val = null;
			var tmpSubscribe = function (isManual) {
				for (var i = 0, iLen = self.task_types_list().length; i < iLen; i++) {
					val = self.task_types_list()[i];
					if (val.task_type_id == self.task_type_id()) {
						if (isManual !== false)
							self.hourly_rate(val.hourly_rate);
						self.name_lbl(val.name);
						return;
					}
				}
			};
			tmpSubscribe(false);
			self.task_type_id.subscribe(tmpSubscribe);

			self.isDirty = Otime.c(function () {
				for (var key in self) {
					if (self.hasOwnProperty(key) && Otime.i(self[key]) && typeof self[key].isDirty === 'function' && self[key].isDirty()) {
						return true;
					}
				}
				return false;
			});
		};

		_this.TeamListModel = function (data, root, parent) {
			var self = this;

			data = data || {};

			self.items = Otime.a([]);
			self.members_count = Otime.o();
			self.membersArr = Otime.a([]);
			self.membersRes = Otime.a([]);
			self.is_edit_mode = Otime.o(false);
			self._info = {};
			self._info.clone_members = Otime.a([]);

			self.onAllUserChange = function () {
				var newVal = parent.all_users();
				if (newVal) {
					self.removelastdummy();
					$.each(self.items(), function (key, value) {
						self._info.clone_members.push(value);
					});
					var items = [];
					$.each(self.membersRes(), function (key, value) {
						var temp_team = new _this.TeamModel(value, self);
						temp_team.isDirty = true;
						items.push(temp_team);
					});
					items.push(new _this.TeamModel(null, self));
					self.items(items);
				} else if (self._info.clone_members().length) {
					self.items(self._info.clone_members());
					self._info.clone_members([]);
					self.items.push(new _this.TeamModel(null, self));
				}
			};

			var updateCount = function () {
				var cnt = 0;
				var items_cnt = 0;
				$.each(self.items(), function (key, val) {
					if (!val._destroy) {
						if (val.user_id())
							items_cnt++;
						if (val.project_user_id()) {
							cnt++;
						}
					}
				});
				self.members_count(cnt);
				var mem_len = Object.keys(self.membersRes()).length;
				if (mem_len != items_cnt) {
					parent.all_users(false);
				} else {
					parent.all_users(true);
				}
			};

			self.is_edit_mode.subscribe(function (newVal) {
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
				updateCount();
				// self.members_count(self.items().length - (Number(newVal)));
			});

			self.items.subscribe(function (newVal) {
				updateCount();
				// self.members_count(self.items().length - (Number(self.is_edit_mode())));
			});

			if (data.members && data.members.otvalues && Object.keys(data.members.otvalues).length > 0) {
				var membs = [];
				data.members = data.members.otvalues.setKeys(data.members.otkeys, function (itm) {
					itm.user_name = itm.first_name + " " + itm.last_name;
					membs.push(itm);
				}, "user_id");

				self.membersArr(membs);
				self.membersRes(data.members);
			}

			if (data.items && data.items.otvalues && Object.keys(data.items.otvalues).length > 0) {
				var tmpArr = [],
					tmpModel = null;
				data.items = data.items.otvalues.setKeys(data.items.otkeys, function (val) {
					val.roles = data.roles;
					tmpArr.push(new _this.TeamModel(val, self));
				});
				self.items(tmpArr);
			}

			//			self.roles	= data.roles;
			//			data.roles	= [];
			//			$.each(self.roles, function(key, name){
			//				data.roles.push({"role_key":key, "role_name":name});
			//			});

			self.edit = function (item, elem) {
				self.items.push(new _this.TeamModel(null, self));
				ko.editable(self);
				self.beginEdit();
				self.is_edit_mode(true);
			};

			self.parent = function () {
				return root;
			};

			self.cancel = function () {
				_Escape();
				self.rollback();

				var items = self.items();
				for (var i = 0; i < items.length; i++) {
					delete items[i]._destroy;
				}

				self.is_edit_mode(false);
				self.removelastdummy();
			};

			self.removelastdummy = function () {
				//remove last empty record
				if (self.items().length > 0) {
					var last = self.items()[self.items().length - 1];
					//  && last.project_user_id() <= 0
					if (last.user_id() <= 0)
					{
						self.removeItem(last);
					}
				}
			};

			self.removeItem = function (item) {
				_Escape();
				// if (item.user_id()-0 == parent.created_by()-0)
				// {
				// 	return false;
				// }
				if (item.project_user_id() > 0) {
					self.items.destroy(item);
				}
				else {
					self.items.remove(item);
				}
			};

			self.addNew = function (item, elem) {
				var index = self.items().indexOf(item);
				if (index == self.items().length - 1) {
					self.items.push(new _this.TeamModel(null, self));
				}
			};

			self.getMembers = _this.GetMembers;

			self.prepareData = function () {
				var copy = JSON.parse(ko.toJSON(self.items()));

				var ret = {
					team_id: parent.team_id(),
					deleted_items: [],
					members: [],
					all_users: parent.all_users() - 0
				};
				$.each(copy, function (key, val) {
					if (val.project_user_id <= 0 && val.user_id <= 0) {
						self.items.remove(self.items()[key]);
					}
					if (val._destroy == true) {
						ret.deleted_items.push(val.project_user_id);
					}
					if (val.user_id && (val.isDirty == true || _this.listModel.selectedItem().project_id() <= 0)) {
						ret.members.push(val);
					}
				});

				return ret;
			};

			self.save = function () {
				_Escape();
				self.removelastdummy();
				data = self.prepareData();
				if (data.members.length <= 0 && data.deleted_items.length <= 0) {
					self.cancel();
					return false;
				}

				var context = new Otime.ContextModel({
					url: "store/" + parent.project_id() + "/members",
					global: false
				}, data, function (cont) {
					var response = cont.response;
					if (response && (Object.keys(response.project_user_id).length > 0 || data.deleted_items.length)) {
						var i = 0;
						var removeItems = [];
						$.each(self.items(), function (key, value) {
							if (value._destroy) {
								removeItems.push(value);
							}
							if (value.isDirty) {
								value.resetIsDirty();
							}
							if (!value.project_user_id()) {
								value.project_user_id(response.project_user_id[i]);
								i++;
							}
						});
						$.each(removeItems, function (key, val) {
							self.items.remove(val);
						});
						removeItems = null;
					}
					self.commit();
					// reload common data
					Otime.Details.isInitialized = false;
					Otime.Details.init();
					self.is_edit_mode(false);
				});

				Otime.app.postData(context);
			};

			self.updateMembersList = function (userId) {
				var allMembers = JSON.parse(JSON.stringify(self.membersRes()));

				$.each(self.items(), function (key, val) {
					val.user_id() != userId && delete allMembers[val.user_id()];
				});

				allMembers = Object.values(allMembers).sort(function (a, b) {
					var nameA = a.first_name.toLowerCase(),
						nameB = b.first_name.toLowerCase();

					if (nameA < nameB) // sort string ascending
						return -1;
					if (nameA > nameB)
						return 1

					return 0 // default return value (no sorting)
				});
				self.membersArr(Object.values(allMembers));
			};

			var updateRoleList = function (userId) {
				var mem = self.membersRes()[userId];
				if (!userId || !mem || mem.user_role == 'A' || mem.user_role == 'M') {
					return false;
				}
				$("#hidder-member #select-role select > option").each(function () {
					if (this.value && this.value != mem.user_role) {
						$(this).attr('disabled', 'disabled');
					}
					else if (this.value) {
						$(this).removeAttr('disabled');
						return false;
					}
				});
				return true;
			};

			var editables = {};

			var _Escape = function () {
				$("#hidder-member").css({
					left: -999,
					top: -999
				});
				$("#hidder-member > *").hide();
				$("#hidder-member input, #hidder-member select").unbind("change");
			};

			self.gridify_params = Otime.o({
				freezed: false,
				onSelect: function (elem, clipBrd, isClick) {
					var targ = elem;

					if (!targ.is("td")) {
						targ = targ.parents("td");
					}
					var item = ko.dataFor(targ.get(0));
					_Escape();
					var hidderElem = $("#hidder-member");
					//					var offset = (parent.is_new_mode()) ? 0 : 30;
					hidderElem.css({
						//						left: targ.position().left + hidderElem.parent().scrollLeft(),
						//						top: Math.round(targ.position().top + hidderElem.parent().scrollTop()) + offset,
						left: targ.position().left + hidderElem.parent().scrollLeft() + 4,
						top: Math.round(targ.position().top + hidderElem.parent().scrollTop()) + 3,
						width: targ.innerWidth() - 3,
						height: targ.innerHeight() - 2
					}).show();

					if (targ.is(".fname")) {
						self.updateMembersList(item.user_id());
						var elem = $("#select-members select", hidderElem);
						elem
							.val(item.user_id() || 0)
							.unbind("change")
							.change(function () {
								item.user_id($(this).val());
								$(this).trigger("blur");
								_Escape();
							})
							.chosen({
								search_contains: true,
								width: "100%",
								minheight: "100%"
							})
							.trigger("chosen:updated");

						//						elem.not(".selector select").uniform();
						//						$.uniform.update(elem);
						$("#hidder-member #select-members").show();
						//						elem.trigger("chosen:open");
						$("#hidder-member #select-members .chosen-search input").get(0).focus();
						//						$("#hidder-member #select-members .chosen-search input").val(word).get(0).focus();
					}
					else if (targ.is(".usrrole")) {
						if (!updateRoleList(item.user_id())) {
							_Escape();
							return false;
						}
						var elem = $("#select-role select", hidderElem);
						elem
							.val(item.user_role())
							.unbind("change")
							.change(function () {
								item.user_role($(this).val());
								$(this).trigger("blur");
								_Escape();
							});
						elem.not(".selector select").uniform();
						$.uniform.update(elem);
						$("#hidder-member #select-role").show();
					}
					else if (targ.is(".hrate")) {
						var elem = $("#txt-rate", hidderElem);
						elem
							.val(item.hourly_rate())
							.unbind("change")
							.change(function () {
								item.hourly_rate($(this).val());
								_Escape();
								$(this).trigger("blur");
							});
						elem.show().get(0).select();
					}
					else if (targ.is(".esthours")) {
						var elem = $("#txt-rate", hidderElem);
						elem
							.val(item.estimated_hours())
							.unbind("change")
							.change(function () {
								item.estimated_hours($(this).val());
								_Escape();
								$(this).trigger("blur");
							});
						elem.show().get(0).select();
					}
					else {
						_Escape();
					}
				},
				onEnter: function (event, elem, word, isClick) {

				},
				onEsc: _Escape,
				onInputKeyPress: null,
				onInputEnter: function (e) {
					var tmpTarg = $("#hidder-member > *:visible").get(0);
					if (tmpTarg) {
						tmpTarg = $(tmpTarg);
						if (!tmpTarg.is("input, select")) {
							tmpTarg = $("input, select", tmpTarg);
						}
						tmpTarg.trigger("change");
						$("#hidder-member input, #hidder-member select").trigger("blur");
						_Escape(e);
					}
					return true;
				},
				onInputEsc: function (e) {
					//					var tmpTarg	= $("#hidder-member > *:visible");
					//					if (!tmpTarg.is("input, select"))
					//					{
					//						tmpTarg	= $("input, select", tmpTarg);
					//					}
					_Escape(e);
					return true;
				}
			});

			if (root.is_new_mode()) {
				// buy default add pmf to new project
				self.membersArr().forEach(function (obj) {
					if (obj.user_id == _this.user_id || obj.user_role == 'F') {
						self.items.push(new _this.TeamModel(self.membersRes()[obj.user_id], self));
					}
				});
				// self.items.push(new _this.TeamModel(self.membersRes()[_this.user_id], self));
				self.edit();
			}

			self.eht = Otime.o(0);
			self.aht = Otime.o(0);
			self.ehta = Otime.o(0);
			self.ahta = Otime.o(0);

			self.calculate = Otime.c(function () {
				if (self.items().length > 0) {
					var ahtS = 0, ehtS = 0, ahtaS = 0, ehtaS = 0;
					$.each(self.items(), function (key, item) {
						ehtS += Number(item.estimated_hours());
						ahtS += Number(item.actual_hours());
						ehtaS += (Number(item.estimated_hours()) * Number(item.hourly_rate()));
						ahtaS += (Number(item.actual_hours()) * Number(item.hourly_rate()));
					});

					self.eht(Number(ehtS).toFixed(2));
					self.aht(Number(ahtS).toFixed(2));
					self.ehta(Number(ehtaS).toFixed(2));
					self.ahta(Number(ahtaS).toFixed(2));

					var tot = 0;
					tot = parent._info.ts_hours() - Number(ahtS);
					parent._info.team_diff_hours(tot);
					return true;
				}

				return false;
			});
		};

		_this.TeamModel = function (data, parent) {
			var self = this;

			data = data || {};

			self.project_user_id = Otime.o(data.project_user_id || 0);
			self.user_image = Otime.o(data.user_image || "");
			self.user_id = Otime.o(data.user_id || 0);
			self.first_name = Otime.o(data.first_name || "").extend({ trackChange: true });
			self.last_name = Otime.o(data.last_name || "").extend({ trackChange: true });
			self.user_role = Otime.o(data.user_role || "").extend({ trackChange: true });
			self.hourly_rate = Otime.o(data.hourly_rate - 0 || "").extend({ trackChange: true });
			self.estimated_hours = Otime.o(data.estimated_hours - 0 || "").extend({ trackChange: true });
			self.actual_hours = Otime.o((data.actual_hours - 0).toFixed(2) - 0 || "").extend({ trackChange: true });

			self.is_valid = function (item) {
				return (item.first_name.isValid() && item.email.isValid() && item.user_role() != '0');
			};

			self.user_id.subscribe(function (newVal) {
				var mem = parent.membersRes()[newVal];

				if (newVal == '-1') {
					newUser({
						onSave: function (userData) {
							parent.membersArr.push(userData);
							parent.membersRes()[userData.user_id] = userData;
							parent.updateMembersList(userData.user_id);
							self.user_id(userData.user_id);
							self.user_role(userData.user_role);
						},
						onCancel: function () {
							self.user_id(0);
						}
					});
				}

				if (newVal && mem && mem.user_id - 0) {
					self.first_name(mem.first_name);
					self.last_name(mem.last_name);
					self.user_id(mem.user_id);
					self.user_image(mem.user_image);
					self.hourly_rate(Number(mem.hourly_rate));
					self.user_role(mem.user_role);
					parent.addNew(self);
				}
			});

			//			self.roles				= Otime.a(data.roles || []);
			self.edit_permission = true;
			self.current_role = Otime.a();

			if (self.user_role() != '' && (self.user_role() == 'M' || self.user_role() == 'A')) {
				self.edit_permission = false;
				self.current_role.push({ role_id: self.user_role(), role_name: _this.roles[self.user_role()] });
			}

			self.resetIsDirty = function () {
				for (var key in self) {
					if (self.hasOwnProperty(key) && Otime.i(self[key]) && typeof self[key].isDirty === 'function' && self[key].isDirty()) {
						self[key].isDirty(false);
					}
				}
			};

			self.isDirty = Otime.c(function () {
				for (var key in self) {
					if (self.hasOwnProperty(key) && Otime.i(self[key]) && typeof self[key].isDirty === 'function' && self[key].isDirty()) {
						return true;
					}
				}
				return false;
			});
		};

		_this.ExpenseTypeListModel = function (data, root, parent) {
			var self = this;

			data = data || {};

			self.is_edit_mode = Otime.o(false);

			self.expense_types = Otime.a(Otime.Details.getExpenseTypes());

			self.expense_types_list = data.expense_types_list;

			self.project_id = Otime.o();

			self.items = Otime.a([]);

			self.expensetypeid = {};

			if (data.items) {
				$.each(data.items, function (key, item) {
					// item.expense_types_list = data.expense_types_list;
					if (!root.is_new_mode()) {
						self.items.push(new _this.ExpenseTypeModel(item));
					}
					self.expensetypeid[item.expense_type_id] = true;
				});
			} else {
				self.items.push(new _this.ExpenseTypeModel({}));
			}

			var _Escape = function () {
				$("#hidder-expense").css({
					left: -999,
					top: -999
				});
				$("#hidder-expense > *").hide();
				$("#hidder-expense input, #hidder-expense select").unbind("change");
			};

			self.gridify_params = Otime.o({
				freezed: false,
				onSelect: function (elem, clipBrd, isClick) {
					var targ = elem;

					if (!targ.is("td")) {
						targ = targ.parents("td");
					}
					var item = ko.dataFor(targ.get(0));
					_Escape();
					var hidderElem = $("#hidder-expense");
					//					var offset = (parent.is_new_mode()) ? 0 : 30;
					hidderElem.css({
						//						left: targ.position().left + hidderElem.parent().scrollLeft(),
						//						top: Math.round(targ.position().top + hidderElem.parent().scrollTop()) + offset,
						left: targ.position().left + hidderElem.parent().scrollLeft() + 4,
						top: Math.round(targ.position().top + hidderElem.parent().scrollTop()) + 3,
						width: targ.innerWidth() - 3,
						height: targ.innerHeight() - 2
					}).show();

					if (targ.is(".name1")) {
						var elem = $("#txt-normal", hidderElem);
						elem
							.val(item.name())
							.unbind("change")
							.change(function () {
								item.name($(this).val());
								_Escape();
								$(this).trigger("blur");
							});
						elem.show().get(0).select();
					}
					else if (targ.is(".name")) {
						var elem = $("#select-expense select", hidderElem);
						elem
							.val(item.expense_type_id())
							.unbind("change")
							.change(function (e) {
								item.expense_type_id($(this).val());
								item.name_lbl($(this).find(":selected").text());
								if (self.items.indexOf(item) == self.items().length-1)
								{
									self.items.push(new _this.ExpenseTypeModel({}));
								}
								$(this).trigger("blur");
								_Escape();
							});
						elem.not(".selector select").uniform();
						$.uniform.update(elem);
						$("#hidder-expense #select-expense").show();
					}
					else if (targ.is(".unitprice")) {
						var elem = $("#txt-rate", hidderElem);
						elem
							.val(item.unit_price())
							.unbind("change")
							.change(function () {
								item.unit_price($(this).val());
								_Escape();
								$(this).trigger("blur");
							});
						elem.show().get(0).select();
					}
					else if (targ.is(".estimated")) {
						var elem = $("#txt-rate", hidderElem);
						elem
							.val(item.estimated())
							.unbind("change")
							.change(function () {
								item.estimated($(this).val());
								_Escape();
								$(this).trigger("blur");
							});
						elem.show().get(0).select();
					}
					else {
						_Escape();
					}
				},
				onEnter: function (event, elem, word, isClick) {

				},
				onEsc: _Escape,
				onInputKeyPress: null,
				onInputEnter: function (e) {
					var tmpTarg = $("#hidder-expense > *:visible").get(0);
					if (tmpTarg) {
						tmpTarg = $(tmpTarg);
						if (!tmpTarg.is("input, select")) {
							tmpTarg = $("input, select", tmpTarg);
						}
						tmpTarg.trigger("change");
						$("#hidder-expense input, #hidder-expense select").trigger("blur");
						_Escape(e);
					}
					return true;
				},
				onInputEsc: function (e) {
					//					var tmpTarg	= $("#hidder-member > *:visible");
					//					if (!tmpTarg.is("input, select"))
					//					{
					//						tmpTarg	= $("input, select", tmpTarg);
					//					}
					_Escape(e);
					return true;
				}
			});

			self.actTot = Otime.o("");
			self.estTot = Otime.o("");
			// self.actAmtTot = Otime.o("");
			// self.estAmtTot = Otime.o("");

			self.calculate = Otime.c(function () {
				if (!self.items().length) {
					return false;
				}

				var actTot = 0, estTot = 0, actAmtTot = 0, estAmtTot = 0;
				$.each(self.items(), function (key, item) {
					estTot += (item.estimated()-0);
					actTot += (item.actual()-0);
					// estAmtTot += ((item.estimated()-0) * (item.unit_price()-0));
					// actAmtTot += ((item.actual()-0) * (item.unit_price()-0));
				});

				self.actTot((actTot).toFixed(2));
				self.estTot((estTot).toFixed(2));
				// self.actAmtTot((actAmtTot).toFixed(2));
				// self.estAmtTot((estAmtTot).toFixed(2));

				return true;
			});

			self.addNew = function (index, item) {
				var tmpLength = self.items().length - 1;
				$.each(self.items(), function (key, val) {
					val._destroy && tmpLength--;
				});

				if (index == undefined || (index() == tmpLength && Number(item.expense_type_id()) > 0)) {
					data = {};
					data.expense_types_list = self.expense_types_list;
					var newItm = new _this.ExpenseTypeModel(data);
					self.items.push(newItm);
				}
			};

			self.edit = function () {
				self.addNew();
				ko.editable(self);
				self.beginEdit();
				self.is_edit_mode(true);
			};

			self.is_edit_mode.subscribe(function (newVal) {
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			self.parent = function () {
				return root;
			};

			root.is_new_mode() && self.edit();

			self.cancel = function () {
				self.rollback();
				self.is_edit_mode(false);
				self.removelastdummy();
			};

			self.removelastdummy = function () {
				//remove last empty record
				if (self.items().length > 0) {
					self.removeItem(self.items()[self.items().length - 1]);
				}
			};

			self.removeItem = function (item) {
				if (item.project_expense_type_id() > 0) {
					self.items.destroy(item);
				}
				else {
					self.items.remove(item);
				}
			};

			self.prepareData = function () {
				var tmpLength = self.items().length - 1;
				$.each(self.items(), function (key, val) {
					val._destroy && tmpLength--;
				});
				if (tmpLength <= 0) {
					alert("at least one expense type required.");
					return false;
				}

				self.removelastdummy();
				var data = JSON.parse(ko.toJSON(self.items())),
					ret = {},
					ttIds = [];
				ret.deleted_items = [],
					ret.expense_types = [];

				var val = null;
				for (var i = 0; i < data.length; i++) {
					val = data[i];
					delete val.expense_types_list;
					if (val._destroy == true) {
						ret.deleted_items.push(val.project_expense_type_id);
						continue;
					}
					ttIds.push(val.expense_type_id);

					if ((val.isDirty == true || root.is_new_mode()) && val.expense_type_id != undefined) {
						ret.expense_types.push(val);
					}
				}

				if (ttIds.length != ttIds.filter(function (v, i, s) { return s.indexOf(v) === i; }).length) {
					alert("Duplicate exist.");
					return false;
				}
				return ret;
			};

			self.save = function () {
				data = self.prepareData();
				if (data === false) {
					return false;
				}
				if (data.expense_types && data.expense_types.length <= 0 && data.deleted_items.length <= 0) {
					self.cancel();
					return false;
				}
				var url = "store/" + _this.listModel.selectedItem().project_id() + "/expense_types";
				Otime.app.postData(new Otime.ContextModel({
					url: url,
					global: false
				}, data, function (cont) {
					var response = cont.response;
					if (data.deleted_items && data.deleted_items.length > 0) {
						var tmpArr = [];
						for (var i = 0; i < self.items().length; i++) {
							if (self.items()[i]._destroy == undefined || self.items()[i]._destroy == false) {
								tmpArr.push(self.items()[i]);
							}
						}
						self.items(tmpArr);
					}
					if (response && response.project_expense_type_id && response.project_expense_type_id.length > 0) {
						var count = 0;
						for (var i = 0; i < self.items().length; i++) {
							var value = self.items()[i];
							if (Number(value.project_expense_type_id() <= 0) && Number(value.expense_type_id()) > 0) {
								value.project_expense_type_id(response.project_expense_type_id[count]);
								count++;
							}
						}
					}
					self.commit();
					self.is_edit_mode(false);
				}));
			};
		};

		_this.ExpenseTypeModel = function (data) {
			var self = this;

			data = data || {};

			self.project_expense_type_id = Otime.o(data.project_expense_type_id || 0);
			// self.is_common				= Otime.o(data.is_common || 0);
			// self.expense_types_list = Otime.a(data.expense_types_list || []);
			self.expense_type_id = Otime.o(data.expense_type_id || 0).extend({ trackChange: true });
			self.estimated = Otime.o(data.estimated - 0 || "").extend({ trackChange: true });
			// self.unit_price = Otime.o(data.unit_price - 0 || "").extend({ trackChange: true });
			self.actual = Otime.o(data.actual - 0 || "").extend({ trackChange: true });
			if (Otime.Details.all_expense_types[data.expense_type_id])
			{
				data.name = Otime.Details.all_expense_types[data.expense_type_id].name;
			}
			self.name_lbl = Otime.o(data.name || "");

			/*
			var val = null;
			var tmpSubscribe = function (isManual) {
				for (var i = 0, iLen = self.expense_types_list().length; i < iLen; i++) {
					val = self.expense_types_list()[i];
					if (val.expense_type_id == self.expense_type_id()) {
						if (isManual !== false)
							self.unit_price(val.unit_price);
						self.name_lbl(val.name);
						return;
					}
				}
			};
			tmpSubscribe(false);
			self.expense_type_id.subscribe(tmpSubscribe);
			*/

			self.isDirty = Otime.c(function () {
				for (var key in self) {
					if (self.hasOwnProperty(key) && Otime.i(self[key]) && typeof self[key].isDirty === 'function' && self[key].isDirty()) {
						return true;
					}
				}
				return false;
			});
		};
		_this.MemberSearch = function (data) {
			var self = this;

			data = data || {};

			self.user_image = data.user_image || "assets/img/noimg_32.png";
			self.user_id = data.user_id || "";
			self.first_name = data.first_name || "";
			self.user_role = data.user_role || "";
		};

		_this.DocumentModel = function (data, parent) {
			var self = this;

			data = data || {};

			self.is_edit_mode = Otime.o(false);
			//			self.attachment_image	= Otime.o("");
			self.attachment_details = Otime.a(data.attachment_details || []);
			self.new_attachment = Otime.a([]);
			self.module_type = Otime.o(data.module_type || "P");
			self.module_id = Otime.o(data.module_id || _this.listModel.selectedItem().project_id() || 0);
			self.posted_by = Otime.o(data.posted_by || "");
			self.posted_date = Otime.o(data.posted_date || "");

			self.edit = function () {
				ko.editable(self);
				self.beginEdit();
				self.is_edit_mode(true);
			};

			self.cancel = function () {
				self.rollback();
				self.is_edit_mode(false);
			};

			var tmpCount = 0,
				fileItems = {},
				key = "";

			self.prepareForNew = function () {
				return JSON.parse(ko.toJSON(self));
			};

			self.prepareData = function (fileItem, encFileName) {
				tmpCount++;
				key = (tmpCount + "##" + new Date().getTime());
				fileItem.uniqueKey = key;
				var newItem = null;

				if (fileItem) {
					var filename = fileItem.file.name;// self.attachment_image();
					var files = filename.split('.');
					for (var i = 0, iDetails = self.attachment_details(), iLen = iDetails.length; i < iLen; i++) {
						console.log(iDetails[i]);
						if ((iDetails[i].file_name() + "." + iDetails[i].file_type()).toLowerCase() == filename.toLowerCase()) {
							if (!confirm("File Already Exists!! Do You want to Overwrite?")) {
								_this.fileApi.fileList.hide();
								return false;
							}
							self.deleteItem(iDetails[i], null, true);
						}
					}
					_this.fileApi.fileList.show();
					newItem = new Otime.AttachmentDetailModel({
						file_type: files.pop(),
						file_path: encFileName,
						file_name: files.join('.'),
						module_type: self.module_type() || "P",
						module_id: self.module_id() || _this.listModel.selectedItem().project_id(),
						file_size: fileItem.file.size,
						posted_by: self.posted_by() || Otime.Project.user_name,
						posted_date: self.posted_date() || new Date().format("YYYY-MM-DD")
					});

					self.new_attachment.push(newItem);
					//					fileItem.attachmentModel	= newItem;
					fileItems[key] = newItem;
				}

				var data = {
					module_type: self.module_type(),
					module_id: self.module_id(),
					new_attachment: null
				};
				// JSON.parse(ko.toJSON(self));
				//				delete data.new_attachment;
				data.new_attachment = [JSON.parse(ko.toJSON(newItem))];

				return data;
			};

			_this.fileApi.onAfterUpload = function (resp, fileItem) {
				if (!resp[0]) {
					Otime.error_message(resp[1], $("#alert_message"));
					return false;
				}
				var postData = self.prepareData(fileItem, resp[2].file_name);

				if (postData === false) {
					return false;
				}

				var url = "store/" + (self.module_id() || _this.listModel.selectedItem().project_id()) + "/document";
				Otime.app.postData(new Otime.ContextModel({
					url: url,
					global: false
				}, postData, function (cont) {
					var response = cont.response;

					self.moveAttachments(resp[2].file_name, response.attachment_id, function () {
						self.is_edit_mode(false);

						//							self.new_attachment() && self.new_attachment()[0]
						if (Object.keys(fileItems).length > 0 && fileItems[fileItem.uniqueKey]) {
							var attach = fileItems[fileItem.uniqueKey];
							attach.attachment_id(response.attachment_id - 0);
							attach.encrypt_key(response.encrypt_key);
							attach.posted_by(response.posted_by || attach.posted_by());
							response.posted_date = response.posted_date ? Otime.Date(response.posted_date) : null;
							attach.posted_date(response.posted_date || attach.posted_date());
							attach.file_size(response.file_size || attach.file_size());

							self.attachment_details.push(attach);
							self.new_attachment.remove(attach);
						}
						data.onAfterSave && typeof data.onAfterSave == "function" && data.onAfterSave();
					});
				}));
			};

			self.save = function (fileItem) {
				_this.fileApi.uploadQueue();
			};

			self.moveAttachments = function (file_name, attachment_id, clbk) {
				var context = new Otime.ContextModel({
					url: "move_attachments",
					global: false
				}, {
					file_name: file_name,
					attachment_id: attachment_id
				}, function (cont) {
					var response = cont.response;
					clbk && clbk(response);
				});
				context.module_name = "attachment";
				Otime.app.postData(context);
			};

			self.deleteItem = function (item, elem, flag) {
				if (!flag)
					if (!confirm("Are you sure you want to delete the file?")) {
						return false;
					}

				var context = new Otime.ContextModel({
					url: "delete_attachment/" + item.attachment_id(),
					global: false
				}, {
					module_type: self.module_type() || "P",
					module_id: self.module_id() || _this.listModel.selectedItem().project_id()
				}, function (cont) {
					var response = cont.response;
					self.attachment_details.remove(item);
					data.onAfterDelete && typeof data.onAfterDelete == "function" && data.onAfterDelete(self, response);
				});
				context.module_name = "attachment";
				Otime.app.postData(context);
			};

			_this.fileApi.onAddFile = function (count) {
				//				var reader = new FileReader();
				//				reader.onload = function(e){
				//	self.attachment_image(e.target.result);
				//				};
				//				reader.readAsDataURL(_this.fileApi.fileQueue[0].file);
				if (count) {
					var fileItem = _this.fileApi.fileQueue[count - 1];
					self.save(fileItem);
				}
			};

			_this.fileApi.onRemoveFile = function () {
			};

			self.parent = function () {
				return parent;
			};

			parent && parent.is_new_mode && parent.is_new_mode() && self.edit();
		};

		_this.BudgetModel = function (data, parent) {
			var self = this;

			data = data || {};

			self.budget_type = Otime.o(data.budget_type || _this.budget_type || "AT");
			self.budget_value = Otime.o(Number(data.budget_value - 0 || 0));
			self.budget_alert_percent = Otime.o(data.budget_alert_percent - 0 || '');

			self._info = {};
			self._info.isAmt = Otime.o(self.budget_type().substr(0, 1) == "A");
			self._info.isBGVal = Otime.o(0);
			self._info.total_hours = Otime.o(0);
			self._info.actual_hours = Otime.o(0);
			self._info.type_diplay = Otime.o(0);
			self._info.is_edit_mode = Otime.o(false);

			self._info.is_edit_mode.subscribe(function (newVal) {
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			self._info.isBGVal(self.budget_type() == "HA" || self.budget_type() == "AA");

			var tmpDisp = "";
			self._info.budget_type_name = Otime.c(function () {
				tmpDisp = Math.round((self._info.total_hours() * self.budget_alert_percent()) / 100);
				tmpDisp += " " + (self._info.isAmt() ? Otime.Currency : "Hrs");
				self._info.type_diplay(tmpDisp);

				return _this.budget_types[self.budget_type()];
			});

			//			self._info.is_width_max	= Otime.c(function() {
			//				var btype_chars = $("<div />").html().text();
			// 				var actual_chars = self._info.actual_hours() + " " + btype_chars;
			//				var budget_chars = self._info.total_hours() + " " + btype_chars;
			//				if(actual_chars.length > 4 || budget_chars.length > 4){
			//					return true;
			//				}
			//				return false;
			//			});

			self.edit = function () {
				ko.editable(self);
				self.beginEdit();
				self._info.is_edit_mode(true);
			};

			self.cancel = function () {
				self.rollback();
				self._info.is_edit_mode(false);
			};

			self.prepareData = function () {
				if (Number(self.budget_alert_percent()) > 100)
					self.budget_alert_percent(100);
				if (Number(self.budget_alert_percent()) < 0)
					self.budget_alert_percent(0);

				// Clear budget value for budget types.
				//				if (self.budget_type() != "HA" && self.budget_type() != "AA")
				//					self.budget_value(0);

				var data = JSON.parse(ko.toJSON(self));

				delete data._info;
				delete data.hasChanges;

				return data;
			};

			self.save = function () {
				var data = self.prepareData();
				var url = "store/" + _this.listModel.selectedItem().project_id() + "/budget";
				Otime.app.postData(new Otime.ContextModel({
					url: url,
					global: false
				}, data, function (cont) {
					var response = cont.response;
					self.commit();
					self._info.is_edit_mode(false);
					_this.budget_type = self.budget_type();
				}));
			};

			self.parent = function () {
				return parent;
			};
		};

		_this.ConfigModel = function (data, parent) {
			var self = this;
			data = data || {};
			self.format_date = Otime.o(Otime.dateFormat);
			self._info = {};
			self._info.is_edit_mode = Otime.o(false);
			self.start_date = Otime.o(new Date(data.start_date || Otime.Date().getTime()));
			self.target_date = Otime.o(new Date(data.target_date));
			self.status_id = Otime.o(data.status_id || "");

			self._info.is_edit_mode.subscribe(function (newVal) {
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			self._info.project_status_name = Otime.c(function () {
				return _this.project_status && _this.project_status[self.status_id()] ? _this.project_status[self.status_id()].name : '';
			});

			self.edit = function () {
				ko.editable(self);
				self.beginEdit();
				self._info.is_edit_mode(true);
			};

			self.prepareData = function () {
				var data = {
					start_date: new Date(self.start_date()).format(Otime.sdf),
					target_date: new Date(self.target_date()).format(Otime.sdf),
					status_id: self.status_id()
				};

				return data;
			};

			self.save = function () {
				var data = self.prepareData();
				// var data	= {
				// 	start_date: new Date(self.start_date()).format(Otime.sdf),
				// 	target_date: new Date(self.target_date()).format(Otime.sdf),
				// 	status_id:self.status_id()
				// };
				var url = "store/" + _this.listModel.selectedItem().project_id() + "/config";
				Otime.app.postData(new Otime.ContextModel({
					url: url,
					global: false
				}, data, function (cont) {
					var response = cont.response;
					self.commit();
					self._info.is_edit_mode(false);
				}));
			}
			self.cancel = function () {
				self.rollback();
				self._info.is_edit_mode(false);
			};
			self.parent = function () {
				return parent;
			};
		}

		_this.InvoiceModel = function (data, parent) {
			var self = this;

			data = data || {};

			self.is_edit_mode = Otime.o(false);

			self.invoice_type = Otime.o(data.invoice_type || "T");
			self.hourly_rate = Otime.o(data.hourly_rate || 0);
			self.invoice_type_name = Otime.c(function () {
				return _this.invoice_types[self.invoice_type()];
			});

			self.invoiced_hours = Otime.o(data.invoiced_hours || 0);
			self.uninvoiced_hours = Otime.o(data.uninvoiced_hours || 0);
			self.billed_hours = Otime.o(data.billed_hours || 0);
			self.uninvoiced_hours = Otime.o(data.uninvoiced_hours || 0);
			self.paid_invoices = Otime.o(data.paid_invoices || 0);
			self.paid_invoices_amount = Otime.o(data.paid_invoices_amount || 0);
			self.unpaid_invoices = Otime.o(data.unpaid_invoices || 0);
			self.unpaid_invoices_amount = Otime.o(data.unpaid_invoices_amount || 0);
			self.expenses_count = Otime.o(data.expenses_count || 0);
			self.expenses_amount = Otime.o(data.expenses_amount || 0);
			self.comments = Otime.o(data.comments || 0);

			self.invoice_prg = function () {
				var hg = Number(self.invoiced_hours()) + Number(self.uninvoiced_hours());
				hg = 100 - ((100 / hg) * Number(self.invoiced_hours()));
				return hg;
			};

			self.is_edit_mode.subscribe(function (newVal) {
				if (newVal)
					Otime.Menu.isAllow(Otime.Menu.isAllow() + 1);
				else
					Otime.Menu.isAllow(Otime.Menu.isAllow() - 1);
			});

			self.edit = function () {
				ko.editable(self);
				self.beginEdit();
				self.is_edit_mode(true);
			};

			self.save = function () {
				var data = {
					invoice_type: self.invoice_type(),
					hourly_rate: (self.invoice_type() == 'A') ? self.hourly_rate() : 0
				};
				var url = "store/" + _this.listModel.selectedItem().project_id() + "/invoice";
				Otime.app.postData(new Otime.ContextModel({
					url: url,
					global: false
				}, data, function (cont) {
					var response = cont.response;
					self.commit();
					self.is_edit_mode(false);
				}));
			};

			self.cancel = function () {
				self.rollback();
				self.is_edit_mode(false);
			};

			self.parent = function () {
				return parent;
			};
		};

		_this.UpdateContainers = function () {
			_this.project_container = $("#projectcontainer");
			_this.list_container = $("#list-container");
			_this.add_container = $("#add_layout");
			_this.view_container = $("#view_layout");
			_this.comment_container = $("#comment_layout");
			_this.client_container = $("#addclient");
			_this.user_container = $("#adduser");
		};

		_this.loadTemplates = function (clbk) {
			var url = Otime.siteUrl + '/project/tmpl';
			Otime.loadTemplates(url, {
				v: Otime.version,
				r: Otime.usr
			}, function (content) {
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
			}, "project_" + Otime.version);
		};

		_this.init = function () {
			_this.UpdateContainers();

			_this.user_id = Otime.userDetails.id;
			_this.user_name = Otime.userDetails.name;
			_this.user_role = Otime.userDetails.role;

			Otime.unbind();

			_this.fileApi = new FileAPI({
				mimeTypes: Otime.allowedmimes,
			});
			// _this.CommentsHandler	= Otime.o(null);

			_this.list_container.masonry({ itemSelector: '.metro-item', columnWidth: 0 });

			_this.listModel = new _this.ProjectListModel();
			_this.listModel.loadFilters(_this.listModel.refresh(_this.listModel.active()));

			ko.applyBindings(_this.listModel, _this.project_container.get(0));

			var prevent = function (ev) {
				ev.stopPropagation();
				ev.preventDefault();
			};
			$("#filecontainer").on("dragenter", prevent).on("dragleave", prevent).on("dragover", prevent).on("drop", function (ev) {
				_this.fileApi.showDroppedFiles(ev.originalEvent);
			});

			/*var scrElem	= $("#main-container");
			scrElem.unbind("scroll");
			scrElem.scroll(function(){
				if($("#projectcontainer").height() <= ($(this).scrollTop()+$(this).height()+100))
				{
					_this.listModel.load_more();
					if (_this.listModel.finish() == true)
						scrElem.unbind("scroll");
				}
			});*/
		};
	};
}(window.Otime));

ko.bindingHandlers.currency = {
    update: function(element, valueAccessor) {
        var value = valueAccessor().val;
        value = ko.isObservable(value) ? value() : value;

        var fix = valueAccessor().fix || 0;
        var symbol = Otime.Project.currency_symbol || "₹";

		if (symbol.includes("&#")) {
            var parser = new DOMParser();
            symbol = parser.parseFromString(symbol, 'text/html').body.textContent || "";
        }

		if (!isNaN(value)) {
            let formattedValue = symbol + " " + Number(value).toFixed(fix).replace(/\B(?=(\d{3})+(?!\d))/g, ",");
            element.innerText = formattedValue;
        } else {
            element.innerText = symbol + " 0";
        }
    }
};

ko.bindingHandlers.format_date = {
    update: function(element, valueAccessor) {
        var value = valueAccessor();
        value = ko.isObservable(value) ? value() : value;

        if (value && value !== '0000-00-00') {
            let dtFormat = Otime.Project.dt_format || "MMM dd, yyyy";
            let date = new Date(value);
            if (isNaN(date.getTime())) {
                element.innerText = "";
            } else {                				
                let monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
                let formattedDate = dtFormat
                    .replace("MMM", monthNames[parseInt(date.getMonth())])
                    .replace("dd", String(date.getDate()).padStart(2, '0'))
					.replace("MM", String(date.getMonth() + 1).padStart(2, '0'))
                    .replace("yyyy", date.getFullYear());

                element.innerText = formattedDate;
            }
        } else {
            element.innerText = "";
        }
    }
};

