﻿(function (Otime) {

	Otime.ResourcePlanner = new function ResourcePlanner() {
		//		"use strict";

		var _this = this;

		_this.name = "timesheet";

		_this.model = "ResourcePlannerModal";

		_this.language = null;

		// For Predict
		// var projectsByUser = {};
		var last = {
			project_id: null
		};

		var dtFormat = "YYYY-MM-DD";
		var schPlugin = null;

		_this.ResourcePlannerModal = function (data) {
			var self = this;

			self.preparedData = null;

			self.filter_projects = Otime.a(Otime.Details.getProjects() || []);
			self.projects = Otime.a(Otime.Details.getProjects() || []);
			self.projectNameByid = {};
			self.projects().forEach(element => {
				self.projectNameByid[element.project_id] = element.project_name;
			});
			self.task_types = Otime.a([]);
			self.users = Otime.a(Otime.Details.getAllUsers() || []);

			// Project Filter
			self.project_id = Otime.a([]);
			self.project_id.subscribe(function (newVal) {
				if (!newVal) {
					schPlugin && schPlugin.showUser();
					return;
				}

				var uIds = [];
				$.each(newVal, function (idx, pId) {
					Otime.Details.getProjectUsers(pId, function (usrId, usrObj) {
						if (uIds.indexOf(usrId) < 0) {
							uIds.push(usrId);
						}
					});
				});

				if (uIds && uIds.length < 1) {
					uIds = null;
				}

				schPlugin && schPlugin.showUser(uIds);
			});

			self.popupBind = Otime.o(null);
			self.tsDetails = Otime.o(null);

			self.curDate = Otime.o();
			self.nav_date = Otime.o();

			self.start_date = Otime.o();
			self.end_date = Otime.o();

			self.viewType = Otime.o("M");

			self.curDate.subscribe(function (newVal) {
				var dt = new Date(newVal);

				if (self.viewType() == "M") {
					self.start_date(dt.getMonthStart());
					self.end_date(dt.getMonthEnd());
				}
				else if (self.viewType() == "W") {
					self.start_date(dt.getWeekStart());
					self.end_date(dt.getWeekEnd());
				}

				var format = "DD";
				if (self.start_date().getFullYear() != self.end_date().getFullYear())
					format = "DD MMM, YYYY";
				else if (self.start_date().getMonth() != self.end_date().getMonth())
					format = "DD MMM";

				self.nav_date(self.start_date().format(format) + self.end_date().format(" - DD MMM, YYYY"));
			});

			self.viewType.subscribe(function (newVal) {
				applyPlugin(_this.scheduler, _this.appModel.preparedData);
			});

			self.swapView = function () {
				if (self.viewType() == "W") {
					self.viewType("M");
				} else {
					self.viewType("W");
				}
			};

			self.curDate(new Date());

			self.prev = function () {
				var dt = new Date(self.curDate());
				// dt.addDays(-7);
				dt.addMonth(-1);
				self.curDate(dt);
				// getData();
				self.init();
			};
			self.next = function () {
				var dt = new Date(self.curDate());
				// dt.addDays(7);
				dt.addMonth(1);
				self.curDate(dt);
				// getData();
				self.init();
			};

			self.showTimeSheet = function (item, elem, clbk) {
				if (item) {
					var popover = $('#popover');
					if (!popover.is(":visible")) {
						var newTsItem = new _this.ResourceDetailModel(item, self);
						self.tsDetails(newTsItem);
						popover.show();
					}
					else {
						popover.hide();
						self.tsDetails(null);
					}
				}
			};
			self.getProjectName = function (id) {
				return self.projectNameByid[id()];
			}
			self.save = function (item) {
				if (!item.project_id()) {
					alert("Project Required");
					return;
				}

				/*if (!item.project_task_id()) {
					alert("Task Required");
					return;
				}*/

				if (!item.user_ids() || !item.user_ids().length) {
					alert("User Required");
					return;
				}

				if (item.isNew()) {
					self.saveNew(item);
				} else {
					self.saveOld(item);
				}

			};

			self.saveNew = function (item) {
				var newTs = JSON.parse(ko.toJSON(item));
				newTs.start_date = new Date(newTs.start_date).format(dtFormat);
				newTs.end_date = new Date(newTs.end_date).format(dtFormat);
				delete newTs.timesheets;

				_this.saveEstimate({
					newTs: newTs
				}, function (resp) {
					if (resp && resp.newTs && resp.newTs.otvalues) {
						var userIds = [];
						resp.newTs.otvalues.setKeys(resp.newTs.otkeys, function (obj, idx) {
							if (!tsheets[obj.user_id]) {
								tsheets[obj.user_id] = {};
							}
							if (userIds.indexOf(obj.user_id) < 0) {
								userIds.push(obj.user_id);
							}
							tsheets[obj.user_id][obj.time_sheet_id + "_" + obj.project_task_id + "_" + obj.entry_date] = obj;
						});

						var tmp = null;
						$.each(userIds, function (k, userId) {
							refreshSingleUser(userId);
						});

						self.cancel();
					}
				});
			}

			self.saveOld = function (item) {
				var obj = JSON.parse(ko.toJSON(item));

				var userIds = [];

				var start_date = new Date(obj.start_date);// .format(dtFormat);
				var end_date = new Date(obj.end_date);// .format(dtFormat);

				obj.start_date = start_date.format(dtFormat);
				obj.end_date = end_date.format(dtFormat);

				var tsIds = [];
				var oldSheets = [];
				$.each(obj.timesheets, function (key, val) {
					oldSheets.push({
						time_sheet_id: val.time_sheet_id,
						user_id: val.user_id,
						entry_date: val.entry_date,
						project_task_id: val.project_task_id
					});

					if (userIds.indexOf(val.user_id) < 0) {
						userIds.push(val.user_id);
					}

					tsIds.push(val.time_sheet_id);
				});

				delete obj.timesheets;

				obj.time_sheets_ids = tsIds;

				_this.saveEstimate({
					newTs: obj
				}, function (resp) {
					if (!resp) {
						return true;
					}

					$.each(oldSheets, function (idx, sheet) {	
						if (tsheets[sheet.user_id] && tsheets[sheet.user_id][sheet.time_sheet_id + "_" + sheet.project_task_id + "_" + sheet.entry_date]) {
							delete tsheets[sheet.user_id][sheet.time_sheet_id + "_" + sheet.project_task_id + "_" + sheet.entry_date];
						}
					});

					if (resp && resp.newTs && resp.newTs.otvalues) {

						resp.newTs.otvalues.setKeys(resp.newTs.otkeys, function (obj, idx) {
							if (!tsheets[obj.user_id]) {
								tsheets[obj.user_id] = {};
							}
							if (userIds.indexOf(obj.user_id) < 0) {
								userIds.push(obj.user_id);
							}
							tsheets[obj.user_id][obj.time_sheet_id + "_" + obj.project_task_id + "_" + obj.entry_date] = obj;
						});

						var tmp = null;
						$.each(userIds, function (k, userId) {
							refreshSingleUser(userId);
						});

						self.cancel();
					}
				});
			};

			self.cancel = function () {
				var popover = $('#popover');
				popover.hide();
				self.tsDetails(null);
			};

			/*
						self.splitItem = function(){
							console.log("Split Item ");
						};
			
						self.deleteItem = function(){
							console.log("Delete Item ");
						};
			*/

			self.init = function () {
				getData(null, function (data) {
					applyPlugin(_this.scheduler, data);
				});
			};
		};

		_this.saveEstimate = function (params, clbk) {
			if (
				(!params.addedTs || !params.addedTs.length) &&
				(!params.deleteIds || !params.deleteIds.length) &&
				(!params.updateTs || !params.updateTs.length) &&
				(!params.newTs)
			) {
				return;
			}

			if (params.newTs) {
				if (!(params.newTs.estimated_hours - 0)) {
					alert("Estimated hours required");
					return false;
				}

				if ((params.newTs.estimated_hours - 0) > 24) {
					alert("Hours can't be greater than 24 hours");
					return false;
				}
			}
			Otime.app.loadData(new Otime.ContextModel("estimate_save", params, function (context) {
				var data = context.response || {};
				/*
								if (data && data.items && data.items.otvalues)
								{
									
								}
				*/
				typeof clbk === "function" && clbk(data);
			}));
		};

		_this.ResourceDetailModel = function (data, parent) {
			var self = this;

			data = data || {};

			parent.projects(Otime.Details.getUserProjects(data.user_id));

			self.isNew = Otime.o(!!data.isNew);

			self.project_id = Otime.o(0);
			self.project_id.subscribe(function (newVal) {
				if (newVal) {
					var task_types = Otime.Details.getProjectTaskTypes(newVal);
					task_types = Object.values(task_types);
					parent.task_types(task_types);

					var usersList = [];
					Otime.Details.getProjectUsers(newVal, function (userId, userObj) {
						usersList.push(userObj);
					});
					parent.users(usersList);

					last.project_id = newVal;
				}
			});

			data.project_id = parent.project_id()[0] || data.project_id || last.project_id;
			if (!data.project_id && parent.projects().length > 0) {
				data.project_id = parent.projects()[0].project_id;
			}
			data.project_id && self.project_id(data.project_id);

			self.task_type_id = Otime.o(data.task_type_id || 0);
			self.project_task_id = Otime.o(data.project_task_id || 0);
			self.activity_name = Otime.o(data.activity_name || "");
			self.activity_name.subscribe(function (newVal) {
				if (!self.activity_name.original_value || newVal != self.activity_name.original_value) {
					self.project_task_id(0);
				}
			});
			self.task_number = data.task_number;
			self.user_ids = Otime.a([data.user_id]);

			data.estimated_hours = ((data.estimated_hours || 0) - 0).toFixed(4) - 0;
			self.estimated_hours = Otime.o(data.estimated_hours || "");
			self.estimatedHoursDisp = Otime.o("");
			self.estimated_hours.subscribe(function (newVal) {
				newVal = Otime.formatHrs(newVal, true);
				self.estimatedHoursDisp(newVal);
			});

			self.onChangeEst = function () {
				self.estimated_hours(Otime.toHrs(self.estimatedHoursDisp()));
			};

			self.estimatedHoursDisp(Otime.formatHrs(self.estimated_hours(), true));

			self.timesheets = Otime.a(data.sheets || []);

			self.getTasks = function (request, callback) {
				if (!self.project_id()) {
					return;
				}

				Otime.Details.Tasks.get(request, callback, self);
			};

			self.setTasks = function (event, ui) {
				Otime.Details.Tasks.set(event, ui, self);
			};

			// self.total_hours = Otime.o(data.hours-0);

			self.start_date = Otime.o(new Date(data.start));
			self.end_date = Otime.o(new Date(data.end));
		};

		var userIds = [];
		var chartData = {};
		var daysArr = [];
		var tsheets = {};
		var datas = {};

		var refreshSingleUser = function (userId) {
			chartData[userId] = null;

			$.each(tsheets[userId], function (tsId, tsObj) {
				getUserChartData(tsObj);
			});

			schPlugin.updateUser(userId, prepareUserData(chartData[userId]));
		};

		var prepareDateList = function () {
			var start_date = new Date(_this.appModel.start_date());
			var end_date = new Date(_this.appModel.end_date());
			var diffDays = (end_date - start_date) / (1000 * 60 * 60 * 24);

			daysArr = [];
			datas = {};
			for (var i = 0; i <= diffDays; i++) {
				datas[start_date.format(dtFormat)] = [];
				daysArr.push(start_date.format(dtFormat));
				start_date.addDays(1);
			}

			datas = JSON.stringify(datas);
		}

		var getData = function (params, clbk) {
			if (!params) {
				params = {
					start_date: _this.appModel.start_date().format(dtFormat),
					end_date: _this.appModel.end_date().format(dtFormat),
					// user_id: 4,
					task_follow: 0
				};
			}

			Otime.app.loadData(new Otime.ContextModel('estimates', params, function (context) {
				var data = context.response || {};

				chartData = {};
				prepareDateList();
				// tsheets = {};
				if (data && data.items && data.items.otvalues) {
					data.items = data.items.otvalues.setKeys(data.items.otkeys, function (obj, idx) {
						if (!tsheets[obj.user_id]) {
							tsheets[obj.user_id] = {};
							userIds.push(obj.user_id - 0);
						}
						// obj.entry_date = obj.entry_date.toDate();
						tsheets[obj.user_id][obj.time_sheet_id + "_" + obj.project_task_id + "_" + obj.entry_date] = obj;
					});
					// userIds.sort(function(a, b){return a-b});
				}


				_this.appModel.preparedData = prepareData();
				typeof clbk === "function" && clbk(_this.appModel.preparedData);
			}));
		};

		var prepareData = function () {
			userIds = [];
			chartData = {};

			if (Otime.isM) {
				if (!chartData[Otime.UID]) {
					userIds.push(Otime.UID);
					chartData[Otime.UID] = {
						userName: "User Name - " + Otime.UID,
						user_id: Otime.UID,
						listItems: JSON.parse(datas),
						listItemsId: JSON.parse(datas)
					};
				}
			} else {
				var prjs = Otime.Details.getActiveProjects();
				$.each(prjs, function (idx, obj) {
					$.each(Otime.Details.project_users[obj.project_id], function (_idx, uId) {
						uId = uId - 0;
						if (!chartData[uId]) {
							userIds.push(uId);
							chartData[uId] = {
								userName: "User Name - " + uId,
								user_id: uId,
								listItems: JSON.parse(datas),
								listItemsId: JSON.parse(datas)
							};
						}
					});
				});
			}

			var userList = [];
			if (userIds && userIds.length) {
				$.each(userIds, function (key, userId) {
					$.each(tsheets[userId], function (tsId, tsObj) {
						getUserChartData(tsObj);
					});

					userList.push(prepareUserData(chartData[userId]));
				});
			}

			return userList;
		};

		var getUserChartData = function (obj) {
			if (!chartData[obj.user_id]) {
				chartData[obj.user_id] = {
					userName: "User Name - " + obj.user_id,
					user_id: obj.user_id,
					listItems: JSON.parse(datas),
					listItemsId: JSON.parse(datas)
				};
			}

			var key = obj.project_id + "-" + obj.task_type_id + "-" + obj.project_task_id + "-" + obj.activity_name + "-" + obj.estimated_hours;

			if (!chartData[obj.user_id].listItems[obj.entry_date])
			{
				chartData[obj.user_id].listItems[obj.entry_date] = [];
			}
			chartData[obj.user_id].listItems[obj.entry_date].push(key);

			if (!chartData[obj.user_id].listItemsId[obj.entry_date])
			{
				chartData[obj.user_id].listItemsId[obj.entry_date] = [];
			}
			chartData[obj.user_id].listItemsId[obj.entry_date].push(obj);
		}

		var prepareUserData = function (userObj) {
			if (!userObj) {
				return;
			}

			var start_date = new Date(_this.appModel.start_date());
			var end_date = new Date(_this.appModel.end_date());

			var drawData = [];
			var totHoursArr = [];
			var totHours = {};

			var currRow = 0,
				tmpIdx = 0,
				tsObj = null,
				nxtEntDate = null;

			var maxRows = 0;

			$.each(daysArr, function (idx, entry_date) {
				nxtEntDate = daysArr[idx + 1];

				maxRows = (userObj.listItems[entry_date].length > maxRows) ? userObj.listItems[entry_date].length : maxRows;

				$.each(userObj.listItems[entry_date], function (_idx, tsKey) {
					tsObj = userObj.listItemsId[entry_date][_idx];

					if (
						userObj.listItems[nxtEntDate] &&
						userObj.listItems[nxtEntDate].indexOf(tsKey) > -1
					) {
						tmpIdx = userObj.listItems[nxtEntDate].indexOf(tsKey);

						swapPosition(userObj.listItems[nxtEntDate], tmpIdx, _idx);
						swapPosition(userObj.listItemsId[nxtEntDate], tmpIdx, _idx);
					}
				});

			});

			// convert columns to rows
			var dt = null, cols = 1, id = "", tNo = "";
			for (var i = 0; i < maxRows; i++) {
				var currSheet = null, lastSheet = null, lastElem = null;

				currRow++;

				while (start_date < end_date) {
					dt = start_date.format(dtFormat);
					currSheet = userObj.listItemsId[dt][i];

					if (!currSheet) {
						lastElem = null;
						lastSheet = null;
						cols = 1;
						start_date.addDays(1);
						continue;
					}

					currSheet.estimated_hours = currSheet.estimated_hours - 0;

					if (lastSheet && (
						lastSheet.project_id != currSheet.project_id ||
						lastSheet.task_type_id != currSheet.task_type_id ||
						lastSheet.project_task_id != currSheet.project_task_id ||
						lastSheet.activity_name != currSheet.activity_name ||
						lastSheet.estimated_hours != currSheet.estimated_hours
					)
					) {
						lastElem = null;
						lastSheet = null;
						cols = 1;
					}

					currSheet._entry_date = currSheet.entry_date.toDate();

					if (!lastElem) {
						lastElem = {
							start: new Date(currSheet._entry_date),
							end: new Date(currSheet._entry_date),
							row: i, cols: cols,
							title: "", text: "",
							sheets: [],
							bg_color: currSheet.bg_color,
							user_id: currSheet.user_id,
							project_id: currSheet.project_id,
							task_type_id: currSheet.task_type_id,
							project_task_id: currSheet.project_task_id,
							activity_name: currSheet.activity_name,
							estimated_hours: currSheet.estimated_hours,
							task_number: currSheet.task_number
						};

						drawData.push(lastElem);
					} else {
						lastElem.end = new Date(currSheet._entry_date);
						lastElem.cols++;
					}

					lastElem.sheets.push(currSheet);

					lastElem.title = currSheet.project_code + currSheet.project_name;

					if (currSheet.task_type_name) {
						lastElem.title += "-" + currSheet.task_type_name;
					}
					lastElem.title += "\n";
					lastElem.text = lastElem.title;

					tNo = "";
					if (currSheet.task_number) {
						tNo = "#" + currSheet.task_number;// + " " + lastElem.title;
						lastElem.title += tNo + " - ";
					}

					lastElem.title += currSheet.activity_name;
					// lastElem.text += currSheet.estimated_hours + " hr" + (currSheet.estimated_hours > 1 ? "s" : "");
					lastElem.text += currSheet.estimated_hours + " h";

					if (tNo) {
						lastElem.text += "  <span style=\"opacity:0.7\">- " + tNo + " - " + currSheet.activity_name + "</span>";
					}

					if (currSheet.estimated_hours) {
						id = "tot-" + currSheet.user_id + "-" + currSheet._entry_date.format(dtFormat);
						if (!totHours[id]) {
							var obj = {
								hours: 0,
								user_id: currSheet.user_id,
								date: new Date(currSheet._entry_date)
							};
							totHours[id] = obj;
							totHoursArr.push(obj);
						}
						totHours[id].hours += currSheet.estimated_hours - 0;
					}

					lastSheet = currSheet;

					start_date.addDays(1);
				}
				// reset
				start_date = new Date(_this.appModel.start_date());
			}

			return {
				userName: userObj.userName,
				user_id: userObj.user_id,
				rows: maxRows,
				drawData: drawData,
				totHoursArr: totHoursArr
			};
		};

		var swapPosition = function (arr, from, to) {
			//if (!arr[from] || !arr[to]) {
			// Fill Empty places
			// return false;
			//}

			var tmp = arr[from] || null;
			arr[from] = arr[to] || null;
			arr[to] = tmp;
		};

		var initFlag = false;
		var applyPlugin = function (elem, data) {
			elem.empty();

			var tmpUser = null;
			var template = '';
			template += '<div class="media">';
			template += '	<div class="media-left">';
			template += '		<img src="#user_image#" title="#user_name#" onerror="onImageError(this);" class="img32x32" />';
			template += '	</div>';
			template += '	<div class="media-body vam">';
			template += '		<h5 class="media-heading nm">#user_name#</h5>';
			template += '		<span class="media-description user-role">#user_role#</span>';
			template += '	</div>';
			template += '</div>';

			var sch = elem.scheduler({
				data: data,
				date: _this.appModel.curDate(),
				startDate: _this.appModel.start_date(),
				endDate: _this.appModel.end_date(),
				view: _this.appModel.viewType(),
				perDayHours: _this.perDayHours,
				onReady: function (instance) {
					if (!initFlag) {
						instance.scrollToToday();
						initFlag = true;
					}
				},
				onAdd: function (data, elem, clbk) {
					elem = $(elem);
					data.isNew = true;
					_this.appModel.showTimeSheet(data, elem, function (respData) {
						var days = 1;
						/*
						if (data.boxData && data.boxData[1] > 1) {
							$(elem).text("1hr for " + data.boxData[1] + " days");
						} else {
							$(elem).text("1hr");
						}
						*/
						$(elem).text("1hr");
						clbk(respData);
					});
				},
				onEdit: function (data) {
					_this.appModel.showTimeSheet(data, null, function (respData) {

					});
				},
				onRemove: function (date, item) {
					console.log("Deleted : ", date, item);
				},
				onLoadMore: function (e, pos) {
					var end_date = null,
						start_date = null;

					if (pos == -1) {
						end_date = new Date(_this.appModel.start_date()).addDays(-1);
						start_date = new Date(_this.appModel.start_date()).addMonth(-1);
						_this.appModel.start_date(start_date);
					} else if (pos == 1) {
						start_date = new Date(_this.appModel.end_date()).addDays(1);
						end_date = new Date(_this.appModel.end_date()).addMonth(1);
						_this.appModel.end_date(end_date);
					}

					var params = {
						start_date: start_date.format(dtFormat),
						end_date: end_date.format(dtFormat),
						task_follow: 0
					};

					getData(params, function (data) {
						applyPlugin(_this.scheduler, data);
					});
				},
				onResize: function (obj, tsdata, clbk) {
					var deleteIds = [];
					var deleteTs = [];
					var addedTs = [];

					if (obj.deleted.length) {
						var tsheetsByDate = {};
						$.each(tsdata.sheets, function (key, val) {
							tsheetsByDate[val._entry_date.format(dtFormat)] = val;
						});

						$.each(obj.deleted, function (key, val) {
							deleteIds.push(tsheetsByDate[val.format(dtFormat)].time_sheet_id);
							deleteTs.push(tsheetsByDate[val.format(dtFormat)]);
						});
					}

					var tsObj = {};
					if (tsdata.sheets && tsdata.sheets[0]) {
						tsObj = tsdata.sheets[0];
						tsObj.time_sheet_id = 0;
						delete tsObj.task_number;
						delete tsObj.task_priority;
						delete tsObj.is_progress;
						delete tsObj.parent_task_id;
						tsObj = JSON.stringify(tsObj);
					}
					tsdata.sheets = [];
					if (obj.added.length) {
						$.each(obj.added, function (k, val) {
							var obj = JSON.parse(tsObj);
							obj.entry_date = new Date(val).format(dtFormat);
							addedTs.push(obj);
						});
					}

					_this.saveEstimate({
						addedTs: addedTs,
						deleteIds: deleteIds
					}, function (resp) {
						// After Save/Delete ajax
						var _chartData = chartData[tsdata.user_id];
						var isRefresh = false;

						if (resp && resp.deleted) {
							$.each(deleteTs, function (key, ts) {
								delete tsheets[tsdata.user_id][ts.time_sheet_id];

								var list = _chartData.listItemsId[ts._entry_date.format(dtFormat)];
								_chartData.listItems[ts._entry_date.format(dtFormat)].splice(list.indexOf(ts), 1);
								list.splice(list.indexOf(ts), 1);
							});
							isRefresh = true;
						}

						if (resp && resp.added) {
							$.each(addedTs, function (key, ts) {
								if (resp.added[key] && resp.added[key].time_sheet_id) {
									ts.time_sheet_id = resp.added[key].time_sheet_id;
								}
								tsheets[tsdata.user_id][ts.time_sheet_id] = ts;
							});

							chartData[tsdata.user_id] = null;
							$.each(tsheets[tsdata.user_id], function (k, obj1) {
								obj1.entry_date = new Date(obj1.entry_date).format(dtFormat);
								getUserChartData(obj1);
							});

							// clbk && clbk(prepareUserData(chartData[tsdata.user_id]));
							isRefresh = true;
						}

						isRefresh && clbk && clbk(prepareUserData(chartData[tsdata.user_id]));
					});
				},
				onDragDrop: function (params, sucClbk, errClbk) {
					var dt = new Date(params.dates.start);
					var updateTs = [],
						tmpObj = null,
						oldUserId = null;

					$.each(params.tsdata.sheets, function (key, tsObj) {
						if ((tsObj.hours - 0)) {
							alert("Hours already posted, restricted to drag drop.");
							typeof errClbk === "function" && errClbk();
							return false;
						}

						if (new Date(dt).addDays(key).format(dtFormat) != tsObj._entry_date.format(dtFormat) || params.user_id) {
							tmpObj = {
								time_sheet_id: tsObj.time_sheet_id,
								entry_date: new Date(dt).addDays(key).format(dtFormat),
								user_id: tsObj.user_id
							};

							if (!oldUserId) {
								oldUserId = tsObj.user_id;
							}

							if (params.user_id) {
								tmpObj.user_id = params.user_id;

								var obj1 = tsheets[tsObj.user_id][tsObj.time_sheet_id] || {};
								delete tsheets[tsObj.user_id][tsObj.time_sheet_id];

								obj1.user_id = tmpObj.user_id;

								if (!tsheets[obj1.user_id]) {
									tsheets[obj1.user_id] = {};
								}

								tsheets[obj1.user_id][obj1.time_sheet_id] = obj1;
							}

							updateTs.push(tmpObj);
						}
					});

					_this.saveEstimate({
						updateTs: updateTs
					}, function (resp) {
						if (resp.updated) {
							$.each(updateTs, function (key, val) {
								tsheets[val.user_id][val.time_sheet_id].entry_date = val.entry_date;
							});

							params.user_id && refreshSingleUser(params.user_id);
							oldUserId && refreshSingleUser(oldUserId);
						}
					});
				},
				onDeleteBar: function (elem) {
					var tsData = elem.data("tsdata");
					var deleteIds = [];
					var canDelete = true;
					var oldSheets = [];
					$.each(tsData.sheets, function (key, val) {
						if (val.hours > 0) {
							canDelete = false;
						}
						deleteIds.push(val.time_sheet_id);
						oldSheets.push({
							time_sheet_id: val.time_sheet_id,
							user_id: val.user_id,
							entry_date: val.entry_date,
							project_task_id: val.project_task_id
						});
					});

					if (!canDelete) {
						alert("Can't delete, working hours posted.");
						return false;
					}

					_this.saveEstimate({
						deleteIds: deleteIds
					}, function (resp) {
						$.each(oldSheets, function (key, obj) {
							delete tsheets[obj.user_id][obj.time_sheet_id + "_" + obj.project_task_id + "_" + obj.entry_date];
						});
						elem.remove();
						refreshSingleUser(tsData.user_id);
					});
				},
				onUserTmpl: function (usrObj) {
					tmpUser = Otime.Details.all_users[usrObj.user_id];
					if (tmpUser) {
						return $(template
							.replace(/#user_name#/g, tmpUser.user_name)
							.replace(/#user_image#/g, Otime.USIP + tmpUser.user_image)
							.replace(/#user_role#/g, Otime.Details.user_roles[tmpUser.user_role])
						);
					}

					return $("<span/>").text(usrObj.userName).addClass("sch-title");
				}
			});

			schPlugin = sch.data("smxScheduler");
		};

		var deleteByDate = function (date) {
			console.log("deleteByDate : ", date);
		};

		_this.UpdateContainers = function () {
			_this.list_container = $("#planner-container");
			_this.scheduler = $("#scheduler");
			//_this.edit_container = $("#edit-layout");
			//_this.add_container = $("#edit-layout");
		};

		_this.loadTemplates = function (clbk) {
			var url = Otime.siteUrl + '/timesheet/plannert';

			Otime.loadTemplates(url, {
				v: Otime.version,
				r: Otime.usr
			}, function (content) {
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
			}, "planner_" + Otime.version);
		};

		_this.init = function () {
			_this.UpdateContainers();

			_this.appModel = new _this.ResourcePlannerModal();
			ko.applyBindings(_this.appModel, _this.list_container.get(0));
			_this.appModel.init();
		};
	};

}(window.Otime));
