(function (Otime) {

	Otime.Team = new function Team() {
		// "use strict";

		var _this = this;

		var refreshFlag = false;

		var initFlag = false;

		var isIE = !!$.browser.msie;

		_this._listing = null;
		

		_this.name = "team";

		_this.model = "TeamListModel";

		_this.language = "team";

		_this.appModel = null;

		_this.error = false;

		var elem = {
			team: null,
			main: null,
			body: null,
			teamList: null,
			teamTmpl: null
		};

		_this.UpdateContainers = function () {
			elem.team = $("#team-container");
			elem.main = $("#main-container");
			elem.body = $("#body-container");
			_this.list_container = $("#team-container1");
			elem.teamList = $("#team-list");
			elem.teamTmpl = $("#team-tmpl");

			if (!elem.teamList.get(0))
			{
				elem.teamList = $("<div/>").attr({
					"id": "team-list",
					"class": "container np fw fh"
				});
				elem.teamList.appendTo(elem.main);
			}
		};

		_this.TeamListModel = function (data) {
			var self = this;
			data = data || {};

			self.listing = Otime.a();
			self.is_edit_mode = Otime.o(false);
			self.is_list_view = Otime.o(false);
			self.is_document = Otime.o(false);
			self.is_comment = Otime.o(false);
			self.paneTypes = {
				COMMENT: 1,
				DOCUMENT: 2,
				ACTIVITY: 4,
				CHECKLIST: 8,
				TAGS: 16,
				ALL: 31
			},
			self.users = Otime.a(Otime.Details.getAllUsers());
			self.roles = [];
			self.rolesObj = Otime.Details.user_roles;
			$.each(Otime.Details.user_roles, function(key, val){
				self.roles.push({
					key: key,
					val: val
				});
			});
			self.editItem = Otime.o();
			self.search_team = Otime.o('');

			self.addNew = function(){
				self._edit(new _this.TeamModel({}, self));
			};

			self.search	= function(item, event){
				if (event.keyCode == 13)
				{						
					self.getList();						
				}
				return true;
			};

			self.clearSearch = function () {
				if (self.search_team()) {
					self.search_team("");
					self.getList();	
				}
			};

			self.export_team = function(){
				Otime.app.loadData(new Otime.ContextModel("export_csv", {
					team_name : self.search_team(),
					export: 1,
				}, function (cont) {
					var file_name = cont.response.name.replace(' ', '_').replace(/-/g, '');
					$('#iframe_download').attr('src', Otime.siteUrl + '/report/download/' + file_name + "/team_report");
					return true;
				}));
			};
		
			self.swapView = function(){
				self.is_list_view(!self.is_list_view());
				_this.list_container.masonry('reload');
			};
			self.getList = function(){
				Otime.app.postData(new Otime.ContextModel("listing", {
					team_name : self.search_team(),
				},  function(cont){
					var resp = cont.response;
					var items = [];
					if (resp.items && resp.items.otkeys && resp.items.otvalues)
					{						
						resp.items.otvalues.setKeys(resp.items.otkeys, function(item){
							items.push(new _this.TeamModel(item, self));
						});						
					}
					self.listing(items);
					_this.list_container.masonry("reload");
				}));
			};

			self._edit = function(item){
				ko.editable(item);
				item.beginEdit();
				self.editItem(item);
				item.initComments();
				self.is_edit_mode(true);
				_this.list_container.masonry('reload');
			};

			self.getBackground = function(item) {
				console.log(Otime.bgpicker_colors);
				return "#ff0000"

			}

			self.edit = function(item){
				if (!item.team_id()) {
					self._edit(item);
					return;
				}

				Otime.app.loadData(new Otime.ContextModel("edit/" + item.team_id(), {
					
				},  function(cont){
					var resp = cont.response;

					var users = [];
					$.each(resp.users, function(k, usr){
						if (usr.user_id)
						{
							var mem = Otime.Details.all_users[usr.user_id];
							usr = Object.assign(usr, mem);
							users.push(new _this.UserModel(usr, item));
						}
					});

					users.push(new _this.UserModel({}, item));

					item.users(users);

					self._edit(item);
				}));
			};

			// self.removedUsers = Otime.a([]);
			self.prepareData = function(item){
				// var saveData = JSON.parse(ko.toJSON(item));
				var users = [];
				$.each(item.users(), function(k, usr){
					if (usr.user_id())
					{
						users.push({
							team_user_id: usr.team_user_id(),
							user_id: usr.user_id(),
							user_role: usr.user_role()
						});
					}
				});
				
				var postData = {
					team_id: item.team_id(),
					team_name: item.team_name(),
					users: users
				};

				if (item.removedUsers().length)
				{
					postData.removedUsers = item.removedUsers();
				}

				return postData;
			};

			self.save = function(item){
				var saveData = self.prepareData(item);
				Otime.app.postData(new Otime.ContextModel("save", saveData,  function(cont){
					var resp = cont.response;
					if (!item.team_id())
					{
						item.team_id(resp.team_id);
						item.members(saveData.users.length)
						self.listing.push(item);
					} else {
						self.listing().forEach(teamlisting);
						function teamlisting(team) {
							if(team.team_id() == saveData.team_id) {
								team.members(saveData.users.length)
							}
						}
					}
					if (resp.team_user_ids && resp.team_user_ids.length)
					{
						var users = item.users();
						$.each(resp.team_user_ids, function(idx, val){
							users[idx].team_user_id(val);
						});
					}
					item.commit();
					self.is_edit_mode(false);
					self.editItem(null);
					_this.list_container.masonry('reload');
				}));
			};

			// self.removeUser = function(usr){
			// 	if (usr.user_id())
			// 	{
			// 		removedUsers.push(usr.user_id());
			// 	}
			// 	self.users.remove(usr);
			// };

			self.remove = function(item){
				if (!window.confirm("Are you sure to delete the team & its project links ?"))
				{
					return;
				}

				Otime.app.loadData(new Otime.ContextModel("delete/" + item.team_id(), {
					
				}, function(cont){
					var resp = cont.response;
					self.listing.remove(item);
					_this.list_container.masonry('reload');
				}));
			};

			self.cancel = function(item){
				// item.rollback();
				self.is_edit_mode(false);
				_this.list_container.masonry('reload');
				self.editItem(null);
			};

			self.getList();
		};

		_this.TeamModel = function (data, parent) {
			var self = this;

			data = data || {};

			self.team_id = Otime.o(data.team_id);
			self.team_name = Otime.o(data.team_name);
			self.members = Otime.o(data.members);
			self.users = Otime.a([]);
			self.removedUsers = Otime.a([]);
			self.is_document=Otime.o(false);
			self.is_comment=Otime.o(true);

			self.addNewUser = function(){
				self.users.push(new _this.UserModel({}, self));
			};
			self.removeUser = function(usr){
				if (usr.user_id())
				{
					self.removedUsers.push(usr.user_id());
				}
				self.users.remove(usr);
			};
			self.addNewUser();

			var _Escape = function () {
				$("#hidder-users").css({
					left: -999,
					top: -999
				});
				$("#hidder-users > *").hide();
				$("#hidder-users input, #hidder-user select").unbind("change");
			};

			var updateRoleList = function (userId) {
				var mem = Otime.Details.all_users[userId];
				if (!userId || !mem || mem.user_role == 'A' || mem.user_role == 'M') {
					return false;
				}
				$("#hidder-users #select-role select > option").each(function () {
					if (this.value && this.value != mem.user_role) {
						$(this).attr('disabled', 'disabled');
					}
					else if (this.value) {
						$(this).removeAttr('disabled');
						return false;
					}
				});
				return true;
			};

			self.gridify_params = Otime.o({
				freezed: false,
				onSelect: function (elem, clipBrd, isClick) {
					var targ = elem;

					if (!targ.is("td")) {
						targ = targ.parents("td");
					}
					var item = ko.dataFor(targ.get(0));
					_Escape();
					var hidderElem = $("#hidder-users");
					//					var offset = (parent.is_new_mode()) ? 0 : 30;
					hidderElem.css({
						//						left: targ.position().left + hidderElem.parent().scrollLeft(),
						//						top: Math.round(targ.position().top + hidderElem.parent().scrollTop()) + offset,
						left: targ.position().left + hidderElem.parent().scrollLeft() + 4,
						top: Math.round(targ.position().top + hidderElem.parent().scrollTop()) + 3,
						width: targ.innerWidth() - 3,
						height: targ.innerHeight() - 2
					}).show();

					if (targ.is(".fname")) {
						// self.updateMembersList(item.user_id());
						var elem = $("#select-user select", hidderElem);
						elem.val(item.user_id() || 0)
							.unbind("change")
							.change(function () {
								item.user_id($(this).val());
								$(this).trigger("blur");
								_Escape();
							})
							.chosen({
								search_contains: true,
								width: "100%",
								minheight: "100%"
							})
							.trigger("chosen:updated");

						$("#hidder-users #select-user").show();
						$("#hidder-users #select-user .chosen-search input").get(0).focus();
					}
					else if (targ.is(".usrrole")) {
						if (!updateRoleList(item.user_id())) {
							_Escape();
							return false;
						}

						var elem = $("#select-role select", hidderElem);
						elem.val(item.user_role())
							.unbind("change")
							.change(function () {
								item.user_role($(this).val());
								$(this).trigger("blur");
								_Escape();
							});
						elem.not(".selector select").uniform();
						$.uniform.update(elem);
						$("#hidder-users #select-role").show();
					}
					else if (targ.is(".hrate")) {
						var elem = $("#txt-rate", hidderElem);
						elem
							.val(item.hourly_rate())
							.unbind("change")
							.change(function () {
								item.hourly_rate($(this).val());
								_Escape();
								$(this).trigger("blur");
							});
						elem.show().get(0).select();
					}
					else if (targ.is(".esthours")) {
						var elem = $("#txt-rate", hidderElem);
						elem
							.val(item.estimated_hours())
							.unbind("change")
							.change(function () {
								item.estimated_hours($(this).val());
								_Escape();
								$(this).trigger("blur");
							});
						elem.show().get(0).select();
					}
					else {
						_Escape();
					}
				},
				onEnter: function (event, elem, word, isClick) {

				},
				onEsc: _Escape,
				onInputKeyPress: null,
				onInputEnter: function (e) {
					var tmpTarg = $("#hidder-users > *:visible").get(0);
					if (tmpTarg) {
						tmpTarg = $(tmpTarg);
						if (!tmpTarg.is("input, select")) {
							tmpTarg = $("input, select", tmpTarg);
						}
						tmpTarg.trigger("change");
						$("#hidder-users input, #hidder-users select").trigger("blur");
						_Escape(e);
					}
					return true;
				},
				onInputEsc: function (e) {
					_Escape(e);
					return true;
				}
			});
/*
			self.users_disp = Otime.o("");
			self.users.subscribe(function(newVal){
				var users = [];
				$.each(newVal, function(idx, uId){
					if (Otime.Details.all_users[uId])
					{
						users.push(Otime.Details.all_users[uId].user_name);
					}
				});

				self.users_disp(users.join(", "));
			});
*/
			// self.rp = Otime.o({});
			self.CommentsHandler = Otime.o(null);
			self.rp = Otime.o(null);
			self.rp_min_view = Otime.o(true);
			// self.onChangePane  = function (paneType) {
			// 	console.log(paneType,self.paneTypes);
			// 	if(self.paneTypes.COMMENT == paneType) {
			// 		self.is_comment(true);
			// 		self.is_document(false);
			// 	}else if(self.paneTypes.DOCUMENT == paneType) {
			// 		self.is_document(true);
			// 		self.is_comment(false);
			// 	}
			// }
			self.initComments = function () {
				self.CommentsHandler(new Otime.Comments.init({
					module: "team",
					module_type: "M",
					module_id: self.team_id(),
					model: self,
					parent: self,
					isSeparate: true,
					noBind: true,
					onToggleMinimize: function (isMin) {
						self.rp_min_view(isMin);
					},
					onAddFile: function (newAttachItem) {
						newAttachItem && newAttachItem.save && newAttachItem.save();
					},
				}));
				self.rp().is_document(false);
			};
/*
			self.show_comments = function () {
				// _this.UpdateContainers();
				// _this.comment_container = $("#comment_layout");
				if (self.is_comment_mode() == true) {
					self.is_comment_mode(false);
					_this.comment_container.removeClass("opened").addClass("closed");
					return;
				}
				else {
					initComments();
					self.is_comment_mode(true);
					_this.comment_container.addClass('opened').removeClass('closed');
				}
			};
*/
			return self;
		};

		_this.UserModel = function(data, parent){
			var self = this;
			data = data || {};

			self.team_user_id = Otime.o(data.team_user_id || 0);
			self.user_id = Otime.o();
			self.user_name = Otime.o(data.user_name || "");
			self.user_role = Otime.o(data.user_role || "");
			self.first_name = Otime.o(data.first_name || "");
			self.last_name = Otime.o(data.last_name || "");
			self.user_image = Otime.o(data.user_image || "");

			self.user_id.subscribe(function(newVal){
				var usr = {};

				if (newVal && Otime.Details.all_users[newVal])
				{
					usr = Otime.Details.all_users[newVal] || {};
				}

				self.user_name(usr.user_name || "");
				self.user_role(usr.user_role || "");
				self.first_name(usr.first_name || "");
				self.last_name(usr.last_name || "");
				self.user_image(usr.user_image || "");

				if (parent.users().indexOf(self) == parent.users().length-1)
				{
					parent.users.push(new _this.UserModel({}, parent));
				}
			});

			data.user_id && self.user_id(data.user_id);
		};
	
		_this.loadTemplates = function (clbk) {
			var url = Otime.siteUrl + "/team/tmpl";
			var storeName = "team_";

			Otime.loadTemplates(url, {
				v: Otime.version
			}, function (content) {
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
			}, storeName + Otime.version);
		};

		_this.init = function () {
			_this.UpdateContainers();
			_this.list_container.masonry({ itemSelector: '.metro-item', columnWidth: 0 });
			_this.appModel = new _this.TeamListModel();

			Otime.app.model = _this.appModel;
			ko.applyBindings(_this.appModel, elem.team.get(0));
/*
			if (Object.keys(Otime.Details.all_projects).length <= 0) {
				$("body").addClass("loading");
				_this.tasks_container.removeClass("dib").hide();
				if (!Otime.Details.isInitialized) {
					Otime.Details.onReady(_this.init);
					return false;
				}
				Otime.show_propop('Track Your Time', 'Create your project to track your time');
				return false;
			}
			_this.tasks_container.show().addClass("dib");
			$("body").removeClass("loading");

			initFlag = true;
			if (_this.isToDo) {
				_this.Splitters = new _this.Splitter_ToDo();
			}
			else {
				_this.Splitters = new _this.Splitter_Task();
			}

			_this.ResetTmpl();
			_this.Splitters.init();
			Otime.unbind();
*/
			/*
			Otime.Storage.onChange(function(e){
				console.log("Storage changed : ", e);
			});
			*/
/*
			var pID = window.location.pathname.match(/tasks\/(\d+)/);
			if (pID && pID.length == 2) {
				_this.PID = pID[1];
				initFlag = false;
			}

			_this.appModel.date_filter.applyDFT(_this.dft || "ALL");

			_this.PID && Otime.Storage.set("tasks_project_id", _this.PID);

			// _this.Refresh();
			_this.appModel.setTab();

			var prevent = function (ev) {
				ev.stopPropagation();
				ev.preventDefault();
			};
			Otime.onTabChange(function (isHidden) {
				if (!isHidden) {
					$("#hidder0 #txt-normal").focus();
				}
			});
			$("#documents-container #filecontainer").on("dragenter", prevent).on("dragleave", prevent).on("dragover", prevent).on("drop", function (ev) {
				Otime.Project.fileApi.showDroppedFiles(ev.originalEvent);
			});
*/
		};
	};
}(window.Otime));

