<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class OTUpdate {

	function __construct()
	{
		
	}

	public function updateDatabase($ot_version="0.0.0")
	{
		$CI =& get_instance();
		
		$tables 	= $CI->db->list_tables();
	
		if (!in_array('oauth_authorization_codes', $tables)) {
			if (!$CI->db->table_exists('oauth_authorization_codes')) {
							$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_oauth_authorization_codes` (
				  `authorization_code` varchar(40) NOT NULL,
				  `client_id` varchar(80) NOT NULL,
				  `user_id` varchar(255) DEFAULT NULL,
				  `redirect_uri` varchar(2000) DEFAULT NULL,
				  `expires` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
				  `scope` varchar(2000) DEFAULT NULL,
				  PRIMARY KEY (`authorization_code`)
				) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
							$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_oauth_clients` (
				  `client_id` varchar(80) NOT NULL,
				  `client_secret` varchar(80) NOT NULL,
				  `redirect_uri` varchar(2000) NOT NULL,
				  `grant_types` varchar(80) DEFAULT NULL,
				  `user_id` varchar(80) DEFAULT NULL,
				  `title` varchar(255) NOT NULL,
				  `description` text NOT NULL,
				  PRIMARY KEY (`client_id`)
				) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
							$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_oauth_jwt` (
				  `client_id` varchar(80) NOT NULL,
				  `subject` varchar(80) DEFAULT NULL,
				  `public_key` varchar(2000) DEFAULT NULL,
				  PRIMARY KEY (`client_id`)
				) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
							$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_oauth_refresh_tokens` (
				  `refresh_token` varchar(40) NOT NULL,
				  `client_id` varchar(80) NOT NULL,
				  `user_id` varchar(255) DEFAULT NULL,
				  `expires` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
				  `scope` varchar(2000) DEFAULT NULL,
				  PRIMARY KEY (`refresh_token`)
				) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
							$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_oauth_scopes` (
				  `type` varchar(255) NOT NULL DEFAULT 'supported',
				  `scope` varchar(2000) DEFAULT NULL,
				  `client_id` varchar(80) DEFAULT NULL,
				  `is_default` tinyint(1) NOT NULL
				) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
							$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_oauth_access_tokens` (
				  `access_token` varchar(40) NOT NULL,
				  `client_id` varchar(80) NOT NULL,
				  `user_id` varchar(255) DEFAULT NULL,
				  `expires` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
				  `scope` varchar(2000) DEFAULT NULL,
				  PRIMARY KEY (`access_token`)
				) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
			}
		} else {
			$CI->db->query("RENAME TABLE `oauth_authorization_codes` TO `ot_oauth_authorization_codes`;");
			$CI->db->query("RENAME TABLE `oauth_clients` TO `ot_oauth_clients`;");
			$CI->db->query("RENAME TABLE `oauth_jwt` TO `ot_oauth_jwt`;");
			$CI->db->query("RENAME TABLE `oauth_refresh_tokens` TO `ot_oauth_refresh_tokens`;");
			$CI->db->query("RENAME TABLE `oauth_scopes` TO `ot_oauth_scopes`;");
		}

		$CI->db->query("UPDATE `ot_currency` SET `currency_symbol`='&#8364;' WHERE `currency_code`='EUR';");

		$CI->db->query("ALTER TABLE `ot_entity_users` CHANGE `time_zone_code` `time_zone_code` VARCHAR( 4 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'UTC';");

		if (!$CI->db->field_exists('is_archived', 'ot_project_task'))
		{
			$CI->db->query("ALTER TABLE `ot_project_task` ADD `is_archived` TINYINT(1) NOT NULL DEFAULT '0' AFTER `is_closed`;");
		}
		
		if (!$CI->db->field_exists('task_required', 'ot_entity_setting'))
		{
			$CI->db->query("ALTER TABLE `ot_entity_setting` ADD `task_required` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `time_stamp_req` ;");
		}
		
		if (!$CI->db->field_exists('module_action', 'ot_user_notifications'))
		{
			$CI->db->query("DROP TABLE ot_user_notifications;");
			$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_user_notifications` (
							  `notification_id` int(11) NOT NULL AUTO_INCREMENT,
							  `user_id` int(11) NOT NULL,
							  `module_type` char(1) NOT NULL COMMENT 'P/T/I/W/C',
							  `module_id` int(11) NOT NULL,
							  `module_action` char(2) NOT NULL,
							  `post_by` text NOT NULL,
							  `is_read` tinyint(1) NOT NULL DEFAULT '0',
							  `posted_on` int(11) NOT NULL,
							  `type` char(1) NOT NULL COMMENT 'T/W',
							  PRIMARY KEY (`notification_id`),
							  KEY `user_date` (`user_id`,`posted_on`)
							) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 AUTO_INCREMENT=1 ;");
		}
		
		if (!$CI->db->field_exists('notes', 'ot_user_notifications'))
		{
			$CI->db->query("ALTER TABLE `ot_user_notifications` ADD `notes` TEXT NOT NULL AFTER `posted_on` ;");
		}
		if (!$CI->db->field_exists('dob', 'ot_entity_users'))
		{
			$CI->db->query("ALTER TABLE `ot_entity_users` ADD `dob` DATE NOT NULL AFTER `hourly_rate`, ADD `doj` DATE NOT NULL AFTER `dob`;");
		}
		
		if (!$CI->db->table_exists('wall_activity')) {
				$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_wall_activity` (
				  `activity_id` int(11) NOT NULL AUTO_INCREMENT,
				  `entity_id` int(11) NOT NULL,
				  `to_type` char(1) NOT NULL COMMENT 'U-User/P-Project/E-Every One/M-Project Manager/F-Project Finance/A-Administrator',
				  `to_id` int(11) NOT NULL COMMENT 'User_Id or Project_id or 0',
				  `module_type` char(1) NOT NULL COMMENT 'P(Project), T(Task),I(Invoice),E(Estimate),U(User),X(Expense),R(Invoice Payment Receipt),A(Attachment), O(post)',
				  `module_id` int(11) NOT NULL,
				  `last_updated` int(11) NOT NULL,
				  PRIMARY KEY (`activity_id`),
				  UNIQUE KEY `IX_to` (`to_type`,`to_id`,`last_updated`),
				  KEY `IX_Activity` (`module_type`,`module_id`,`to_type`,`to_id`)
				) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
				$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_wall_favorite` (
				  `post_id` int(11) NOT NULL,
				  `user_id` int(11) NOT NULL,
				  UNIQUE KEY `user_post_id` (`user_id`,`post_id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
				$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_wall_notification` (
				  `notification_id` int(11) NOT NULL AUTO_INCREMENT,
				  `user_id` int(11) NOT NULL,
				  `module_type` char(1) NOT NULL COMMENT 'P/T/I/W/C',
				  `module_id` int(11) NOT NULL,
				  `module_action` char(1) NOT NULL,
				  `post_by` text NOT NULL,
				  `is_read` tinyint(1) NOT NULL DEFAULT '0',
				  `posted_on` int(11) NOT NULL,
				  PRIMARY KEY (`notification_id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
				$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_wall_posts` (
				  `post_id` int(11) NOT NULL AUTO_INCREMENT,
				  `entity_id` int(11) NOT NULL,
				  `post_date` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp',
				  `post_by` int(11) NOT NULL,
				  `post_to` text NOT NULL,
				  `post_type` char(1) NOT NULL COMMENT 'M-Message / E-Event / P-Poll / A-Announcement',
				  `post_subject` varchar(255) NOT NULL DEFAULT '',
				  `post_message` text NOT NULL,
				  `post_content` text NOT NULL,
				  `post_input` text NOT NULL,
				  `followers` text NOT NULL COMMENT 'User_id comma delimiter',
				  `unfollow` text NOT NULL COMMENT 'User_id comma delimiter',
				  `like_count` smallint(5) unsigned NOT NULL,
				  `liked` text NOT NULL COMMENT 'User_id comma delimiter',
				  `ack_count` smallint(5) unsigned NOT NULL,
				  `ack` text NOT NULL COMMENT 'User_id comma delimiter',
				  `keep_ontop_till` int(11) NOT NULL COMMENT 'Timestamp',
				  `comments_count` int(11) NOT NULL,
				  PRIMARY KEY (`post_id`)
				) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
				$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_wall_tagmessages` (
				  `tag_id` int(11) NOT NULL,
				  `message_id` int(11) NOT NULL,
				  PRIMARY KEY (`tag_id`,`message_id`),
				  KEY `message_id` (`message_id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
				$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_wall_tags` (
				  `tag_id` int(11) NOT NULL AUTO_INCREMENT,
				  `name` varchar(20) NOT NULL,
				  `entity_id` int(11) NOT NULL,
				  PRIMARY KEY (`tag_id`),
				  UNIQUE KEY `entity_tagname` (`entity_id`,`name`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
				$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_wall_tokens` (
				  `token_id` int(11) NOT NULL AUTO_INCREMENT,
				  `user_id` int(11) NOT NULL,
				  `first_name` varchar(30) NOT NULL,
				  `email` varchar(50) NOT NULL,
				  `entity_id` int(11) NOT NULL,
				  `auth_token` varchar(250) NOT NULL,
				  `expiry_date` datetime NOT NULL,
				  PRIMARY KEY (`token_id`)
				) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
				$CI->db->query("ALTER TABLE `ot_comments` ADD `like_count` SMALLINT( 5 ) NOT NULL DEFAULT '0' AFTER `is_protected` ,
ADD `liked` TEXT NOT NULL AFTER `like_count`;");
				$CI->db->query("ALTER TABLE `ot_users_auth_tokens` CHANGE `auth_token` `auth_token` VARCHAR(250) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;");
		}
		
		$row = $CI->db->select('app_id')->from('apps')->where('app_id', 4)->get()->row();
		if (!$row) {
			$CI->db->query("INSERT INTO `ot_apps` (`app_id`, `app_name`, `auth_key_name`, `developed_by`, `app_description`, `is_internal`, `is_active`, `config_fields`, `category_code`, `app_image`, `allow_user_event`) VALUES
(4, 'Output Wall', 'API-Key', 'srimax', 'Private wall', 1, 1, NULL, 'DT', 'outputwall.png', 0);");
		}
		
		if (!$CI->db->field_exists('type', 'ot_entity_accounts'))
		{
			$CI->db->query("ALTER TABLE `ot_entity_accounts` ADD `type` VARCHAR(1) NOT NULL AFTER `gdomain`;");
		}

		if (!$CI->db->field_exists('task_types', 'ot_user_department'))
		{
			$CI->db->query("ALTER TABLE `ot_user_department` ADD `task_types` VARCHAR(250) NOT NULL AFTER `department`;");
		}

		$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_wall_usermessages` (
		`user_id` int(11) NOT NULL,
		`message_id` int(11) NOT NULL
		) ENGINE=InnoDB DEFAULT CHARSET=utf8;");


		if (!$CI->db->table_exists('ot_user_notification_read')) {
			$CI->db->query("CREATE TABLE IF NOT EXISTS `ot_user_notification_read` (
			`user_id` int(11) NOT NULL,
			`notific_last_read` int(11) NOT NULL,
			`post_id` int(11) NOT NULL,
			UNIQUE KEY `user_id` (`user_id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8;");

			$CI->db->query("insert into ot_user_notification_read (user_id,notific_last_read) select user_id,unix_timestamp(if(last_login,last_login,now())) as notific_last_read from ot_entity_users;");
		} else {
			if (!$CI->db->field_exists('post_id', 'ot_user_notification_read'))
			{
				$CI->db->query("ALTER TABLE `ot_user_notification_read` ADD `post_id` int(11) NOT NULL AFTER `notification_id`;");
			}
			
			if ($CI->db->field_exists('notification_id', 'ot_user_notification_read')) {
				$CI->db->query("ALTER TABLE `ot_user_notification_read` CHANGE `notification_id` `notific_last_read` INT(11) NOT NULL;");
				$CI->db->query("update ot_user_notification_read dest, (select user_id,unix_timestamp(if(last_login,last_login,now())) as notific_last_read from ot_entity_users) src set dest.notific_last_read=src.notific_last_read where dest.user_id=src.user_id;");
			}
		}

		if (!$CI->db->field_exists('is_repeat', 'ot_project_task'))
		{
			$CI->db->query("ALTER TABLE `ot_project_task` ADD `is_repeat` varchar(3) NOT NULL AFTER `assignee_id`;");
			$CI->db->query("ALTER TABLE `ot_project_task` ADD `repeat_on` varchar(2) NOT NULL AFTER `is_repeat`;");
		}

		if (!$CI->db->field_exists('entity_id', 'ot_user_notifications'))
		{
			$CI->db->query("ALTER TABLE `ot_user_notifications` ADD `entity_id` INT(11) NOT NULL AFTER `notification_id` ;");
			$CI->db->query("update ot_user_notifications dest , (select entity_id,user_id from ot_entity_users ) src set dest.entity_id=src.entity_id where dest.user_id=src.user_id;");
		}

		if (!$CI->db->field_exists('user_role', 'ot_wall_tokens')) {
			$CI->db->query("ALTER TABLE `ot_wall_tokens` ADD `user_role` VARCHAR(1) NOT NULL AFTER `email`;");
			$CI->db->query("TRUNCATE ot_wall_tokens;");
		}

		if ($CI->db->field_exists('is_billable', 'ot_project_task')) {
			$CI->db->query("ALTER TABLE `ot_project_task` DROP `is_billable`;");
		}

		if (!$CI->db->field_exists('estimated_hours', 'ot_project')) {
			$CI->db->query("ALTER TABLE `ot_project` ADD `estimated_hours` int(11) NOT NULL AFTER `hourly_rate`;");
		}

		if ($ot_version && version_compare($ot_version, "1.2.1252", "lt"))
		{
			$CI->db->query("ALTER TABLE `ot_project_task_types` CHANGE `estimated_hours` `estimated_hours` FLOAT(9,2) NULL DEFAULT NULL;");

			$CI->db->query("ALTER TABLE `ot_user_mails` CHANGE `mail_type` `mail_type` VARCHAR(250) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'W' COMMENT 'W-Weekly,M-Monthly,D-Daily,WS-weekly,DD-daily digest,AT(A|C) assigned task status, FT(A|C) following task status';");

			$CI->db->query("ALTER TABLE `ot_time_sheet` CHANGE `hours` `hours` FLOAT(6,2) NOT NULL;");
		}
		

		if (!$CI->db->field_exists('status_mail', 'ot_client_contact')) {
			$CI->db->query("ALTER TABLE `ot_client_contact` ADD `status_mail` VARCHAR(2) NOT NULL AFTER `title`;");
			$CI->db->query("UPDATE `ot_user_mails` SET mail_type='WS,DD';");
		}			

		if (!$CI->db->field_exists('all_users', 'ot_project')) {
			$CI->db->query("ALTER TABLE `ot_project` ADD `all_users` TINYINT(1) NOT NULL AFTER `members_count`;");
		}
		
		if (!$CI->db->table_exists('ot_check_list')) {
			$CI->db->query("CREATE TABLE `ot_check_list` (
			  `chk_id` int(11) NOT NULL,
			  `entity_id` int(11) NOT NULL,
			  `module_type` char(1) DEFAULT NULL COMMENT 'module_type=\nP(Project), \nT(Task),\nI(Invoice),\nE(Estimate),\nU(User),\nX(Expense),\nR(Invoice Payment Receipt),\nA(Attachment)',
			  `module_id` int(11) DEFAULT NULL,
			  `order_no` int(11) NOT NULL DEFAULT '1',
			  `message` mediumtext,
			  `is_closed` tinyint(1) DEFAULT '0',
			  `created_by` int(11) DEFAULT NULL,
			  `created_date` datetime NOT NULL
			) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
			$CI->db->query("ALTER TABLE `ot_check_list` ADD PRIMARY KEY (`chk_id`);");
			$CI->db->query("ALTER TABLE `ot_check_list` MODIFY `chk_id` int(11) NOT NULL AUTO_INCREMENT;");
		}

		if (!$CI->db->field_exists('chkl_count', 'ot_project_task')) {
			$CI->db->query("ALTER TABLE `ot_project_task` ADD `chkl_count` INT(11) NOT NULL DEFAULT '0' AFTER `has_attachments`;");
		}

		if ($ot_version && version_compare($ot_version, "1.2.1371", "lt"))
		{
			$CI->db->query("ALTER TABLE `ot_task_status` CHANGE `system_defined` `system_defined` VARCHAR(1) NULL DEFAULT '';");
			$CI->db->query("update `ot_task_status` set system_defined='' WHERE system_defined=0;");
			$CI->db->query("update `ot_task_status` set system_defined='O' WHERE system_defined=1 and is_closed=0;");
			$CI->db->query("update `ot_task_status` set system_defined='C' WHERE system_defined=1 and is_closed=1;");
			$CI->db->query("update `ot_task_status` set system_defined='H' WHERE name='Hold';");
		}

		if (!$CI->db->field_exists('hourly_cost', 'ot_entity_users')) {
			$CI->db->query("ALTER TABLE `ot_entity_users` ADD `hourly_cost` FLOAT(0) NOT NULL AFTER `hourly_rate`;");
			$CI->db->query("UPDATE `ot_entity_users` SET `hourly_cost`=`hourly_rate`;");
		}

		
		if (!$CI->db->table_exists('ot_tags'))
		{
			$CI->db->query("CREATE TABLE `ot_tags` (`id` int(11) NOT NULL, `entity_id` int(11) NOT NULL, `tagName` varchar(60) NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
			$CI->db->query("ALTER TABLE `ot_tags` ADD PRIMARY KEY (`id`);");
			$CI->db->query("ALTER TABLE `ot_tags` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;");
		}

		if (!$CI->db->table_exists('ot_task_tags'))
		{
			$CI->db->query("CREATE TABLE `ot_task_tags` (`entity_id` int(11) NOT NULL, `tag_id` int(11) NOT NULL, `task_id` int(11) NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
			$CI->db->query("ALTER TABLE `ot_task_tags` ADD PRIMARY KEY (`tag_id`,`task_id`);");
		}

		if ($ot_version && version_compare($ot_version, "1.2.1500", "lt"))
		{
			$CI->db->query("ALTER TABLE `ot_project` CHANGE `project_code` `project_code` VARCHAR(15) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;");
		}

		if ($ot_version && version_compare($ot_version, "1.2.1534", "lt"))
		{
			$CI->db->query("update `ot_project_users` set actual_hours=0 where actual_hours is null;");
			$CI->db->query("update `ot_project_task_types` set actual_hours=0 where actual_hours is null;");
		}

		if (!$CI->db->table_exists('ot_task_tags'))
		{
			$CI->db->query("update `ot_project_users` set actual_hours=0 where actual_hours is null;");
			$CI->db->query("update `ot_project_task_types` set actual_hours=0 where actual_hours is null;");
		}

		if (!$CI->db->table_exists('ot_project_status'))
		{
			$CI->db->query("ALTER TABLE `ot_project` ADD `start_date` DATE NOT NULL, ADD `target_date` DATE NOT NULL, ADD `status_id` INT(11) NOT NULL;");
			$CI->db->query("CREATE TABLE `ot_project_status` (`id` int(11) NOT NULL,`entity_id` int(11) NOT NULL,`name` varchar(60) NOT NULL,`is_default` tinyint(1) DEFAULT NULL) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
			$CI->db->query("ALTER TABLE `ot_project_status` ADD PRIMARY KEY (`id`);");
			$CI->db->query("ALTER TABLE `ot_project_status` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;");
			$CI->db->query("INSERT INTO `ot_project_status` (`entity_id`, `name`, `is_default`) SELECT entity_id,'In Process' AS name, 0 as is_default from ot_entity;");
			$CI->db->query("INSERT INTO `ot_project_status` (`entity_id`, `name`, `is_default`) SELECT entity_id,'On Hold' AS name, 0 as is_default from ot_entity;");
			$CI->db->query("INSERT INTO `ot_project_status` (`entity_id`, `name`, `is_default`) SELECT entity_id,'Completed' AS name, 0 as is_default from ot_entity;");
			$CI->db->query("INSERT INTO `ot_project_status` (`entity_id`, `name`, `is_default`) SELECT entity_id,'Not Started' AS name, 1 as is_default from ot_entity;");
		}

		if (!$CI->db->table_exists('ot_custom_fields'))
		{
			$CI->db->query("CREATE TABLE `ot_custom_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `entity_id` int(11) NOT NULL,
  `mType` char(1) NOT NULL COMMENT 'P(Project), T(Task), I(Invoice), C(Comments), E(Expense), R(Invoice Payment Receipt',
  `fName` varchar(50) NOT NULL,
  `fType` varchar(10) NOT NULL DEFAULT 'text' COMMENT 'text, number, select, date, hours, user, users',
  `fOptions` text NOT NULL,
  `isSys` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
		}
		if (!$CI->db->table_exists('ot_custom_mod'))
		{
			$CI->db->query("CREATE TABLE `ot_custom_mod` (
  `entity_id` INT(11) NOT NULL,
  `mType` char(1) NOT NULL COMMENT 'P(Project), T(Task), I(Invoice), C(Comments), E(Expense), R(Invoice Payment Receipt',
  `mId` int(11) NOT NULL,
  `fId` VARCHAR(11) NOT NULL,
  `fCode` VARCHAR(2) NOT NULL,
  `ordNo` tinyint(2) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
		}
		if (!$CI->db->table_exists('ot_custom_values'))
		{
			$CI->db->query("CREATE TABLE `ot_custom_values` (
  `entity_id` int(11) NOT NULL,
  `mType` char(1) NOT NULL COMMENT 'P(Project), T(Task), I(Invoice), C(Comments), E(Expense), R(Invoice Payment Receipt',
  `mId` int(11) NOT NULL,
  `fId` int(11) NOT NULL,
  `fValue` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
		}

		if (!$CI->db->field_exists('modType', 'ot_project_task_users'))
		{
			$CI->db->query("ALTER TABLE `ot_project_task_users` ADD `modType` varchar(2) NOT NULL;");
		}

		if ($ot_version && version_compare($ot_version, "1.2.1600", "lt"))
		{
			$CI->db->query("UPDATE `ot_entity_users` dest,(SELECT user_dept_id,entity_id,department FROM ot_user_department) src SET dest.department=src.user_dept_id WHERE dest.entity_id=src.entity_id AND dest.department=src.department;");
			$CI->db->query("INSERT INTO ot_user_department (department,entity_id) SELECT DISTINCT department,entity_id FROM ot_entity_users WHERE department!='' AND department NOT REGEXP '^[0-9]+$';");
			$CI->db->query("UPDATE ot_entity_users dest,(SELECT user_dept_id,entity_id,department FROM ot_user_department) src SET dest.department=src.user_dept_id where dest.entity_id=src.entity_id and dest.department=src.department;");
			$CI->db->query("ALTER TABLE `ot_entity_users` CHANGE `department` `department` INT(11) NULL DEFAULT NULL;");
		}

		if (!$CI->db->table_exists('ot_tasks_delete_users'))
		{
			$CI->db->query("CREATE TABLE `ot_tasks_delete_users` (
			`entity_id` int(11) NOT NULL,
			`task_id` int(11) NOT NULL,
			`user_id` int(11) NOT NULL,
			`last_updated_date` datetime NOT NULL
			) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
		}

		if (!$CI->db->field_exists('progress_status', 'ot_comments'))
		{
			$CI->db->query("ALTER TABLE `ot_comments` ADD `progress_status` varchar(1) NOT NULL COMMENT 'G-On Track, O-Off Track, R-at Risk';");
		}

		if (!$CI->db->table_exists('ot_task_tmpl'))
		{
			$CI->db->query("CREATE TABLE `ot_task_tmpl` (`id` int(11) NOT NULL, `entity_id` int(11) NOT NULL, `name` varchar(255) NOT NULL, `tasks` text NOT NULL, `created_by` int(11) NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=latin1;");
			$CI->db->query("ALTER TABLE `ot_task_tmpl` ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `entity_id` (`entity_id`,`name`);");
			$CI->db->query("ALTER TABLE `ot_task_tmpl` MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;");
		}

		if (!$CI->db->table_exists('ot_project_expense_types'))
		{
			$CI->db->query("CREATE TABLE `ot_project_expense_types` (`project_expense_type_id` int(11) NOT NULL, `entity_id` int(11) NOT NULL, `project_id` int(11) NOT NULL, `expense_type_id` int(11) NOT NULL, `estimated` float(9,2) DEFAULT NULL, `actual` float(9,2) DEFAULT '0.00', `created_by` int(11) DEFAULT NULL, `created_date` datetime DEFAULT NULL, `last_updated_by` int(11) DEFAULT NULL, `last_updated_date` datetime DEFAULT NULL) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
			$CI->db->query("ALTER TABLE `ot_project_expense_types` ADD PRIMARY KEY (`project_expense_type_id`), ADD KEY `ix_entity_project_id` (`entity_id`,`project_id`);");
			$CI->db->query("ALTER TABLE `ot_project_expense_types` MODIFY `project_expense_type_id` int(11) NOT NULL AUTO_INCREMENT;");
		}

		if (!$CI->db->table_exists('ot_team'))
		{
			$CI->db->query("CREATE TABLE `ot_team` (
  `team_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `team_name` varchar(64) NOT NULL,
  `isActive` tinyint(1) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;");

			$CI->db->query("ALTER TABLE `ot_team` ADD PRIMARY KEY (`team_id`), ADD UNIQUE KEY `team_id` (`team_id`);");
			$CI->db->query("ALTER TABLE `ot_team` MODIFY `team_id` int(11) NOT NULL AUTO_INCREMENT;");
		}

		if (!$CI->db->field_exists('team_id', 'ot_project'))
		{
			$CI->db->query("ALTER TABLE `ot_project` ADD `team_id` INT(11) NULL AFTER `status_id`;");
		}

		if (!$CI->db->table_exists('ot_team_users'))
		{
			$CI->db->query("CREATE TABLE `ot_team_users` (
  `team_user_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `team_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `user_role` char(1) DEFAULT NULL COMMENT 'A - Administrator\nF - Project Manager with Finance\nP - Project Manager\nM - Member',
  `is_billable` tinyint(1) DEFAULT NULL,
  `estimated_hours` int(11) DEFAULT NULL,
  `hourly_rate` float DEFAULT NULL,
  `actual_hours` float(9,2) DEFAULT '0.00' COMMENT 'Updated when Task Hours Approved / Deleted based on project budget type',
  `created_by` int(11) DEFAULT NULL,
  `created_date` datetime DEFAULT NULL,
  `last_updated_by` int(11) DEFAULT NULL,
  `last_updated_date` datetime DEFAULT NULL,
  `new_attachments` int(11) NOT NULL,
  `new_comments` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
			$CI->db->query("ALTER TABLE `ot_team_users` ADD PRIMARY KEY (`team_user_id`), ADD KEY `ix_entity_team_id` (`entity_id`,`team_id`);");
			$CI->db->query("ALTER TABLE `ot_team_users` MODIFY `team_user_id` int(11) NOT NULL AUTO_INCREMENT;");
		}

		if (!$CI->db->table_exists('ot_sprint'))
		{
			$CI->db->query("CREATE TABLE `ot_sprint` (
  `sprint_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `duration` varchar(20) NOT NULL,
  `start_date` datetime DEFAULT NULL,
  `end_date` datetime DEFAULT NULL,
  `created_by` int(11) DEFAULT NULL,
  `created_date` datetime DEFAULT NULL,
  `last_updated_by` int(11) DEFAULT NULL,
  `last_updated_date` datetime DEFAULT NULL,
  `is_complete` tinyint(1) DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;");

			$CI->db->query("ALTER TABLE `ot_sprint` ADD PRIMARY KEY (`sprint_id`), ADD KEY `entity_id` (`entity_id`);");
			$CI->db->query("ALTER TABLE `ot_sprint` MODIFY `sprint_id` int(11) NOT NULL AUTO_INCREMENT;");
		}

		if (!$this->field_exists('sprint_id', 'ot_project_task'))
		{
			$CI->db->query("ALTER TABLE `ot_project_task` ADD `sprint_id` INT(11) NOT NULL DEFAULT '0' AFTER `repeat_on`;");
		}

		if (!$this->field_exists('story_point', 'ot_project_task'))
		{
			$CI->db->query("ALTER TABLE `ot_project_task` ADD `story_point` INT(11) NULL DEFAULT '0' AFTER `sprint_id`;");
		}

		if (!$this->field_exists('release_mail', 'ot_entity_setting'))
		{
			$CI->db->query("ALTER TABLE `ot_entity_setting` ADD `release_mail` TINYINT(1) NOT NULL DEFAULT '1' AFTER `has_update`;");
		}

		if (!$this->field_exists('sprint_required', 'ot_entity_setting'))
		{
			$CI->db->query("ALTER TABLE `ot_entity_setting` ADD `sprint_required` TINYINT(1) NOT NULL DEFAULT '0' AFTER `release_mail`;");
		}

		if (!$this->field_exists('daily_progress_report_required', 'ot_entity_setting'))
		{
			$CI->db->query("ALTER TABLE `ot_entity_setting` ADD `daily_progress_report_required` TINYINT(1) NOT NULL DEFAULT '0' AFTER `sprint_required`;");
		}

		if (!$this->field_exists('preschedule_min_hours_per_day', 'ot_entity_setting'))
		{
			$CI->db->query("ALTER TABLE `ot_entity_setting` ADD `preschedule_min_hours_per_day` int NOT NULL AFTER `daily_progress_report_required`;");
		}

		if (!$this->field_exists('user_depts', 'ot_entity_setting'))
		{
			$CI->db->query("ALTER TABLE `ot_entity_setting` ADD `user_depts` VARCHAR(255) NOT NULL AFTER `preschedule_min_hours_per_day`;");
		}

		if (!$this->field_exists('daily_progress_user_depts', 'ot_entity_setting'))
		{
			$CI->db->query("ALTER TABLE `ot_entity_setting` ADD `daily_progress_user_depts` VARCHAR(255) NOT NULL AFTER `user_depts`;");
		}

		if (!$CI->db->table_exists('ot_user_setting'))
		{
			$CI->db->query("CREATE TABLE `ot_user_setting` (
  `setting_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `setting_code` varchar(8) NOT NULL,
  `setting_value` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;");
			$CI->db->query("ALTER TABLE `ot_user_setting` ADD PRIMARY KEY (`setting_id`), ADD UNIQUE KEY `IX_eus` (`entity_id`,`user_id`,`setting_code`);");
			$CI->db->query("ALTER TABLE `ot_user_setting` MODIFY `setting_id` int(11) NOT NULL AUTO_INCREMENT");
		}
		
		if ($ot_version && version_compare($ot_version, "1.3.1864", "lt"))
		{
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Task Type' as fName, 'TT' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Duration' as fName, 'DU' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Start Date' as fName, 'SD' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Finish Date' as fName, 'FD' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Estimated Hours' as fName, 'EH' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Actual Hours' as fName, 'AH' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Status' as fName, 'ST' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Assignee' as fName, 'AS' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Followers' as fName, 'FL' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Predecessors' as fName, 'PR' as fType,'' as fOptions, 1 as isSys from ot_entity;");
			$CI->db->query("INSERT INTO `ot_custom_fields` (`entity_id`, `mType`, `fName`, `fType`, `fOptions`, `isSys`) SELECT entity_id,'T' AS mType, 'Sprint' as fName, 'SP' as fType,'' as fOptions, 1 as isSys from ot_entity;");
		}
		
		if (!$this->field_exists('pending_task_ids', 'ot_sprint'))
		{
			$CI->db->query("ALTER TABLE `ot_sprint` ADD `pending_task_ids` VARCHAR(1000) NOT NULL AFTER `is_complete`;");
		}
		
		if (!$this->field_exists('new_task_ids', 'ot_sprint'))
		{
			$CI->db->query("ALTER TABLE `ot_sprint` ADD `new_task_ids` VARCHAR(1000) NOT NULL AFTER `pending_task_ids`;");
		}
		
		$this->renameAttachmentImages($CI);

		return true;
	}

	public function renameAttachmentImages($_this)
	{
		$query = $_this->db->select('*')->from('attachment')->db->get();
		$result	= $query->result_array();

		foreach($result as $val)
		{
			$extension	= strtolower($val['file_type']);
			// Is Image
			if ($val['file_path'] && in_array($extension, array('bmp','gif','jpg','jpeg','png')))
			{

				$from_name	= 'uploads/' . $val['entity_id'] . '/files/' . $val['file_path'];
				$new_file_name	= str_replace('.opt', '.' . $val['file_type'], $val['file_path']);
				$to_name	= 'uploads/' . $val['entity_id'] . '/files/' . $new_file_name;

				@rename($from_name, $to_name);

				$_this->db->where('attachment_id', $val['attachment_id']);
				$_this->db->update('attachment', array(
					'file_path'	=> $new_file_name
				));
			}
		}
	}
}

