(function (Otime) {

	Otime.Tasks = new function Tasks() {
		// "use strict";

		var _this = this;

		var refreshFlag = false;

		var initFlag = false;

		var isIE = !!$.browser.msie;

		_this._listing = null;

		_this.name = "tasks";

		_this.model = "TaskListModel";

		_this.language = "tasks";

		_this.appModel = null;

		_this.taskTypesList = {};
		_this.ttypeByName = {};
		_this.tstatByName = {};
		_this.tUsersByName = {};

		_this.task_status = null;

		_this.searchArray = {
			projects: null,
			sprint: null
		};

		_this.allItems = {};
		_this.allItemsArr = [];

		_this.Keys = null;

		_this.increment_key = 0;

		_this.error = false;

		_this.isTSR = Otime.tsReq;

		_this.fFlag = 0;

		_this.sFlag = 0;

		_this.users = {};
		_this.usersById = {};

		_this.all_users = {};

		_this.isToDo = false;

		_this.isM = Otime.isM;

		_this.PID = 0;

		_this.TID = 0;

		_this.custom_mod = [];
		_this.custom_mod_storage = [];
		var currSubcribe = [];
		var changed_data = {};
		var new_items = {};
		var isEditFromGrid = false;

		var weekAndDay = function (date) {
			if (!date) {
				date = new Date;
			} else {
				date = new Date(date);
			}
			var days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday',
				'Thursday', 'Friday', 'Saturday'];
			var prefixes = ['1st', '2nd', '3rd', '4th', '5th'];

			return prefixes[0 | Math.floor(date.getDate() / 7)] + ' ' + days[date.getDay()];
		}

		var _INITIALIZE_COMMENTS = function (targ, _parent, clbk) {
			if (!targ.form.task_id()) {
				return false;
			}
			new Otime.Comments.init({
				module_type: "T",
				module_id: targ.form.task_id(),
				elem: "",
				all_tags: targ.tags(),
				parent: _parent,
				model: targ,
				onToggleMinimize: function (isMin) {
					_parent.rp_min_view(isMin);
				},
				onUpdate: function (cnt) {
					targ.has_comments(cnt.comments > 0);
					targ.has_attachments(cnt.attach > 0);
				},
				isSeparate: true,
				dropZone: "#right-pane, #bottom-pane",
				//				fileApi_buttonValue: '&nbsp;', // '<span class="icon icon-paper-clip"></span>',
				//				fileApi_buttonClass: 'dn',
				//				fileApi_buttonValue: '<span class="icon icon-paper-clip blue"></span>',
				fileApi_buttonClass: 'blue anchor',
				noBind: true,
				onAddFile: function (newAttachItem) {
					newAttachItem && newAttachItem.save && newAttachItem.save();
				},
				onPaneChange: function (newVal) {
					_parent.is_detail(newVal <= 0 ? true : false);
				},
				onChangeCheckList: function (chk) {
					var chk_active = chk.checklist().filter(function (_itm) {
						return !_itm.is_closed();
					}).length;
					targ.chkl_count(chk_active);
				},
				onAddTag: function (tagItm) {
					// tagItm && tagItm.id && _parent.tags.push(tagItm);
					tagItm && tagItm.id && targ.tags(tagItm.id);
				},
				onTagUpdate: function (tagIds) {
					targ.tags(tagIds);
				},
				clbk: clbk
			});
		};
		// _this.predecessor_expr =
		// /^(\d+)(FF|SS|FS|SF)\+(\d{0,3})|^(\d+)\+(\d{0,3})|^(\d+)(FF|SS|FS|SF)|^(\d+)/;
		_this.predecessor_expr = /^(\d+)(FF|SS|FS|SF)(\+|\-)(\d{0,3})|^(\d+)(\+|\-)(\d{0,3})|^(\d+)(FF|SS|FS|SF)|^(\d+)/;

		_this.getFinishDate = function (start, dur) {
			dur = Number(dur) || 1;
			start = new Date(start);
			for (var i = 0; i < dur; i++) {
				start = Date.checkLeave(start);
				start.addDays(1);
			}
			return start.addDays(-1);
		};

		var tsListPopOver = {
			close: function () {
				var popover = $("#popover-day");
				popover.hide();
				tsListPopOver.tsDayDetails(null);
			},
			tsDayDetails: Otime.o(null)
		};

		var sortCustomFields = function () {	
			_this.custom_mod.mergeSort(function (a, b) {
				if (!a.ordNo) {
					return 1;
				}
				if (!b.ordNo) {
					return -1;
				}
				return parseInt(a.ordNo) - parseInt(b.ordNo);
			});
		};
		_this.ShowTSList = function (item, self, taskItem) {

		};

		_this.TaskListModel = function (data) {
			var self = this;
			data = data || {};
			self.isToDo = Otime.o(_this.isToDo || false);

			self.swap_view = function (item, elem) {
				if ($(elem.delegateTarget).is(".task")) {
					self.isToDo() && self.save(function () {
						Otime.cloneNewInstance("Tasks", "tasks");
					});
				}
				else {
					!self.isToDo() && self.save(function () {
						Otime.cloneNewInstance("Tasks", "tasks/todo");
					});
				}
			};

			self.is_archived = Otime.o(false);
			self.show_archived = function () {
				refreshFlag = false;
				if (self.is_archived()) {
					self.is_archived(false);
					_this.Refresh(self.project_id(), self.sprint_id(), null, true);
					return;
				}
				_this.Refresh(self.project_id(), self.sprint_id(), null, true, true);
				self.is_archived(true);
			};

			self.gantt = null;
			self.uGantt = null;

			self.users = Otime.o(null);
			self.users_sort = Otime.a([]);
			self.sprint = Otime.a([]);					
			self.followers = Otime.a([]);
			self.projects = Otime.a([]);
			self.department = Otime.a([]);
			self.tags = Otime.a(Otime.Details.tags || []);

			self.custom_fields = Otime.a([]);// _this.custom_mod;
			self.custom_options = {};
			self.cfOptionsByVal = {};

			var prjId = data.project_id || _this.PID || 0;
			prjId = isNaN(prjId) ? 0 : prjId;
			self.project_id = Otime.o(prjId);
			
			self.project_name = Otime.o("");
			self.project_code_name = Otime.o("");
			self.sprint_id = Otime.o(0);
			self.showChild = Otime.o();
			self.sprint_name = Otime.o("");
			self.showChild.subscribe(function (showChild) {
				var itms = self.items();
				for (var i = 0, iLen = itms.length; i < iLen; i++) {
					itms[i].show_child(showChild);
				}
			});

			self.showUser = Otime.o();
			self.showUser.subscribe(function (showuser) {
				var itms = self.department;
				for (var i = 0, iLen = itms.length; i < iLen; i++) {
					itms[i].show_user = showuser;
				}
			});

			self._info = {
				closedStatusId: 0,
				filters: Otime.o(data.filters),
				date_filter_type: Otime.o(data.date_filter_type || _this.dft || "ALL"),
				date_filter_disp: Otime.o(_this.filter_labels[data.date_filter_type || _this.dft || "ALL"]),
				task_status: Otime.a([]),
				is_nodata: Otime.o()
			};

			self.task_status = Otime.a([]);
			var pr_status = Otime.Storage.get("task_filter_task_status_" + self.project_id(), -2);
			self.task_status_id = Otime.o(pr_status ? pr_status : -2);
			self.default_status = 0;

			self.repeat_options = Otime.a([
				{ 'value': '-1', 'name': 'None', 'enabled': ko.observable(true) },
				{ 'value': 'D', 'name': 'Every Day', 'enabled': ko.observable(true) },
				{ 'value': 'WD', 'name': 'Every Weekday', 'enabled': ko.observable(true) },
				{ 'value': 'W', 'name': 'Every Week', 'enabled': ko.observable(true) },
				{ 'value': 'MD', 'name': 'Every Month', 'enabled': ko.observable(true) },
				{ 'value': 'M', 'name': Otime.o('Every Month'), 'enabled': ko.observable(true) }
			]);
			self.repeat_frequency = {
				'W': [{ value: 0, name: 'Sunday' }, { value: 1, name: 'Monday' }, { value: 2, name: 'Tuesday' }, { value: 3, name: 'Wednesday' }, { value: 4, name: 'Thursday' }, { value: 5, name: 'Friday' }, { value: 6, name: 'Saturday' }]
				//'MH' :[{value:1,name:'1st'},{value:2, name:'2nd'}],
			};
			self.is_repeat = Otime.o('-1');
			self.repeat_on = Otime.o('');

			self.search_task_types = Otime.a([]);
			self.task_types = Otime.a([]);
			// self.task_types(_this.searchArray.task_types);
			self.task_type_id = Otime.o(Otime.Storage.get("task_filter_task_type_" + self.project_id(), 0));
			self.task_name = Otime.o('').extend({ throttle: 400 });
			self.stort_point = Otime.o('');
			self.duration = Otime.o('');
			self.predecessors = Otime.o('');

			self.task_assignee_id = Otime.o(Otime.Storage.get("task_filter_assignee_" + self.project_id(), 0) - 0);
			self.today = Otime.o(new Date().format(Otime.jdf));
			self.date = Otime.o(new Date().format(Otime.jdf));
			self.date_disp = Otime.o(new Date(self.date()).format(Otime.dateFormat));

			Otime.date_filter(self, _this, self.search);
			self.field_filter = {};

			self.filters = null;
			self.getFilters = function () {
				var filters = {
					task_status_id: self.task_status_id(),
					task_type_id: self.task_type_id(),
					assignee_id: self.task_assignee_id() - 0,
					name: self.task_name()
					// duration: self.duration(),
					// predecessors: self.predecessors().toUpperCase()
				};
				if(self.sprint_id() != "-1" && self.sprint_id() != "0")
					filters["sprint_id"] = self.sprint_id();
				if (self._info.date_filter_type() != 'ALL') {
					$.extend(filters, {
						date: {
							start_date: new Date(_this.appModel.date_filter.from_date()).format("YYYY-MM-DD"),
							finish_date: new Date(_this.appModel.date_filter.to_date()).format("YYYY-MM-DD")
						}
					});
				}
				self.filters = filters;
				return filters;
			};

			self.applyFilter = function (item, filters) {
				// if (item && item.form.name() != "")
				if (item && item.form.task_id()) {
					var isV = true;
					if (_this.isM) {
						if (item.created_by() != Otime.UID - 0 && item.form.followers().indexOf("-1") < 0 && item.form.followers().indexOf(Otime.UID + "") < 0) {
							isV = false;
							// item.is_visible(false);
							// return false;
						}
					}

					filters = filters || self.filters || self.getFilters();
					var is_visible = false, tmp_visible = false;

					$.each(filters, function (name, value) {
						tmp_visible = false;
						switch (name) {
							case 'name':
								var txt = [
									item.form.task_number(),
									item.form.name(),
									item.form.task_type_name(),
									item.status() ? item.status().name : "",
									item.form._info.assignee_disp(),
									item.form._info.followers_disp(),
									new Date(item.form.start_date()).format(Otime.dateFormat),
									new Date(item.form.finish_date()).format(Otime.dateFormat),
									item.tagNames.join(" ")
								];

								$.each(_this.custom_fields, function (key, cf) {
									if (typeof item.form.custom_values["cf_" + cf.id] === "function") {
										txt.push(item.form.custom_values["cf_" + cf.id]());
									}
								});

								tmp_visible = txt.join(" ").toLowerCase().search(value.toLowerCase()) != -1;
								break;
							case 'date':
								tmp_visible = (new Date(item.form.start_date()).getTime() >= new Date(value.start_date).getTime() && new Date(item.form.finish_date()).getTime() <= new Date(value.finish_date).getTime());
								break;
							case 'task_status_id':
								value = value - 0;
								// 0 = All active task
								// -1 = All task
								// other = matched task
								// tmp_visible = ((!value && item.form.task_status_id() - 0 != self._info.closedStatusId - 0) || value == -1 || item.form.task_status_id() == value);
								if (value != -3) {
									tmp_visible = ((value == -2 && !item.is_closed()) || value == -1 || item.form.task_status_id() == value);
								} else {
									tmp_visible = (!item.is_closed() || new Date(item.form.actual_finish_date()).toInt() >= (new Date().toInt() - 3));
								}

								// tmp_visible = (value <= 0 ||
								// item.form.task_status_id() == value);

								// Show today closed tasks
								// tmp_visible = (!tmp_visible && !value &&
								// item.status_date() &&
								// item.status_date().isToday()) ? true :
								// tmp_visible;
								break;
							default:
								tmp_visible = (!value || item.form[name]() == value);
								break;
						}
						//console.log("******tmp_visible",tmp_visible);
						if (!tmp_visible) {
							is_visible = false;
							return false;
						}
						is_visible = true;
					});
					item.is_visible(isV && is_visible);

					if (item.is_visible()) {
						return true;
					}
					return false;
				}
				return true;
			};

			self.filter = function (list, filters) {				
				var ret_visible = false, isV = false;
				$.each(list, function (key, val) {
					isV = self.applyFilter(val, filters);

					//					val.is_visible((val.children() && val.children().length > 0 && self.filter(val.children(), filters)) || isV);
					//					ret_visible = ret_visible || isV;

					val.is_visible((val.children() && val.children().length > 0) ? self.filter(val.children(), filters) : isV);
					ret_visible = ret_visible || val.is_visible();
				});
				return ret_visible;
			};

			self.search = function () {
				
				self.filter(self.items(), self.getFilters());

				self.gridify_params().scope && self.gridify_params().scope.setSelected(_this.TID);
// _this.TID = 6; // 34667;
				if (_this.TID-0)
				{
					self.isPane(true);
					self.is_detail(true);
					self.rp_min_view(true);
				}

				_this.TID = 0;

				if (self.is_gantt())
				{
					self.buildGantt();
					_this.Splitters.init();
				}
			};

			self.taskTypes = {};

			self.new_id = Otime.o(1);
			self.gridify_params = Otime.o();
			self.hours_per_day = 0;
			self.is_root = true;

			self.items = Otime.a([]);
			self.columns = Otime.a([]);
			// self.is_tsu = Otime.o(false);
			self.tsw = Otime.o(null);
			self.is_tsw = Otime.o(false);
			self.tsa = Otime.o(null);
			self.is_tsa = Otime.o(false);
			self.selectedItem = Otime.o(null);
			/*
						var __selectedItem	= null;
						self.selectedItem = function(itm){
							if (itm)
								__selectedItem	= itm;
			
							return __selectedItem;
						};
			*/
			self.selectedItems = Otime.a([]);
			self.editItem = Otime.o(null);
			self.selectedTask = Otime.a([]);
			self.is_edit_mode = Otime.o(false);
			self.is_gantt = Otime.o(false);
			self.show_gantt = Otime.o(false);
			self.ganttTime = Otime.o(null);
			self.tswList = Otime.o({});

			self.isPane = Otime.o(_this.isToDo ? true : false);
			self.is_user_grid = Otime.o(_this.isToDo ? true : false);
			self.is_pinned = Otime.o(_this.isToDo ? true : false);
			self.isRightPane = Otime.o(_this.isToDo ? true : false);
			
			//self.addSprintPopup = Otime.o(new Otime.Sprint(self));
			self.addSprintPopup = Otime.o(null);
			self.edit_sprint_id = Otime.o("");
			self.sprint_name = Otime.o("");
			self.sprint_duration = Otime.o("");	
			self.sprintstart_date = Otime.o(null);
			//self.sprintstart_date(new Date())		
			self.sprintend_date = Otime.o(null);

			self.onSprintChange = function() {	
				if(self.sprint_duration() != 0){
					self.sprintend_date(new Date(new Date(self.sprintstart_date()).getTime()+(self.sprint_duration()*24*60*60*1000)).format("MM/dd/yyyy hh:mm AP"));
				}
			};

			self.deleteSprint = function() {
				if (!confirm("Are you sure you want to delete this sprint ?")) {
					return;
				}
				Otime.app.postData(new Otime.ContextModel({
					url: Otime.siteUrl + "/sprint/delete/" + self.sprint_id(),
					global: false,
					callback: function (cont) {
						var arr = [];						
						_this.appModel.sprint().find((o, i) => {
							if (o.sprint_id != self.sprint_id()) {
								arr.push(o);
							}
						});
						_this.appModel.sprint([]);
						_this.appModel.sprint(arr);
						delete Otime.Details.all_sprint[self.sprint_id()]
						delete Otime.Details.completed_sprint[self.sprint_id()]
					}
				}), true);				
			};

			self.editSprint = function(){
				var project_name = "";
				var tmpP = Otime.Storage.get("tasks_project_id") - 0;
				tmpP = tmpP ? tmpP : project_id - 0;
				$.each(Otime.app.model.projects(), function (key, val) {
					if ((val.value - 0) == (tmpP - 0)) {
						project_name = val.label;
						return false;
					}
				});	
				self.project_code_name(project_name);
				var objSprint = Otime.Details.all_sprint[self.sprint_id()]
				if(objSprint){
					self.edit_sprint_id(self.sprint_id());
					self.sprint_name(objSprint.name);
					self.sprint_duration(objSprint.duration);
					self.sprintstart_date(new Date(objSprint.start_date).format("MM/dd/yyyy hh:mm AP"));
					self.sprintend_date(new Date(objSprint.end_date).format("MM/dd/yyyy hh:mm AP"));
				}				
				$("#addsprint-modal").modal('show');
				self.addSprintPopup(self);	
			}

			self.cancelSPrint = function () {
				$("#addsprint-modal").modal('hide');
			}

			self.addSprint = function(item) {	
				self.edit_sprint_id(0);
				self.sprint_name("");
				self.sprint_duration(7);
				self.sprintstart_date(new Date().format("MM/dd/yyyy hh:mm AP"));
				self.sprintend_date(new Date(new Date(self.sprintstart_date()).getTime()+(self.sprint_duration()*24*60*60*1000)).format("MM/dd/yyyy hh:mm AP"));
				var project_name = "";
				var tmpP = Otime.Storage.get("tasks_project_id") - 0;
				tmpP = tmpP ? tmpP : project_id - 0;
				$.each(Otime.app.model.projects(), function (key, val) {
					if ((val.value - 0) == (tmpP - 0)) {
						project_name = val.label;
						return false;
					}
				});	
				self.project_code_name(project_name);
				$("#addsprint-modal").modal('show');								
				self.addSprintPopup(item);				
			};			

			self.saveSprint = function(item) {
				var tmpP = Otime.Storage.get("tasks_project_id") - 0;
				tmpP = tmpP ? tmpP : project_id - 0;
				var postData = {
					sprint_id: self.edit_sprint_id(),
					name: self.sprint_name(),
					duration: self.sprint_duration(),
					start_time: $("#starttimepicker").val(),
					end_time: $('#endtimepicker').val(),
					project_id: tmpP
				};
				if (self.sprint_name() == '') {
					alert("Sprint Name Required.");
					return false;
				}
				if ($("#starttimepicker").val() == '') {
					alert("Sprint Start Date Required.");
					return false;
				}
				if ($('#endtimepicker').val() == '') {
					alert("Sprint End Date Required.");
					return false;
				}
				if(new Date($("#starttimepicker").val()).format("MM/dd/yyyy") > new Date($('#endtimepicker').val()).format("MM/dd/yyyy"))
				{
					alert('Start date should not be greater than End date');
					return false;
				}
				var url    = Otime.siteUrl + "/sprint/save";
                Otime.app.postData(new Otime.ContextModel(url, postData,  function(cont){
				var resp = cont.response;
				if(resp.data.sprint_id!=''){
					var bolExists = false;
					let obj = _this.appModel.sprint().find((o, i) => {
						if (o.sprint_id == resp.data.sprint_id) {
							bolExists = true;
							_this.appModel.sprint()[i].name = self.sprint_name();
							_this.appModel.sprint()[i].duration = self.sprint_duration();
							_this.appModel.sprint()[i].start_date = $("#starttimepicker").val();
							_this.appModel.sprint()[i].end_date = $('#endtimepicker').val();					
							return true; // stop searching
						}
					});
					if(!bolExists){
						Otime.Details.all_sprint[resp.data.sprint_id] = {
							"sprint_id": resp.data.sprint_id,
							"name": self.sprint_name(),
							"duration": self.sprint_duration(),
							"start_date": $("#starttimepicker").val(),
							"end_date": $('#endtimepicker').val(),
							"project_id": tmpP,
						}
						// Find the position to insert the new sprint (before the completed sprints)
						let separatorIndex = _this.appModel.sprint().findIndex(sprint => sprint.sprint_id === 0);
						if (separatorIndex === -1) {
							// If there's no separator, just push to the end
							_this.appModel.sprint.push({
								"sprint_id": resp.data.sprint_id,
								"name": self.sprint_name(),
								"is_complete": false // Assuming new sprints are not complete
							});
						} else {
							// Insert before the separator
							_this.appModel.sprint.splice(separatorIndex, 0, {
								"sprint_id": resp.data.sprint_id,
								"name": self.sprint_name(),
								"duration": self.sprint_duration(),
								"start_date": $("#starttimepicker").val(),
								"end_date": $('#endtimepicker').val(),
								"project_id": tmpP,
							});
						}
					}else{
						let updatedSprint = {
							"name" : self.sprint_name(),
							"duration" : self.sprint_duration(),
							"start_date" : $("#starttimepicker").val(),
							"end_date" : $('#endtimepicker').val(),
							"project_id" : tmpP
						}
						// Find the index of the sprint in the open sprints array
						let index = Otime.Details.all_sprint.findIndex(sprint => sprint.sprint_id === resp.data.sprint_id);

						// If the sprint is found in the open sprints list
						if (index !== -1) {
							Otime.Details.all_sprint[index] = updatedSprint;
						} else {
							// Otherwise, find the index in the completed sprints array
							let completedIndex = Otime.Details.completed_sprint.findIndex(sprint => sprint.sprint_id === resp.data.sprint_id);
							if (completedIndex !== -1) {
								Otime.Details.completed_sprint[completedIndex] = updatedSprint;
							}
						}
					}

					/*	//_this.appModel.sprint.push({ name: self.sprint_name(), sprint_id: resp.data.sprint_id });
						if(self.edit_sprint_id() == 0 || Otime.Details.all_sprint[resp.data.sprint_id]){
							Otime.Details.all_sprint[resp.data.sprint_id] = {
								"sprint_id": resp.data.sprint_id,
								"name": self.sprint_name(),
								"duration": self.sprint_duration(),
								"start_date": $("#starttimepicker").val(),
								"end_date": $('#endtimepicker').val(),
								"project_id": tmpP,
							}
						}
						if(self.edit_sprint_id() != 0 || !Otime.Details.all_sprint[resp.data.sprint_id]){
							Otime.Details.completed_sprint[resp.data.sprint_id] = {
								"sprint_id": resp.data.sprint_id,
								"name": self.sprint_name(),
								"duration": self.sprint_duration(),
								"start_date": $("#starttimepicker").val(),
								"end_date": $('#endtimepicker').val(),
								"project_id": tmpP,
							}
						}
						_this.appModel.all_sprint[self.sprint_id()] = {
							"sprint_id": resp.data.sprint_id,
							"name": self.sprint_name(),
							"duration": self.sprint_duration(),
							"start_date": $("#starttimepicker").val(),
							"end_date": $('#endtimepicker').val(),
							"project_id": tmpP,
						}
					}
					let arr = _this.appModel.sprint();
					_this.appModel.sprint([]);
					_this.appModel.sprint(arr);			
					//sprint_id,name,project_id,duration,start_date,end_date
					var bolExists = false;
					$.each(Otime.Details.all_sprint, function (key, val) {
						if (resp.data.sprint_id == val.sprint_id) {
							bolExists = true;
							val.name = self.sprint_name();
							val.duration = self.sprint_duration();
							val.start_date = $("#starttimepicker").val();
							val.end_date = $('#endtimepicker').val();
							val.project_id = tmpP;
						}
					});
					if(!bolExists){
						$.each(Otime.Details.completed_sprint, function (key, val) {
							if (resp.data.sprint_id == val.sprint_id) {
								val.name = self.sprint_name();
								val.duration = self.sprint_duration();
								val.start_date = $("#starttimepicker").val();
								val.end_date = $('#endtimepicker').val();
								val.project_id = tmpP;
							}
						});
					}
					$.each(_this.appModel.sprint, function (key, val) {
						if (resp.data.sprint_id == val.sprint_id) {
							val.name = self.sprint_name();
							val.duration = self.sprint_duration();
							val.start_date = $("#starttimepicker").val();
							val.end_date = $('#endtimepicker').val();
							val.project_id = tmpP;
						}
					});*/
					$("#addsprint-modal").modal('hide');
					Otime.Details.init();
				}
                }), true);
			};

			self.rp_min_view = Otime.o(true);
			//			self.rp_min_view.subscribe(function(newVal){
			//				Otime.Storage.set("rp_min_view", newVal-0);
			//			});
			self.toggle_rpview = function () {
				self.rp_min_view(!self.rp_min_view());
			};
			self.is_detail = Otime.o(false);
			self.is_user_grid = Otime.o(false);
			self.swapDetails = function () {
				if (self.is_detail()) {
					self.is_detail(false);
					self.rp_min_view(true);
				}
				else {
					self.is_detail(true);
					self.rp_min_view(false);
				}
			};
			self.show_details = function (item) {
				self.is_detail(true);
				if (item && item.rp) {
					// item.rp().is_all(false);
					item.rp().onChangePane(-1)();
				}
			};

			// _this.applyPaneTypes(self);

			self.isPane.subscribe(function (newVal) {
				if (self.is_pcomments && self.is_pcomments()) {
					self.is_pcomments(false);
				}

				//if (!newVal)
				//{
				// self.is_pinned(false);
				//}

				self.is_pinned(newVal);
				Otime.Storage.set("is_task_pane_pinned", self.is_pinned() - 0);
				_this.Splitters.init();

				if (!_this.isToDo) {
					// set task page pane enabled or not
					Otime.Storage.set("is_task_pane", newVal ? 1 : 0);
				}
			});

			self.isRightPane.subscribe(function (newVal) {
				if (!_this.isToDo) {
					// set is right pane enabled for task page.
					Otime.Storage.set("is_task_right_pane", newVal ? 1 : 0);
				}

				if (newVal)
					_this.Splitters.uninit();
				else
					_this.Splitters.init();
			});

			if (Otime.Storage.get("is_task_pane_pinned") == null) {
				Otime.Storage.set("is_task_pane_pinned", 0);
			}
			self.is_pinned(!!(Otime.Storage.get("is_task_pane_pinned") - 0) || _this.isToDo);

			if (!_this.isToDo) {
				if (Otime.Storage.get("is_task_right_pane") == null) {
					Otime.Storage.set("is_task_right_pane", 0);
				}
				//				self.isRightPane(!!(Otime.Storage.get("is_task_right_pane") - 0));
				self.isRightPane(true);

				if (Otime.Storage.get("is_task_pane") == null) {
					Otime.Storage.set("is_task_pane", 0);
				}
				self.isPane(!!(Otime.Storage.get("is_task_pane") - 0));
			}

			// self.currentPane = Otime.o(_this.Pane.DEFAULT);
			var panFn = function (paneType) {
				if (self.isPane()) {
					//					if (self.isRightPane())
					//					{
					var targ = self.selectedItem();

					if (!targ.form.task_id() && targ.form.name()) {
						self.save();
						return;
					}
					_INITIALIZE_COMMENTS(targ, self);
					//					}
					//					else
					if (!self.isRightPane()) {
						// self.paneType(paneType || self.paneTypes.DETAIL);
						// paneType && self.paneType(paneType);
						!paneType && self.is_detail();
					}
				}

				_this.Splitters.updatePane(self.isPane());
			};
			self.pinIt = function () {
				if (!self.is_pinned()) {
					self.setVisibles();
				}
				self.is_pinned(!self.is_pinned());
				Otime.Storage.set("is_task_pane_pinned", self.is_pinned() - 0);
				// panFn();
				_this.Splitters.init();
			};
			self.swapUserPane = function() {
				self.is_user_grid(!self.is_user_grid());
				if(!self.is_user_grid()){
					_this.grid_container.css({
						height: "calc(93%)"
					});
				}else{
					_this.grid_container.css({
						height: "calc(55%)"
					});
				}
				_this.Splitters.init();
				_this.appModel.gantt.refreshGantt();
				var box3head = $("#box3-head"),
					box3also = $("#grid-container #box3-body, #user-grid-container #box5-body, #scroller #scr3");
				var box3 = box3head.add(box3also);				
				box3.not($("#box3-body, #scroller #scr3")).scrollLeft($("#box3-body, #scroller #scr3").scrollLeft());
			};
			self.swapPane = function () {
				self.is_detail(false);
				self.isPane(!self.isPane());
				panFn();
			};
			self.swapPanePos = function () {
				// self.isRightPane(!self.isRightPane());
				// panFn();
			};

			self.selectThis = function (item) {
				self.selectedItem(item);
				// self.gridify_params()
			};

			self.showPaneDoc = function () {
				self.setVisibles();
				var item = self.selectedItem();

				if (!item.form.task_id() && item.form.name()) {
					self.save();
					return;
				}

				var rp = item && item.rp();
				rp ? rp.paneType(rp.paneTypes.DOCUMENT) : _INITIALIZE_COMMENTS(item, self, function (module) {
					module.paneType(module.paneTypes.DOCUMENT);
				});

				self.rp_min_view(false);
				rp && rp.is_att_min && rp.is_att_min(false);
				self.isPane(true);
				_this.Splitters.updatePane(true);
				$("#contextMenu, #contextMenu > .dropdown-menu").hide();
				return true;
			};

			self.showPaneComments = function () {
				self.setVisibles();
				var item = self.selectedItem();

				if (!item.form.task_id() && item.form.name()) {
					self.save();
					return;
				}

				var rp = item && item.rp();
				rp ? rp.paneType(rp.paneTypes.COMMENT) : _INITIALIZE_COMMENTS(item, self, function (module) {
					module.paneType(module.paneTypes.COMMENT);
				});

				self.rp_min_view(false);
				rp && rp.is_cmt_min && rp.is_cmt_min(false);
				self.isPane(true);
				_this.Splitters.updatePane(true);
				$("#contextMenu, #contextMenu > .dropdown-menu").hide();
				return true;
			};

			self.setVisibles = function (is_gantt, show_gantt, tsw, tsa) {
				if (self.isPane() && self.isRightPane() && self.is_pinned() && (is_gantt || show_gantt || tsw || tsa)) {
					self.pinIt();
					self.swapPane();
				}
				else if (_this.isToDo) {
					self.isPane(true);
					self.is_pinned(true);
				}

				self.is_gantt(is_gantt || false);
				self.show_gantt(show_gantt || false);
				self.is_tsw(tsw || false);
				self.is_tsa(tsa || false);
			};

			self.buildGantt = function () {
				var min = new Date(self.ganttTime().min_date);
				var max = new Date(self.ganttTime().max_date);

				if ((max - min) > 31536E6) {
					min = new Date(max).addDays(-365);
				}
				_this.applyGantt({
					min: min,
					max: max
				});
				_this.applyUsersGantt({
					min: min,
					max: max
				});
				self.show_gantt(true);
				_this.applyLinks(); // Gantt Links
			};
			self.buildUsersGantt = function () {
				var min = new Date(self.ganttTime().min_date);
				var max = new Date(self.ganttTime().max_date);

				if ((max - min) > 31536E6) {
					min = new Date(max).addDays(-365);
				}

				_this.applyUsersGantt({
					min: min,
					max: max
				});
				self.show_gantt(true);
				 _this.applyLinks(); // Gantt Links
			};
			self.showGantt = function () {
				console.log("*********tasks showGantt");
				self.is_user_grid(false);
				self.zoomLevel("y");
				if (self.is_gantt()) {					
					self.setVisibles();
					_this.grid_container.css({
						height: "calc(93%)"
					});
				}
				else {
					//self.getUserHours(_this.appModel.project_id());
					self.isPane(false);
					self.setVisibles(true);
					self.buildGantt();
					//self.buildUsersGantt();
				}
				_this.Splitters.init();
				self.is_gantt() || self.gridify_params().scope.updateEvents();
			};

			self.swapView = function (item) {
				item.show_child(!item.show_child());
				if (self.is_gantt()) {
					_this.applyLinks();
				}
			};

			self.swapUsers = function (item) {
				//self.getUserHours(_this.appModel.project_id());
				item.show_user(!item.show_user());
			};

			self.taskCount = function (type) {
				return function () {
					type = type || 'status';
					Otime.app.postData(new Otime.ContextModel("task_count", {
						project_id: self.project_id() - 0,
						task_type_id: self.task_type_id() - 0,
						assignee_id: self.task_assignee_id() - 0,
						group_by: type
					}, function (cont) {
						var status_count = {};
						if (cont.response && cont.response.otvalues) {
							var resp = cont.response;

							status_count = cont.response.otvalues.setKeys(cont.response.otkeys, function (itm) {
							}, "task_status_id");
						}
						var el = $('#task_status_filter');

						$.each(self._info.task_status(), function (key, val) {
							val.count(0);
							if (status_count[val.task_status_id]) {
								val.count(status_count[val.task_status_id].cnt);
							}
						});
						$('select', el).trigger("chosen:updated");
					}));
				};
			}

			self.getUserHours = function (projectId) {
				var postData = {
					project_id: projectId,
					project_resource: true,
					start_date: new Date(self.ganttTime().min_date).format("YYYY-MM-DD") || new Date().clearTime().getMonthStart().format("YYYY-MM- DD"),
					end_date: new Date(self.ganttTime().max_date).format("YYYY-MM-DD") || new Date().clearTime().getMonthEnd().format("YYYY-MM-DD"),
				};

				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/timesheet/estimates", postData, function (cont) {
					if (cont.response.items && cont.response.items.otvalues) {
						// Reset Values
						var users = Object.values(_this.usersById);
						$.each(users, function (k, v) {
							v.hoursByDate = {};
							v.hours([]);
						});

						var hrsDate = null;
						cont.response.items = cont.response.items.otvalues.setKeys(cont.response.items.otkeys, function (itm) {
							if (!_this.usersById[itm.user_id]) {
								_this.usersById[itm.user_id] = {
									hoursByDate: {},
									hours: Otime.a([])
								};
							}

							hrsDate = _this.usersById[itm.user_id].hoursByDate[itm.entry_date];
							if (hrsDate) {
								if (!hrsDate.estimated_hours()) {
									hrsDate.estimated_hours(0);
								}
								if (!hrsDate.taskHrs[itm.project_task_id]) {
									hrsDate.taskHrs[itm.project_task_id] = 0;
								}

								hrsDate.estimated_hours(hrsDate.estimated_hours() + (itm.estimated_hours - 0));
								hrsDate.taskHrs[itm.project_task_id] += (itm.estimated_hours - 0);
							}
							else {
								itm.taskHrs = {};
								itm.taskHrs[itm.project_task_id] = itm.estimated_hours - 0;
								itm.taskHours = Otime.c(function () {
									return this.taskHrs[_this.appModel.selectedItem().form.task_id()] || "";
								}, itm);
								itm.estimated_hours = Otime.o(itm.estimated_hours - 0);
								itm.validHrClass = Otime.c(function () {
									if (_this.appModel.hours_per_day < this.estimated_hours()) {
										return "label-danger " + (this.taskHours() ? "taskhrs" : "");
									} else if (_this.appModel.hours_per_day == this.estimated_hours()) {
										return "label-success " + (this.taskHours() ? "taskhrs" : "");
									} else {
										return "label-primary " + (this.taskHours() ? "taskhrs" : "");
									}
								}, itm);

								_this.usersById[itm.user_id].hoursByDate[itm.entry_date] = itm;
								_this.usersById[itm.user_id].hours.push(itm);
							}
						});
					}
				}), true);
			}

			self.filter_column = {
				task_type: function (item, elem) {
					var el = $('#task_type_filter');
					$('select', el).click();
					var p_elem = $(elem.delegateTarget).parent();
					el.css({
						'position': 'fixed',
						'width': p_elem.outerWidth(),
						// 'min-width' : 170,
						'left': p_elem.offset().left,
						'top': p_elem.offset().top,
						'display': 'block',
						'z-index': 2
					});
					$('.chosen-drop', el).css({
						'min-width': 170
					});
					$('select', el).trigger('chosen:open.chosen');
					elem.stopPropagation();
					$('.chosen-search input', el).get(0).focus();
				},
				task_status: function (item, elem) {
					var el = $('#task_status_filter');
					$('select', el).click();
					var p_elem = $(elem.delegateTarget).parent();
					el.css({
						'position': 'fixed',
						'width': p_elem.outerWidth(),
						// 'min-width' : 170,
						'left': p_elem.offset().left,
						'top': p_elem.offset().top,
						'display': 'block',
						'z-index': 2
					});
					$('.chosen-drop', el).css({
						'min-width': 170
					});
					$('select', el).trigger('chosen:open.chosen');
					elem.stopPropagation();
					$('.chosen-search input', el).get(0).focus();
				},
				assignee_id: function (item, elem) {
					var el = $('#task_assignee_filter');
					$('select', el).click();
					var p_elem = $(elem.delegateTarget).parent();
					el.css({
						'position': 'fixed',
						'width': p_elem.outerWidth(),
						// 'min-width' : 170,
						'left': p_elem.offset().left,
						'top': p_elem.offset().top,
						'display': 'block',
						'z-index': 2
					});
					$('.chosen-drop', el).css({
						'min-width': 170
					});
					$('select', el).trigger('chosen:open.chosen');
					elem.stopPropagation();
					$('.chosen-search input', el).get(0).focus();
				}
			};

			self.toggleCollapse = function () {
				self.showChild(!self.showChild());
				Otime.Storage.set("task_showChild", self.showChild() ? "1" : "0");
			};

			var isAsc = true;
			self.sort = function (targ, isCf) {
				targ = targ || "name";

				var compareFn = function (a, b, x, y) {
					// if (!a.form.name() || !b.form.name() || !x || !y)
					// {
					// return 1;
					// }
					// else
					// return ((x < y) ? -1 : ((x > y) ? 1 : 0));
					// return ((!a.form.name() || !b.form.name() || !x || !y ||
					// (x < y)) ? -1 : ((x > y) ? 1 : 0));
					return ((!a.form.name() || !b.form.name() || (x < y)) ? -1 : ((x > y) ? 1 : 0));
				};

				if (targ == "duration" || targ == "worked_hours" || targ == "estimated_hours") {
					return function () {
						var tmpArr = self.items();
						if (isAsc) {
							isAsc = false;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, +a.form[targ](), +b.form[targ]());
							});
						}
						else {
							isAsc = true;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, +b.form[targ](), +a.form[targ]());
							});
						}
						self.items(tmpArr);
					};
				}
				else if (targ == "status") {
					return function () {
						var tmpArr = self.items();
						if (isAsc) {
							isAsc = false;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, a.status().name, b.status().name);
							});
						}
						else {
							isAsc = true;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, b.status().name, a.status().name);
							});
						}
						self.items(tmpArr);
					};
				}
				else if (targ == "task_number") {
					return function () {
						var tmpArr = self.items();
						if (isAsc) {
							isAsc = false;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, a.form.task_number() - 0, b.form.task_number() - 0);
							});
						}
						else {
							isAsc = true;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, b.form.task_number() - 0, a.form.task_number() - 0);
							});
						}
						self.items(tmpArr);
					};
				}
				else if (isCf) {
					return function () {
						var tmpArr = self.items();
						if (isAsc) {
							isAsc = false;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, a.form.custom_values[targ](), b.form.custom_values[targ]());
							});
						}
						else {
							isAsc = true;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, b.form.custom_values[targ](), a.form.custom_values[targ]());
							});
						}
						self.items(tmpArr);
					};
				}
				else {
					return function () {
						var tmpArr = self.items();
						if (isAsc) {
							isAsc = false;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, a.form[targ](), b.form[targ]());
							});
						}
						else {
							isAsc = true;
							tmpArr.mergeSort(function (a, b) {
								return compareFn(a, b, b.form[targ](), a.form[targ]());
							});
						}
						self.items(tmpArr);
					};
				}
			};
			/*
						var updateTimeSheetUsers = function(resp){
							if (!resp.users)
								return false;
			
							var users = resp.users.values.setKeys(resp.users.keys, function(item){
								if (item.user_image)
									item.user_image = Otime.UTIP + item.user_image;
								else
									item.user_image = Otime.baseUrl + "files/photo/noUser.png";
							}, "user_id");
			
							var newUsers = [], newObj = {}, is_added = [];
			
							var totalAmt = 0;
							var items = resp.items.values.setKeys(resp.items.keys, function(item){
								newObj[item.project_task_id] = newObj[item.project_task_id] || {};
								newObj[item.project_task_id][item.user_id] = item;
								totalAmt += parseFloat(item.hours);
			
								if (newUsers.indexOf(users[item.user_id]) < 0)
								{
									newUsers.push(users[item.user_id]);
								}
							});
							totalAmt = totalAmt.toFixed(2);
							newUsers.push({
								first_name: "Total : " + totalAmt,
								last_name: "",
								user_id: "TOTAL"
							});
							self.columns(newUsers);
							var allItems = _this.getAllItems(null, null, null, function(item){
								if (item.form.task_id() && newObj[item.form.task_id()])
								{
									var total = 0;
									for (key in newObj[item.form.task_id()])
									{
										total += parseFloat(newObj[item.form.task_id()][key].hours);
									}
									total = total.toFixed(2);
									var obj = newObj[item.form.task_id()];
									obj["TOTAL"] = {
										hours: total,
										project_task_id: item.form.task_id(),
										user_id: "TOTAL"
									};
									item.time_sheet_users(obj);
								}
							});
							return true;
						};
			
						self.tsuHours = function(item, column){
							if (item.time_sheet_users()[column.user_id])
							{
								return parseFloat(item.time_sheet_users()[column.user_id].hours).toFixed(2);
							}
							return "&nbsp;";
						};
			
						self.showTSU = function(){
							if (!self.project_id())
							{
								return false;
							}
			
							if (self.is_tsu())
							{
								self.is_tsu(false);
								_this.Splitters.init();
							}
							else
							{
								Otime.app.loadData(new Otime.ContextModel("ts_hrs", {
									project_id: self.project_id(),
									type: "USER"
								}, function(cont){
									updateTimeSheetUsers(cont.response);
									self.setVisibles(false, false, true, false, false);
									_this.Splitters.init();
								}));
							}
						};
			*/
			// #region-My Timesheet begin here.
			var runningProcess = null, runningItem = null;

			var updateTimeSheetWeek = function (resp) {
				// if (!resp.values)
				// {
				// return true;
				// }

				var active = resp.active;

				var dates = {}, cols = self.tsw().columns();

				for (var i = 0; i < cols.length; i++) {
					dates[cols[i].date.format("YYYY-MM-DD")] = cols[i];
				}

				var newData = [], newObj = {}, is_added = [];

				var totalHrs = 0;

				if (resp.otvalues && resp.otvalues.length > 0) {
					var items = resp.otvalues.setKeys(resp.otkeys, function (item) {
						item.hours = Number(item.hours);
						item.count = Number(item.count);
						newObj[item.project_task_id] = newObj[item.project_task_id] || {};

						newObj[item.project_task_id][item.entry_date] = item;

						var colTot = parseFloat(dates[item.entry_date].hours()) + parseFloat(item.hours);
						dates[item.entry_date].hours(colTot.toFixed(2));

						totalHrs += parseFloat(item.hours);
						if (newData.indexOf(dates[item.entry_date]) < 0) {
							newData.push(dates[item.entry_date]);
						}
					});
				}

				totalHrs = totalHrs.toFixed(2);

				var allItems = _this.getAllItems(null, null, null, function (item) {
					var total = 0, tmpObj = {}, tmp = null, tmp1 = null, dt = null;

					var today = Otime.Date().format(Otime.sdf);
					for (var i = 0; i < cols.length; i++) {
						dt = cols[i].date.format("YYYY-MM-DD");

						tmp = newObj[item.form.task_id()] || {};
						tmp = tmp[dt] || {};

						tmp1 = new _this.TimeSheet({
							approval_status: tmp.approval_status || "",
							entry_date: dt,
							date: cols[i].date,
							project_id: self.project_id(),
							task_type_id: item.form.task_type_id(),
							project_task_id: item.form.task_id(),
							activity_name: item.form.name(),
							time_sheet_id: tmp.time_sheet_id || 0,
							is_billable: item.form.is_billable(),
							count: tmp.count || 0,
							hours: tmp.hours || ""
						}, item);
						/*
												if (active && active.entry_date == dt && active.time_sheet_id == tmp1.time_sheet_id())
												{
													tmp1._info.is_ts_running(true);
													item.is_ts_running(true);
													tmp1._info.from_time = active.from_time;
													Otime.app.running_process(tmp1);
													runningProcess = tmp1;
													runningItem = item;
													Otime.TimeSheet.curTime = resp.cur_time;
													Otime.TimeSheet.SetInterval(tmp1._info.from_time, tmp1, (Number(tmp1.hours()) * 60 * 60), 'HH<span class="blink">:</span>NN');
												}
						
												if (active && active.time_sheet_id == tmp1.time_sheet_id() && active.entry_date == dt)
												{
													tmp1._info.is_ts_running(true);
													item.is_ts_running(true);
													tmp1._info.from_time = active.from_time;
													Otime.app.running_process(tmp1);
													runningProcess = tmp1;
													runningItem = item;
													Otime.TimeSheet.curTime = resp.cur_time;
													Otime.TimeSheet.SetInterval(tmp1._info.from_time, tmp1, (Number(tmp1.hours()) * 60 * 60), 'HH<span class="blink">:</span>NN');
												}
						*/

						if (active && active.project_task_id - 0 && active.project_task_id == tmp1.project_task_id && today == dt) {
							tmp1.entry_date(Otime.stoj(active.entry_date).format(Otime.jdf));
							tmp1.time_sheet_id(active.time_sheet_id);
							tmp1._info.is_ts_running(true);
							item.is_ts_running(true);
							tmp1._info.from_time = active.from_time;
							Otime.app.running_process(tmp1);
							runningProcess = tmp1;
							runningItem = item;
							Otime.TimeSheet.curTime = resp.cur_time;
							Otime.TimeSheet.SetInterval(tmp1._info.from_time, tmp1, (Number(tmp1.hours()) * 60 * 60), 'HH<span class="blink">:</span>NN');
						}
						total += parseFloat(tmp.hours || 0);

						tmpObj[dt] = tmp1;
					}
					item.time_sheet_weeks(tmpObj);
					item.tswTotal(total ? total.toFixed(2) : "");
				});

				return true;
			};

			self.tsDetails = Otime.o(null);
			self.tsa_popup = Otime.o(null);

			var stopClbk = function (_cell, stopTime) {
				_cell._info.is_ts_running(false);
				_cell.getParent().is_ts_running(false);
				Otime.Menu.progress()._info.is_running(false);
				Otime.app.running_process(null);
				Otime.TimeSheet.ClearInterval();
				runningProcess = null;
				runningItem = null;

				// Refresh the MyHours right panel.
				loadTSW();
				/*
								var startTime = Otime.RemoveSeconds(_cell._info.from_time), endTime = stopTime;
								var tot = Number(_cell.hours() + Number(jhelper.getTimeDiffPercent(startTime, endTime))).toFixed(2);
								_cell.hours(Number(tot));
								return true;
				*/
			};

			var startItm = function (cell) {
				if (cell.time_sheet_id() > 0) {
					Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/timesheet/start', {
						time_sheet_id: cell.time_sheet_id()
					}, function (cont) {
						var resp = cont.response;

						if (runningProcess != null) {
							runningItem.is_ts_running(false);
							stopClbk(runningProcess, resp.time);
						}
						cell._info.from_time = resp.time;
						Otime.app.running_process(cell);

						Otime.TimeSheet.curTime = resp.cur_time;
						Otime.Menu.curTime = resp.cur_time;
						Otime.TimeSheet.SetInterval(cell._info.from_time, cell, (Number(cell.hours()) * 60 * 60), 'HH<span class="blink">:</span>NN');

						var project_name = "";
						$.each(Otime.app.model.projects(), function (key, val) {
							if ((val.value - 0) == (cell.project_id - 0)) {
								project_name = val.label;
								return false;
							}
						});

						Otime.Menu.activeTask = {
							time_sheet_id: cell.time_sheet_id(),
							activity_name: cell.activity_name(),
							project_name: project_name,
							is_progress: true,
							from_time: resp.time,
							hours: cell.hours()
						};
						Otime.Menu.initProgress();

						cell._info.is_ts_running(true);
						cell.getParent().is_ts_running(true);

						runningItem = cell.getParent();
						runningProcess = cell;
					}), true);

					return true;
				}
				return false;
			};

			self.editTS = function (cell, elem, cont) {
				if (!cell) {
					return false;
				}

				if ($(elem.target).is(".icon-play, .icon-pause")) {
					return false;
				}

				if (cell.getParent().form.task_id() != self.selectedItem().form.task_id()) {
					self.selectedItem(cell.getParent());
				}

				if (!cell.project_task_id) {
					return;
				}

				self.showTimeSheet(cell);
			};

			self.start = function (cell, elem, cont) {
				// var key = Otime.Date().format("YYYY-MM-DD");

				// item.time_sheet_weeks()[key];
				if (!cell) {
					return false;
				}

				if (cell.getParent().form.task_id() != self.selectedItem().form.task_id()) {
					self.selectedItem(cell.getParent());
				}

				if (cell._info.is_ts_running()) {
					if (cont) {
						var resp = cont.response;
						stopClbk(cell, resp.time);
						return true;
					}

					Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/timesheet/stop', {
						time_sheet_id: cell.time_sheet_id()
					}, function (cont) {
						var resp = cont.response;
						stopClbk(cell, resp.time);
					}), true);

					return true;
				}
				var item = self.selectedItem();
				cell.task_type_id = item.form.task_type_id();
				cell.project_task_id = item.form.task_id();

				if (!(cell.task_type_id - 0) && !cell.time_sheet_id()) {
					self.showTimeSheet(cell);
					//					alert("Task Type required.");
					return false;
				}

				if (!startItm(cell)) {
					var data = JSON.parse(ko.toJSON(cell));
					delete data._info;
					data.hours = 0;
					Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/timesheet/save", data, function (cont) {
						if (cont.response && cont.response[0].time_sheet_id) {
							cell.time_sheet_id(cont.response[0].time_sheet_id);
							cell.count(cell.count() + 1);
							startItm(cell);
							// self.start(cell, elem);
						}
					}), true);

					return true;
				}

				return false;
			};

			var cancelTimeSheet = function () {
				$('#popover').hide();
				self.tsDetails(null);
			};

			/*******************************************************************
			 * 
			 * item = target (clicked) cell in table grid (_this.TimeSheet).
			 * _itm = Otime.TimeSheet.TimeSheetDetailModel. selectedTask =
			 * Selected Task. isStart = Start flag.
			 * 
			 */
			var saveTimeSheet = function (item, _itm, selectedTask, isStart, clbk) {
				var is_new = !(_itm.time_sheet_id() - 0) ? true : false;
				Otime.TimeSheet.TimeSheetSave(_itm, function (response, cont, data) {
					var diff = (item.hours() - 0) - (data.hours - 0);
					if (is_new) {
						item.time_sheet_id(response.time_sheet_id - 0);
						_itm.time_sheet_id(response.time_sheet_id - 0);
						// console.log(item.timesheets());
						if (item.timesheets) {
							var tmp_ts = item.timesheets();
							tmp_ts.push(_itm);
							item.timesheets(tmp_ts);
						}
					}
					item.hours(data.hours - 0);


					var parnt = item.getParent();
					parnt.tswTotal(parnt.tswTotal() - 0 - diff);
					var tsa = parnt.time_sheet_actual();
					tsa.hours -= diff;
					parnt.time_sheet_actual(tsa);


					if (isStart) {
						// startItm(item, _itm, selectedTask);
						if (item.date.isToday()) {
							self.start(item);
						}
						else if (item.date.isThisWeek()) {
							self.start(selectedTask.time_sheet_weeks()[Otime.Date().format("YYYY-MM-DD")]);
						}
						else {

						}
					}

					typeof clbk === "function" && clbk(_itm);

					cancelTimeSheet();
				});
			};

			self.showTimeSheetPopup = function (newTsItem, taskItem, item, clbk) {
				var popover = $('#popover');

				var _newTsItem = newTsItem;

				if (!(newTsItem instanceof Otime.TimeSheet.TimeSheetDetailModel)) {
					_newTsItem = JSON.parse(JSON.stringify(newTsItem));

					_newTsItem.task_types = _this.ttypeById;
					_newTsItem.is_task_page = true;

					_newTsItem = new Otime.TimeSheet.TimeSheetDetailModel(_newTsItem);

					_newTsItem.addHoursDetail();
				}

				self.tsDetails({
					tsheet: _newTsItem,
					save: function (_itm) {
						return saveTimeSheet(item, _itm, taskItem, false, clbk);
					},
					cancel: function () {
						return cancelTimeSheet();
					},
					saveStart: function (_itm) {
						return saveTimeSheet(item, _itm, taskItem, true, clbk);
						// if (!item._info.is_active())
						// {
						// return false;
						// }
						// ifSaveStart = true;
						// this.start(item);
					}
				});
				popover.show();
				setTimeout(function () {
					popover.show();
				}, 100);
			};

			self.showTimeSheet = function (item, elem) {
				var taskItem = self.selectedItem();

				if (item._info.is_ts_running() || taskItem.children().length > 0) {
					return;
				}

				var popover = $("#popover-day");

				if (!item.timesheets) {
					item.timesheets = Otime.a();
					item.estHrs = Otime.o(0);
					item.task_types = Object.values(_this.ttypeById);

					item.task_type_id = Otime.o(taskItem.form.task_type_id());
					item.estimated_hours = Otime.o("");
					item.new_hours = Otime.o("");

					var updateTotHrs = function () {
						var hrs = 0,
							estHrs = 0;
						$.each(item.timesheets(), function (idx, _itm) {
							hrs += _itm.hours() - 0;
							estHrs += _itm.estimated_hours() - 0;
						});

						item.hours(hrs);
						item.estHrs(estHrs);
					};

					item.saveTs = function (tsItem, e, isSaveStart) {
						if (tsItem instanceof _this.TimeSheet) {
							if (!tsItem.task_type_id()) {
								alert("Task type required");
								return false;
							}
							if (!tsItem.new_hours() - 0 && !tsItem.estimated_hours() - 0) {
								alert("Actual / Estimated hours required");
								return false;
							}

							var dt = new Date(tsItem.entry_date());

							if (isSaveStart && !tsItem.new_hours() && !dt.isToday()) {
								dt = new Date();
								tsItem.entry_date(new Date());
							}

							var tsSaveObj = {
								project_id: tsItem.project_id,
								project_task_id: tsItem.project_task_id,
								task_type_id: tsItem.task_type_id(),
								activity_name: tsItem.activity_name(),
								entry_date: new Date(tsItem.entry_date()).format(Otime.sdf),
								hours: tsItem.new_hours(),
								estimated_hours: tsItem.estimated_hours(),
								is_billable: tsItem.is_billable() ? 1 : 0,
								time_sheet_id: 0
							};

							Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/timesheet/save", tsSaveObj, function (cont) {
								if (cont.response && cont.response[0].time_sheet_id) {
									tsSaveObj.time_sheet_id = cont.response[0].time_sheet_id;
									tsSaveObj = new Otime.TimeSheet.TimeSheetDetailModel(tsSaveObj);
									tsSaveObj.addHoursDetail();
									item.timesheets.unshift(tsSaveObj);
									item.time_sheet_id(tsSaveObj.time_sheet_id());

									// Reset
									tsItem.new_hours("");
									tsItem.estimated_hours("");

									if (isSaveStart) {
										self.start(item);

										// cancelTimeSheet();
										tsListPopOver.close();
									}
									updateTotHrs();
								}
							}), true);
						} else {
							item.time_sheet_id(tsItem.time_sheet_id());
							isSaveStart && self.start(item);
							updateTotHrs();
						}
					};

					item.startTs = function (tsItem, e) {
						item.saveTs(tsItem, e, true);
					};

					item.deleteTs = function (ts_item) {
						if (ts_item.time_sheet_id() > 0) {
							Otime.app.postData(new Otime.ContextModel({
								url: Otime.siteUrl + "/timesheet/delete/" + ts_item.time_sheet_id(),
								global: false,
								callback: function (cont) {
									item.timesheets.remove(ts_item);
									updateTotHrs();
								}
							}), true);
						}
					};

					item.editTs = function (ts_item) {
						if (ts_item instanceof _this.TimeSheet) {
							ts_item = new Otime.TimeSheet.TimeSheetDetailModel({
								project_id: ts_item.project_id,
								project_task_id: ts_item.project_task_id,
								task_type_id: typeof ts_item.task_type_id === "function" ? ts_item.task_type_id() : ts_item.task_type_id,
								activity_name: ts_item.activity_name(),
								entry_date: new Date(ts_item.entry_date()).format(Otime.sdf),
								hours: ts_item.new_hours(),
								estimated_hours: ts_item.estimated_hours(),
								is_billable: ts_item.is_billable() ? 1 : 0,
								time_sheet_id: 0
							});
							ts_item.addHoursDetail();
						}
						self.showTimeSheetPopup(ts_item, taskItem, item, function (itm) {
							ts_item.hours(itm.hours());
							updateTotHrs();
						});
					};
				}

				if (!ko.dataFor(popover.get(0))) {
					ko.applyBindings(tsListPopOver, popover.get(0));
				}

				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + "/timesheet/listing", {
					project_id: item.project_id,
					project_task_id: item.project_task_id,
					date: new Date(item.date).format(Otime.sdf),
					noassigned: 1
				}, function (cont) {
					if (cont.response.items && cont.response.items.otvalues) {
						var estHrs = 0;
						var items = [];

						cont.response.items = cont.response.items.otvalues.setKeys(cont.response.items.otkeys, function (itm) {
							itm.task_types = _this.ttypeById;
							itm.is_task_page = true;
							estHrs += (itm.estimated_hours - 0);

							itm = new Otime.TimeSheet.TimeSheetDetailModel(itm);
							itm.addHoursDetail();
							items.push(itm);
						});

						item.estHrs(estHrs);
						item.timesheets(items);
					}

					tsListPopOver.tsDayDetails(item);
					popover.show();
				}), true);
			};

			/*******************************************************************
			 * Update the timesheet header row hrs
			 * 
			 * @param item -
			 *			Current item.
			 * @returns
			 */
			var updateHrsHeader = function (item) {
				var cols = self.tsw().columns();
				for (var i = 0, ln = cols.length; i < ln; i++) {
					if (item.hours() && item.entry_date == cols[i].date.format("YYYY-MM-DD")) {
						cols[i].hours((Number(cols[i].hours()) + (item.hours() - item.hours.originalValue)).toFixed(2));
						break;
					}
				}

				var row = _this.appModel.selectedItem();
				row.tswTotal((Number(row.tswTotal()) + (item.hours() - item.hours.originalValue)).toFixed(2));

				item.hours.originalValue = item.hours();
			};

			var columnModel = null;
			self.showColumns = function () {
				if (_this.isToDo) {
					return false;
				}
				var modal = $("#column-modal");
				var keyName = _this.isToDo ? "todo_columns" : "tasks_columns";

				if (!columnModel) {
					var elem = $("#modal-content", modal);
					columnModel = new _this.ColumnSelectionModel({}, function () {
						modal.modal("hide");
					});
					ko.applyBindings(columnModel, elem.get(0));
				}

				if (modal.data('bs.modal')) {
					modal.modal("show");
				}
				else {
					modal.modal();
				}
			};
			var progressModel = null;
			self.showProgressComments = function () {
				if (_this.isToDo) {
					return false;
				}
				var modal = $("#progress-modal");

				if (!progressModel) {
					var elem = $("#modal-content", modal);
					progressModel = new _this.ProgressCommentsModel({}, function () {
						modal.modal("hide");
					});
					ko.applyBindings(progressModel, elem.get(0));
				}

				if (modal.data('bs.modal')) {
					modal.modal("show");
				}
				else {
					modal.modal();
				}
			};
			var _currentDate = null;
			var loadTSW = function () {
				self.tsw(new _this.TimeSheetWeek({
					project_id: self.project_id(),
					isTotal: false
				}, function (resp, currentDate) {
					_currentDate = currentDate;
					updateTimeSheetWeek(resp);
					//					self.showTSA(function(){
					//						self.setVisibles(false, false, true, false);
					//						_this.Splitters.init();
					//					});
					self.setVisibles(false, false, true, false);
					_this.Splitters.init();
				}));
			};

			self.showTSW = function (isAll) {
				if (!self.project_id()) {
					return false;
				}

				if (self.is_tsw()) {
					self.is_tsw(false);
					self.setVisibles(false, false, false, false);
					_this.Splitters.init();
					return true;
				}

				loadTSW();
				_this.Splitters.init();

				return true;
			};

			self.CommentsHandler = Otime.o(null);
			self.is_pcomments = Otime.o(false);
			self.rp_min_view = Otime.o(true);
			self.is_detail = Otime.o(false);
			self.is_user_grid = Otime.o(false);
			self.zoomLevel = Otime.o("");
			var initComments = function () {
				self.CommentsHandler(new Otime.Comments.init({
					module: "projects",
					module_type: "P",
					module_id: self.project_id(),
					parent: self,
					isSeparate: true,
					onAddFile: function (newAttachItem) {
						newAttachItem && newAttachItem.save && newAttachItem.save();
					},
					onToggleMinimize: function (isMin) {
						self.rp_min_view(isMin);
					}
				}));
			};
			self.showPComments = function () {
				self.isPane(false);
				self.is_pinned(false);
				if (self.is_pcomments()) {
					self.is_pcomments(false);
					if (_this.isToDo) {
						self.isPane(true);
						self.is_pinned(true);
					}
					return;
				}
				else {/*
					if (!Otime.app.hasBinding(_this.pcomments_container))
					{
						Otime.app.load_template(Otime.siteUrl + "/project/template/comments", function(response){
							_this.pcomments_container.html($.trim(response));
							initComments();
							ko.applyBindings(self.CommentsHandler, $("#comments-container").get(0));
						}, true);
					}
					else
					{
						initComments();
					}
					self.is_pcomments(true);
					*/
					initComments();
					self.is_pcomments(true);
					self.is_pinned(true);
				}
			};

			self.tswHours = function (item, column) {
				if (column != "TOTAL") {
					var tmp = item.time_sheet_weeks()[new Date(column.date).format("YYYY-MM-DD")];
					if (tmp && Number(tmp.project_task_id) > 0) {
						return tmp.hours; // parseFloat(tmp.hours).toFixed(2);
					}
				}
				else {
					var tmp = item.time_sheet_weeks()["TOTAL"];
					if (tmp && tmp.hours) {
						return tmp.hours; // () ?
						// parseFloat(tmp.hours()).toFixed(2)
						// : "";
					}
				}
				return "";
			};
			// #end-region-My Timesheet end here.

			// Timesheet Actual Hours begin here.
			self.tsaHours = function (item) {
				var tmp = item.time_sheet_actual();
				if (tmp && Number(tmp.project_task_id) > 0 && tmp.hours > 0) {
					return tmp.hours;
				}
				return "";
			};

			// self.showTSA = function(item, elem){
			self.showTSA = function (clbk, elem) {
				if (!self.project_id()) {
					return false;
				}

				var by = (elem && elem.delegateTarget && $(elem.delegateTarget).attr("by")) || "TW";

				// if (self.is_tsa() && !by)
				// {
				// self.is_tsa(false);
				// _this.Splitters.init();
				// return true;
				// }

				self.tsa(new _this.TimeSheetActual({
					project_id: self.project_id(),
					filter_by: by,
					currentDate: _currentDate
				}, function (resp) {
					var totalHrs = 0;

					if (resp && resp.users && resp.users.otvalues && resp.users.otvalues.length > 0) {
						_this.users = resp.users.otvalues.setKeys(resp.users.otkeys, function (item) {
							if (item.user_image)
								item.user_image = Otime.UMIP + item.user_image;
							else
								item.user_image = Otime.baseUrl + "files/photo/noUser.png";
						}, "user_id");
					}

					var newObj = {};
					if (resp && resp.items && resp.items.otvalues && resp.items.otvalues.length > 0) {
						var items = resp.items.otvalues.setKeys(resp.items.otkeys, function (item) {
							item.hours = Number(item.hours);
							totalHrs += item.hours;
							newObj[item.project_task_id] = item;
						});
					}
					var allItems = _this.getAllItems(null, null, null, function (item) {
						item.time_sheet_actual($.extend(newObj[item.form.task_id()] || {}, {
							list: []
						}));
					});

					totalHrs = totalHrs.toFixed(2);
					clbk && typeof clbk == "function" && clbk();
					// self.setVisibles(false, false, false, true);
					// _this.Splitters.init();
				}));
			};
			// Timesheet Actual Hours end here.
			/*
						var canVisible	= function(itm){
							if (itm.is_parent-0 && (self.is_archived() || !!(itm.is_archived-0)) && (!itm.children || !Object.keys(itm.children).length))
							{
								return false;
							}
			
							var ret	= false;
							if (!itm.children || !Object.keys(itm.children).length)
							{
								ret	= true;
							}
			
							ret || Object.values(itm.children).setKeys(_this.Keys, function(val){
								ret	= ret || canVisible(val);
							});
			
							return ret;
						};
			*/
			self.apply = function (data) {
				if (!data)
					return false;
				var tmpArr = [];				
				if (Object.keys(data.items).length > 0) {
					data.items = data.items.sort(function (a, b) {
						var x = Number(a.order_id);
						var y = Number(b.order_id);
						return ((x < y) ? -1 : ((x > y) ? 1 : 0));
					});
					var val = "";

					if (self.items().length >= 10) {
						// Calculate the starting index for the removal
						const startIndex = self.items().length - 10;
						// Remove the last 10 elements
						//self.items().splice(startIndex, 10);
						var itms = self.items();
						for (var i = 0, iLen = itms.length; i < iLen; i++) {
							//itms[i].show_child(showChild);
							//console.log("*******itms[i]",itms[i])
						}
					}

					for (var i = 0; i < data.items.length; i++) {
						val = data.items[i] || null;
						// console.log(checkChild(val), val.name);
						//						if (val.is_parent-0 && (self.is_archived() || val.is_archived-0) && (!val.children || !Object.keys(val.children).length))
						/*						if (!canVisible(val))
												{
													continue;
												}
						*/
						var tmp_task = new _this.TaskContentModel(val, self);
						//self.items.push(tmp_task);
						var isDuplicate = self.items().some(item => item.form.task_id() === tmp_task.form.task_id());
						// If no duplicate found, add the new task to self.items
						if (!isDuplicate) {
							self.items.push(tmp_task);
						}
						tmpArr.push(tmp_task);

						if (_this.TID == val.task_id) {
							self.isPane(1);
							_this.TID = val.task_number;
						}

					}
				}
				for (var i = 0; i < 10; i++) // dummy 10 record.
				{
					tmpArr.push(new _this.TaskContentModel(null, self));
					self.items.push(new _this.TaskContentModel(null, self));
				}

				//self.items(tmpArr);

				self.showChild(!!(Otime.Storage.get("task_showChild") - 0));

				return true;
			};

			self.insertNew = function (data, count) {
				count = count || 1;
				for (var i = 0; i < count; i++)
					self.items.push(new _this.TaskContentModel(data, self));
			};

			self.load = function (context) {
				var item = self.getCommonData().item;
				var data = context.response || {};
				if (data) {
					data.task_id && item.form.task_id(data.task_id);
					data.task_type_id && item.form.task_type_id(data.task_type_id);
					data.name && item.form.name(data.name);
					data.description && item.form.description(data.description);
					data.task_number && item.form.task_number(data.task_number);
					data.duration && item.form.duration(data.duration);
					data.status && item.form.status(data.status);
					data.start_date && item.form.start_date(new Date(data.start_date));
					data.finish_date && item.form.finish_date(new Date(data.finish_date));
					data.estimated_hours && item.form.estimated_hours(data.estimated_hours);
					data.predecessors && item.form.predecessors(data.predecessors);
					data.assignee_id && item.form.assignee_id(data.assignee_id);
					data.followers && item.form.followers(data.followers);
					data.notes && item.form.notes(data.notes);
					data.actual_start_date && item.form.actual_start_date(new Date(data.actual_start_date));
					data.actual_finish_date && item.form.actual_finish_date(new Date(data.actual_finish_date));
					item.form.task_priority(data.task_priority || 2);
					data.is_billable && item.form.is_billable(data.is_billable);
					data.percentage_complete && item.form.percentage_complete(data.percentage_complete);
					(data.worked_hours - 0) && item.form.worked_hours(data.worked_hours - 0);
					item.form.is_parent(data.children && Object.keys(data.children).length > 0);
					(data.is_milestone - 0) && item.form.is_milestone(!!(data.is_milestone - 0));
					// item.form.is_milestone(false);
					data.order_id && item.form.order_id(data.order_id);
				}
			};

			self.onBlur = function (item, parent) {
				if (item.form.name() != "" && parent.items && parent.items().indexOf(item) == parent.items().length - 2) {
					parent.items.push(new _this.TaskContentModel(null, parent));
				}
				if (!item.form.task_id() && !item.form.task_number() && item.form.name() != "") {
					item.form.task_number(_this.appModel.new_id());
					_this.appModel.new_id(Number(_this.appModel.new_id()) + 1);
				}
			};

			self.getCommonData = function () {
				$("#contextMenu, #contextMenu > .dropdown-menu").hide();

				if (_this.appModel.selectedItem() == null) {
					return false;
				}
				var tmpItem = _this.appModel.selectedItem(), tmpItems = _this.appModel.selectedItems();

				// if (tmpItems.length > 0)
				// {
				// // for (vat len)
				// }
				var ret = {
					item: tmpItem,
					listArr: tmpItem.parent().items || tmpItem.parent().children
				};

				ret.index = ret.listArr().indexOf(tmpItem);

				return ret;
			};

			self.moveUp = function () {
				self.gridify_params().scope.trigger("up");
			};
			var _moveUp = function (target, elem) {
				var cData = self.getCommonData(true);
				var prevTR = elem.parent("tr").prev();

				if (!cData || !prevTR.get(0) || !cData.item.form.task_number() || cData.index <= 0) {
					return false;
				}

				var tbody = prevTR.parent();
				var targetName = elem.attr("target");
				// var listArr = cData.listArr,
				// index = cData.index;

				// var currentItem = cData.item; // listArr.splice(index, 1)[0];

				var context = ko.contextFor(prevTR.get(0));
				var prevItem = context.$data;
				var pIndex = cData.listArr.indexOf(prevItem);

				elem = null;
				if (prevItem.parent() != cData.item.parent() && context.$parents.length > 1) {
					// Get index of currentItem parent in previous items parents
					// array.
					pIndex = context.$parents.indexOf(cData.item.parent());

					// check index is > 0 (pIndex-0 is a root item)
					if (pIndex > 0 && context.$parents[pIndex - 1]) {
						prevItem = context.$parents[pIndex - 1];
						pIndex = cData.listArr.indexOf(prevItem);
					}
					elem = "tr.num_" + cData.item.form.task_number() + " td[target='" + targetName + "']";
				}

				if (!cData.item || !prevItem || !prevItem.form.task_number()) {
					return false;
				}

				cData.listArr.splice(cData.index, 1);
				// cData.listArr.splice(cData.index - 1, 0, cData.item);
				cData.listArr.splice(pIndex, 0, cData.item);
				// swap order id.
				// var tmpOrderId = prevItem.form.order_id();
				// prevItem.form.order_id(cData.item.form.order_id());
				// cData.item.form.order_id(tmpOrderId);
				Otime.Swap(cData.item.form.order_id, prevItem.form.order_id);

				// if (!_this.history.flag)
				// {
				// _this.history.undoArr.push({
				// item: cData.item,
				// type: "MVUP"
				// });
				// }

				self.startSaveTimer();

				if (self.is_gantt()) {
					_this.applyLinks();
				}

				if (elem) {
					elem = $(elem, tbody);
					return elem;
				}

				return true;
			};

			self.moveDown = function () {
				self.gridify_params().scope.trigger("down");
			};

			var _moveDown = function (target, elem) {
				var cData = self.getCommonData(true);
				var trElem = elem.parent("tr");
				var nextTR = trElem.next();

				if (!cData || !cData.item || !nextTR.get(0)) {
					return false;
				}

				// var prevTR = elem.parent("tr").prev();
				var tbody = nextTR.parent("tbody");

				var targetName = elem.attr("target");
				if (trElem.attr("level") != nextTR.attr("level")) {
					nextTR = $(trElem.nextAll("[level*='" + trElem.attr("level") + "']").get(0));
				}

				// var listArr = cData.listArr,
				// index = cData.index;
				// var currentItem =
				// cData.item;//listArr()[index];//listArr.splice(index, 1)[0];

				// if (!prevTR.get(0))
				// {
				// nextTR = $("tr:first-child", tbody);
				// }
				// else
				// {
				// nextTR = prevTR.next();
				// }

				// var context = ko.contextFor(nextTR.get(0));
				// var nextItem = context.$data;

				var nextItem = ko.contextFor(nextTR.get(0)).$data;
				var nIndex = cData.listArr.indexOf(nextItem);

				/*
				 * if (nextItem.parent() != cData.item.parent() &&
				 * context.$parents.length > 1) { // Get index of currentItem
				 * parent in previous items parents array. nIndex =
				 * context.$parents.indexOf(cData.item.parent());
				 *  // check index is > 0 (0 is a root item) if (nIndex > 0 &&
				 * context.$parents[nIndex - 1]) { nextItem =
				 * context.$parents[nIndex - 1]; } // nIndex =
				 * listArr.indexOf(nextItem); elem = "tr.num_" +
				 * cData.item.form.task_number() + " td[target='" + targetName +
				 * "']"; }
				 */

				// if (nextItem.parent() == cData.item)
				// {
				// nextItem = cData.listArr()[cData.index + 1];
				// }
				if (!nextItem || !nextItem.form.task_number()) {
					return false;
				}

				cData.listArr.splice(cData.index, 1);
				cData.listArr.splice(nIndex, 0, cData.item);
				// listArr.splice(nIndex+1, 0, currentItem);

				// update order id if not have next item.
				if (!nextItem.form.order_id()) {
					nextItem.form.order_id(cData.item.form.order_id() + 1);
				}

				// swap order id.
				// var tmpOrderId = nextItem.form.order_id();
				// nextItem.form.order_id(cData.item.form.order_id());
				// cData.item.form.order_id(tmpOrderId);
				Otime.Swap(cData.item.form.order_id, nextItem.form.order_id);

				self.startSaveTimer();

				elem = "tr.num_" + cData.item.form.task_number() + " td[target='" + targetName + "']";

				if (self.is_gantt()) {
					_this.applyLinks();
				}

				if (elem) {
					elem = $(elem, tbody);
					return elem;
				}

				return true;
			};

			var updateOrderIds = function (list, item) {
				$.each(list(), function (key, val) {
					if (val.form) {
						val.form.order_id(key + 1);
					}
					//if (val.form && (val.form.task_id() || val.form.name()))
					//	val.form.order_id(key + 1);
				});
				// swap order id.
				// var tmpOrderId = nextItem.form.order_id();
				// nextItem.form.order_id(currentItem.form.order_id());
				// currentItem.form.order_id(tmpOrderId);
			};

			self.insertAbove = function (item) {
				self.gridify_params().scope.trigger("ctrlInsertA");
			};
			var _insertAbove = function () {
				var cData = self.getCommonData();

				if (!cData) {
					return false;
				}

				var listArr = cData.listArr,
					index = cData.index,
					item = cData.item,
					parent = cData.item.parent(),
					newItem = new _this.TaskContentModel(null, parent);

				if (parent.children) {
					if (parent.is_closed()) {
						return false;
					}
					newItem.form.parent_task_id(parent.form.task_id() || parent.form.task_number());
				}
				else {
					newItem.form.parent_task_id(0);
				}

				listArr.splice(index, 0, newItem);
				updateOrderIds(listArr);
				if (self.is_gantt()) {
					_this.applyLinks();
				}
			};

			self.insertBelow = function () {
				self.gridify_params().scope.trigger("ctrlInsertB");
			};
			var _insertBelow = function () {
				var cData = self.getCommonData(true);

				if (!cData) {
					return false;
				}

				var listArr = cData.listArr, index = cData.index, item = cData.item, parent = cData.item.parent(), newItem = new _this.TaskContentModel(null, parent);

				if (parent.children) {
					if (parent.is_closed()) {
						return false;
					}
					newItem.form.parent_task_id(parent.form.task_id() || parent.form.task_number());
				}
				else {
					newItem.form.parent_task_id(0);
				}

				listArr.splice(index + 1, 0, newItem);
				updateOrderIds(listArr);
				if (self.is_gantt()) {
					_this.applyLinks();
				}
			};

			self.indent = function () {
				self.gridify_params().scope.trigger("i");
			};
			var _indent = function (target, elem) {
				var cData = self.getCommonData(true);

				var prevTR = elem.parent("tr").prev();

				if (!cData || !prevTR.get(0)) {
					return false;
				}

				var listArr = cData.listArr, index = cData.index;

				var currentItem = cData.item; // listArr.slice(index,
				// index+1)[0];
				var context = ko.contextFor(prevTR.get(0));

				// prevItem = previous row data.
				var prevItem = context.$data;
				// check, is already indented to the previous row item
				if (prevItem == currentItem.parent()) {
					return false;
				}

				if (prevItem.parent() != currentItem.parent() && context.$parents.length > 1) {
					// Get index of currentItem parent in previous items parents
					// array.
					var pIndex = context.$parents.indexOf(currentItem.parent());

					// check index is > 0 (0 is a root item)
					if (pIndex > 0 && context.$parents[pIndex - 1]) {
						prevItem = context.$parents[pIndex - 1];
					}
				}

				// prevItem = ko.dataFor(prevTR.get(0));//
				// listArr.slice(index-1, index)[0];
				if (!currentItem || !prevItem || !prevItem.form.task_number() || prevItem.is_closed() || (!prevItem.form.is_parent() && prevItem.form.worked_hours() - 0)
					|| (currentItem.parent().is_closed && currentItem.parent().is_closed())) {
					if (!prevItem.form.is_parent() && prevItem.form.worked_hours() - 0) {
						alert("Timesheet posted tasks can't be a parent.");
					}
					return false;
				}

				var order_id = 1;
				if (prevItem.children) {
					var tmp1 = prevItem.children()[prevItem.children().length - 1];
					if (tmp1 && tmp1.form) {
						order_id = prevItem.children()[prevItem.children().length - 1].form.order_id() - 0;
					}
					order_id++;
					prevItem.children.push(currentItem);
				}
				else if (prevItem.items) {
					prevItem.items.push(currentItem);
				}

				prevItem.form.is_parent(true);
				prevItem.calcEstimate();
				currentItem.parent(prevItem);
				//				prevItem.form.task_status_id.originalValue	= "";
				currentItem.form.parent_task_id(prevItem.form.task_id() || prevItem.form.task_number());
				listArr.splice(index, 1);

				/*
								var child	= prevItem.children();
				console.log("Here 1 : ", prevItem.form.name());
								if (child.length > 0)
								{
				console.log("Here 2 : ", child[child.length-1].form.name(), child[child.length-1].form.order_id());
									order_id	= child[child.length-1].form.order_id()-0;
								}
				*/
				currentItem.form.order_id(order_id);
				_this.ReArrangeDate(currentItem);

				// by default add parent followers to child followers
				// var tmp_follow = prevItem.form.followers();//$.merge(prevItem.form.followers(),currentItem.form.followers());
				var follow = currentItem.form.followers();
				// $.each(tmp_follow, function(key, val) {
				$.each(prevItem.form.followers(), function (key, val) {
					if (follow.indexOf(val) == -1) {
						follow.push(val);
					}
				});
				currentItem.form.followers(follow);

				if (self.is_gantt()) {
					_this.applyLinks();
				}
			};

			var getNextOrPrevItem = function (item, isPrev) {
				var arr = item.parent().children;
				if (!arr && item.parent().items) {
					arr = item.parent().items;
				}
				var index = arr.indexOf(item);

				if (isPrev) {
					return (!index ? null : arr()[index - 1]) || null;
				}

				return arr()[index + 1] || null;
			};

			self.outdent = function () {
				self.gridify_params().scope.trigger("u");
			};
			var _outdent = function () {
				var cData = self.getCommonData(true);

				if (!cData || cData.item.parent().items) {
					return false;
				}

				var listArr = cData.listArr, index = cData.index, parent = cData.item.parent() || null, gparent = cData.item.parent().parent() || null, currentItem = listArr.slice(index, index + 1)[0];

				currentItem.parent(gparent);

				if (gparent.items) {
					currentItem.form.parent_task_id(0);
					gparent.items.splice(gparent.items.indexOf(parent) + 1, 0, currentItem);
				}
				else {
					gparent.form.is_parent(true);
					currentItem.form.parent_task_id(gparent.form.task_id() || gparent.form.task_number());
					gparent.children.splice(gparent.children.indexOf(parent) + 1, 0, currentItem);
				}

				listArr.splice(index, 1);

				// Update order ID.
				var prevItem = getNextOrPrevItem(currentItem, true);
				currentItem.form.order_id(prevItem.form.order_id() + 1);

				// updateOrderIds(listArr());

				if (parent.form) {
					parent.form.is_parent(parent.children().length > 0);
				}
				parent.calcEstimate();
				_this.ReArrangeDate(currentItem);

				// while indent empty last row will add, need to remove that when OutDent the task.
				if (parent.children().length > 0) {
					var lastItem = parent.children()[parent.children().length - 1];
					if (lastItem && !lastItem.form.task_id()) {
						parent.children.remove(lastItem);
					}
				}
				// _this.history.flag = false;
				// _this.history.iFlag = false;
				if (self.is_gantt()) {
					_this.applyLinks();
				}
			};

			// self.undo = _this.history.undo;
			// self.redo = _this.history.redo;

			self.zoomIn = function () {
				_this.appModel.gantt && _this.appModel.gantt.zoomGantt(true);
				self.zoomLevel(_this.appModel.gantt.zoom);
				if(self.zoomLevel()!="m"){					
					if(self.is_user_grid()==true){
						self.is_user_grid(false);
						_this.grid_container.css({
							height: "calc(93%)"
						});						
					}
				}
			};

			self.zoomOut = function () {
				_this.appModel.gantt && _this.appModel.gantt.zoomGantt(false);
				self.zoomLevel(_this.appModel.gantt.zoom);
				if(self.zoomLevel()!="m"){
					if(self.is_user_grid()==true){
						self.is_user_grid(false);
						_this.grid_container.css({
							height: "calc(93%)"
						});	
					}
				}
			};

			self.isSingleField = Otime.o(!!(Otime.Storage.get("task_single_field_copy", "0") - 0));
			self.selectRow = function (itm, elem) {
				self.isSingleField(!self.isSingleField());
				Otime.Storage.set("task_single_field_copy", self.isSingleField() ? 1 : 0);
				$("#contextMenu, #contextMenu > .dropdown-menu").hide();
				return false;
			};

			// var txtItems = ["name", "task_type_id", "start_date",
			// "finish_date", "duration", "task_status_id", "assignee"];
			var toText = function (item, indent) {
				var ret = "";
				ret += (item.form.name() || "#") + "\t";
				ret += (item.form.task_type_name() || "#") + "\t";
				ret += (item.form.duration() || "#") + "\t";
				ret += (item.form.start_date() || "#") + "\t";
				ret += (item.form.finish_date() || "#") + "\t";
				ret += (item.form.estimated_hours() || "0") + "\t";
				ret += (item.form.worked_hours() || "0") + "\t";
				ret += (item.status().name || "#") + "\t";
				ret += (item.form._info.assignee_disp() || "#") + "\t";
				ret += (item.form._info.followers_disp() || "#") + "\t";
				ret += (item.form.is_archived() || "#") + "\t";

				ret += (indent || "0") + "\t";

				/*
								// is children column
								if (item.parent().is_root) {
									ret += "0\t";
								} else {
									ret += "1\t";
								}
				
								// is parent column (has children)
								if (item.children().length > 0) {
									ret += "1\t";
								} else {
									ret += "0\t";
								}
				*/
				return $.trim(ret);
			};

			var pars = [];
			var getParents = function (item) {
				pars.unshift(item);

				if (item.parent) {
					getParents(item.parent());
				}
			};
			var level = function (item) {
				if (item.parent() && item.parent().is_root) {
					return 0;
				}

				if (pars.indexOf(item.parent()) > -1) {
					return 0;
				}

				return 1 + level(item.parent());
			};

			var getCopyContent = function (itms, childFlag, isClone, fnToText) {
				if (itms.length) {
					var cnt = "";
					if (isClone) {
						cnt = [];
					}

					var txt = "";

					if (!childFlag) {
						pars = [];
						getParents(itms[0].parent());
					}

					fnToText = fnToText || toText;

					for (var i = 0, ln = itms.length; i < ln; i++) {
						var lvl = level(itms[i]);

						if (isClone) {
							txt = itms[i].form.task_id();
							cnt.push(txt);
						} else {
							txt = fnToText(itms[i], lvl);
							cnt += txt ? txt + "\n" : "";
						}

						if ((!itms[i].show_child() || childFlag) && itms[i].children().length > 0) {
							if (isClone) {
								cnt = $.merge(cnt, getCopyContent(itms[i].children(), true, isClone, fnToText))
							} else {
								cnt += getCopyContent(itms[i].children(), true, isClone, fnToText);
							}
						}
					}

					return cnt;
				}

				return "";
			};

			self.cloneTasks = function () {
				var copyCnt = self.copy(null, null, true);

				if (typeof copyCnt === "string") {
					self.gridify_params().scope.copyText(copyCnt);
				}

				return true;
			};

			self.copy = function (e, clipBrd, isClone) {
				if (self.isSingleField()) {
					return true;
				}

				var itms = _this.appModel.selectedItems();
				if (!itms.length && _this.appModel.selectedItem()) {
					itms = [_this.appModel.selectedItem()];
				}

				var copyCnt = "";
				copyCnt = getCopyContent(itms, null, isClone);

				if (isClone) {
					copyCnt = "CLONE:" + copyCnt.join(",");
					Otime.Storage.set("clipboard", copyCnt);
				}

				clipBrd && clipBrd.val && clipBrd.val(copyCnt);

				return copyCnt;
			};

			self.cut = function (e, clipBrd) {
				return self.copy(e, clipBrd, true);
			};

			var fromText = function (text, item) {
				var ret = {};
				text = text.split("\t");

				isEditFromGrid = true;
				item.form.name(text[0]);
				// item.form.task_type_name(text[1]);
				text[1] && item.form.task_type_id(_this.ttypeByName[text[1]]);
				// item.form.duration(text[4]);
				if (text[3] && (text[3].match(/(\d{4})\/(\d{2})\/(\d{2})/) || []).length == 4) {
					item.form.start_date(text[3]);
				}
				if (text[4] && (text[4].match(/(\d{4})\/(\d{2})\/(\d{2})/) || []).length == 4) {
					item.form.finish_date(text[4]);
				}
				text[5] && item.form.estimated_hours((text[5] - 0) || "");
				// _this.tstatByName[text[6]]-0);
				item.form.task_status_id(text[7] ? _this.tstatByName[text[7]] : _this.appModel.default_status);

				text[8] && item.form.assignee_id(_this.tUsersByName[$.trim(text[8]).trim()] || 0);

				if (text[9]) {
					text[9] = text[9].split(",");
					var assig = [], usr_id = 0;
					for (var i = 0, len = text[9].length; i < len; i++) {
						usr_id = _this.tUsersByName[$.trim(text[9][i]).trim()] || 0;
						usr_id && assig.push(usr_id);
					}
					item.form.followers(assig);
				}
				if (text[10] && _this.appModel.is_archived()) {
					item.form.is_archived(text[10]);
				}

				if (text[11]) {
					item.indentLevel = text[11];
				}

				/*
								// is children
								if(text[11] != "0") {
									// get last item & set it as parent for current.
									// get last item id & assign it in parent_task_id()
									// item.form.is_parent(true);
									item.isChild = true;
								} else {
									item.isChild = false;
								}
				
								// has children (is parent)
								if(text[12] != "0") {
									// item.form.is_parent(true);
									item.hasChild = true;
								} else {
									item.hasChild = false;
								}
				*/
				isEditFromGrid = false;

				return ret;
			};

			self.paste_new = function (e, copyCnt) {
				// var copyCnt = Otime.Storage.get("clipboard");

				var cnt = copyCnt;// || clipBrd.val();
				cnt = $.trim(cnt);
				if (!cnt) {
					return;
				}

				cnt = cnt.split(",");
				var tmpArr = [], allItems = Object.values(_this.getAllItems());
				var postData = {
					task_ids: cnt,
					project_id: self.project_id()
				};

				Otime.app.postData(new Otime.ContextModel("tclone", postData, function (cont) {
					var response = cont.response;
					refreshFlag = false;
					_this.Refresh();
				}));

				// Clear Clipboard Storage
				Otime.Storage.set("clipboard", "");
			};

			self.pasteClone = function () {
				// copyCnt = self.gridify_params().scope.pasteText();
				var copyCnt = Otime.Storage.get("clipboard");
				Otime.Storage.set("clipboard", "");

				if (copyCnt.substr(0, 6) == "CLONE:") {
					copyCnt = copyCnt.replace("CLONE:", "");
					self.paste_new(null, copyCnt);
				}

				return true;
			};

			self.paste = function (e, clipBrd) {
				if (!clipBrd || !clipBrd.val) {
					return true;
				}

				var cnt = clipBrd.val();
				if (cnt.substr(0, 6) == "CLONE:") {
					cnt = cnt.replace("CLONE:", "");
					self.paste_new(e, cnt);
					return true;
				}

				var tmpArr = [], allItems = Object.values(_this.getAllItems());

				cnt = cnt.split("\n");
				if (cnt.length < 0) {
					return false;
				}

				var itms = _this.appModel.selectedItems();
				if (itms.length) {
					// for (var i=0, len=cnt.length; i<len; i++)
					// {
					// cnt[i] && tmpArr.push(fromText(cnt[i]));
					// }
					return true;
				}
				itms = _this.appModel.selectedItem();

				var gridify = self.gridify_params().scope;
				var cur = gridify.target.parent();
				for (var i = 0, len = cnt.length; i < len; i++) {
					if (cnt[i]) {
						itms = ko.dataFor(cur.get(0));
						fromText(cnt[i], itms);

						tmpArr.push(itms);

						if (!itms.form.task_id() && !itms.form.task_number() && itms.form.name() != "") {
							itms.form.task_number(_this.appModel.new_id());
							_this.appModel.new_id(Number(_this.appModel.new_id()) + 1);

							if (!itms.form.order_id()) {
								var childs = null;
								var prev = null;
								if (itms.parent().children) {
									childs = itms.parent().children();
								}
								else if (itms.parent().items) {
									childs = itms.parent().items();

									if (childs.indexOf(itms) > (childs.length - 5)) {
										self.insertNew(null, 5);
									}
								}
								prev = childs[childs.indexOf(itms) - 1];
								itms.form.order_id(prev ? prev.form.order_id() + 1 : 1);
							}
						}

						cur.next().get(0) || self.insertNew(null, 5);
						cur = cur.next();
					}
				}

				self.save(function () {
					changed_data = {};
					new_items = {};

					var parents = [], par = null, oldPar = null;

					$.each(tmpArr, function (key, val) {
						parents[val.indentLevel] = val;
						if (val.indentLevel > 0) {
							oldPar = val.parent();

							par = parents[val.indentLevel - 1];
							val.form.parent_task_id(par.form.task_id());
							par.children.push(val);
							val.parent(par);

							oldPar.items.remove(val);
						}
					});

					self.save();
				});
			};

			// Task Template Start
			var getTemplateContent = function () {
				var itms = _this.appModel.selectedItems();
				if (!itms.length && _this.appModel.selectedItem()) {
					itms = [_this.appModel.selectedItem()];
				}

				var tasks = [];
				recursiveItems(itms, null, function (itm) {
					tasks.push(itm.form.task_id());
				});

				return tasks;
			};

			var insertTemplate = function (tmplId) {
				var currItm = _this.appModel.selectedItem();

				Otime.app.loadData(new Otime.ContextModel("tmpl", {
					tmplId: tmplId,
					project_id: self.project_id(),
					orderFrom: currItm.form.order_id(),
					insertAfter: currItm.form.task_id()
				}, function (cont) {
					if (!cont.response || !cont.response.tasks) {
						return;
					}

					var parent = currItm.parent();
					var listItems = null;
					if (parent.items) {
						listItems = parent.items;
					}
					else if (parent.children) {
						listItems = parent.children;
					}
					var idx = listItems.indexOf(currItm), cnt = 0;

					// Grap & Insert the items into list
					cont.response.tasks.otvalues.setKeys(cont.response.tasks.otkeys, function (itm) {
						var tmp_task = new _this.TaskContentModel(itm, self);
						tmp_task.show_child(false);
						listItems.splice(++idx, 0, tmp_task);
						cnt++
					});

					// Select the inserted tasks
					var elems = $("#task-table1 .num_" + currItm.form.task_number()).nextAll("*:lt(" + cnt + ")");
					elems.addClass("active");
					elems = $("#task-table2 .num_" + currItm.form.task_number()).nextAll("*:lt(" + cnt + ")");
					elems.addClass("active");
				}));
			};

			var taskTmplModel = null;

			self.tmplInsert = function (e) {
				Otime.app.loadData(new Otime.ContextModel("tmpls", {}, function (cont) {
					var resp = cont.response;
					if (resp.items && resp.items.otkeys && resp.items.otvalues && Object.keys(resp.items.otvalues).length > 0) {
						resp.items = resp.items.otvalues.setKeys(resp.items.otkeys);

						var taskTmplModal = $("#tasks-tmpl-modal");
						var container = $("#modal-content", taskTmplModal);

						if (!ko.dataFor(container.get(0))) {
							taskTmplModel = {
								tmpls: Otime.a(resp.items),
								selected: Otime.o(),
								select: function (e) {
									taskTmplModel.selected(e);
								},
								deleteTmpl: function (e) {
									self.tmplDelete(e);
								},
								insert: function (e) {
									if (taskTmplModel.selected()) {
										insertTemplate(taskTmplModel.selected().id);
										taskTmplModal.modal("hide");
									}
								},
								close: function (e) {
									taskTmplModal.modal("hide");
								}
							};

							ko.applyBindings(taskTmplModel, container.get(0));
						} else {
							taskTmplModel.tmpls(resp.items);
						}

						if (taskTmplModal.data('bs.modal')) {
							taskTmplModal.modal("show");
						} else {
							taskTmplModal.modal();
						}
					}
				}));
			};

			self.tmplDelete = function (e) {
				if (!e || !e.id) {
					return false;
				}

				if (!confirm("Are you sure to delete the selected task template ?")) {
					return false;
				}

				Otime.app.loadData(new Otime.ContextModel('deletetmpl/' + e.id, null, function (cont) {
					var resp = cont.response;
					taskTmplModel.tmpls.remove(e);
				}), true);
			};

			self.tmplSave = function (e) {
				var data = {
					name: prompt("Enter Template Name")
				};

				if (!data.name) {
					return;
				}

				// data.tasks = self.copy(e);
				data.tasks = getTemplateContent();

				Otime.app.postData(new Otime.ContextModel("savetmpl", data, function (cont) {
					var resp = cont.response;
					/*
					if (resp.id) {
					}
					*/
				}));
			};


			// Task Template End

			// self.changedData = [];
			self.deletedItems = [];
			self.deletedItemsIds = [];
			// self.deletedNewItems = [];
			self.clone = Otime.a([]);
			// var cloneArr = [];
			self.parentIndex = 0;
			/*
						self.prepareData = function(){
							// self.clone([]);
							cloneArr = [];
							self.changedData = [];
							self.deletedItemsIds = [];
							self.makeData(self.items());
			
							if (self.deletedNewItems.length > 0)
							{
								for (var i = 0; i < self.deletedNewItems.length; i++)
								{
									self.items.remove(self.deletedNewItems[self.deletedNewItems[i]]);
								}
								self.deletedNewItems = [];
							}
			
							return {
								items : self.changedData,
								deletedItems : self.deletedItemsIds,
								project_id : self.project_id()
							};
						};
			
						var fieldsToUpdateOriValue = [];
						var getChangedData = function(item){
							var ret = {};
							// ret.project_id = (_this.appModel.project_id()-0);
							// ret.task_id = item.form.task_id();
			
							var task_id = item.form.task_id();
			
							var arr = [ "task_type_id", "name", "description", "task_number", "parent_task_id", "duration", "task_status_id", "start_date", "finish_date", "estimated_hours", "predecessors", "assignee_id",
								"followers", "notes", "is_billable", "is_parent", "is_milestone", "order_id", "percentage_complete", "task_priority" ];
			
							for (var i = 0, tmpItmProp, len = arr.length; i < len; i++)
							{
								tmpItmProp = item.form[arr[i]];
								if (!task_id || !tmpItmProp.isDirty || tmpItmProp.isDirty())
								{
									switch (arr[i])
									{
										case "start_date":
										case "finish_date":
											ret.start_date = ret.start_date || new Date(item.form.start_date()).format("YYYY-MM-DD");
											ret.finish_date = ret.finish_date || new Date(item.form.finish_date()).format("YYYY-MM-DD");
											break;
										case "is_parent":
											ret.is_parent = (item.form.is_parent() - 0);
											break;
										case "is_milestone":
											ret.is_milestone = (item.form.is_milestone() - 0);
											break;
										case "is_closed":
											ret.is_closed = item.status().is_closed || 0;
											break;
										case "followers":
											ret.followers = item.form.followers();
											if (!ret.followers || !ret.followers.length)
											{
												ret.followers = [ null ];
											}
											break;
										default:
											ret[arr[i]] = tmpItmProp();
											break;
									}
									if (tmpItmProp.isDirty && tmpItmProp.isDirty())
										fieldsToUpdateOriValue.push(tmpItmProp);
									// ret['name'] = item.form['name'];
								}
							}
			
							if (Object.keys(ret).length > 0)
							{
								ret.project_id = (_this.appModel.project_id() - 0);
								ret.task_id = task_id;
								self.changedData.push(ret);
								return true;
							}
			
							return false;
						};
			
						/**
						 * Recursive data preparation for AJAX Save.
						 *
						self.makeData = function(items){
							var tmp = null;
							var val = null;
			
							for (var i = 0, iLen = items.length; i < iLen; i++)
							{
								val = items[i];
								if (val._destroy)
								{
									if (Number(val.form.task_id()) > 0)
									{
										self.deletedItemsIds.push(val.form.task_id());
										self.deletedItems.push(items[i]);
									}
									else
									{
										self.deletedNewItems.push(val);
									}
									continue;
								}
			
								// if (!val.form.task_type_id())
								// {
								// var ttypeId = (i > 0) ? items[i-1].form.task_type_id() :
								// self.task_types()[1].id();
								// val.form.task_type_id(0);
								// }
			
								if ($.trim(val.form.name()) != "" && val.isDirty())
								{
									cloneArr.push(val);
									getChangedData(val);
								}
			
								if (val.children().length > 0)
								{
									self.makeData(val.children());
								}
							}
						};
			
						var updateOriginalValue = function(obser){
							obser.originalValue = obser();
							if ($.isArray(obser.originalValue))
							{
								obser.originalValue = JSON.parse(JSON.stringify(obser.originalValue));
							}
						};
			*/
			self.quickSave = function () {
				// console.log("Quick Save : ", _this.appModel.is_detail(), isEditFromGrid);
				if (!isEditFromGrid && !_this.appModel.is_detail()) {
					self.save();
				}
			};

			var timerId = null;
			self.startSaveTimer = function (clbk) {
				if (timerId) {
					clearTimeout(timerId);
				}

				timerId = setTimeout(function () {
					self.save(clbk);
				}, 2000);
			};

			var saveFlag = false;
			self.save = function (clbk) {
				var keys = Object.keys(changed_data);
				if (!keys.length && !self.deletedItemsIds.length) {
					clbk && typeof clbk === "function" && clbk();
					return true;
				}

				if (saveFlag) {
					return false;
				}
				saveFlag = true;

				var data = {
					items: Object.values(changed_data),
					deletedItems: self.deletedItemsIds,
					project_id: self.project_id()
				};
				changed_data = {};
				var newItems = new_items;
				new_items = {};

				// data = self.prepareData();

				if (!data.items.length && !data.deletedItems.length) {
					saveFlag = false;
					clbk && typeof clbk === "function" && clbk();
					return false;
				}
				$("#box3-body").attr('disabled', true);
				Otime.app.postData(new Otime.ContextModel("save", data, function (cont) {
					var response = cont.response;
					var tmp = "";

					if (response.deleted_ids && response.deleted_ids.length == self.deletedItems.length) {
						$.each(self.deletedItems, function (key, val) {
							val.parent() && val.parent().items && val.parent().items.remove(val);
							val.parent() && val.parent().children && val.parent().children.remove(val);
						});

						self.deletedItems = [];
						self.deletedItemsIds = [];
					}

					if (newItems && Object.keys(newItems).length > 0) {
						if (response.map_ids && Object.keys(response.map_ids).length > 0) {
							$.each(newItems, function (key, val) {
								if (tmp = response.map_ids[val.form.task_number()]) {
									val.form.task_number(tmp[0] - 0);
									val.form.task_id(tmp[1] - 0);
									val.form.parent_task_id(tmp[2] - 0);
								}
							});
						}
						newItems = {};
					}

					/*
										// $.each(self.clone(), function(key, val){
										$.each(cloneArr, function(key, val){
											if (response.map_ids && Object.keys(response.map_ids).length > 0)
											{
												if (tmp = response.map_ids[val.form.task_number()])
												{
													val.form.task_number(tmp[0]);
													val.form.task_id(tmp[1]);
													val.form.parent_task_id(tmp[2]);
												}
											}
					/*
											for (var i = 0, iLen = fieldsToUpdateOriValue.length; i < iLen; i++)
											{
												updateOriginalValue(fieldsToUpdateOriValue[i]);
											}
											fieldsToUpdateOriValue = [];
					* /
											if (response.predecessors && Object.keys(response.predecessors).length > 0 && response.predecessors[val.form.task_id()])
											{
												val.form.predecessors(response.predecessors[val.form.task_id()]);
											}
										});
					*/
					response.new_id && _this.appModel.new_id(Number(response.new_id));

					currSubcribe = [];

					Otime.Menu.isAllow(0);
					saveFlag = false;
					$("#box3-body").removeAttr('disabled');

					if (self.isPane() && self.selectedItem().form.task_id()) {
						var targ = self.selectedItem();
						if (!targ.form.task_id()) {
							return;
						}
						_INITIALIZE_COMMENTS(targ, self);
					}
					clbk && typeof clbk === "function" && clbk();
				}, null, function (err) {
					// on Error
					if (self.deletedItems.length > 0) {
						self.items.valueWillMutate();
						$.each(self.deletedItems, function (key, val) {
							val._destroy = false;
						});
						self.items.valueHasMutated();
						self.deletedItems = [];
						self.deletedItemsIds = [];
					}
					saveFlag = false;
				}));
			};

			self.saveStatus = function (item) {
				if (item.form.task_id()) {
					self.save();
				}
			};

			var recursive = function (list, clbk) {
				if (typeof clbk != "function") {
					return false;
				}
				var val = "";
				for (var i = 0, iLen = list.length; i < iLen; i++) {
					val = list[i];
					if (val.form.task_number()) {
						if (clbk(val) && val.children() && val.children().length > 0) {
							recursive(val.children(), clbk);
						}
					}
				}
			};

			var recursiveArchive = function (itm, isArchived) {
				if (itm.form.task_id() - 0) {
					itm.form.is_archived(isArchived);
					itm.form.parent_task_id(0);
					if (itm.children().length > 0) {
						recursive(itm.children(), function (val) {
							val.form.is_archived(isArchived);
							return true;
						});
					}

					(itm.parent().items || itm.parent().children).destroy(itm);
				}
			};

			self.archive = function () {
				var cData = self.getCommonData(true);

				if (!cData.item || !cData.item.is_editable() || !cData.item.form.task_number())// || !cData.item.form.task_id()
				{
					return false;
				}

				if (cData.item.form.is_archived()) {
					return _deleteItem();
				}

				if (!confirm("Are you sure you want to archive that selected task ?\n\nNote: Time entries for this task will remain. Only the task will be archived.")) {
					return false;
				}


				if (self.selectedItems().length > 0) {
					var items = self.selectedItems();
					$.each(items, function (key, val) {
						recursiveArchive(val, true);
						removePredecessors(val);
					});
				}
				else {
					recursiveArchive(cData.item, true);
					removePredecessors(cData.item);
				}

				self.save(function () {
					if (self.is_gantt()) {
						_this.applyLinks();
					}
				});
			};

			self.unArchive = function () {
				var cData = self.getCommonData(true);
				// cData.item.form.is_archived(false);
				// cData.listArr.destroy(cData.item);

				recursiveArchive(cData.item, false);
				self.save();
			};

			self.deleteItem = function () {
				// self.gridify_params().scope.trigger("delete");
				_deleteItem();
				self.save();
			};

			var removePredecessors = function (item) {
				var taskNum = item.form.task_number();
				var allTaskNum = Object.keys(_this.getAllItems(item.children(), true, "task_number")) || [];
				allTaskNum.push(taskNum);
				var value = "", expr = new RegExp("(" + allTaskNum.join("|") + ")(FF|SS|FS|SF)");

				recursive(_this.appModel.items(), function (item) {
					if (allTaskNum.indexOf(item.form.task_number()) >= 0) {
						return false;
					}
					value = item.form.predecessors();
					if (value && value.match(expr) != null) {
						var arr = value.split(","), newArr = [];
						if (arr.length > 0) {
							for (var i = 0; i < arr.length; i++) {
								if (arr[i] && arr[i].match(expr) == null) {
									newArr.push(arr[i]);
								}
								else {
									$("[from='" + arr[i].match(expr)[1] + "']").remove();
								}
							}
						}
						newArr = newArr.join(",");

						if (arr.join(",") != newArr) {
							item.form.predecessors(newArr);
						}
					}
					return true;
				});
			};

			var recursiveDelete = function (item, parentArr) {
				/* Check Predecessor begins */
				removePredecessors(item);
				/* Check Predecessor end */

				if (item.form.task_id() - 0) {
					if (item.children().length > 0) {
						$.each(item.children(), function (key, val) {
							recursiveDelete(val, item.children);
						});
					}

					if (self.deletedItemsIds.indexOf(item.form.task_id()) < 0) {
						self.deletedItemsIds.push(item.form.task_id());
						self.deletedItems.push(item);
						parentArr.destroy(item);
					}
				}
				else {
					parentArr.remove(item);
				}
			};

			var _deleteItem = function () {
				var cData = self.getCommonData(true);

				if (!cData.item || !cData.item.is_editable() || !cData.item.form.task_number()// || !cData.item.form.task_id()
					|| !confirm("Are you sure you want to delete that selected task ?\n\nNote: Time entries for this task will remain. Only the task will be deleted.")) {
					return false;
				}

				var items = [];
				if (self.selectedItems().length > 0) {
					items = self.selectedItems();
				}
				else {
					items = [cData.item];
				}

				$.each(items, function (key, val) {
					if (val.parent().children) {
						recursiveDelete(val, val.parent().children);
					} else if (val.parent().items) {
						recursiveDelete(val, val.parent().items);
					}
				});

				if (self.is_gantt()) {
					_this.applyLinks();
				}

				return true;
			};

			self.selectedItem.subscribe(function (newItem) {
				if (!newItem) {
					return;
				}

				self.is_detail(false);
				var tmp = _this.appModel.repeat_options();
				var is_enb = true;
				if (newItem.form.start_date()) {
					tmp[5].name('Every Month (on ' + weekAndDay(newItem.form.start_date()) + ')');
				} else {
					tmp[5].name('Every Month (on ' + weekAndDay(new Date()) + ')');
					//is_enb = false;
				}
				_this.appModel.repeat_options(tmp);
				$('#is_repeat').trigger("chosen:updated");
				self.save();
			});

			/*******************************************************************
			 * Editable box changes from here.
			 */
			var _Escape = function (e) {
				$("#hidder2, #hidder1, #hidder0, #popover-tah").css({
					left: -999,
					top: -999
				});
				$("#hidder2 select, #hidder1 select, #hidder0 select").trigger("chosen:close");
				$("#hidder2 input, #hidder2 select, #hidder1 input, #hidder1 select, #hidder0 input, #hidder0 select").unbind("change").unbind("blur");
				$("#hidder2 > *, #hidder1 > *, #hidder0 > *, #popover-tah").hide();
				$("body > .datepicker.datepicker-dropdown").remove();
				return true;
			};
			var editables = {};
			var taskId = 0;

			var fieldEditables = {};
			fieldEditables["text"] = function (key, field) {
				return function (elem, word) {
					var item = self.selectedItem();
					if (!item.is_editable()) {
						return true;
					}

					var _var = null;
					if (typeof field === "string" && item.form[field]) {
						_var = item.form[field];
					}
					else {
						_var = item.form.custom_values[key];
					}

					var parents = ko.contextFor(elem.get(0)).$parents;

					var isLast = elem.parent().is(":last-child");

					// var isLast = (elem.parent().parent().children("tr").length -
					// elem.parent().index()) <= 4
					var hidder = _this.isToDo ? "#hidder0" : "#hidder1";

					$(hidder + " #txt-normal").css({
						"padding-left": ((parents.length - 1) * 20) + 5
					}).show().val(word || _var() || "").unbind("blur").blur(function () {
						if ($.trim($(this).val()).trim()) {
							_var($(this).val());
							_this.grid_container.focus();
							if (isLast) {
								// Add new item here (for last row)
								self.insertNew(null, _this.isToDo ? 1 : 5);
							}
						}
					}).get(0).focus();
				};
			};

			fieldEditables["select"] = function (key, field) {
				return function (e, word, isClick, event, hidderElem) {
					var item = self.selectedItem();

					var _var = item.form.custom_values[key];

					if (item.form.is_parent()) {
						hidderElem.css({
							left: -999,
							top: -999
						});
						return true;
					}

					var selectBoxDiv = $(_this.isToDo ? "#hidder0" : "#hidder1" + " #" + key);
					var elem = $("select", selectBoxDiv);

					elem.val(_var()).unbind("change").change(function () {
						isEditFromGrid = true;
						_var($(this).val());
						isEditFromGrid = false;
						$(this).trigger("blur");
						_this.grid_container.focus();
						_Escape();
					}).chosen({
						imgSelect: true,
						search_contains: false,
						width: "100%",
						placeholder_text: 'select',
					}).trigger("chosen:updated");

					selectBoxDiv.show();
					var search_field = $(".chosen-search input", selectBoxDiv);
					search_field.val(word);
					$(".chosen-container .chosen-single", selectBoxDiv).trigger("mousedown");
					search_field.get(0).focus();
				};
			};

			fieldEditables["user"] = function (key, field) {
				return function (e, word, isClick, event, hidderElem) {
					var item = self.selectedItem();

					var _var = null;
					if (typeof field === "string" && item.form[field]) {
						_var = item.form[field];
					}
					else {
						_var = item.form.custom_values[key];
					}

					if (item.form.is_parent()) {
						hidderElem.css({
							left: -999,
							top: -999
						});
						return true;
					}

					var hidder = _this.isToDo ? "#hidder0" : "#hidder1";
					var elem = $(hidder + " #assignee_box select");

					elem.val(_var()).unbind("change").change(function () {
						isEditFromGrid = true;
						_var($(this).val());
						isEditFromGrid = false;
						$(this).trigger("blur");
						_this.grid_container.focus();
						_Escape();
					}).chosen({
						imgSelect: true,
						search_contains: false,
						width: "100%",
						placeholder_text: 'select',
					}).trigger("chosen:updated");

					$(hidder + " #assignee_box").show();
					var search_field = $(hidder + " #assignee_box .chosen-search input");
					search_field.val(word);
					$(hidder + " #assignee_box .chosen-container .chosen-single").trigger("mousedown");
					search_field.get(0).focus();
				};
			};

			fieldEditables["users"] = function (key, field) {				
				return function (e, word, isClick, event, hidderElem) {
					var item = self.selectedItem();
					
					var _var = null;
					if (typeof field === "string" && item.form[field]) {
						_var = item.form[field];
					}
					else {
						_var = item.form.custom_values[key];
					}

					/*if (item.form.is_parent())
					{
						hidderElem.css({
							left : -999,
							top : -999
						});
						return true;
					}*/

					var hideer = _this.isToDo ? "#hidder0" : "#hidder1", followersBox = $(hideer + " #followers_box"), elem = $("select", followersBox);
					elem.val(_var())
						.unbind("change").change(function (e, param) {
							var el = $(this);
							var val = el.val();
							if (val.indexOf("0") > -1) {
								el.val([]);
								el.trigger("chosen:updated");
							}

							if (val.indexOf("-1") > -1) {
								if (_var().indexOf("-1") > -1) {
									val.splice(val.indexOf("-1"), 1);
								} else {
									val = ["-1"];
								}

								el.val(val);
								el.trigger("chosen:updated");
							}

							isEditFromGrid = true;
							// item.form.followers(val || []);
							_var(val || []);
							isEditFromGrid = false;
							// _Escape();
							// $(this).trigger("blur");
							// _this.grid_container.focus();
						})
						.chosen({
							imgSelect: true,
							search_contains: true,
							width: "100%",
							placeholder_text: 'select',
						}).trigger("chosen:updated");
					
					followersBox.show();
					// $(hideer + " #assignees_box div ul li
					// input").val(word).get(0).focus();

					var _e = $("div ul li input", followersBox).get(0);
					_e.focus();

					// Due to issue in delay for applying module we have to use
					// settimeout fn for applying value.
					if (word) {
						setTimeout(function () {
							_e.value = word;
						}, 100);
					}
				};
			};

			fieldEditables["date"] = function (key, field) {
				return function (e, word) {
					var item = self.selectedItem();

					var _var = null;
					if (typeof field === "string" && item.form[field]) {
						_var = item.form[field];
					}
					else {
						_var = item.form.custom_values[key];
					}

					if (item.children().length > 0 || !item.is_editable()) {
						return true;
					}
					var elem = $("#hidder1 #date-picker input");
					$("#hidder1 #date-picker").show();

					if (elem.data("datepicker") != undefined) {
						elem.datepicker('remove');
					}

					elem.datepicker({
						weekviewMode: '',
						minViewMode: '',
						weekStart: Otime.Days.getPos(Otime.weekStart) - 1 || 0,
						endDate: null,
						startDate: null,
						range: null,
						format: "yyyy/mm/dd", //Otime.jdf,
						autoclose: true,
						startView: 0,
						todayHighlight: true
					});

					elem.on("hide", function (e) {
						_Escape();
						$(this).trigger("blur");
						_this.grid_container.focus();
					});

					elem.val(_var()).unbind("change").change(function () {
						currSubcribe = [];
						_var($(this).val());

						// _Escape();
						// $(this).trigger("blur");
						// _this.grid_container.focus();
						// elem.get(0).focus();
					}).show().datepicker('update');

					elem.data("datepicker").show();
					elem.get(0).focus();
				};
			};

			editables["tnum"] = function (e) {

				var item = self.selectedItem();
				// self.swapPane();
				if (taskId == item.form.task_id()) {
					self.isPane(false);
					return false;
				}
				taskId = item.form.task_id();
				self.isPane(true);

				panFn();
			};

			editables["tname"] = function (elem, word) {
				var item = self.selectedItem();
				if (!item.is_editable()) {
					return true;
				}

				var parents = ko.contextFor(elem.get(0)).$parents;

				var isLast = elem.parent().is(":last-child");

				// var isLast = (elem.parent().parent().children("tr").length -
				// elem.parent().index()) <= 4

				$("#hidder0 #txt-normal").css({
					"padding-left": ((parents.length - 1) * 20) + 5
				}).show().val(word || item.form.name() || "").unbind("blur").blur(function () {
					if ($.trim($(this).val()).trim()) {
						item.form.name($(this).val());
						_this.grid_container.focus();
						if (isLast) {
							// Add new item here (for last row)
							self.insertNew(null, _this.isToDo ? 1 : 5);
						}
					}
				}).get(0).focus();
			};

			editables["ttype"] = function (e, word, isClick, event) {
				var item = self.selectedItem();
				if (item.form.is_parent() || !item.is_editable()) {
					return true;
				}
				var hidder = _this.isToDo ? "#hidder0" : "#hidder1";
				var elem = $(hidder + " #task_type_box select");
				elem.val(item.form.task_type_id()).unbind("change").change(function () {
					var ttypeId = $(this).val();
					item.form.task_type_id(ttypeId);
					// item.form.task_type_name(_this.taskTypesList[ttypeId] || "");
					$(this).trigger("blur");
					_this.grid_container.focus();
					_Escape();
				}).chosen({
					search_contains: false,
					width: "100%",
					minheight: "100%",
					placeholder_text: 'select',
				}).trigger("chosen:updated");
				// elem.not(".selector select").uniform();
				// $.uniform.update(elem);
				$(hidder + " #task_type_box").show();
				// elem.get(0).focus();
				// elem.trigger("chosen:open.chosen");
				var search_field = $(hidder + " #task_type_box .chosen-search input");
				search_field.get(0).focus();
				search_field.val(word);
				// if (isClick)
				// {
				// }
			};
			editables["sprint"] = function (e, word, isClick, event) {
				var item = self.selectedItem();
				if (item.form.is_parent() || !item.is_editable()) {
					return true;
				}
				var hidder = _this.isToDo ? "#hidder0" : "#hidder1";
				var elem = $(hidder + " #sprint_box select");				
				elem.val(item.form.sprint_id()).unbind("change").change(function () {
					var ttypeId = $(this).val();
					item.form.sprint_id(ttypeId);
					$(this).trigger("blur");
					_this.grid_container.focus();
					_Escape();
				}).chosen({
					search_contains: false,
					width: "100%",
					minheight: "100%",
					placeholder_text: 'select',
				}).trigger("chosen:updated");
				// elem.not(".selector select").uniform();
				// $.uniform.update(elem);
				$(hidder + " #sprint_box").show();
				// elem.get(0).focus();
				// elem.trigger("chosen:open.chosen");
				var search_field = $(hidder + " #sprint_box .chosen-search input");
				search_field.get(0).focus();
				search_field.val(word);
				// if (isClick)
				// {
				// }
			};
			editables["duration"] = function (e, word) {
				word = isNaN(word) ? "" : word - "";
				var item = self.selectedItem();

				if (item.form.is_parent() || !item.is_editable()) {
					return true;
				}
				var hideer = _this.isToDo ? "#hidder0" : "#hidder1";
				var elem = $(hideer + " #txt-duration");
				elem.show().unbind("blur").blur(function () {
					currSubcribe = [];
					$(this).trigger("change");
					item.form.duration($(this).val() || 0);
					_Escape();
					_this.grid_container.focus();
				}).get(0).focus();
				elem.val(word || item.form.duration());
				elem.get(0).setSelectionRange(1, 1);
			};

			editables["esthrs"] = function (e, word) {
				word = isNaN(word) ? "" : word - "";
				var item = self.selectedItem();
				if (item.form.is_parent() || !item.is_editable()) {
					return true;
				}
				var elem = $("#hidder1 #txt-duration");
				elem.show().unbind("blur").blur(function () {
					$(this).trigger("change");
					item.form.estimated_hours($(this).val() || 0);
					_Escape();
					_this.grid_container.focus();
				}).get(0).focus();
				elem.val(word || item.form.estimated_hours());
				elem.get(0).setSelectionRange(1, 1);
			};

			editables["sdate"] = fieldEditables["date"](null, "start_date");
			editables["fdate"] = function (e, word) {
				var item = self.selectedItem();

				if (item.children().length > 0 || !item.is_editable()) {
					return true;
				}
				var hideer = _this.isToDo ? "#hidder0" : "#hidder1";
				var elem = $(hideer + " #date-picker input");
				$(hideer + " #date-picker").show();

				if (elem.data("datepicker") != undefined) {
					elem.datepicker('remove');
				}

				elem.datepicker({
					weekviewMode: '',
					minViewMode: '',
					weekStart: Otime.Days.getPos(Otime.weekStart) - 1 || 0,
					endDate: null,
					startDate: null,
					range: null,
					format: "yyyy/mm/dd", //Otime.jdf,
					autoclose: true,
					todayHighlight: true
				});

				elem.on("hide", function (e) {
					_Escape();
					$(this).trigger("blur");
					_this.grid_container.focus();
				});

				elem.val(item.form.finish_date()).unbind("change").change(function () {
					currSubcribe = [];
					if (item.form.is_milestone()) {
						item.form.start_date($(this).val());
						return;
					}

					isEditFromGrid = true;
					item.form.finish_date($(this).val());
					isEditFromGrid = false;
					// _Escape();
					// $(this).trigger("blur");
					// _this.grid_container.focus();
					// elem.get(0).focus();
				}).show().datepicker('update');

				elem.data("datepicker").show();
				elem.get(0).focus();
			};
			editables["predec"] = function (e, word) {
				var item = self.selectedItem();
				if (!item.is_editable()) {
					return true;
				}
				$("#hidder1 #txt-normal").val(word || item.form.predecessors()).unbind("blur").blur(function () {
					item.form.predecessors($(this).val());
					_Escape();
					_this.grid_container.focus();
				}).show().get(0).focus();
			};

			editables["status"] = function (e, word, isClick, event, hidderElem) {
				var item = self.selectedItem();

				if (item.form.is_parent()) {
					hidderElem.css({
						left: -999,
						top: -999
					});
					return true;
				}

				var hidder = _this.isToDo ? "#hidder0" : "#hidder1";
				var elem = $(hidder + " #status_box select");

				elem.val(item.form.task_status_id()).unbind("change").change(function () {
					isEditFromGrid = true;
					item.form.task_status_id($(this).val() + "");
					isEditFromGrid = false;
					_Escape();
					$(this).trigger("blur");
					_this.grid_container.focus();
				}).chosen({
					search_contains: false,
					width: "100%",
					placeholder_text: 'select',
				}).trigger("chosen:updated");
				// elem.not(".selector select").uniform();
				// $.uniform.update(elem);
				$(hidder + " #status_box").show();
				// $(hidder + " #status_box .chosen-search
				// input").get(0).focus().value=word;
				var search_field = $(hidder + " #status_box .chosen-search input");
				search_field.val(word);
				$(hidder + " #status_box .chosen-container .chosen-single").trigger("mousedown");
				search_field.get(0).focus();

				// Due to issue in delay for applying module we have to use
				// settimeout fn for applying value.
				// if (word)
				// {
				// setTimeout(function(){
				// _e.value = word;
				// }, 100);
				// }

				// if (isClick)
				// {
				// }
				// elem.not(".selector select").uniform();
				// $.uniform.update(elem);
				// $("#hidder1 #status_box").show();
			};

			editables["closed"] = function (e, word, isClick) {
				var item = self.selectedItem();
				if (item.children().length > 0) {
					return true;
				}
				item.is_closed(!item.is_closed());
			};

			editables["followers"] = fieldEditables["users"](null, "followers");
			editables["assignee"] = fieldEditables["user"](null, "assignee_id");

			editables["tsdPopup"] = function (e, word) {
				word = isNaN(word) ? "" : word - "";

				var itm = ko.dataFor(e.get(0));
				if (!!(Otime.tsReq - 0) || itm.count() > 1) {
					// self.showDetails(itm, e.get(0));
					self.showTimeSheet(itm, e.get(0));
				}
				else {
					$("#hidder2 #txt-hours").show().val(word || itm.hours()).unbind("blur").blur(function () {
						itm.hours($(this).val() || 0);
						self.saveTS(itm);
						_this.grid_container.focus();
					}).get(0).focus();
				}
			};

			editables["comments"] = self.showPaneComments;
			editables["documents"] = self.showPaneDoc;

			var setSelectedItem = function (e, clipBrd, isMultiple) {
				// var dtPicker = $("hidder1 #date-picker
				// input").unbind("change").data("datepicker");
				// dtPicker && dtPicker.remove();
				$("body > .datepicker.datepicker-dropdown").remove();
				$("#popover-tah").hide();


				var targ = ko.dataFor(e.parents("tr").get(0));
				// clipBrd.val($.trim(e.text()));

				if (!targ) {
					return;
				}

				if (isMultiple) {
					self.selectedItems.push(targ);
					return;
				}
				self.selectedItem() != targ && self.selectedItem(targ);
				if (!targ.form.task_id() && targ.form.name()) {
					var targName = e.attr("target");
					var prev = e.parents("tr").prev().get(0);

					// Set default task type id when focusing duration field
					/*
					 * if (targName == "duration" && !targ.form.task_type_id()) {
					 * if (prev) { prev = ko.dataFor(prev);
					 * targ.form.task_type_id(prev.form.task_type_id()); } else {
					 * targ.form.task_type_id(self.task_types()[1].id()); } }
					 */

					// if(Otime.Date() <= new Date(prev.form.start_date()))
					// {
					// targ.form.start_date(prev.form.start_date());
					// }
				}

				if (self.is_archived()) {
					return true;
				}

				if (targ.form.task_id())
				{
					// Load Documents, Comments, activities
					// if (self.isPane() && self.paneType() != self.paneTypes.DETAIL)
					if (self.isPane() && !self.is_detail())
					{
						_INITIALIZE_COMMENTS(targ, self);
					}

					// is Actual hours td then load the Total hours tooltip.
					if (e.attr("target") == "acthrs")
					{
						_this.ActualHoursPopup(targ, e);
					}

					if (self.isPane())
					{
						self.is_detail(true);
						self.rp_min_view(true);
					}
				}
				else
				{
					/* Auto indent child task begins */
					var prev = e.parents("tr").prev();
					if (prev.get(0) && !targ.form.name()) {
						var cont = ko.contextFor(prev.get(0));
						var current = ko.contextFor(e.get(0));

						if (cont.$parent != current.$parent && cont.$data != current.$parent) {
							var pos = e.index() + 1;	// if not take before indent, then will be virtual(Can't accessible)
							_indent(targ, e);
							$("td:nth-child(" + pos + ")", prev.next()).click();
						}
					}
					/* Auto indent child task end */

					if (self.isPane()) {
						self.is_detail(true);
						self.rp_min_view(false);
						// self.paneType(self.paneTypes.DETAIL);
					}
				}

				return targ;
			};

			var hideBox = function () {
				$(".cell-top, .cell-right, .cell-bottom, .cell-left").css({
					top: -999,
					left: -999
				});
			};
			var makeBox = function (elem) {
				if ($.isArray(elem)) {
					if (elem[0].parents("tr").is(".active")) {
						elem = elem[elem.length - 1];
					}
					else {
						elem = elem[0];
					}
				}


				var elementWidth = elem.get(0).clientWidth - 1;
				var elementheight = elem.get(0).clientHeight - 1;
				var $parent = elem.parents(".task-tbl.table").parent();
				// var _left = elem.position().left +
				// $("#box2-body").scrollLeft(),
				var _left = elem.position().left,// + $parent.scrollLeft(),
					_top = elem.position().top,
					_width = elementWidth,
					_height = elementheight;

				hideBox();
				var parent = elem.parents(".cont");
				if (elem.attr("target") == "acthrs") {
					// $(".cell-top, .cell-right, .cell-bottom, .cell-left", parent).css('border-color', '#CDDDF4');
					$(".cell-top, .cell-right, .cell-bottom, .cell-left", parent).css('border-color', '#f5f5f5');
				}
				else {
					$(".cell-top, .cell-right, .cell-bottom, .cell-left", parent).css('border-color', '');
				}

				$(".cell-top", parent).css({
					left: _left,
					top: _top + 1,
					width: _width + 2,
					height: 1
				});
				$(".cell-right", parent).css({
					left: _left + _width + 2 - (Otime.isChrome ? 0 : 2),
					top: _top + 1,
					width: 1,
					height: _height + 2.5
				});
				$(".cell-bottom", parent).css({
					left: _left,
					top: _top + _height + 2,
					width: _width + 2,
					height: 1
				});
				$(".cell-left", parent).css({
					left: _left,
					top: _top + 1,
					width: 1,
					height: _height + 2
				});

				// $(".cellselect").css({
				// left: -1000,
				// top: -1000,
				// });
				// $(".cellselect", elem.parents(".cont")).css({
				// left: elem.position().left,
				// top: elem.position().top,
				// width: elem.innerWidth(),
				// height: elem.innerHeight()
				// });
			};

			var deleteValue = {};
			deleteValue["tname"] = function (evnt, elem) {
				var item = self.selectedItem();
				//				if (!item.form.task_id())
				item.form.name("");
			};
			deleteValue["ttype"] = function (evnt, elem) {
				var item = self.selectedItem();
				item.form.task_type_id(0);
			};
			deleteValue["duration"] = function (evnt, elem) {
				var item = self.selectedItem();
				item.form.duration(0);
			};
			deleteValue["esthrs"] = function (evnt, elem) {
				var item = self.selectedItem();
				item.form.estimated_hours(0);
			};
			deleteValue["sdate"] = function (evnt, elem) {
				var item = self.selectedItem();
				item.form.start_date("");
			};
			deleteValue["fdate"] = function (evnt, elem) {
				var item = self.selectedItem();
				if (!item.form.start_date())
					item.form.finish_date("");
			};
			deleteValue["predec"] = function (evnt, elem) {
				var item = self.selectedItem();
				item.form.predecessors("");
			};
			deleteValue["status"] = function (evnt, elem) {
				var item = self.selectedItem();
				// item.form.status_id(0);
			};
			deleteValue["followers"] = function (evnt, elem) {
				var item = self.selectedItem();
				item.form.followers([]);
			};
			deleteValue["assignee"] = function (evnt, elem) {
				var item = self.selectedItem();
				item.form.assignee_id(0);
			};

			var loadOnClickArr = ["tnum", "ttype", "status", "assignee", "sdate", "fdate", "comments", "documents"];
			// if (_this.isToDo)
			// {
			//	loadOnClickArr = ["tname", "ttype", "assignee", "fdate"];
			// }

			self.gridify_params({
				initCell: 2,
				freezed: _this.isToDo ? null : ["#box1-body > table", "#box2-body > table", "#box3-body > table"],
				enterNav: "H", // H - Horizondal navigation, Vertical
				// navigation.
				ctrlEnterNav: "V",
				contextmenu: {
					elem: "#box1-body, #box2-body",
					callback: function (e) {
						var offset = $("#box1-body").parent().offset();
						var pos = $("#box1-body").parent().position();
						$("#contextMenu").css({
							top: e.pageY - offset.top + pos.top,
							left: e.pageX - offset.left + pos.left
						});
						var handler = function (e) {
							if (!$(e.target).closest("#contextMenu").length) {
								$("#contextMenu, #contextMenu > .dropdown-menu").hide();
								$(document).unbind("mousedown", handler);
							}
						};

						$("#contextMenu .dropdown-menu .menuitem").click(function () {
							setTimeout(function () {
								$("#contextMenu, #contextMenu > .dropdown-menu").hide();
								$(document).unbind("mousedown", handler);
							}, 50);
						});

						$(document).unbind("mousedown", handler).bind("mousedown", handler);
						$("#contextMenu, #contextMenu > .dropdown-menu").show();

						return false;
					}
				},
				onSelect: function (elem, clipBrd, isClick) {
					makeBox(elem);

					// var item = null;
					self.selectedItems([]);
					/*
										var targ = elem.attr("target");
										if (targ == "tnum" && isClick) {
											self.isPane(true);
										}
					*/
					if ($.isArray(elem) && !_this.isToDo) {
						var cpbrd = "", lastElem = null;
						for (var i = 0; i < elem.length; i++) {
							cpbrd += $.trim(elem[i].text()) + "\n";
							// item = setSelectedItem(elem[i], clipBrd, true);
							lastElem = elem[i];
							setSelectedItem(elem[i], clipBrd, true);
						}
						clipBrd.val(cpbrd);
						setSelectedItem(lastElem, clipBrd);
					}
					else {
						if ($.isArray(elem)) // when skip condition by todo view.
							elem = elem[0];
						// item = setSelectedItem(elem, clipBrd);
						clipBrd.val($.trim(elem.text()));
						setSelectedItem(elem, clipBrd);
					}

					// if (elem.length == 1)
					// {
					// elem = elem.first();
					// }
					// elem = elem[elem.length];

					if ($.isArray(elem)) {
						return false;
					}

					if (self.is_archived()) {
						return true;
					}

					var targ = elem.attr("target");

					if (isClick && elem.length == 1 && (elem.is(".cfselect") || loadOnClickArr.indexOf(targ) > -1)) {
						if (targ == "tnum") {
							// self.selectedItem().form.task_id() && self.isPane() && self.rp_min_view(true);
							if (self.selectedItem().form.task_id() != 0) {
								self.isPane(true);
								self.selectedItem().form.task_id() && self.rp_min_view(true);
								panFn();
							}
							else {
								self.isPane(false);
								self.selectedItem().form.task_id() && self.rp_min_view(true);
								panFn();
							}
							//							self.isPane() && self.rp_min_view(true);
							// self.isPane(true);
							// self.isRightPane(true);
							// self.rp_min_view(false);
							// self.show_details();
						}
						else if (targ == "comments" || targ == "documents") {
							self.isPane() && self.gridify_params().onEnter(null, elem, "", isClick);
						}
						else {
							self.gridify_params().onEnter(null, elem, "", isClick);
						}
					}

					// elem.parent().is("last-child")
					// if (false)
					// {
					// // Add new item here (for last row)
					// self.insertNew();
					// elem.parent().next().scrollIntoView();
					// }
				},
				onEnter: function (event, elem, word, isClick) {
					
					var targ = elem.attr("target");

					$(".hidder > *").hide();

					if (!targ) {
						return true;
					}

					if (self.is_archived()) {
						return true;
					}

					if (["closed", "tnum", "documents", "comments"].indexOf(targ) < 0) {
						var hidderElem = {
							"tname": "#hidder0",
							"tsdPopup": "#hidder2"
						}[targ] || "#hidder1";
						hidderElem = _this.isToDo ? "#hidder0" : hidderElem;
						hidderElem = $(hidderElem);

						// var hidderElem = $((targ == "tname") ? "#hidder0" :
						// "#hidder1");
						var minWidth = 0;/*({
							"followers" : 200,
							"assignee" : 150,
							"status" : 150
						}[targ] || 0);*/
						hidderElem.css({
							left: elem.position().left + 2,// + hidderElem.parent().scrollLeft(),
							top: Math.round(elem.position().top + 3 + hidderElem.parent().scrollTop()),
							// width: elem.innerWidth(),
							width: elem.get(0).clientWidth - 3,
							height: elem.get(0).clientHeight - 2,
							// height: elem.innerHeight() - 1,
							"min-width": minWidth
						}).show();

						// hideBox();
					}

					if (targ == "closed" && isClick) {
						return true;
					}

					editables[targ] && editables[targ](elem, word, isClick, event, hidderElem);
				},
				onEsc: _Escape,
				onInputKeyPress: null,
				onInputEnter: function (e) {
					var tmpTarg = $($("#hidder2 > *:visible").get(0) || $("#hidder1 > *:visible").get(0) || $("#hidder0 > *:visible").get(0));
					if (tmpTarg.get(0)) {
						if (!tmpTarg.is("input, select")) {
							tmpTarg = $("input, select", tmpTarg);
						}
						tmpTarg.trigger("change");
						$("#hidder1 input, #hidder1 select, #hidder0 input, #hidder0 select").trigger("blur").blur();
						_Escape(e);
					}
					_this.grid_container.focus();
					return true;
				},
				onInputEsc: function (e) {
					// _this.isToDo ? "#hidder0" : hidderElem;
					// var tmpTarg = $("#hidder1 > *:visible");
					// if (!tmpTarg.is("input, select"))
					// {
					// tmpTarg = $("input, select", tmpTarg);
					// }
					_Escape(e);
					_this.grid_container.focus();
					return true;
				},
				onDelete: function (event, elem) {
					deleteValue[elem.attr("target")] && deleteValue[elem.attr("target")](event, elem);
				},
				onBackSpace: function (event, elem) {
					deleteValue[elem.attr("target")] && deleteValue[elem.attr("target")](event, elem);
				},
				ctrlC: self.copy,
				ctrlX: self.cut,
				ctrlV: self.paste,
				ctrlS: self.save,
				ctrlI: _indent,
				ctrlU: _outdent,
				ctrlInsertA: _insertAbove,
				ctrlInsertB: _insertBelow,
				ctrlUp: _moveUp,
				ctrlDown: _moveDown,
				ctrlDelete: self.archive	// _deleteItem
				// ctrlZ: self.undo,
				// ctrlY: self.redo
			});

			// self.loadActivities = function(){
			// self.paneType(self.paneTypes.ACTIVITY);
			// };

			self.project_id.originalValue = self.project_id() - 0;
			self.project_id.subscribe(function (newVal) {			
				newVal = newVal - 0;

				if (!newVal || (self.project_id.originalValue == newVal && self.sprint_is_complete==0)) {
					return;
				}

				if (!self.project_id.originalValue) {
					self.project_id.originalValue = newVal;
					return;
				}

				if (isIE) {
					Otime.Menu.loadURL(_this.name + (_this.isToDo ? "/todo/" : "/") + newVal);
					return;
				}
				if (initFlag) {
					initFlag = false;
					Otime.Menu.ReplaceURL(_this.name + (_this.isToDo ? "/todo/" : "/") + newVal);
					return false;
				}
				if (self.project_id.originalValue != newVal) {
					refreshFlag = false;
					self.is_gantt(false);
					self.is_tsw(false);
					Otime.Storage.set("tasks_project_id", newVal);
					Otime.Menu.ReplaceURL(_this.name + (_this.isToDo ? "/todo/" : "/") + newVal);
					self.project_id.originalValue = newVal;
					self.sprint_id(0);
					if (self.is_archived()) {
						_this.Refresh(self.project_id(), self.sprint_id(), self.search, false, true);
					}
					else {
						_this.Refresh(newVal, self.sprint_id(), self.search);
					}
					self.sprint_is_complete = 0;

					//					Otime.cloneNewInstance("Tasks", _this.name + (_this.isToDo ? "/todo/" : "/") + newVal);
				}
				self.project_id.originalValue = self.project_id();
				return true;

				//				if (self.project_id.originalValue != newVal)
				//				{
				//					self.setVisibles(false, false, false, false);
				//					self.task_status_id(0);
				//					self.task_type_id(0);
				//					self.gantt(null);
				//					Otime.Storage.set("tasks_project_id", newVal);
				//					Otime.Menu.ReplaceURL("/index.php/" + _this.name + "/" + newVal);
				//					self.project_id.originalValue = newVal;
				//					_this.Refresh(newVal, self.search);
				//				}
			});
			self.sprint_id.originalValue = self.sprint_id() - 0;
			self.sprint_is_complete = 0;
			self.sprint_id.subscribe(function (newVal) {
				/*newVal = newVal - 0;

				if (!newVal || self.sprint_id.originalValue == newVal) {
					return;
				}				
				/*if (!self.sprint_id.originalValue) {
					self.sprint_id.originalValue = newVal;
					return;
				}*/
				if (self.sprint_id.originalValue != newVal) {
					Otime.Storage.set("tasks_project_sprint_id", newVal);
				}
				self.sprint_id.originalValue = self.sprint_id();
				self.sprint_is_complete = 0;
				$.each(self.sprint(), function(key, val){
					if(val.sprint_id == newVal){
						if(val.is_complete==1){
							self.task_status_id(-1);
							self.sprint_is_complete = 1;
						}else{
							self.task_status_id(-2);
						}
					}
				});
				if(self.sprint_is_complete==1){
					refreshFlag = false;
					_this.Refresh(self.project_id(), newVal, self.search, true);
				}else{
					self.filter(self.items(), self.getFilters());
				}
				return true;
			});

			self.resetPos = function () {
				$('#task_type_filter, #task_status_filter, task_assignee_filter').css({
					'top': -999,
					'left': -999
				});
			};

			self.afterInit = function () {
				$.each(_this.custom_fields, function (key, val) {
					if (!fieldEditables[val.fType]) {
						val.fType = "text";
					}

					if (!editables[val.fCode]) {
						editables[val.fCode] = fieldEditables[val.fType](val.fCode, val);
					}

					switch (val.fType) {
						case "select":
						case "user":
							deleteValue[val.fCode] = function (evnt, elem) {
								var item = self.selectedItem();
								item.form.custom_values[val.fCode](0);
							};
							break;
						case "users":
							deleteValue[val.fCode] = function (evnt, elem) {
								var item = self.selectedItem();
								item.form.custom_values[val.fCode]([]);
							};
							break;
						default:
							deleteValue[val.fCode] = function (evnt, elem) {
								var item = self.selectedItem();
								item.form.custom_values[val.fCode]("");
							};
							break;
					}
				});
			};

			var isAll = false;
			self.task_status_id.subscribe(function (newVal) {
				if (self._info.task_status().length > 0) {
					newVal = newVal - 0;
					(newVal != -1) && Otime.Storage.set("task_filter_task_status_" + self.project_id(), newVal);
					if (isAll) {
						self.search();
						return;
					}
					// if all task or Closed status chosen then reload the page.
					if ((newVal < 0 && newVal != -2 && !isAll) || newVal == self._info.closedStatusId) {
						refreshFlag = false;
						isAll = true;
						_this.Refresh(self.project_id(), self.sprint_id(), null, true);
						return;
					}
					// var start = new Date().getTime();
					self.search();
				}
			});

			self.task_type_id.subscribe(function (newVal) {
				if (self.task_types().length > 0) {
					Otime.Storage.set("task_filter_task_type_" + self.project_id(), newVal);
					self.search();
				}
			});
			self.task_assignee_id.subscribe(function (newVal) {
				if (self.users_sort().length > 0) {
					Otime.Storage.set("task_filter_assignee_" + self.project_id(), newVal);
					self.search();
				}
			});
			self.task_name.subscribe(function (newVal) {
				self.search();
			});
			self.clearSearch = function () {
				if (self.task_name()) {
					self.task_name("");
				}
			};
			self.duration.subscribe(function (newVal) {
				self.search();
			});
			self.predecessors.subscribe(function (newVal) {
				self.search();
			});

			// Tabs Begins
			self.tabs = Otime.a([
				{ name: "Board", id: "board", fn: "initBoard", tmpl: "task-board-tmpl" },
				{ name: "Grid", id: "grid", fn: "initGrid", tmpl: "task-main-grid-tmpl" },
				{ name: "Gantt", id: "gantt", fn: "initGantt", tmpl: "task-main-grid-tmpl" },
				{ name: "Progress", id: "progress", fn: "initProgress", tmpl: "task-progress-tmpl" },
				{ name: "More", id: "more", fn: "initMore", tmpl: "task-more-tmpl" }
			]);

			self.currTab = Otime.o();

			self.setTab = function (tab) {
				if (!tab) {
					tab = self.tabs()[0];
				}

				self.currTab(tab);
				self[tab.fn] && self[tab.fn]();
			};

			self.initBoard = function () {
				_this.Refresh();
			};

			self.initGantt = function () {
				_this.Refresh();
			};

			self.initProgress = function () {
				_this.Refresh();
			};

			self.initMore = function () {
				_this.Refresh();
			};

			self.initGrid = function () {
				_this.Refresh();
			};

			// Tabs End
		};

		/***********************************************************************
		 * in timesheet each cell will hold this model.
		 */
		_this.TimeSheet = function (data, parent) {
			var self = this;

			data = data || {};

			self.date = data.date;
			self.entry_date = data.entry_date;
			self.approval_status = data.approval_status;
			self.project_id = data.project_id;
			self.task_type_id = data.task_type_id;
			self.project_task_id = data.project_task_id;
			self.time_sheet_id = Otime.o(data.time_sheet_id);
			self.is_billable = Otime.o(data.is_billable - 0);
			self.count = Otime.o(data.count);
			self.hours = Otime.o(data.hours);
			self.hours.originalValue = data.hours || 0;
			self.haveDetails = Otime.o(false);

			self.activity_name = Otime.o(data.activity_name || "");
			self.direct_entry = Otime.o(0);
			self.details = Otime.a([]);

			var entryDate = Otime.stoj(self.entry_date);
			self.entry_date = Otime.o(entryDate.format(Otime.jdf));

			self._info = {};
			self._info.isLeave = Otime.o(entryDate.isLeave());
			self._info.isFuture = Otime.o(entryDate.isFuture());
			self._info.isToday = Otime.o(entryDate.isToday());
			self._info.is_edit_mode = Otime.o(false);
			self._info.is_new = Otime.o(false);
			self._info.hours_disp = Otime.o("");
			self._info.is_ts_running = Otime.o(false);
			
			/*
			 * self.addHoursDetail = function(){ if (self.details().length <= 0 ||
			 * self.details()[self.details().length-1].from_time() != "") { var
			 * newHrsModel = new Otime.TimeSheet.HoursDetailModel();
			 * newHrsModel.from_time(""); newHrsModel.to_time("");
			 * self.details.push(newHrsModel); } };
			 * 
			 * self.deleteHrs = function(item) { if (item.time_sheet_detail_id() >
			 * 0) { self.details.destroy(item); } else {
			 * self.details.remove(item); } };
			 * 
			 * self.newHrs = function(item, elem){ if
			 * (self.details().indexOf(item) == self.details().length-1 &&
			 * $.trim(item.from_time()) != "") { self.addHoursDetail(); } };
			 */
			self.getParent = function () {
				return parent;
			};

			//			self.hours.subscribe(function(newVal){
			//				if (Number(newVal) > 24)
			//				{
			//					self.hours(24);
			//					return true;
			//				}
			//			});
		};

		_this.ActualHoursPopup = function (item, e) {
			var isRefreshed = false;
			var isUsersData = false;

			if (item.form.task_id() - 0 <= 0) {
				return false;
			}

			var showPopup = function () {
				e.one("mouseleave", function () {
					$("#tsa-popup").hide();
				});

				$("#tsa-popup").css({
					left: e.offset().left - 250,
					top: e.offset().top - 100
				}).show();
			};

			setTimeout(function () {
				if (e.is(":hover")) {
					var targetItem = item;
					if (item.isLoaded && !isRefreshed) {
						_this.appModel.tsa_popup(targetItem.time_sheet_actual());
						showPopup();
						return false;
					}

					var data = {
						project_id: _this.appModel.project_id(),
						isTotal: 1,
						type: "ACTUAL",
						project_task_id: targetItem.form.task_id() - 0
					};

					Otime.app.loadData(new Otime.ContextModel({
						url: "ts_hrs",
						data: data,
						global: false,
						callback: function (cont) {
							var resp = cont.response;
							if (resp.items && resp.items.otkeys && resp.items.otvalues && Object.keys(resp.items.otvalues).length > 0) {
								var tmpArr = [];
								resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (item) {
									tmpArr.push($.extend(item, _this.all_users[item.user_id]));
								});
								targetItem.time_sheet_actual($.extend(targetItem.time_sheet_actual(), {
									list: tmpArr
								}));
								_this.appModel.tsa_popup(targetItem.time_sheet_actual());
								showPopup();
							}
							item.isLoaded = true;
							isRefreshed = true;
						},
						onError: function () {
							isUsersData = false;
						}
					}));
				}
			}, 600);
		};

		_this.TimeSheetActual = function (data, clbk) {
			var self = this;

			data = data || {};

			self.project_id = Otime.o(data.project_id);
			self.filter_by = data.filter_by || "ALL";
			self.currentDate = data.currentDate ? new Date(data.currentDate) : Otime.newDate();
			self.fromDate = null;
			self.toDate = null;

			switch (self.filter_by) {
				case "LW":
					self.currentDate = self.currentDate.addDays(-7);
				case "TW":
					self.fromDate = self.currentDate.getWeekStart();
					self.toDate = self.currentDate.getWeekEnd();
					break;
				case "LM":
					self.currentDate = self.currentDate.addMonth(-1);
				case "TM":
					self.fromDate = self.currentDate.getMonthStart();
					self.toDate = self.currentDate.getMonthEnd();
					break;
				default:
					break;
			}

			var isRefreshed = false;
			var isUsersData = false;
			self.loadTaskUsers = function (item, e) {
				if (item.form.task_id() - 0 <= 0 || item.time_sheet_actual().hours <= 0) {
					return false;
				}

				var showPopup = function () {
					var elem = $("span", $(e.delegateTarget));
					$("#tsa-popup").css({
						left: elem.offset().left - 280,
						top: elem.offset().top - 100
					}).show();
				};

				setTimeout(function () {
					if ($(e.delegateTarget).is(":hover")) {
						var targetItem = item;
						if (targetItem.time_sheet_actual().list.length <= 0) {
							if (item.isLoaded && !isRefreshed) {
								return false;
							}

							isUsersData = true;
							self.load(targetItem.form.task_id(), function (resp) {
								isUsersData = false;
								if (resp.items && resp.items.otkeys && resp.items.otvalues && Object.keys(resp.items.otvalues).length > 0) {
									var tmpArr = [];
									resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (item) {
										tmpArr.push($.extend(item, _this.users[item.user_id]));
									});
									targetItem.time_sheet_actual($.extend(targetItem.time_sheet_actual(), {
										list: tmpArr
									}));
									_this.appModel.tsa_popup(targetItem.time_sheet_actual());
									showPopup();
								}
								item.isLoaded = true;
							});
							return true;
						}

						_this.appModel.tsa_popup(targetItem.time_sheet_actual());
						if (e.handleObj.origType == "mouseenter") {
							showPopup();
						}
					}
				}, 600);

				if (e.handleObj.origType != "mouseenter") {
					/*
					 * { showPopup(); } else {
					 */
					$("#tsa-popup").hide();
				}
			};

			self.load = function (task_id, callback) {
				var data = {
					project_id: self.project_id(),
					isTotal: 1,
					type: "ACTUAL"
				};

				if (self.filter_by != "" && self.filter_by != "ALL") {
					data.start_date = self.fromDate.format(Otime.sdf);
					data.end_date = self.toDate.format(Otime.sdf);
					if (Object.keys(_this.users).length > 0)
						data.filter_by = self.filter_by;
				}

				if (isUsersData) {
					data.project_task_id = task_id - 0;
					if (!data.project_task_id)
						return false;
				}

				Otime.app.loadData(new Otime.ContextModel({
					url: "ts_hrs",
					data: data,
					global: false,
					callback: function (cont) {
						var response = cont.response;
						isRefreshed = true;
						if (typeof callback == "function") {
							callback(response);
						}
					},
					onError: function () {
						isUsersData = false;
					}
				}));
				return true;
			};

			self.load(0, clbk);
			return self;
		};

		/***********************************************************************
		 * Model used in Top table header of timesheet.
		 * 
		 * @param data
		 * @param clbk
		 * @returns
		 */
		_this.TimeSheetWeek = function (data, clbk) {
			var self = this;

			data = data || {};

			self.project_id = Otime.o(data.project_id);
			self.columns = Otime.a([]);
			self.current = Otime.o(new Date());
			self.totHours = Otime.o(0);

			// for Total Timesheet view
			self.isTotal = data.isTotal;

			var dateObj = function (dat) {
				var _this = this;
				var dt = new Date(dat.date);

				_this.date = dt;
				// _this.day = dt.format("DDD");
				_this.sdate = dt.format("DD");
				_this.month = dt.format("MMM");
				_this.isToday = dt.isToday();
				_this.isLeave = dt.isLeave();
				_this.hours = Otime.o(dat.hours);

				return _this;
			};

			var applyCols = function () {
				var cols = [];
				var start = self.current().getWeekStart();

				for (var i = 0; i < 7; i++) {
					cols.push(new dateObj({
						date: new Date(start),
						hours: 0
					}));
					start.addDays(1);
				}

				self.columns(cols);
				self.reload();
			};

			self.reload = function () {
				var start = new Date(self.columns()[0].date);
				var end = new Date(self.columns()[self.columns().length - 1].date);

				Otime.app.loadData(new Otime.ContextModel("ts_hrs", {
					project_id: self.project_id(),
					start_date: start.format("YYYY-MM-DD"),
					end_date: end.format("YYYY-MM-DD"),
					type: "WEEK",
					isTotal: Number(self.isTotal)
				}, function (cont) {
					var response = cont.response;

					if (typeof clbk == "function") {
						clbk(response, self.current());
					}
				}));
				return true;
			};

			self.nav = function (inc) {
				return function () {
					var dt = self.current();
					dt.addDays(Number(inc + "7"));
					self.current(dt);
					applyCols();
				};
			};

			applyCols();
			return self;
		};

		_this.ReArrangeDate = function (item, parent) {
			if (!item && !parent) {
				return false;
			}

			parent = parent || item.parent() || {};

			if (typeof parent.children == 'function') {
				var startDates = [], finishDates = [];
				/**
				 * Do nothing if parent start_date is less then current item
				 * start_date and parent finish_date is greater then current
				 * item finish_date
				 */
				/*
				 * if (new Date(item.form.start_date()) >= new
				 * Date(parent.form.start_date()) && new
				 * Date(item.form.finish_date()) <= new
				 * Date(parent.form.finish_date())) { return true; }
				 */
				/**
				 * Loop through the childrens of parent item and store the
				 * start_date, finish_date in seperate array varialbe for sort
				 * it.
				 */
				var childs = parent.children(), sd, fd;
				for (var i = 0, iLen = childs.length; i < iLen; i++) {
					if (currSubcribe.indexOf(childs[i].form.task_number()) > -1) {
						continue;
					}

					currSubcribe.push(childs[i].form.task_number());

					sd = childs[i].form.start_date();
					sd && startDates.push(new Date(sd).getTime());
					fd = childs[i].form.finish_date();
					fd && finishDates.push(new Date(fd).getTime());
				}
				if (startDates.length > 0) {
					parent.form.start_date(new Date(startDates.sort()[0]).format(Otime.jdf));
				}

				if (finishDates.length > 0) {
					parent.form.finish_date(new Date(finishDates.sort().reverse()[0]).format(Otime.jdf));
				}
				return true;
			}
			return false;
		};

		/***********************************************************************
		 * update parent status when child status changed.
		 */
		var updateStatus = function (item) {
			if (item.form.is_parent()) {
				var childs = item.children();
				var is_closed = true;
				for (var i = 0, iLen = childs.length; i < iLen; i++) {
					is_closed = is_closed && childs[i].is_closed();
				}
				item.is_closed(is_closed);
			}
		};

		var applyFollowers = function (newVal, self) {
			newVal = newVal || self.form.followers();

			if (!newVal || !newVal.length) {
				return "";
			}

			if (newVal[0] == "-1") {
				return "All User";
			}

			var usrs = Otime.Details.all_users;// _this.appModel.users();
			var departmentsById = Otime.Details.departmentsById;// _this.appModel.users();
			var opt = [];

			newVal.forEach(function (val, key) {
				if (usrs && usrs[val]) {
					opt.push(usrs[val].first_name);
				} else if (val == Otime.UID) {
					opt.push(Otime.UFNAME);
				} else if (val.substr(0, 1) == "D" && Otime.Details.departmentsById[val.substr(1)]) {
					opt.push(Otime.Details.departmentsById[val.substr(1)].department);
				}
			});

			return (opt.join(", ") || (_this.isToDo ? "Followers" : ""));
		};

		var applyAssignee = function (newVal, self) {
			newVal = (newVal || self.form.assignee_id()) - 0;
			if (!newVal) {
				return "";
			}
			newVal = newVal + "";
			var usrs = Otime.Details.all_users;

			// If assignee changed, we have to add that user to the list of
			// followers.
			var followers = self.form.followers();
			if (!followers || (followers.indexOf("-1") < 0 && followers.indexOf(newVal) < 0)) {
				self.form.followers.push(newVal);
			}

			return (usrs && usrs[newVal]) ? usrs[newVal].first_name : '';
		};

		var startDateSubscribe = function (newVal, self) {			
			var dt = new Date(newVal);
			if (isNaN(dt.getTime())) {
				return false;
			}

			if (self.startFlag) {
				var fd = new Date(self.form.finish_date()).getTime() - dt.getTime();
				self.form.duration(fd / (24 * 60 * 60 * 1000));
				return false;
			}

			//dt.addDays(Number(self.form.duration()) - 1);
			if (Otime.leave.skip) {
				self.tmp_flag = true;
				dt = _this.getFinishDate(dt, self.form.duration() - 0 || 1);
				self.form.finish_date(dt.format(Otime.jdf));
				self.tmp_flag = false;
			}
			else {
				dt.addDays(Number(self.form.duration()) - 1);
				self.form.finish_date(dt.format(Otime.jdf));
			}
		};

		var doCommonForFinishDates = function (self) {
			_this.fFlag++;

			_this.getAllItems();

			// console.log("Update Predec : ", self.form.task_number());
			self.updatePredecessor("", true);
			// console.log("Check Predec : ", self.form.task_number());
			self.checkPredecessor();
			// console.log("Re-Arrange : ", self.form.task_number());
			_this.ReArrangeDate(self);
			_this.fFlag--;
		};
		var finishDateSubscribe = function (newVal, self) {
			if (self.f_flag) {
				return false;
			}

			var dt = new Date(newVal);
			if (isNaN(dt.getTime())) {
				return false;
			}

			// if start_date not avail, don't affect any thing just update the parents only.
			if (!self.form.start_date()) {
				doCommonForFinishDates(self);
				return;
			}

			// If finish date greater than start date then set finish date same as start date.
			if (dt < new Date(self.form.start_date())) {
				self.form.finish_date(self.form.start_date());
				return false;
			}

			// Skip leave days
			if (self.tmp_flag && Otime.leave.skip) {
				self.f_flag = true;
				dt = _this.getFinishDate(new Date(self.form.start_date()), self.form.duration());
				self.form.finish_date(dt.format(Otime.jdf));
				self.f_flag = false;
			}
			else if (!self.tmp_flag && Otime.leave.skip) {
				self.tmp_flag = true;
				// Calculate duration with skip leave here.
				var _newval = Date.checkLeave(new Date(newVal), true);
				if (dt.getTime() != _newval.getTime()) {
					self.f_flag = true;
					dt = _newval;
					self.form.finish_date(_newval.format(Otime.jdf));
					self.f_flag = false;
				}

				var _diff = Number((dt.getTime() - new Date(self.form.start_date()).getTime()) / (1000 * 60 * 60 * 24));
				var _leave = Number(Date.getTotalLeave(new Date(self.form.start_date()), dt));

				self.form.duration((_diff + 1) - _leave);

				self.tmp_flag = false;
			}
			else if (!self.tmp_flag && !Otime.leave.skip) {
				self.tmp_flag = true;
				self.form.duration(((dt.getTime() - new Date(self.form.start_date()).getTime()) / (1000 * 60 * 60 * 24)) + 1);
				self.tmp_flag = false;
			}

			doCommonForFinishDates(self);
		};

		var durationSubscribe = function (newVal, self) {
			if (isNaN(newVal) || self.du_flag) {
				return false;
			}
			if (Number(newVal) < 1) {
				// self.form.is_milestone(true);
				if (newVal < 0) {
					self.du_flag = true;
					self.form.duration(0);
					self.du_flag = false;
				}
			}

			if (parseInt(newVal) != Number(newVal)) // check float value.
			{
				self.du_flag = true;
				self.form.duration(Math.abs(parseInt(newVal)));
				self.du_flag = false;
			}
			if (self.tmp_flag == true) {
				return false;
			}

			if (!self.form.start_date()) {
				return;
			}
			var dt = new Date(self.form.start_date());
			dt.addDays(Number(newVal) - 1);
			self.tmp_flag = true;
			self.form.finish_date(dt.format(Otime.jdf));
			self.tmp_flag = false;
		};

		_this.applyTimesheet = function (item, timer) {
			timer = timer || _this.timer;
			var self = item;

			var ttypes = Object.values(_this.ttypeById);
			ttypes.splice(0, 0, {
				task_type_id: "0",
				name: "Select Task Types"
			});
			var newTsItem = {};
			if (timer.time_sheet_id) {

				timer.task_types = ttypes;
				timer.is_task_page = true;
				newTsItem = new Otime.TimeSheet.TimeSheetDetailModel(timer);
				newTsItem.addHoursDetail();
			}
			else {
				newTsItem = new Otime.TimeSheet.TimeSheetDetailModel({
					task_types: ttypes,
					time_sheet_id: 0,
					project_id: self.project_id() - 0,
					task_type_id: self.form.task_type_id() - 0,
					project_task_id: self.form.task_id() - 0,
					task_number: self.form.task_number() - 0,
					entry_date: entry_date,
					is_billable: self.form.is_billable(),
					project_code: 0,
					project_name: self.project_name(),
					activity_name: self.form.name(),
					is_task_page: true
				});
				newTsItem.addHoursDetail();
			}

			var start = function (time_sheet_id, item) {
				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/timesheet/start', {
					time_sheet_id: time_sheet_id
				}, function (cont) {
					var resp = cont.response;
					/*
										if (self.active_tasks())
										{
											var ts	= self.active_tasks();
											ts._info.is_running(false);
											Otime.app.running_process(null);
											Otime.TimeSheet.ClearInterval();
											ts._info.hours_disp("");
											ts._info.is_running(false);
										}
					*/
					if ($("#popover").is(":visible"))
						$("#popover").hide();
					Otime.TimeSheet.curTime = resp.cur_time;
					Otime.Menu.curTime = resp.cur_time;

					item._info.is_running(true);
					// self.active_tasks(item);

					Otime.TimeSheet.SetInterval(resp.time, item, (Number(item.hours()) * 60 * 60), 'HH:NN<sub>SS</sub>');

					//					Otime.TimeSheet.SetInterval(cell._info.from_time, cell, (Number(cell.hours()) * 60 * 60), 'HH<span class="blink">:</span>NN');

					Otime.Menu.activeTask = {
						time_sheet_id: resp.time_sheet_id,
						activity_name: item.activity_name(),
						project_name: item._info.project_name(),
						is_progress: true,
						from_time: resp.time,
						hours: 0
					};
					Otime.Menu.initProgress();
				}), true);
			};

			var saveStart = function (_itm, elem, save_only) {
				save_only = save_only || false;
				/*
								if (!$("#popover").is(":visible") && !_itm._info.is_running())
								{
									// parent.tsDetails(self.timesheet());
									$("#popover").show();
									return false;
								}
				*/
				var item = self.timesheet();
				item = item.tsheet;

				if (!save_only && item.time_sheet_id()) {
					if (item._info.is_running()) {
						Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/timesheet/stop', {
							time_sheet_id: item.time_sheet_id()
						}, function (cont) {
							var resp = cont.response;

							item._info.is_running(false);
							Otime.app.running_process(null);
							var prog = Otime.Menu.progress();
							if (prog) {
								prog.hours(resp.hours);
								prog.time_sheet_id(resp.time_sheet_id);
								resp.entry_date && prog.entry_date(Otime.stoj(resp.entry_date).format(Otime.jdf));
							}
							Otime.TimeSheet.ClearInterval();
							item._info.hours_disp("");
							item._info.is_running(false);
							// self.active_tasks(null);
						}), true);
					}
					else {
						start(item.time_sheet_id(), item);
					}
					return false;
				}

				Otime.TimeSheet.TimeSheetSave(item, function (resp) {
					$("#popover").hide();
					if (!save_only) {
						start(resp.time_sheet_id, item);
					}
				});
			};

			self.timesheet({
				tsheet: newTsItem,
				save: function (_itm, elem) {
					saveStart(_itm, elem, true)
				},
				start: saveStart,
				saveStart: saveStart,
				cancel: function (_itm) {
					$("#popover").hide();
				}
			});
		};

		var incr = 0;
		_this.TaskContentModel = function (data, parent) {
			var self = this;
			data = data || {};
			var tmp = null;
			self.parent = Otime.o(parent);
			self.children = Otime.a([]);
			self.is_crossed_estimates = Otime.o(false);
			self.children.subscribe(function () {
				var hrs = 0;
				$.each(self.children(), function (key, val) {
					hrs += val.form.worked_hours() - 0;
				});
				self.form.worked_hours(hrs);
				var est = (self.form.estimated_hours() - 0) - hrs;
				if (est < 0 && self.form.estimated_hours()) {
					self.is_crossed_estimates(true);
				}
			});

			self.is_editable = Otime.o(true);
			self.show_child = Otime.o(true);
			self.show_user = Otime.o(true);
			// self.level = Otime.o(data.level || 0);
			self.isActive = Otime.o(false);
			self.task_status = Otime.a(_this.appModel.task_status() || []);
			self.status = Otime.o(null);
			self.is_visible = Otime.o(true);
			self.time_sheet_actual = Otime.o({
				list: []
			});
			self.time_sheet_weeks = Otime.o({});
			self.is_ts_running = Otime.o(false);
			self.tswTotal = Otime.o(0);

			// self.uniqueId = Otime.o((new Date().getTime()).toString(16));
			self.uniqueId = Otime.o(new Date().getTime() + "" + Math.floor(Math.random() * 1024) + "" + (++incr));

			data.is_milestone = !!(data.is_milestone - 0);

			// Right panel
			self.rp = Otime.o(null);

			self.tags = Otime.a();
			self.tagNames = [];
			self.tags.subscribe(function (newVal) {
				if (self.tags().length > 0 && Otime.Details.tagsById) {
					$.each(self.tags(), function (idx, val) {
						if (Otime.Details.tagsById[val]) {
							self.tagNames.push(Otime.Details.tagsById[val].tagName);
						}
					});
				}
			});
			self.tags(data.tags ? data.tags.split(",") : []);

			self.form = {
				custom_values: {},
				cvObj: {}
			};

			var _unique_key = data.task_id || 0;
			self.form.task_number = Otime.o(data.task_number || "");

			self.form.task_id = Otime.o(data.task_id || 0);
			self.form.task_id.subscribe(function (newVal) {
				_unique_key = newVal;
			});
			var updateChangeData = function (key, val, isCustomField) {
				if (key == "name" && !val) {
					return;
				}
				//console.trace("updateChangeData : ", self.form.task_number(), key, val);
				var tmpObj = changed_data[_unique_key] || {};
				if (!tmpObj.custom_values) {
					tmpObj.custom_values = {};
				}

				if (!(self.form.task_id() - 0)) {
					if (!self.form.name()) {
						delete changed_data[_unique_key];
						return false;
					}

					tmpObj.order_id = self.form.order_id();
					tmpObj.followers = self.form.followers();
					if (!(self.form.task_number() - 0)) {
						self.form.task_number(_this.appModel.new_id());
						_this.appModel.new_id(Number(_this.appModel.new_id()) + 1);
					}
					tmpObj.task_number = self.form.task_number();
					tmpObj.assignee_id = self.form.assignee_id();
					tmpObj.task_status_id = self.form.task_status_id();
					tmpObj.parent_task_id = self.form.parent_task_id();
					tmpObj.start_date = self.form.start_date();
					tmpObj.finish_date = self.form.finish_date();
					tmpObj.duration = self.form.duration();
					tmpObj.estimated_hours = self.form.estimated_hours();
					tmpObj.predecessors = self.form.predecessors();
					tmpObj.is_billable = self.form.is_billable();
					tmpObj.is_milestone = self.form.is_milestone();
					tmpObj.is_repeat = self.form.is_repeat();
					if (self.form.is_repeat() != 'W' && self.form.is_repeat() != 'MD' && self.form.is_repeat() != 'M') {
						self.form.repeat_on('');
					}
					tmpObj.repeat_on = self.form.repeat_on();
					tmpObj.is_closed = self.is_closed();
					tmpObj.percentage_complete = self.form.percentage_complete();
					tmpObj.is_parent = 0;
					new_items[self.form.task_number()] = self;
					tmpObj.project_id = _this.appModel.project_id();
				}

				tmpObj["task_id"] = self.form.task_id();
				if (!isCustomField) {
					tmpObj[key] = val;
				}
				else {
					// tmpObj.custom_values[key.replace("cf_", "")] = val;
					if (Array.isArray(val)) {
						val = val.join(",");
					}
					tmpObj.custom_values[key] = val;
				}

				if (key == 'is_repeat' && val == '-1') {
					tmpObj[key] = '';
				}
				changed_data[_unique_key] = tmpObj;
			};

			self.form.task_type_name = Otime.o(Otime.Details.all_task_types[data.task_type_id] ? Otime.Details.all_task_types[data.task_type_id].name : "");
			self.form.task_type_id = Otime.o(data.task_type_id || 0);
			self.form.task_type_id.subscribe(function (newVal) {
				self.form.task_type_name(Otime.Details.all_task_types[newVal] ? Otime.Details.all_task_types[newVal].name : "");
				updateChangeData("task_type_id", newVal);
			});

			self.form.name = Otime.o(data.name || "");
			self.form.description = Otime.o(data.description || "");
			self.form.description.subscribe(function (newVal) {
				updateChangeData("description", newVal);
				isEditFromGrid = false;
				_this.appModel.quickSave();
				self.form._info.new_desc(true);
			});

			self.form.parent_task_id = Otime.o(data.parent_task_id || 0);			
			self.form.parent_task_id.subscribe(function (newVal) {
				updateChangeData("parent_task_id", newVal);
			});

			self.form.sprint_name = Otime.o("");
			self.form.sprint_id = Otime.o("");
			if(data.sprint_id != "" && data.sprint_id != 0 && data.sprint_id != "0"){
				self.form.sprint_id(data.sprint_id);
			}else{
				self.form.sprint_id("-1");
			}
			/*else{
				if(_this.appModel.sprint().length > 1)
					self.form.sprint_id(_this.appModel.sprint()[1].sprint_id);
			}*/
			_this.appModel.sprint().find((o, i) => {
				if (o.sprint_id == data.sprint_id && data.sprint_id != "0") {
					self.form.sprint_name(o.name);
					return true; // stop searching
				}
			});
//			self.form.sprint_name = Otime.o(_this.appModel.sprint()[data.sprint_id] ? _this.appModel.sprint()[data.sprint_id].name : "");			
			self.form.sprint_id.subscribe(function (newVal) {
				_this.appModel.sprint().find((o, i) => {
					if (o.sprint_id == newVal && newVal != "0" && newVal != "-1") {
						self.form.sprint_name(o.name);
						return true; // stop searching
					}
				});				
				//self.form.sprint_name(_this.appModel.sprint()[newVal] ? _this.appModel.sprint()[newVal].name : "");				
				updateChangeData("sprint_id", newVal);
			});
			// self.form.duration = Otime.o(data.duration || (data.is_milestone ? 0 : 1)).extend({taskChange: true});
			data.duration = isNaN(data.duration) ? 0 : data.duration - 0;
			self.form.duration = Otime.o(data.duration);

			self.form.is_archived = Otime.o(!!(data.is_archived - 0));
			self.form.task_status_id = Otime.o((data.task_status_id || _this.appModel.default_status || 0) + "");
			self.form.is_repeat = Otime.o((data.is_repeat || _this.appModel.is_repeat() || 0) + "");
			self.form.repeat_on = Otime.o(data.repeat_on || 1);
			self.form.is_repeat.subscribe(function (newVal) {
				if (newVal == 'M') {
					var tmp_date = self.form.start_date() ? new Date(self.form.start_date()) : new Date();
					self.form.repeat_on(Math.floor(tmp_date.getDate() / 7) + "" + tmp_date.getDay());
				} else if (self.form.repeat_on() > 31) {
					self.form.repeat_on(31);
				}
				updateChangeData("is_repeat", newVal);
			});
			self.form.repeat_on.subscribe(function (newVal) {
				if (self.form.is_repeat() == 'MD') {
					if (newVal > 31) { self.form.repeat_on(31); return; }
					if (newVal <= 0) { self.form.repeat_on(1); return; }
				}
				updateChangeData("repeat_on", newVal);
			});

			var reload_chosen = function (self) {
				$('#is_repeat').trigger("chosen:updated");
				if (self.form.is_repeat() == 'M') {
					var tmp_date = self.form.start_date() ? new Date(self.form.start_date()) : new Date();
					self.form.repeat_on(Math.floor(tmp_date.getDate() / 7) + "" + tmp_date.getDay());
				}
				updateChangeData("repeat_on", self.form.repeat_on());
			}

			data.start_date = (data.start_date && data.start_date != '0000-00-00') ? new Date(data.start_date).format(Otime.jdf) : '';
			self.form.start_date = Otime.o(data.start_date);
			if (data.start_date) {
				var tmp = _this.appModel.repeat_options();
				tmp[5].name('Every Month (on ' + weekAndDay(data.start_date) + ')');
				_this.appModel.repeat_options(tmp);
				// reload_chosen(self);
				//$('#is_repeat').trigger("chosen:updated");
			}

			data.finish_date = (data.finish_date && data.finish_date != '0000-00-00') ? new Date(data.finish_date).format(Otime.jdf) : '';
			self.form.finish_date = Otime.o(data.finish_date);

			if (!self.form.duration() && self.form.start_date() && self.form.finish_date() && self.form.start_date() == self.form.finish_date()) {
				self.form.duration(1);
			}

			data.actual_start_date = (data.actual_start_date && data.actual_start_date != '0000-00-00 00:00:00') ? Otime.stoj(data.actual_start_date).format(Otime.dateFormat) : '';
			self.form.actual_start_date = Otime.o(data.actual_start_date);

			data.actual_finish_date = (data.actual_finish_date && data.actual_finish_date != '0000-00-00 00:00:00') ? Otime.stoj(data.actual_finish_date).format(Otime.dateFormat) : '';
			self.form.actual_finish_date = Otime.o(data.actual_finish_date);

			self.form.task_priority = Otime.o(data.task_priority || 2);
			self.form.task_priority.subscribe(function (newVal) {
				updateChangeData("task_priority", newVal);
			});
			self.form.estimated_hours = Otime.o(data.estimated_hours || "");

			var tmpSubscribe = function () {
				if (self.form.parent_task_id()) {
					var par = self.parent();
					par && par.calcEstimate && par.calcEstimate();
				}
			};

			self.form.name.subscribe(function (newVal) {
				// check if new task,
				if (!self.form.task_id() && !self.form.task_number() && newVal != "")
				//				if (!self.form.task_id() && newVal != "")
				{
					self.form.task_number(_this.appModel.new_id());
					_unique_key = self.form.task_number();
					_this.appModel.new_id(Number(_this.appModel.new_id()) + 1);

					self.status(_this.task_status[self.form.task_status_id()]);

					if (!self.form.order_id()) {
						var childs = null;
						var prev = null;
						if (self.parent().children) {
							childs = self.parent().children();
						}
						else if (self.parent().items) {
							childs = self.parent().items();
						}
						prev = childs[childs.indexOf(self) - 1];
						self.form.order_id(prev ? prev.form.order_id() + 1 : 1);
					}
				}

				updateChangeData("name", newVal);
			});

			self.form.estimated_hours.subscribe(function (newVal) {
				if (isNaN(newVal)) {
					var matches = (newVal + "").match(/(\d{1,2})(\.|\:)(\d{1,2})|(\.|\:)(\d{1,2})|(\d{1,2})/);
					var out = 0;
					if (matches && matches[6]) {
						out = matches[6] - 0;
					}
					else if (matches && matches[4] && matches[5]) {
						if (matches[4] == ':') {
							matches[5] = matches[5] < 60 ? Math.floor((matches[5] * 10) / 6) : 0;
						}
						out = '0.' + matches[5];
					}
					else if (matches && matches[1] && matches[2] && matches[3]) {
						if (matches[2] == ':') {
							matches[3] = matches[3] < 60 ? Math.floor((matches[3] * 10) / 6) : 0;
						}
						out = matches[1] + '.' + matches[3];
					}
					self.form.estimated_hours(out - 0);
					return true;
				}
				updateChangeData("estimated_hours", newVal);
				tmpSubscribe();
			});
			self.form.parent_task_id.subscribe(function (newVal) {
				updateChangeData("parent_task_id", newVal);
				tmpSubscribe();
			});

			self.calcEstimate = function () {
				var hrs = 0;
				$.each(self.children(), function (key, val) {
					hrs += val.form.estimated_hours() - 0;
				});
				self.form.estimated_hours(hrs);
			};

			self.form.predecessors = Otime.o(data.predecessors || "").extend({
				taskChange: true
			});

			if (data.followers && data.followers.length > 0) {
				data.followers = data.followers.join(",").replace(/ /g, "").split(",");
			}
			else if (!self.form.task_id()) {
				data.followers = [Otime.UID + ""];
			}
			else {
				data.followers = [];
			}

			self.form.assignee_id = Otime.o(data.assignee_id || (_this.isM ? Otime.UID : 0));
			self.form.followers = Otime.a(data.followers);
			self.form.notes = Otime.o(data.notes || "");
			self.form.notes.subscribe(function (newVal) {
				updateChangeData("notes", newVal);
			});

			self.form.is_billable = Otime.o(data.is_billable || 1);
			self.form.is_billable.subscribe(function (newVal) {
				updateChangeData("is_billable", newVal);
			});
			self.form.worked_hours = Otime.o(data.worked_hours - 0 || 0);

			var est = self.form.estimated_hours() - 0;

			if ((est - (self.form.worked_hours() - 0)) < 0 && self.form.estimated_hours()) {
				self.is_crossed_estimates(true);
			}

			self.form.is_parent = Otime.o(data.children != undefined && Object.keys(data.children).length > 0);
			self.form.is_parent.subscribe(function (newVal) {
				updateChangeData("is_parent", newVal ? 1 : 0);
			});
			self.form.is_milestone = Otime.o(data.is_milestone);
			self.form.order_id = Otime.o(Number(data.order_id) || 0);
			self.form.order_id.subscribe(function (newVal) {
				updateChangeData("order_id", newVal);
			});
			self.form.percentage_complete = Otime.o(data.percentage_complete || 0);
			self.form.percentage_complete.subscribe(function (newVal) {
				updateChangeData("percentage_complete", newVal);
			});

			self.tooltip = Otime.o();

			self.new_comments = Otime.o(data.new_comments - 0 || "");
			// self.new_attachments = Otime.o(data.new_attachments-0 || "");

			self.status_date = Otime.o(data.status_date ? Otime.stoj(data.status_date) : null);

			self.created_by = Otime.o((data.created_by - 0) || (Otime.UID - 0));
			// self.last_updated_by = Otime.o(data.created_by-0);
			// created_date, last_updated_date

			// Check the created by if member role.
			// Member should not edit higher role posted tasks.
			if (_this.isM && self.created_by() != Otime.UID - 0) {
				self.is_editable(false);
			}
			else if (_this.isM && self.created_by() == Otime.UID && self.form.followers().indexOf(Otime.UID + "") < 0) {
				self.form.followers.push(Otime.UID + "");
			}

			self.has_comments = Otime.o(!!(data.has_comments - 0));
			self.has_attachments = Otime.o(!!(data.has_attachments - 0));
			self.chkl_count = Otime.o(data.chkl_count - 0 || 0);

			self.form.is_milestone(data.is_milestone);
			self.form.is_milestone.subscribe(function (newVal) {
				updateChangeData("is_milestone", newVal ? 1 : 0);
				/*
				if (newVal && !self.form.finish_date())
				{
					self.form.finish_date(new Date().addDays(1).format(Otime.jdf));
				}
				*/
				if (newVal) {
					self.form.finish_date(self.form.start_date());
				}
			});

			self.form._info = {};

			var _usr = _this.all_users[self.created_by()] || {};
			self.form._info.created_by = Otime.o(_usr["first_name"] || "?");
			self.form._info.created_by_img = Otime.o(_usr["user_image"] ? Otime.UMIP + _usr["user_image"] : "noimgenc.jpg");

			self.form._info.assignee_disp = Otime.o("");
			self.form._info.followers_disp = Otime.o("");
			//self.form._info.new_desc = Otime.o(self.form.description()?false:true);
			self.form._info.new_desc = Otime.o(true);

			if (self.form.task_id()) {
				self.status(_this.task_status[self.form.task_status_id()]);
			}
			else {
				self.status("");
			}

			var flgIsClosed = false;
			self.is_closed = Otime.o(self.status() && !!(self.status().is_closed - 0));
			self.is_closed.subscribe(function (newVal) {
				if (flgIsClosed) {
					return true;
				}
				if (newVal) {
					self.form.task_status_id(_this.appModel._info.closedStatusId + "");
				}
				else {
					self.form.task_status_id(_this.appModel.default_status + "");
				}
			});

			self.form.task_status_id.subscribe(function (newVal) {
				if (!newVal || !_this.task_status[newVal]) {
					newVal = newVal || _this.appModel.default_status || Object.keys(_this.task_status)[0] || "";
					self.status(_this.task_status[newVal]);
					return false;
				}
				else {
					self.status(_this.task_status[newVal]);
				}
				flgIsClosed = true;
				self.is_closed(!!(self.status().is_closed - 0));
				if (self.is_closed()) {
					self.form.actual_finish_date(new Date());
				} else {
					self.form.actual_finish_date('');
				}
				flgIsClosed = false;

				updateChangeData("task_status_id", newVal);
				_this.appModel.quickSave();

				//				if (self.form.parent_task_id() - 0)
				//				{
				//					updateStatus(self.parent());
				//				}
			});

			self.form.is_archived.subscribe(function (newVal) {
				updateChangeData("is_archived", newVal ? 1 : 0);
				// _this.appModel.quickSave();
			});

			self.form._info.followers_disp(applyFollowers(null, self));
			var onArrayChange = function (changes) {
				if (!changes || !changes[0]) {
					return;
				}
				changes = changes[0];

				if (changes.value != "-1" && self.form.followers().indexOf("-1") > -1) {
					self.form.followers.remove("-1");
				}

				if (!self.children().length) {
					return;
				}

				for (var i = 0, childs = self.children(), iLen = childs.length; i < iLen; i++) {
					if (changes.status == "deleted") {
						childs[i].form.followers.remove(changes.value);
					} else if (changes.status == "added") {
						if (changes.value == "-1") {
							// changes.value != "-1"
							childs[i].form.followers(["-1"]);
						} else {
							childs[i].form.followers.push(changes.value);
						}
					}
				}
			};

			// self.form.followers.subscribe(onArrayChange, null, "arrayChange");

			var _followers_oldval = [];
			self.form.followers.subscribe(function (oldVal) {
				_followers_oldval = oldVal;
			}, null, "beforeChange");

			var fFlag = false;
			self.form.followers.subscribe(function (newVal) {
				if (fFlag) {
					return;
				}
				onArrayChange(ko.utils.compareArrays(_followers_oldval, newVal));

				if (!newVal || newVal.indexOf(self.form.assignee_id() + "") < 0) {
					self.form.assignee_id(0);
				}
				if (newVal && newVal.indexOf("0") >= 0 || newVal.indexOf(0) >= 0) {
					self.form.followers([]);
					return;
				}

				if (newVal[0] == "-1") {
					fFlag = true;
					self.form.followers(["-1"]);
					fFlag = false;
					newVal = ["-1"];

					var childs = self.children();
					for (var i = 0, iLen = childs.length; i < iLen; i++) {
						childs[i].form.followers(["-1"]);
					}
				}

				updateChangeData("followers", newVal);

				self.form._info.followers_disp(applyFollowers(newVal, self));
				_this.appModel.quickSave();
			});

			self.form._info.assignee_disp(applyAssignee(null, self));

			var assigneeOldVal = "";
			self.form.assignee_id.subscribe(function (oldVal) {
				assigneeOldVal = oldVal;
			}, "beforeChange");
			self.form.assignee_id.subscribe(function (newVal) {
				if (!assigneeOldVal && assigneeOldVal == newVal) {
					return false;
				}
				updateChangeData("assignee_id", newVal);
				self.form._info.assignee_disp(applyAssignee(newVal, self));
				_this.appModel.quickSave();
			});
			if (!self.form.task_id() && _this.isM) {
				self.form.assignee_id(Otime.UID);
			}

			self.tmp_flag = false;

			self.startFlag = false;

			self.form.start_date.subscribe(function (newVal) {
				 //console.log("start_date.subscribe : ", self.form.task_number(), newVal);
				updateChangeData("start_date", newVal ? new Date(newVal).format(Otime.sdf) : "");
				var tmp = _this.appModel.repeat_options();
				if (newVal) {
					tmp[5].name('Every Month (on ' + weekAndDay(newVal) + ')');
				} else {
					tmp[5].name('Every Month (on ' + weekAndDay(new Date()) + ')');
					//is_enb = false;
				}
				_this.appModel.repeat_options(tmp);
				reload_chosen(self);
				startDateSubscribe(newVal, self);

				if (self.form.is_milestone()) {
					self.form.duration(1);
				}
			});

			self.f_flag = false;
			//			var flag100 = false;
			self.form.finish_date.subscribe(function (newVal) {
				// console.log("finish_date.subscribe : ", self.form.task_number(), newVal);
				updateChangeData("finish_date", newVal ? new Date(newVal).format(Otime.sdf) : "");
				/*
								if (!flag100 && self.form.is_milestone()) {
									flag100 = true;
									self.form.start_date(newVal);
									flag100 = false;
									return;
								}
				*/
				finishDateSubscribe(newVal, self);
				_this.appModel.quickSave();
			});

			self.du_flag = false;
			self.form.duration.subscribe(function (newVal) {
				// console.log("duration.subscribe : ", self.form.task_number(), newVal);
				updateChangeData("duration", newVal);
				if (self.form.is_milestone()) {
					//self.du_flag = true
					self.form.duration(1);
					//self.du_flag = false;
					return;
				}
				durationSubscribe(newVal, self);
			});
			self.form.story_point = Otime.o(data.story_point || "");
			self.form.story_point.subscribe(function (newVal) {
				console.log("story point subscribe : ", newVal);
				updateChangeData("story_point", newVal);				
			});


			self.validateFlag = Otime.o("");

			self.validateFlag.subscribe(function (newVal) {
				if (!newVal)
					return false;

				newVal = self.parseFlag(newVal);
				var key = Number(newVal[1]);

				// console.log("Validate : ", newVal, self.form.task_number());

				switch (newVal[0]) {
					case "P":
					case "B":
						if (!self.updateChildFlags(key))
							return !1;
						self.updateParentFlags(key);
						break;
					case "U":
						self.updateParentFlags(key);
						break;
					case "D":
						if (!self.updateChildFlags(key))
							return !1;
						break;
				}
				self.checkPredecessor(self.form.task_number());
			});

			self.updateParentFlags = function (key) {
				if (self.parent().validateFlag) {
					self.parent().validateFlag("U" + key);
				}
			};

			self.updateChildFlags = function (key) {
				if (self.children().length > 0) {
					var childs = self.children();
					for (var i = 0, iLen = childs.length; i < iLen; i++) {
						if (childs[i].children().length == 0 && childs[i].validateFlag() != "") {
							_this.error = true;
							// console.log("Error at Child flag : ",
							// self.form.task_number());
							return false;
						}
						childs[i].validateFlag("D" + key);
					}
				}
				return true;
			};

			self.parseFlag = function (flag) {
				if (!flag)
					return ["", ""];
				return flag.toUpperCase().match(/(B|U|D|P)(\d+)/).slice(1, 3);
			};

			self.targetItems = [];
			self.checkPredecessor = function (task_number) {
				self.targetItems = [];
				task_number = task_number || self.form.task_number();

				/**
				 * Getting all parent and child items in single object with key
				 * as a task_numeber.
				 * 
				 * _this.allItems[task_number] will have the curresponding item.
				 */
				_this.getAllItems();

				var keys = Object.keys(_this.allItems), value = null;
				for (var i = 0, iLen = keys.length; i < iLen; i++) {
					value = _this.allItems[keys[i]].form.predecessors().split(",");
					for (var j = 0, jLen = value.length; j < jLen; j++) {
						var matches = value[j].match(_this.predecessor_expr);
						if (!matches) {
							continue;
						}
						if (Number(matches[10] || matches[8] || matches[5] || matches[1] || 0) == Number(task_number) && self.targetItems.indexOf(keys[i]) < 0) {
							var itm = _this.allItems[keys[i]];

							// if (itm.form.task_number() == Number(task_number)
							// || (itm.validateFlag() &&
							// itm.validateFlag().substr(0,1) == "B"))
							if (self.validateFlag() != "" && (itm.form.task_number() == Number(task_number) || (itm.validateFlag() && itm.validateFlag().substr(0, 1) == "B"))) {
								_this.error = j + 1;
								// console.log("Error at predec : ",
								// itm.form.task_number(), " - ",
								// Number(task_number), " - ",
								// self.validateFlag(), " - ",
								// itm.validateFlag());
								return false;
							}

							itm.validateFlag("P" + ++_this.increment_key);
							itm.updatePredecessor("", true);

							self.targetItems.push(keys[i]);
						}
					}
				}
			};

			self.predecFlag = false;
			self.form.predecessors.subscribe(function (newVal) {
				if (self.predecFlag == true || !newVal) {
					updateChangeData("predecessors", newVal);
					return false;
				}
				updateChangeData("predecessors", newVal);
				self.updatePredecessor(newVal);
			});

			self.updatePredecessor = function (newVal, manual) {
				if (newVal || manual === true) {
					newVal = (newVal || self.form.predecessors()).replace(" ", "").toUpperCase().split(",");

					var ret = [];

					if (manual !== true) {
						// Get all items in single Array _this.allItems
						_this.getAllItems();
					}

					var today = new Date().format(Otime.jdf);
					var start_dates = [], finish_dates = [], newPredec = "";

					for (var j = 0; j < newVal.length; j++) {
						if (newVal[j] == "#REF")
							continue;

						var matches = newVal[j].match(_this.predecessor_expr);
						if (!matches) {
							continue;
						}

						var id = Number(matches[10] || matches[8] || matches[5] || matches[1] || 0), type = matches[9] || matches[2] || "FS", // Default
							lag = Number(matches[7] || matches[4] || 0), lag_exp = "", value = "";

						if (lag) {
							lag_exp = matches[3] || matches[6];
						}
						// Roundup lag days to 365
						lag = lag > 365 ? 365 : lag;
						newPredec = id + type + (lag ? lag_exp + lag : "");
						lag = (lag_exp == "+") ? lag : -lag;

						/**
						 * Check weather predecessor task number is available in
						 * allItems Array, Forgetting duplicate predecessor,
						 */
						if (!id || !_this.allItems[id] || self.form.task_number() == id || ret.indexOf(newPredec) >= 0) {
							newPredec = "";
							continue;
						}

						!_this.allItems[id].form.finish_date() && _this.allItems[id].form.finish_date(today);
						!_this.allItems[id].form.start_date() && _this.allItems[id].form.start_date(today);

						if (manual !== true) {
							_this.increment_key = 0;
							_this.error = false;

							_this.clearValidateFlag(_this.appModel.items());

							self.validateFlag("B" + ++_this.increment_key);
							if (_this.error) {
								if (typeof _this.error != "boolean" && !isNaN(_this.error)) {
									_this.error = Number(_this.error) - 1;
									newVal[_this.error] = "#REF";
								}

								self.form.predecessors(newVal.join(","));
								// console.log("Error occured : ",
								// self.form.task_number());
								return false;
							}
						}

						ret.push(newPredec);

						switch (type) {
							case 'SS':
								start_dates.push(new Date(_this.allItems[id].form.start_date()).addDays(lag).getTime());
								break;
							case 'FF':
								finish_dates.push(new Date(_this.allItems[id].form.finish_date()).addDays(lag).getTime());
								break;
							case 'SF':
								finish_dates.push(new Date(_this.allItems[id].form.start_date()).addDays(lag - 1).getTime());
								break;
							case 'FS':
							default:
								start_dates.push(new Date(_this.allItems[id].form.finish_date()).addDays(lag + 1).getTime());
								break;
						}
					}
					self.predecFlag = true;
					self.form.predecessors(ret.join(","));
					self.predecFlag = false;

					if (start_dates.length && !finish_dates.length) {
						start_dates.sort().reverse();
						self.form.start_date(new Date(start_dates[0]).format(Otime.jdf));
					}

					if (finish_dates.length && !start_dates.length) {
						finish_dates.sort().reverse();
						var diff = (finish_dates[0] - new Date(self.form.finish_date()).getTime()) / (24 * 60 * 60 * 1000);
						self.form.start_date(new Date(self.form.start_date()).addDays(diff).format(Otime.jdf));
					}
					if (start_dates.length && finish_dates.length) {
						start_dates.sort().reverse();
						finish_dates.sort().reverse();

						if (Number(self.form.duration()) < (finish_dates[0] - start_dates[0]) / (24 * 60 * 60 * 1000)) {
							var diff = (finish_dates[0] - new Date(self.form.finish_date()).getTime()) / (24 * 60 * 60 * 1000);
							self.form.start_date(new Date(self.form.start_date()).addDays(diff).format(Otime.jdf));
						}
						else {
							self.form.start_date(new Date(start_dates[0]).format(Otime.jdf));
						}
					}
				}
			};

			data.custom_values = data.custom_values || {};

			$.each(_this.custom_fields, function (key, val) {
				var k = "cf_" + val.id;

				switch (val.fType) {
					case "user":
						self.form.custom_values[k] = Otime.o();
						self.form._info[k] = Otime.o();
						self.form.custom_values[k].subscribe(function (newVal) {
							updateChangeData(k, newVal, true);

							var usrs = Otime.Details.all_users;
							self.form._info[k]((usrs && usrs[newVal]) ? usrs[newVal].first_name : '');
						});
						self.form.custom_values[k](data.custom_values[k] || "");
						break;
					case "users":
						self.form.custom_values[k] = Otime.a([]);
						self.form._info[k] = Otime.o();
						self.form.custom_values[k].subscribe(function (newVal) {
							updateChangeData(k, newVal, true);

							var usrs = Otime.Details.all_users;// _this.appModel.users();
							var opt = [];

							for (var i = 0, iLen = newVal.length; i < iLen; i++) {
								if (usrs && usrs[newVal[i]]) {
									opt.push(usrs[newVal[i]].first_name);
								}
								else if (newVal[i] == Otime.UID) {
									opt.push(Otime.UFNAME);
								}
							}

							self.form._info[k](opt.join(", "));
						});
						if (data.custom_values[k] && !Array.isArray(data.custom_values[k])) {
							data.custom_values[k] = data.custom_values[k].split(",");
						}
						self.form.custom_values[k](data.custom_values[k] || []);
						break;
					default:
						var bg = "";
						if (val.fType == "select" && val.fOptions && val.fOptions.isMultiple) {
							if (data.custom_values[k] && !Array.isArray(data.custom_values[k])) {
								data.custom_values[k] = data.custom_values[k].split(",");
							}

							self.form.custom_values[k] = Otime.a(data.custom_values[k] || []);
							if (_this.appModel.cfOptionsByVal[k] && _this.appModel.cfOptionsByVal[k][data.custom_values[k]] && _this.appModel.cfOptionsByVal[k][data.custom_values[k]].bg) {
								bg = _this.appModel.cfOptionsByVal[k][data.custom_values[k]].bg
							}
							self.form.cvObj[k] = Otime.o(bg);
							/*
														// Filter
														if (_this.appModel.filter_column && !_this.appModel.filter_column[k])
														{
															parent.filter_column[k] = function(_item, _elem){
							console.log(_item, _elem);
															};
														}
							*/
						}
						else {
							self.form.custom_values[k] = Otime.o(data.custom_values[k] || "");
							if (_this.appModel.cfOptionsByVal[k] && _this.appModel.cfOptionsByVal[k][data.custom_values[k]] && _this.appModel.cfOptionsByVal[k][data.custom_values[k]].bg) {
								bg = _this.appModel.cfOptionsByVal[k][data.custom_values[k]].bg
							}
							self.form.cvObj[k] = Otime.o(bg);
						}

						self.form.custom_values[k].subscribe(function (newVal) {
							_this.appModel.cfOptionsByVal[k] && _this.appModel.cfOptionsByVal[k][newVal] && self.form.cvObj[k](_this.appModel.cfOptionsByVal[k][newVal].bg);
							updateChangeData(k, newVal, true);
						});
						break;
				}
			});

			var tmpArr = [];

			if (data.children != undefined && Object.keys(data.children).length > 0) {
				if (data.children != undefined) {
					data.children = Object.values(data.children).setKeys(_this.Keys);
				}
				tmpArr = [];

				data.children = data.children.sort(function (a, b) {
					var x = Number(a.order_id);
					var y = Number(b.order_id);
					return ((x < y) ? -1 : ((x > y) ? 1 : 0));
				});
				for (var i = 0; i < data.children.length; i++) {
					var tmp_task = new _this.TaskContentModel(data.children[i], self);
					tmpArr.push(tmp_task);

					if (_this.TID == data.children[i].task_id) {
						_this.appModel.isPane(1);
						_this.TID = data.children[i].task_number;
						self.show_child(true);
					}
				}
				self.children(tmpArr.slice());
			}

			self.apply = function (item) {
				if (item.isDirty()) {
					item.form.commit();
					var keys = Object.keys(item.form);
					for (var i = 0; i < keys.length; i++) {
						if (Otime.i(item.form[keys[i]]) && typeof item.form[keys[i]].isDirty == "function" && item.form[keys[i]].isDirty()) {
							_this.appModel.selectedItem().form[keys[i]](item.form[keys[i]]());
						}
					}
				}
				_this.appModel.is_edit_mode(false);
			};

			self.cancel = function (item) {
				item.form.rollback();
				_this.appModel.is_edit_mode(false);
			};

			self.timesheet = Otime.o(null);
			if (_this.timer && data.task_id == _this.timer.project_task_id) {
				_this.applyTimesheet(self, _this.timer);
			}

			self.is_over_due = Otime.o();
			self.is_today = Otime.o();
			self.isDirty = Otime.c(function () {
				if (self.form.name()) {
					self.tooltip('#' + self.form.task_number() + " - " + self.form.name());
				}
				else {
					self.tooltip("");
				}
				var fDt = new Date(self.form.finish_date());
				self.is_over_due(fDt.isPast() && !fDt.isToday() && !self.is_closed());
				self.is_today(fDt.isToday());

				// updateChangeData("predecessors", newVal);

				return false;
			});
		};

		var recursiveItems = function (list, listObservableArray, clbk) {
			var val = null;
			for (var i = 0; i < list.length; i++) {
				val = list[i];
				if (val.form && val.form.task_number()) {
					if (clbk && clbk(val, listObservableArray, i) === false) {
						return false;
					}
					if (val.children() && val.children().length > 0) {
						if (recursiveItems(val.children(), val.children, clbk) === false) {
							break;
						}
					}
				}
			}
		};
		_this.UpdateTaskContent = function (task_ids) {
			// task_ids	= [3062, 3076];
			if (!$.isArray(task_ids)) {
				// console.log("Task ID is not an Array.");
				return false;
			}

			Otime.app.loadData(new Otime.ContextModel("items", {
				project_id: _this.appModel.project_id(),
				task_ids: task_ids
			}, function (cont) {
				var resp = cont.response;
				if (resp.items && resp.items.otvalues && Object.keys(resp.items.otvalues)) {
					var items = resp.items.otvalues.setKeys(resp.items.otkeys, null, "task_id");
					var count = Object.keys(items).length;
					var i = 0;

					if (_this.appModel) {
						recursiveItems(_this.appModel.items(), _this.appModel.items, function (itm, list, pos) {
							if (items[itm.form.task_id()]) {
								i++;
								var tmpItem = items[itm.form.task_id()];
								tmpItem.followers = tmpItem.followers.split("-");
								var newItem = new _this.TaskContentModel(tmpItem, itm.parent());
								if (itm.children()) {
									newItem.children(itm.children());
								}
								list.splice(pos, 1, newItem);
								if (count == i) {
									return false;
								}
							}
							return true;
						});
					}
				}
			}));
		};

		_this.clearValidateFlag = function (list) {
			var val = null;
			for (var i = 0; i < list.length; i++) {
				val = list[i];
				val.validateFlag("");
				if (val.children() && val.children().length > 0) {
					_this.clearValidateFlag(val.children());
				}
			}
		};

		/**
		 * Getting all items recursivly into single array "_this.allItems".
		 * Array key is a task_number.
		 * 
		 * @param list -
		 *			array of items.
		 * @param prop -
		 *			Property value, If prop set "allItems" object will hold
		 *			the particular property of item.form, - eg:-
		 *			item.form.task_status_id
		 * @returns
		 */
		_this.getAllItems = function (list, form, prop, clbk) {
			var allItems = {};
			var allItemsArr = [];

			var recursive = function (list, form, prop) {
				var val = null;
				for (var i = 0; i < list.length; i++) {
					val = list[i];

					if (clbk && typeof clbk == "function") {
						clbk(val);
					}
					if (val.form && val.form.task_number()) {
						if (form) {
							allItems[val.form.task_number()] = (prop ? val.form[prop] : val.form);
						} else {
							allItems[val.form.task_number()] = (prop ? val[prop] : val);
						}

						allItemsArr.push(allItems[val.form.task_number()]);

						if (val.children() && val.children().length > 0) {
							recursive(val.children(), form, prop);
						}
					}
				}
			};

			if (_this.appModel instanceof _this.TaskListModel == false) {
				_this.appModel = Otime.app.model;
			}

			allItems = {};
			allItemsArr = [];
			if (list) {
				recursive(list, form, prop);
			}
			else if (_this.appModel) {
				list = _this.appModel.items();
				recursive(list, form, prop);
				_this.allItems = allItems;
				_this.allItemsArr = allItemsArr;
			}

			return allItems;
		};

		/**
		 * Refresh the page to reload all details.
		 * 
		 * @param project_id -
		 *			If project_id set listing items only update, otherwise
		 *			whole model reload.
		 * @returns
		 */

		_this.ResetTmpl = function () {
			_this.list_container.html($("#task-tmpl").html());
			if (!_this.isToDo) {
				// Otime.getTaskTmpl(_this.list_container, _this.language, _this.custom_fields);
				Otime.getTaskTmpl(_this.list_container, _this.language, _this.custom_mod);
			}
			_this.UpdateContainers();
		};

		_this.ReBindAll = function () {
			ko.applyBindings(_this.appModel, _this.list_container.get(0));
			_this.Splitters.init();
			$("#tsk-loading").hide();
			_this.list_container.show();
		};

		var taskColumns = {
			"TT": { id: 0, fCode: "TT", fEnable: 1, isSys: 1, fName: "Task Type", colName: "ttype" },
			"DU": { id: 0, fCode: "DU", fEnable: 1, isSys: 1, fName: "Duration", colName: "duration" },
			"SD": { id: 0, fCode: "SD", fEnable: 1, isSys: 1, fName: "Start Date", colName: "sdate" },
			"FD": { id: 0, fCode: "FD", fEnable: 1, isSys: 1, fName: "Finish Date", colName: "fdate" },
			"EH": { id: 0, fCode: "EH", fEnable: 1, isSys: 1, fName: "Estimated Hours", colName: "esthrs" },
			"AH": { id: 0, fCode: "AH", fEnable: 1, isSys: 1, fName: "Actual Hours", colName: "acthrs" },
			"ST": { id: 0, fCode: "ST", fEnable: 1, isSys: 1, fName: "Status", colName: "status" },
			"AS": { id: 0, fCode: "AS", fEnable: 1, isSys: 1, fName: "Assignee", colName: "assignee" },
			"FL": { id: 0, fCode: "FL", fEnable: 1, isSys: 1, fName: "Followers", colName: "followers" },
			"PR": { id: 0, fCode: "PR", fEnable: 1, isSys: 1, fName: "Predecessors", colName: "predec" }
		};
		//if(Otime.isSPRINT){
			taskColumns["SP"] = { id: 0, fCode: "SP", fEnable: 1, isSys: 1, fName: "Sprint", colName: "sprint" }
//}

		_this.ResetTaskColumns = function () {
			_this.cfByFCode = {};
			// _this.custom_mod = [];
			_this.custom_mod.length = 0;

			Object.values(taskColumns).forEach(function (val) {
				_this.cfByFCode[val.fCode] = val;
				// _this.custom_mod.push(JSON.parse(JSON.stringify(val)));
				_this.custom_mod.push(val);
			});
		};

		_this.Refresh = function (project_id, sprint_id, clbk, isRefreshOnly, isArchived) {			
			if (refreshFlag) {
				refreshFlag = false;
				return false;
			}
			//			_this.list_container.hide();
			$("#tsk-loading").show();
			var _loadData = function (project_id, sprint_id) {
				var status = _this.appModel.task_status_id();

				if (status == -1 || status == -3 || status == _this.appModel._info.closedStatusId) {
					status = "all";
				}
				else {
					status = "active";
				}

				// status = "all";

				// var filterStatus = {"#-1":"all", "#0":"active"};
				// var filterStatus = {"#-1":"all", "#0":"active"};
				// filterStatus["#" + _this.appModel._info.closedStatusId] =
				// "closed";

				// var status = filterStatus["#" +
				// _this.appModel.task_status_id()] || "active";
				var tmpP = Otime.Storage.get("tasks_project_id") - 0;
				tmpP = tmpP ? tmpP : project_id - 0;

				if (isArchived) {
					status = "archived";
				}

				var ajaxStart = new Date().getTime();
				Otime.app.loadData(new Otime.ContextModel("listing/" + status, {
					project_id: tmpP,
					sprint_id: sprint_id,
					todo: _this.isToDo ? 1 : 0
				}, function (cont) {
					var start1 = new Date().getTime();
					// console.log("Ajax Elapsed : ", start1 - ajaxStart);					
					if(_this.appModel.sprint_is_complete==0){
						 _this.appModel.items([]);
					}else{
						const startIndex = _this.appModel.items().length - 10;
						// Remove the last 10 elements
						_this.appModel.items().splice(startIndex, 10);
					}
					_this.appModel._info.is_nodata(false);

					var resp = cont.response;
					_this.appModel.hours_per_day = resp.hours_per_day - 0;
					if (resp.timesheets && resp.timesheets.otvalues) {
						resp.timesheets = resp.timesheets.otvalues.setKeys(resp.timesheets.otkeys);
						_this.timer = resp.timesheets[0];
					}

					// console.log("resp.custom_mod ", resp.custom_mod);

					_this.ResetTaskColumns();

					if (resp.custom_mod && resp.custom_mod.otvalues) {
						_this.custom_mod.forEach(function (itm) {
							itm.fEnable = 0;
						});

						// Convert resp.custom_mod.otvalues to a Set of fNames
						const respFNamesSet = new Set(resp.custom_mod.otvalues.map(val => val[1])); // Assuming fName is the second element in each inner array

						// Filter _this.custom_mod to keep only objects with fName present in respFNamesSet
						_this.custom_fields = _this.custom_mod.filter(item => respFNamesSet.has(item.fName));
						_this.custom_mod = _this.custom_mod.filter(item => respFNamesSet.has(item.fName));

						resp.custom_mod = resp.custom_mod.otvalues.setKeys(resp.custom_mod.otkeys, function (val) {
							val.id = val.id - 0;
							val.fEnable = 1;
							val.fCode = val.fCode || ("cf_" + val.id);

							if (taskColumns[val.fCode]) {
								val.fName = taskColumns[val.fCode].fName;
							}

							if (_this.cfByFCode[val.fCode]) {								
								Object.assign(_this.cfByFCode[val.fCode], val);
							}
							else {								
								_this.cfByFCode[val.fCode] = val;
								_this.custom_mod.push(val);
							}
							// _this.appModel.custom_options["cf_" + val.id] = val.fOptions.items;
						});
					}
					if (resp.custom_fields && resp.custom_fields.otvalues) {
						var cust_fields = [];
						resp.custom_fields = resp.custom_fields.otvalues.setKeys(resp.custom_fields.otkeys, function (val) {
							val.id = val.id - 0;
							val.isSys = val.isSys - 0;

							val.fCode = "cf_" + val.id;

							if (_this.cfByFCode[val.fCode]) {
								val.fEnable = 1;
								_this.cfByFCode[val.fCode] = Object.assign(_this.cfByFCode[val.fCode], val);
							}
							else {
								val.fEnable = 1;
								_this.cfByFCode[val.fCode] = val;
							}

							if (val.fOptions) {
								val.fOptions = JSON.parse(val.fOptions);

								if (val.fOptions.items && val.fOptions.items.length) {
									if (typeof val.fOptions.items == "string") {
										val.fOptions.items = val.fOptions.items.split(",");
									}
									_this.appModel.custom_options[val.fCode] = val.fOptions.items;

									if (!_this.appModel.cfOptionsByVal[val.fCode]) {
										_this.appModel.cfOptionsByVal[val.fCode] = {};
									}

									$.each(val.fOptions.items, function (key, fOpt) {
										_this.appModel.cfOptionsByVal[val.fCode][fOpt.val] = fOpt;
									});
								}
							}
							_this.custom_mod.push(val);
						});

						_this.custom_fields = resp.custom_fields;
						_this.appModel.custom_fields(resp.custom_fields);
					}
					_this.custom_mod.forEach(function (itm) {
						_this.custom_mod_storage.push(itm);
					});    				
					//check if fields not in storage field remove that from custom_mod array
					var columns = Otime.Storage.get("tasks_columns");
					if (columns) {
						// Split the stored columns string into an array of column names and ordNo pairs
						var enabledFieldsArr = columns.split(",");

						// Check if the stored columns contain ord numbers (i.e., new storage format)
						var isNewStorage = enabledFieldsArr.some(function(field) {
							return field.includes(":");
						});

						_this.custom_mod.forEach(function (itm) {
							if (isNewStorage) {
								// New storage format: field name with ordNo
								var foundItem = enabledFieldsArr.find(function (field) {
									// Split the field into name and ordNo
									var [fieldName, ordNo] = field.split(":");
									return fieldName.trim() === itm.fName;
								});
					
								if (foundItem) {
									// If the item's fName exists in the stored columns, update its ordNo
									var [, ordNo] = foundItem.split(":");
									itm.ordNo = ordNo.trim(); // Update the ordNo
								} else {
									// If itm.fName does not exist in the stored columns, set itm.fEnable to 0
									itm.fEnable = 0;
								}
							} else {
								// Old storage format: only field names
								if (!enabledFieldsArr.includes(itm.fName)) {
									// If itm.fName does not exist in the stored columns, set itm.fEnable to 0
									itm.fEnable = 0;
								}
							}
						});
					}
					sortCustomFields();					
					/*
					console.clear();
					console.table(_this.cfByFCode);
					console.table(_this.custom_mod);
					*/
					_this.appModel.new_id(resp.new_id);

					ko.cleanNode(_this.list_container.get(0));
					_this.ResetTmpl();
					// $(".chosen-container", _this.list_container).remove();

					if (resp.items && Object.keys(resp.items).length) {
						var starts = [], finish = [];
						_this.Keys = resp.items.otkeys;
						// resp.items.otvalues = Object.values(resp.items.otvalues);
						resp.items = resp.items.otvalues.setKeys(_this.Keys, function (itm) {
							// if (itm.is_parent || !itm.duration)
							// SURESH
							if (!itm.duration || !itm.start_date || itm.start_date == "0000-00-00") {
								return true;
							}

							if (itm.start_date && itm.start_date != "0000-00-00") {
								starts.push(Otime.stoj(itm.start_date).getTime());
							}
							if (itm.finish_date && itm.finish_date != "0000-00-00") {
								finish.push(Otime.stoj(itm.finish_date).getTime());
							}
						});

						starts = starts.sort()[0] || new Date().getMonthStart();
						finish = finish.sort().reverse()[0] || new Date().addMonth(1).getMonthEnd();

						starts = new Date(starts);
						finish = new Date(finish);

						if (starts.getMonth() == finish.getMonth()) {
							finish.addMonth(1);
						}
						_this.appModel.ganttTime({
							min_date: starts,
							max_date: finish
						});

						_this.appModel.apply(resp);
					}
					else {
						_this.appModel._info.is_nodata(true);
						_this.appModel.ganttTime({
							min_date: new Date().getMonthStart(),
							max_date: new Date().addMonth(1).getMonthEnd()
						});

						_this.appModel.insertNew(null, 20);
					}

					_this.appModel.project_id(tmpP);

					var start2 = new Date().getTime();
					// console.log("Process Elapsed : ", start2 - start1);
					_this.ReBindAll();
					var start3 = new Date().getTime();
					// console.log("Render Elapsed : ", start3 - start2);

					clbk && typeof clbk == "function" && clbk();
					_this.appModel.search();
					_this.appModel.afterInit();

					// console.log("Process elapsed : ", new Date().getTime() - start3);
					// console.log("Total Elapsed : ", (new Date().getTime() - start1));
					return true;
				}));
			};

			if (isRefreshOnly && (project_id || sprint_id)) {
				_loadData(project_id, sprint_id);
				return;
			}

			/* Projects Begins */
			var default_project = null;
			default_project = project_id || _this.PID || Object.keys(Otime.Details.all_projects)[0];
			default_project = Number(Otime.Storage.get("tasks_project_id") || default_project || 0);
			if (!Otime.Details.all_projects[default_project]) {
				default_project = Object.keys(Otime.Details.all_projects)[0];
				// Object.keys(Otime.Details.all_projects)
			}
			//			default_project		= Otime.Details.all_projects[default_project];

			Otime.Storage.set("tasks_project_id", default_project);
			_this.appModel.project_id(default_project);
			_this.appModel.project_name(Otime.Details.all_projects[default_project + ""].project_name);

			var tmpArr = [];
			$.each(Otime.Details.getActiveProjects(), function (key, val) {
				tmpArr.push({
					label: val.project_code + val.project_name + (val.task_count ? (' (' + val.task_count + ')') : ''),
					value: val.project_id
				});
			});
			_this.appModel.projects(tmpArr);
			
			/* Projects End */

			/* Task Types Begins */
			_this.taskTypesList = {};
			_this.ttypeByName = {};

			var lbl = "";
			tmpArr = [];
			tmpArr.push(new Otime.DropDownModel({
				"label": "",
				"value": "",
				"id": 0
			}));

			_this.ttypeById = Otime.Details.getProjectTaskTypes(default_project, function (key, val) {
				if (val) {
					tmpArr.push(new Otime.DropDownModel({
						"label": val.name,
						"value": val.name,
						"id": val.task_type_id
					}));
					_this.taskTypesList[val.task_type_id] = val.name;
					_this.ttypeByName[val.name] = val.task_type_id;
				}
			});
			_this.appModel.task_types(tmpArr);
			tmpArr = tmpArr.slice();
			tmpArr.splice(0, 0, new Otime.DropDownModel({
				"label": "All task types", // "Select task type",
				"value": "0",
				"id": 0
			}));
			_this.appModel.search_task_types(tmpArr);
			/* Task Types End */

			/* Task Users Begins */
			_this.tUsersByName = {};
			var _users_list = [{
				user_id: 0,
				first_name: _this.isToDo ? "" : "Any User",
				is_active: "1",
				last_name: "",
				user_image: Otime.baseUrl + "assets/img/noimg_48.png"
			}];
			var _followers_list = [{
				user_id: -1,
				first_name: "All User",
				is_active: "1",
				last_name: "",
				modType: "",
				user_image: Otime.baseUrl + "assets/img/noimg_48.png"
			}];
			var _sprint_list = [{
				sprint_id: -1,
				name: "All Sprint"
			}];
			var _department = [];
			var _users = {
				"0": {
					user_id: 0,
					first_name: "Select the User",
					is_active: "1",
					last_name: "",
					user_image: Otime.baseUrl + "assets/img/noimg_48.png"
				}
			};

			Otime.Details.getProjectUsers(default_project, function (key, val) {
				if (!val) {
					return true;
				}

				if (val.user_image.search('://') == -1) {
					val.user_image = Otime.USIP + (val.user_image || "no_usr.jpg");
				}
				_this.tUsersByName[val.first_name] = val.user_id;
				if (!!(val.is_active - 0)) {
					_users[val.user_id] = val;
					_users_list.push(val);
					val.modType = "";
					_followers_list.push(val);
				}
			});

			var _departmentById = {
				0: {
					user_dept_id: 0,
					name: "Others",
					users: Otime.a([]),
					show_user: Otime.o(true),
				}
			};
			_department.push(_departmentById[0]);

			$.each(Otime.Details.departments, function (key, val) {
				_followers_list.push({
					user_id: "D" + val.user_dept_id,
					first_name: val.department,
					user_image: "",
					modType: "D"
				});

				_departmentById[val.user_dept_id] = {
					user_dept_id: val.user_dept_id,
					name: val.department,
					users: Otime.a([]),
					show_user: Otime.o(true),
				};
				_department.push(_departmentById[val.user_dept_id]);
			});

			/*
			_followers_list.mergeSort(function (a, b) {
				return a.first_name > b.first_name ? 1 : (a.first_name < b.first_name ? -1 : 0);
			});
			*/

			$.each(Otime.Details.all_sprint, function(key, val){				
				if(val.project_id == _this.appModel.project_id()){
					_sprint_list.push({
						"sprint_id": val.sprint_id,
						"name": val.name,
						"is_complete": val.is_complete
					});
				}
			});			
			var count = 0; // Counter to track the number of printed records			
			var completed_sprint = [];
			var count = 0;
			var sprints = Otime.Details.completed_sprint; // Access the observable object's underlying value
			var sprintKeys = Object.keys(sprints); // Get the keys of the object

			// Convert keys to numbers and sort in reverse order
			sprintKeys = sprintKeys.map(Number).sort((a, b) => b - a);

			// Iterate over the sorted keys
			for (var i = 0; i < sprintKeys.length; i++) {
				var key = sprintKeys[i];
				var val = sprints[key];
				if (count < 3 && _this.appModel && val && val.project_id == _this.appModel.project_id()) {
					completed_sprint.push({
						"sprint_id": val.sprint_id,
						"name": val.name,
						"is_complete": val.is_complete
					});
					count++; // Increment counter after adding a record
				}
			}

			if(completed_sprint.length > 0){
				_sprint_list.push({"sprint_id": 0,"name":"====================="});
				_sprint_list = _sprint_list.concat(completed_sprint);
			}

			/* Sprint */
			var default_sprint = null;
			default_sprint = sprint_id || (_sprint_list.length > 1) ? Object.keys(_sprint_list)[1] : Object.keys(_sprint_list)[0];
			default_sprint = Number(Otime.Storage.get("tasks_project_sprint_id") || default_sprint || 0);
			if (!_sprint_list[default_sprint]) {
				default_sprint = (_sprint_list.length > 1) ? Object.keys(_sprint_list)[1] : Object.keys(_sprint_list)[0];
			}
			Otime.Storage.set("tasks_project_sprint_id", default_sprint);
			_this.appModel.sprint_id(default_sprint);
			_this.appModel.sprint_name(_sprint_list[default_sprint + ""].name);

			_this.appModel.users(_users);
			_this.appModel.users_sort(_users_list);
			_this.appModel.sprint(_sprint_list);
			_this.appModel.followers(_followers_list);

			_this.all_users = Otime.Details.all_users;

			Otime.Details.getProjectUsers(default_project, function (key, usr) {
				if (!usr) {
					return true;
				}

				if (!!(usr.is_active - 0)) {
					usr.hours = Otime.a();
					usr.hoursByDate = {};
					_this.usersById[usr.user_id] = usr;
					if (!_departmentById[usr.department])
					{
						_departmentById[usr.department] = {
							user_dept_id: usr.department,
							name: "---Trashed---",
							users: Otime.a([]),
							show_user: Otime.o(true)
						};
					}
					_departmentById[usr.department].users.push(usr);
				}

			});

			_this.appModel.department(_department);


			/* Task Users End */

			/* Task Status Begins */
			var status1 = [], status2 = [{
				name: "All Tasks",
				task_status_id: -1,
				bg_color: "transparent",
				text_color: "#000000",
				count: Otime.o(1)
			}, {
				name: "Active Tasks",
				task_status_id: -2,
				bg_color: "transparent",
				text_color: "#000000",
				count: Otime.o(1)
			}, {
				name: "Recent Tasks",
				task_status_id: -3,
				bg_color: "transparent",
				text_color: "#000000",
				count: Otime.o(1)
			}], tmp = null;

			_this.task_status = {};
			_this.tstatByName = {};

			$.each(Otime.Details.all_task_status, function (key, val) {
				val.count = Otime.o(1);
				status1.push(val);
				status2.push(val);

				_this.task_status[val.task_status_id] = val;
				_this.tstatByName[val.name] = val.task_status_id;

				if (!!(val.is_default - 0)) {
					_this.appModel.default_status = val.task_status_id;
				}

				if (val.is_closed - 0) {
					_this.appModel._info.closedStatusId = val.task_status_id;
				}
			});
			_this.appModel.task_status(status1);
			_this.appModel._info.task_status(status2);
			_this.appModel.default_status = _this.appModel.default_status || 0;
			/* Task Status End */

			if (!project_id && !isIE && default_project) {
				refreshFlag = true;
				// _this.isM=false;
				_this.isM = (Otime.Details.all_projects[default_project].user_role == "M");
				_this.appModel.project_id(default_project);
			}

			initFlag = false;
			Otime.Menu.ReplaceURL(_this.name + (_this.isToDo ? "/todo/" : "/") + default_project);

			_loadData(default_project,sprint_id);
			return true;
		};

		_this.applyLinks = function (refreshBox) {
			if(_this.appModel.gantt.zoom=="m") _this.appModel.getUserHours(_this.appModel.project_id());
			var _ganttObj = _this.appModel.gantt;

			// console.log("Called Apply Links");
			if (refreshBox) {
				_this.getAllItems(null, null, null, function (item) {
					_ganttObj.resizeTaskBox(item);
				});
			}
			else {
				_this.getAllItems();
			}

			_ganttObj.clearLinks();

			//			var keys = Object.keys(_this.allItems);
			for (var i = 0, iLen = _this.allItemsArr.length; i < iLen; i++) {
				// var current = _this.allItems[keys[i]];
				var current = _this.allItemsArr[i];

				if (current.form.predecessors()) {
					var predecArr = current.form.predecessors().split(",");

					for (var j = 0; j < predecArr.length; j++) {
						var matches = predecArr[j].match(_this.predecessor_expr);
						if (!matches) {
							continue;
						}

						var number = Number(matches[10] || matches[8] || matches[5] || matches[1] || 0),
							type = matches[9] || matches[2] || "",
							target = _this.allItems[number];

						if (target) {
							_ganttObj.drawLink(target, current, type);
						}
					}
				} else {
					// Remove links if exist for empty predecessor.
					$("[to='" + current.form.task_number() + "']", _ganttObj.element).remove();
					$("[from='" + current.form.task_number() + "']", _ganttObj.element).remove();
				}
			}
		};

		_this.applyGantt = function (data) {
			data = data || {};

			_this.appModel.gantt = new Gantt({
				name: "TasksGantt",
				element: $("#box3-body.gantt-body"),
				task_table: $("#task-table1"),
				parentId: "#grid-container",
				startMillis: data.min.clearTime() || new Date().clearTime().getMonthStart(),
				endMillis: data.max.clearTime() || new Date().clearTime().getMonthEnd(),
				minDate: data.min.clearTime(),
				maxDate: data.max.clearTime(),
				zoom: "y" //y, s, q, m, w // w, m, q, s, y
			}).init();
			setTimeout(function () {
				_this.appModel.gantt.centerOnToday();
				// _this.appModel.gantt.centerOnData();
			}, 500);
		};
		_this.applyUsersGantt = function (data) {
			data = data || {};

			_this.appModel.uGantt = new Gantt({
				name: "UsersGantt",
				element: $("#box5-body.gantt-body"),
				task_table: $("#box4-body"),
				parentId: "#user-grid-container",
				startMillis: data.min.clearTime() || new Date().clearTime().getMonthStart(),
				endMillis: data.max.clearTime() || new Date().clearTime().getMonthEnd(),
				minDate: data.min.clearTime(),
				maxDate: data.max.clearTime(),
				zoom: "y" //y, s, q, m, w // w, m, q, s, y
			}).init();
			setTimeout(function () {
				_this.appModel.uGantt.centerOnToday();
				// _this.appModel.gantt.centerOnData();
			}, 500);
		};

		_this.Splitters = null;

		_this.Splitter_ToDo = function () {
			var self = this;

			self.init = function () {
				var heads = $("#header-container #vph > div"),
					grid = $("#grid-container #view-port"),
					box1also = $("#grid-container #box1-body, #scroller #scr1"),
					scr1bar = $("#scroller #scr1"),
					box3head = $("#box3-head"),
					box3also = $("#grid-container #box3-body, #scroller #scr3"),
					scr3bar = $("#scroller #scr3"),
					tbl1also = $("#box1-head .table, #scroller #scr1 .bar"),
					tbl1 = $("#task-table1"),
					tbl3also = $("#box3-head .table, #scroller #scr3 .bar"),
					tbl3 = $("#box3-body > .table");

				var gridPane = $("#grid-pane");
				var box1 = box1also;
				var box3 = box3head.add(box3also);
				gridPane.css({
					width: "calc(70% - 30px)"
				});
				box1.css({
					width: "100%"
				});
				if (box3.get(0)) {
					gridPane.css({
						width: "100%"
					});
					box1.css({
						width: "50%"
					});
					box3.css({
						width: "50%"
					});
					// Box1 resizable
					//					tbl1also.width(tbl1.width());
					/*
										 var box1head = $("#box1-body");
										 box1head.resizable({
											 handles: "e",
											 minWidth: 500,
											 helper: "ui-resizable-helper",
											 stop: function(event, ui){
												 box1also.width(box1head.width());
												 box3.width(grid.width() - (box1head.width() + 2));
												 tbl1also.width(tbl1.width());
												 tbl3also.width(tbl3.width());
											 }
										 });
					*/
					// Update horizondal scroll
					$("#scroller #scr3 .bar").width($("#box3-body #tswTable").width());
					$("#box3-body, #scroller #scr3").unbind("scroll").scroll(function (e) {
						box3.not($(this)).scrollLeft($(this).scrollLeft());
					});
				}
				self.initPane();
			};

			self.initPane = function () {
				/*
								var pane = $("#pane-container");
								$("#grid-pane").resizable({
									handles : "s",
									helper : "ui-resizable-helper",
									minHeight : pane.innerHeight() * 0.30, // 30%
									maxHeight : pane.innerHeight() * 0.70, // 70%
									start : function(event, ui){
										_this.appModel.isPane(true);
										// $("#bottom-pane").css({height: "0%"});
									},
									stop : function(event, ui){
										$("#bottom-pane").innerHeight(pane.innerHeight() - ui.size.height);
									}
								});
								$(".ui-resizable-handle.ui-resizable-s").css("z-index", "2");
				*/
				self.updatePane(false);
			};

			self.uninit = function () {
				if ($("#grid-pane").data("resizable")) {
					$("#grid-pane").resizable('destroy');
				}
			};

			self.updatePane = function (isPane) {
				//				if (isPane)
				//				{
				//					$("#grid-pane").css({
				//						height : "60%"
				//					});
				//					$("#bottom-pane").css({
				//						height : "40%"
				//					});
				//				}
				//				else
				//				{
				$("#grid-pane").css({
					height: "100%"
				});
				//				}

				var handle = null;
				$("#right-pane").unbind("mouseenter").unbind("mouseleave");
				if (_this.appModel && !_this.appModel.is_pinned()) {
					$("#right-pane").bind({
						mouseenter: function () {
							clearTimeout(handle);
						},
						mouseleave: function () {
							handle = setTimeout(function () {
								if (_this.appModel.is_detail()) {
									_this.appModel.isPane(false);
								}
							}, 1750);
						}
					});
				}
			};
		};

		_this.Splitter_Task = function () {
			var self = this;

			self.init = function () {
				var heads = $("#header-container #vph > div"),
					grid = $("#grid-container #view-port"),
					box1head = $("#box1-head"),
					box1also = $("#grid-container #box1-body, #scroller #scr1"),
					scr1bar = $("#scroller #scr1"),
					box2head = $("#box2-head"),
					box2also = $("#grid-container #box2-body, #scroller #scr2"),
					scr2bar = $("#scroller #scr2"),
					box3head = $("#box3-head"),
					box3also = $("#grid-container #box3-body, #user-grid-container #box5-body, #scroller #scr3"),
					scr3bar = $("#scroller #scr3"),
					tbl1also = $("#box1-head .table, #scroller #scr1 .bar"),
					tbl1 = $("#task-table1"),
					tbl2also = $("#box2-head .table, #scroller #scr2 .bar"),
					tbl2 = $("#task-table2"),
					tbl3also = $("#box3-head .table, #scroller #scr3 .bar"),
					tbl3 = $("#box3-body > .table"),
					tbl4also = $("#user-grid-container #box5-body"),
					tbl4 = $("#box4-body");

				var box1 = box1head.add(box1also);
				var box2 = box2head.add(box2also);
				var box3 = box3head.add(box3also);
				var box4 = tbl4;
				var box5 = tbl4also;

				var isBox2 = !!(box2head.get(0) && box2also.get(0));
				var isBox3 = !!(box3head.get(0) && box3also.get(0));
//console.log("*******Storage",Otime.Storage.get("task_grid_size_box1"),Otime.Storage.get("task_grid_size_box2"));
//console.log("********isBox2",isBox2,":",isBox3,":",_this.appModel && _this.appModel.isPane());
				// Box width setting.
				/*box1.css({
					width: ((_this.appModel && _this.appModel.isPane()) || isBox3 ? "35%" : Otime.Storage.get("task_grid_size_box1","35%")),
					//width: isBox2 || isBox3 ? "35%" : "100%",
					left: 0
				});*/
				box1.css({
					width: Otime.Storage.get("task_grid_size_box1","35%"),
					left: 0
				});

				if (isBox2 && _this.appModel && $("> div:visible", grid).length <= 2) {
					/*
					box2.width(box1.parent().width() - box1.width());
					*/

					/*box2.css({
						width: ((_this.appModel && _this.appModel.isPane()) || isBox3 ? "65%" : Otime.Storage.get("task_grid_size_box2", "65%"))
					});*/
					box2.css({
						width: Otime.Storage.get("task_grid_size_box2", "65%")
					});
				}
				else {
					if (box3.is(".tsa")) {
						box2.css({
							width: "45%"
						});
						box3.css({
							width: isBox2 ? "20%" : "65%"
						});
					}
					else {
						/*
						var pendingWid = box1.parent().width() - box1.width();
						pendingWid = Math.floor(pendingWid/2);
						box2.width(pendingWid);
						box3.width(pendingWid);

						box4.width(Math.floor(box1.width() + box2.width()));
						box5.width(pendingWid);
						*/

						box2.css({
							width: "15%"
						});
						box3.css({
							width: isBox2 ? "50%" : "65%"
						});
						box4.css({
							width: isBox2 ? "50%" : "35%"
						});
						box5.css({
							width: isBox2 ? "50%" : "65%"
						});
					}
				}

				self.initPane();

				setTimeout(function () {
					tbl1also.width(tbl1.width());
					tbl2also.width(tbl2.width());
				}, 1000);

				var box2Wid = "";
				// Box1 resizable
				box1head.resizable({
					handles: "e",
					minWidth: 200,
					helper: "ui-resizable-helper",
					stop: function (event, ui) {
						box1also.width(box1head.width());
						box2Wid = grid.width() - (box1head.width() + (box3head.width() || 0) + 1);
						if (box2Wid < 20) {
							box2Wid = 50;
							box2.width(box2Wid);
							box3.width(grid.width() - (box1head.width() + box2head.width() + 2));
						}
						else {
							box2.width(box2Wid);
						}

						!isBox2 && isBox3 && box3.width(grid.width() - (box1head.width() + 1));
						tbl1also.width(tbl1.width());
						tbl2also.width(tbl2.width());
						tbl3also.width(tbl3.width());
						tbl4.width(tbl1.width() + tbl2.width());
						tbl4also.width(tbl3also.width());
						Otime.Storage.set("task_grid_size_box1", box1head.width());
						Otime.Storage.set("task_grid_size_box2", box2Wid);
					}
				});

				// Box2 resizable
				box2head.resizable({
					handles: "e",
					disable: true,
					minWidth: 50,
					helper: "ui-resizable-helper",
					stop: function (event, ui) {
						box2also.width(box2head.width());
						box3.width(grid.width() - (box1head.width() + box2head.width() + 2));
						tbl2also.width(tbl2.width());
						tbl3also.width(tbl3.width());
						tbl4.width(box1head.width() + box2head.width());
						tbl4also.width(box3.width());
						Otime.Storage.set("task_grid_size_box2", box2head.width());
						Otime.Storage.set("task_grid_size_box3", box3.width());
					}
				});

				$("#box1-body, #scroller #scr1").unbind("scroll").scroll(function (e) {
					box1.not($(this)).scrollLeft($(this).scrollLeft());
				});				

				$("#box2-body, #scroller #scr2").unbind("scroll").scroll(function (e) {
					$("> .ui-resizable-handle", box2head).css("right", "-" + $(this).scrollLeft() + "px");
					box2.not($(this)).scrollLeft($(this).scrollLeft());
				});

				if ($("> div:visible", grid).length > 2 || !isBox2) {
					$("table colgroup col:last-child", box2).width(170);
					box2head.resizable("enable");

					$("#box3-body, #scroller #scr3").unbind("scroll").scroll(function (e) {
						box3.not($(this)).scrollLeft($(this).scrollLeft());
					});
				}

				var elems = $("table thead tr th:not(:last-child)", box2head), colWidth = null, colElement = null, alsoElem = null, originalSize = null;
				var sizes = Otime.Storage.get("task_grid_size");
				if (sizes) {
					sizes = JSON.parse(sizes);
					$("table colgroup col:not(:last-child)", box2).each(function (idx, el) {
						$(el).width(sizes[el.getAttribute("for")]);
					});
				}

				elems.resizable({
					handles: "e",
					start: function (event, ui) {
						colElement = $("table colgroup col:nth-child(" + (ui.helper.index() + 1) + ")", box2head);
						alsoElem = $("table colgroup col:nth-child(" + (ui.helper.index() + 1) + ")", box2also);
						// get col width (faster than .width() on IE)
						colWidth = parseInt(colElement.get(0).style.width, 10);
						originalSize = ui.size.width;
					},
					stop: function () {
						sizes = {};
						elems.each(function (idx, el) {
							sizes[el.getAttribute("target")] = el.clientWidth;
						});
						Otime.Storage.set("task_grid_size", JSON.stringify(sizes));
					},
					resize: function (event, ui) {
						$("table, .bar", box2also).width($("table", box2head).innerWidth());
						colElement.width(colWidth + (ui.size.width - originalSize));
						alsoElem.width(colWidth + (ui.size.width - originalSize));
						// $(this).css("height", "auto");
					}
				});
				self.updatePane(_this.appModel && _this.appModel.isPane());
				self.resizeHeaderPadding();
			};

			self.initPane = function () {
				if (!_this.appModel || _this.appModel.isRightPane()) {
					return;
				}
				var pane = $("#pane-container");
				$("#grid-pane").resizable({
					handles: "s",
					helper: "ui-resizable-helper",
					minHeight: pane.innerHeight() * 0.30, // 30%
					maxHeight: pane.innerHeight() * 0.70, // 70%
					start: function (event, ui) {
						_this.appModel.isPane(true);
						// $("#bottom-pane").css({height: "0%"});
					},
					stop: function (event, ui) {
						$("#bottom-pane").innerHeight(pane.innerHeight() - ui.size.height);
					}
				});
				$(".ui-resizable-handle.ui-resizable-s").css("z-index", "2");
				self.updatePane(false);
			};

			self.uninit = function () {
				if ($("#grid-pane").data("resizable")) {
					$("#grid-pane").resizable('destroy');
				}
			};

			self.updatePane = function (isPane) {
				if (isPane) {
					$("#grid-pane").css({
						height: "60%"
					});
					$("#bottom-pane").css({
						height: "40%"
					});
				}
				else {
					$("#grid-pane").css({
						height: "100%"
					});
				}

				var handle = null;
				$("#right-pane").unbind("mouseenter").unbind("mouseleave");
				if (_this.appModel && !_this.appModel.is_pinned()) {
					$("#right-pane").bind({
						mouseenter: function () {
							clearTimeout(handle);
						},
						mouseleave: function () {
							handle = setTimeout(function () {
								if (_this.appModel.is_detail()) {
									_this.appModel.isPane(false);
								}
							}, 1750);
						}
					});
				}
			};

			self.resizeHeaderPadding = function () {
				var $box1Head = $("#box1-head");
				var $box1Body = $("#box1-body");
				setTimeout(function () {
					var $tasklistcnt = $("[task-list-cnt='true']");
					if ($tasklistcnt.get(0)) {
						var scrollBarWidth = $tasklistcnt.get(0).offsetWidth - $tasklistcnt.get(0).clientWidth;
						$("#header-container").css({
							"padding": "0 " + scrollBarWidth + "px 0 0"
						});
					}
				}, 1000);
			};
		};

		_this.UpdateContainers = function () {
			// _this.tasks_container = $("#tasks-container");
			// _this.list_container = $("#body-container");

			_this.tasks_container = $("#body-container");
			_this.list_container = $("#tasks-container");
			if (!_this.list_container.get(0)) {
				_this.list_container = $("<div/>").attr({
					"id": "tasks-container",
					"class": "container np fw fh"
				});
				_this.list_container.appendTo($("#main-container"));
			}
			_this.task_container = $("#edit_layout");
			_this.gantt_container = $("#gantt-container");
			_this.grid_container = $("#grid-container");
			_this.pcomments_container = $("#pcomments");
			_this.taskTmplContainer = $("#tasks-tmpl-modal");
		};

		_this.loadTemplates = function (clbk) {
			Otime.Tasks.language = { "TASK_TYPE": "Task Type", "DURATION": "Duration", "START_DATE": "Start Date", "FINISH_DATE": "Finish Date", "ESTIMATED_HOURS": "Estimated Hours", "ACTUAL_HOURS": "Actual Hours", "STATUS": "Status", "ASSIGNEE": "Assignee", "FOLLOWERS": "Followers", "PREDECESSORS": "Predecessors" };
			Otime.Tasks.filter_labels = { "ALL": "ALL", "TO": "TODAY", "TW": "THIS_WEEK", "TS": "THIS_SEMI_MONTHLY", "TM": "THIS_MONTH", "YE": "YESTERDAY", "LW": "LAST_WEEK", "LS": "LAST_SEMI_MONTHLY", "LM": "LAST_MONTH" };
			Otime.Tasks.dft = 'ALL';
			// Otime.Tasks.isToDo	= false;

			var url = Otime.siteUrl + "/tasks/template";
			var storeName = "tasks_";

			if (_this.isToDo) {
				url = Otime.siteUrl + "/tasks/todo_template";
				storeName = "todo_";
			}

			Otime.loadTemplates(url, {
				v: Otime.version
			}, function (content) {
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
			}, storeName + Otime.version);
		};

		_this.ColumnSelectionModel = function (data, closeClbk) {
			var self = this;

			data = data || {};

			self.custom_fields = Otime.a(_this.custom_fields);
			self.custom_field = Otime.o();
			self.columns = Otime.a();

			var boolFlag1 = false;

			var enabledCols = [];
			self.columns();
			$.each(_this.custom_mod, function (key, val) {
				if(val.fCode=='SP'){
					if(Otime.isSPRINT){
						if (typeof val.fEnable === "undefined") {
							val.fEnable = 1;
						}
						enabledCols.push(_this.cfByFCode[val.fCode]);
						self.columns.push(_this.cfByFCode[val.fCode]);
					}
				}else{
					if (typeof val.fEnable === "undefined") {
						val.fEnable = 1;
					}
					enabledCols.push(_this.cfByFCode[val.fCode]);
					self.columns.push(_this.cfByFCode[val.fCode]);
				}
			});
			// self.columns(enabledCols);

			self.save = function () {
				var saveData = {
					mId: _this.appModel.project_id() - 0,
					mType: "T",
					fields: []
				};
				var enabledFields = "";

				var ordNo = 0;
				$.each(self.columns(), function (key, val) {
					if (val.fEnable) {
						enabledFields += (enabledFields != '') ? "," + val.fName + ":" + ordNo : val.fName + ":" + ordNo;
						val.id = val.id - 0;
						saveData.fields.push({
							fId: val.id || 0,
							fCode: val.fType,
							// ordNo: val.ordNo - 0
							ordNo: ++ordNo
						});
					}
				});

				Otime.Storage.set("tasks_columns", enabledFields);			

				//Otime.app.postData(new Otime.ContextModel("savefields", saveData, function (cont) {
					/*if (cont.response[0]) {
						enabledCols = self.columns();
						typeof closeClbk === "function" && closeClbk();
					}*/					
					_this.custom_mod.forEach(function (item) {
						// Find the corresponding ordNo value from saveData.field using the id
						var matchingField = saveData.fields.find(function (field) {
							return field.fId === item.id;
						});
						
						// If a matching field is found, update the ordNo property in _this.custom_mod
						if (matchingField) {
							item.ordNo = matchingField.ordNo;
						}
					});

					$.each(saveData.fields, function (key, val) {						
						var k = (val.fId - 0) ? ("cf_" + val.fId) : val.fType;
						if (_this.cfByFCode[k]) {
							_this.cfByFCode[k].fEnable = 1;
							_this.cfByFCode[k].ordNo = val.ordNo;
						}
						if (_this.custom_mod.indexOf(_this.cfByFCode[k]) < 0) {
							_this.custom_mod.push(_this.cfByFCode[k]);
							 //console.log("Called Push");
						}
					});

					_this.custom_mod = _this.custom_mod.filter(item => item !== null && item !== undefined);
					
					sortCustomFields();

					_this.ResetTmpl();
					_this.ReBindAll();
					_this.appModel.gridify_params().scope && _this.appModel.gridify_params().scope.setSelected();
					if (_this.appModel.is_gantt())
					{
						_this.appModel.buildGantt();
						_this.Splitters.init();
					}
					typeof closeClbk === "function" && closeClbk();
				//}));
			};

			self.reset = function() {
				Otime.Storage.set("tasks_columns", "");
				refreshFlag = false;
				_this.Refresh();
				self.columns([]);
				enabledCols.forEach(function (col) {
					self.columns.push(col);
				});
				typeof closeClbk === "function" && closeClbk();
			};

			self.close = function () {
				self.columns([]);
				enabledCols.forEach(function (col) {
					self.columns.push(col);
				});
				typeof closeClbk === "function" && closeClbk();
			};

			self.addField = function (item) {
				var columns = [];

				var cf = self.custom_field();

				var result = self.columns().filter(function (val) {
					return (val.fCode == cf);
				});

				if (result && result.length) {
					return;
				}

				result = self.custom_fields().filter(function (val) {
					return (val.fCode == cf);
				});

				if (!result || !result.length) {
					return;
				}

				result = result[0];

				result.fEnable = true;
				self.columns.push(result);
				self.custom_field(0);
			};

			self.remove = function (itm) {
				var idx = self.columns.indexOf(itm);
				self.columns.splice(idx, 1);
			};
		};

		_this.ProgressCommentsModel = function (data, closeClbk) {
			var self = this;
			data = data || {};
			// "G"-  On Track "O" - Off Track "R" - at Risk
			self.progress_type = [
				{
					status: "On Track",
					value: "G"
				},
				{
					status: "Off Track",
					value: "O"
				},
				{
					status: "At Risk",
					value: "R"
				},
			];
			self.isDashboard = Otime.o(false);
			self.addNewComment = Otime.o(true);
			self.progress_comment = {
				message: Otime.o(""),
				status: Otime.o(self.progress_type[0].value)
			};
			self.addnew = function () {
			}
			self.current_Time = Otime.stoj(new Date(), true);
			self.current_User = Otime.userDetails;
			if (self.current_User.image) {
				self.current_User.image = Otime.UMIP + "/" + self.current_User.image;
			}
			self.save = function () {
				if (self.progress_comment.message()) {
					var saveData = {
						module_id: _this.appModel.project_id() - 0,
						message: self.progress_comment.message(),
						module_type: "P",
						parent_comment_id: 0,
						progress_status: self.progress_comment.status() ? self.progress_comment.status() : self.progress_type[0].value,
					};

					Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + "/comments/save", saveData, function (cont) {
						if (cont.response[0]) {
							typeof closeClbk === "function" && closeClbk();
						}
						self.progress_comment.message("");
						self.progress_comment.status(self.progress_type[0].value);
						typeof closeClbk === "function" && closeClbk();
					}), true);
				}
			};
			self.close = function () {
				self.progress_comment.message("");
				self.progress_comment.status(self.progress_type[0].value);
				typeof closeClbk === "function" && closeClbk();
			};

			self.addField = function (item) {

			};

			self.remove = function (itm) {
			};			
		};

		_this.init = function () {
			_this.UpdateContainers();
			if (Object.keys(Otime.Details.all_projects).length <= 0) {
				$("body").addClass("loading");
				_this.tasks_container.removeClass("dib").hide();
				if (!Otime.Details.isInitialized) {
					Otime.Details.onReady(_this.init);
					return false;
				}
				Otime.show_propop('Track Your Time', 'Create your project to track your time');
				return false;
			}
			_this.tasks_container.show().addClass("dib");
			$("body").removeClass("loading");

			initFlag = true;
			if (_this.isToDo) {
				_this.Splitters = new _this.Splitter_ToDo();
			}
			else {
				_this.Splitters = new _this.Splitter_Task();
			}

			_this.ResetTmpl();
			_this.Splitters.init();
			Otime.unbind();
			/*
			Otime.Storage.onChange(function(e){
				console.log("Storage changed : ", e);
			});
			*/

			var pID = window.location.pathname.match(/tasks\/(\d+)/);
			if (pID && pID.length == 2) {
				_this.PID = pID[1];
				initFlag = false;
			}

			_this.appModel = new _this.TaskListModel();

			Otime.app.model = _this.appModel;

			_this.appModel.date_filter.applyDFT(_this.dft || "ALL");

			_this.PID && Otime.Storage.set("tasks_project_id", _this.PID);

			// _this.Refresh();
			_this.appModel.setTab();

			var prevent = function (ev) {
				ev.stopPropagation();
				ev.preventDefault();
			};
			Otime.onTabChange(function (isHidden) {
				if (!isHidden) {
					$("#hidder0 #txt-normal").focus();
				}
			});
			$("#documents-container #filecontainer").on("dragenter", prevent).on("dragleave", prevent).on("dragover", prevent).on("drop", function (ev) {
				Otime.Project.fileApi.showDroppedFiles(ev.originalEvent);
			});
		};
	};
}(window.Otime));

ko.bindingHandlers.taskBox = {
	update: function (element, valueAccessor, allBindingsAccessor, viewModel, bindingContext) {
		var init = false;

		if (!element.isInit) {
			init = true;
			var src = $(".task_" + viewModel.uniqueId(), $("#box1-body"));
			$(element).css({
				width: "100px"
			}).parent().css({
				height: src.outerHeight() + "px"
			});

			Otime.app.model.gantt.drawTask(viewModel);
			element.isInit = true;
		}

		Otime.app.model.gantt.resizeTaskBox(viewModel);
		//Otime.app.model.uGantt.resizeTaskBox(viewModel);

		/*if (Otime.app.model.gantt.resizeTable(viewModel) && (Otime.app.model.uGantt.resizeTable(viewModel))) {
			return false;
		}*/
		if (Otime.app.model.gantt.resizeTable(viewModel)) {
			return false;
		}

		if (!Otime.app.model.fFlag && !init) {
			Otime.Tasks.applyLinks();
		}
	}
};

ko.bindingHandlers.userHours = {
	update: function (element, valueAccessor, allBindingsAccessor, viewModel, bindingContext) {
		Otime.app.model.gantt.drawUserHour(viewModel, element);
	}
};

// Not Used anywhere.
// Gantt DragScroller instead of scroll left & top
function draggableGantt() {
	var $layer = $("#box3-body");
	var layer = $layer.get(0);
	var downPos = null;
	var gridContainer = $("#grid-container").get(0);
	$layer.mouseup(function (e) {
		downPos = null;
	});
	$layer.mousedown(function (e) {
		// console.log(e.target);
		downPos = {
			X: e.offsetX,
			Y: e.offsetY
		};
	});
	$layer.mousemove(function (e) {
		if (!downPos) {
			return;
		}
		layer.scrollLeft = layer.scrollLeft - (e.offsetX - downPos.X);
		gridContainer.scrollTop = gridContainer.scrollTop - (e.offsetY - downPos.Y);
	});
}

